/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/base/common/stopwatch","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ee){for(var e=[],i=0,T=ee.length;i<T;i++)e[i]=Ie[ee[i]];return e};define(Ie[79],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(C,O){const S=Object.create(null);for(const k of C){const M=O(k);let D=S[M];D||(D=S[M]=[]),D.push(k)}return S}e.groupBy=i;function T(C,O){const S=[],k=[];for(const M of C)O.has(M)||S.push(M);for(const M of O)C.has(M)||k.push(M);return{removed:S,added:k}}e.diffSets=T;function y(C,O){const S=[],k=[];for(const[M,D]of C)O.has(M)||S.push(D);for(const[M,D]of O)C.has(M)||k.push(D);return{removed:S,added:k}}e.diffMaps=y;class L{constructor(){this.a=new Map}add(O,S){let k=this.a.get(O);k||(k=new Set,this.a.set(O,k)),k.add(S)}delete(O,S){const k=this.a.get(O);!k||(k.delete(S),k.size===0&&this.a.delete(O))}forEach(O,S){const k=this.a.get(O);!k||k.forEach(S)}}e.SetMap=L}),define(Ie[61],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(C){return(O,S,k)=>{let M=null,D=null;if(typeof k.value=="function"?(M="value",D=k.value):typeof k.get=="function"&&(M="get",D=k.get),!D)throw new Error("not supported");k[M]=C(D,S)}}function T(C,O,S){let k=null,M=null;if(typeof S.value=="function"?(k="value",M=S.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",M=S.get),!M)throw new Error("not supported");const D=`$memoize$${O}`;S[k]=function(...m){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,m)}),this[D]}}e.memoize=T;function y(C,O,S){return i((k,M)=>{const D=`$debounce$${M}`,m=`$debounce$result$${M}`;return function(...v){this[m]||(this[m]=S?S():void 0),clearTimeout(this[D]),O&&(this[m]=O(this[m],...v),v=[this[m]]),this[D]=setTimeout(()=>{k.apply(this,v),this[m]=S?S():void 0},C)}})}e.debounce=y;function L(C,O,S){return i((k,M)=>{const D=`$throttle$timer$${M}`,m=`$throttle$result$${M}`,v=`$throttle$lastRun$${M}`,f=`$throttle$pending$${M}`;return function(...t){if(this[m]||(this[m]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),O&&(this[m]=O(this[m],...t)),this[f])return;const c=this[v]+C;c<=Date.now()?(this[v]=Date.now(),k.apply(this,[this[m]]),this[m]=S?S():void 0):(this[f]=!0,this[D]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),k.apply(this,[this[m]]),this[m]=S?S():void 0},c-Date.now()))}})}e.throttle=L}),define(Ie[80],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ie[109],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var T;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function C(r,s=!1){let a=0;const d=r.length;let o="",u=0,n=16,h=0;function g(A){let F=0,B=0;for(;F<A;){const z=r.charCodeAt(a);if(z>=48&&z<=57)B=B*16+z-48;else if(z>=65&&z<=70)B=B*16+z-65+10;else if(z>=97&&z<=102)B=B*16+z-97+10;else break;a++,F++}return F<A&&(B=-1),B}function P(A){a=A,o="",u=0,n=16,h=0}function N(){const A=a;if(r.charCodeAt(a)===48)a++;else for(a++;a<r.length&&k(r.charCodeAt(a));)a++;if(a<r.length&&r.charCodeAt(a)===46)if(a++,a<r.length&&k(r.charCodeAt(a)))for(a++;a<r.length&&k(r.charCodeAt(a));)a++;else return h=3,r.substring(A,a);let F=a;if(a<r.length&&(r.charCodeAt(a)===69||r.charCodeAt(a)===101))if(a++,(a<r.length&&r.charCodeAt(a)===43||r.charCodeAt(a)===45)&&a++,a<r.length&&k(r.charCodeAt(a))){for(a++;a<r.length&&k(r.charCodeAt(a));)a++;F=a}else h=3;return r.substring(A,F)}function j(){let A="",F=a;for(;;){if(a>=d){A+=r.substring(F,a),h=2;break}const B=r.charCodeAt(a);if(B===34){A+=r.substring(F,a),a++;break}if(B===92){if(A+=r.substring(F,a),a++,a>=d){h=2;break}switch(r.charCodeAt(a++)){case 34:A+='"';break;case 92:A+="\\";break;case 47:A+="/";break;case 98:A+="\b";break;case 102:A+="\f";break;case 110:A+=`
`;break;case 114:A+="\r";break;case 116:A+="	";break;case 117:{const V=g(4);V>=0?A+=String.fromCharCode(V):h=4;break}default:h=5}F=a;continue}if(B>=0&&B<=31)if(S(B)){A+=r.substring(F,a),h=2;break}else h=6;a++}return A}function Z(){if(o="",h=0,u=a,a>=d)return u=d,n=17;let A=r.charCodeAt(a);if(O(A)){do a++,o+=String.fromCharCode(A),A=r.charCodeAt(a);while(O(A));return n=15}if(S(A))return a++,o+=String.fromCharCode(A),A===13&&r.charCodeAt(a)===10&&(a++,o+=`
`),n=14;switch(A){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,o=j(),n=10;case 47:{const F=a-1;if(r.charCodeAt(a+1)===47){for(a+=2;a<d&&!S(r.charCodeAt(a));)a++;return o=r.substring(F,a),n=12}if(r.charCodeAt(a+1)===42){a+=2;const B=d-1;let z=!1;for(;a<B;){if(r.charCodeAt(a)===42&&r.charCodeAt(a+1)===47){a+=2,z=!0;break}a++}return z||(a++,h=1),o=r.substring(F,a),n=13}return o+=String.fromCharCode(A),a++,n=16}case 45:if(o+=String.fromCharCode(A),a++,a===d||!k(r.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=N(),n=11;default:for(;a<d&&G(A);)a++,A=r.charCodeAt(a);if(u!==a){switch(o=r.substring(u,a),o){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return o+=String.fromCharCode(A),a++,n=16}}function G(A){if(O(A)||S(A))return!1;switch(A){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let A;do A=Z();while(A>=12&&A<=15);return A}return{setPosition:P,getPosition:()=>a,scan:s?R:Z,getToken:()=>n,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>a-u,getTokenError:()=>h}}e.createScanner=C;function O(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function k(r){return r>=48&&r<=57}var M;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(M||(M={}));function D(r,s){const a=[],d=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function h(g,P,N,j){u.value=g,u.offset=P,u.length=N,u.type=j,u.colonOffset=void 0,o=u}try{E(r,{onObjectBegin:(g,P)=>{if(s<=g)throw d;o=void 0,n=s>g,a.push("")},onObjectProperty:(g,P,N)=>{if(s<P||(h(g,P,N,"property"),a[a.length-1]=g,s<=P+N))throw d},onObjectEnd:(g,P)=>{if(s<=g)throw d;o=void 0,a.pop()},onArrayBegin:(g,P)=>{if(s<=g)throw d;o=void 0,a.push(0)},onArrayEnd:(g,P)=>{if(s<=g)throw d;o=void 0,a.pop()},onLiteralValue:(g,P,N)=>{if(s<P||(h(g,P,N,w(g)),s<=P+N))throw d},onSeparator:(g,P,N)=>{if(s<=P)throw d;if(g===":"&&o&&o.type==="property")o.colonOffset=P,n=!1,o=void 0;else if(g===","){const j=a[a.length-1];typeof j=="number"?a[a.length-1]=j+1:(n=!0,a[a.length-1]=""),o=void 0}}})}catch(g){if(g!==d)throw g}return{path:a,previousNode:o,isAtPropertyKey:n,matches:g=>{let P=0;for(let N=0;P<g.length&&N<a.length;N++)if(g[P]===a[N]||g[P]==="*")P++;else if(g[P]!=="**")return!1;return P===g.length}}}e.getLocation=D;function m(r,s=[],a=L.DEFAULT){let d=null,o=[];const u=[];function n(g){Array.isArray(o)?o.push(g):d!==null&&(o[d]=g)}return E(r,{onObjectBegin:()=>{const g={};n(g),u.push(o),o=g,d=null},onObjectProperty:g=>{d=g},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const g=[];n(g),u.push(o),o=g,d=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:n,onError:(g,P,N)=>{s.push({error:g,offset:P,length:N})}},a),o[0]}e.parse=m;function v(r,s=[],a=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(g){d.type==="property"&&(d.length=g-d.offset,d=d.parent)}function u(g){return d.children.push(g),g}E(r,{onObjectBegin:g=>{d=u({type:"object",offset:g,length:-1,parent:d,children:[]})},onObjectProperty:(g,P,N)=>{d=u({type:"property",offset:P,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:g,offset:P,length:N,parent:d})},onObjectEnd:(g,P)=>{d.length=g+P-d.offset,d=d.parent,o(g+P)},onArrayBegin:(g,P)=>{d=u({type:"array",offset:g,length:-1,parent:d,children:[]})},onArrayEnd:(g,P)=>{d.length=g+P-d.offset,d=d.parent,o(g+P)},onLiteralValue:(g,P,N)=>{u({type:w(g),offset:P,length:N,parent:d,value:g}),o(P+N)},onSeparator:(g,P,N)=>{d.type==="property"&&(g===":"?d.colonOffset=P:g===","&&o(P))},onError:(g,P,N)=>{s.push({error:g,offset:P,length:N})}},a);const h=d.children[0];return h&&delete h.parent,h}e.parseTree=v;function f(r,s){if(!r)return;let a=r;for(const d of s)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let o=!1;for(const u of a.children)if(Array.isArray(u.children)&&u.children[0].value===d){a=u.children[1],o=!0;break}if(!o)return}else{const o=d;if(a.type!=="array"||o<0||!Array.isArray(a.children)||o>=a.children.length)return;a=a.children[o]}return a}e.findNodeAtLocation=f;function t(r){if(!r.parent||!r.parent.children)return[];const s=t(r.parent);if(r.parent.type==="property"){const a=r.parent.children[0].value;s.push(a)}else if(r.parent.type==="array"){const a=r.parent.children.indexOf(r);a!==-1&&s.push(a)}return s}e.getNodePath=t;function c(r){switch(r.type){case"array":return r.children.map(c);case"object":{const s=Object.create(null);for(const a of r.children){const d=a.children[1];d&&(s[a.children[0].value]=c(d))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=c;function l(r,s,a=!1){return s>=r.offset&&s<r.offset+r.length||a&&s===r.offset+r.length}e.contains=l;function p(r,s,a=!1){if(l(r,s,a)){const d=r.children;if(Array.isArray(d))for(let o=0;o<d.length&&d[o].offset<=s;o++){const u=p(d[o],s,a);if(u)return u}return r}}e.findNodeAtOffset=p;function E(r,s,a=L.DEFAULT){const d=C(r,!1);function o(se){return se?()=>se(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(se){return se?le=>se(le,d.getTokenOffset(),d.getTokenLength()):()=>!0}const n=o(s.onObjectBegin),h=u(s.onObjectProperty),g=o(s.onObjectEnd),P=o(s.onArrayBegin),N=o(s.onArrayEnd),j=u(s.onLiteralValue),Z=u(s.onSeparator),G=o(s.onComment),R=u(s.onError),A=a&&a.disallowComments,F=a&&a.allowTrailingComma;function B(){for(;;){const se=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:A||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(se){case 12:case 13:A?z(10):G();break;case 16:z(1);break;case 15:case 14:break;default:return se}}}function z(se,le=[],_=[]){if(R(se),le.length+_.length>0){let me=d.getToken();for(;me!==17;){if(le.indexOf(me)!==-1){B();break}else if(_.indexOf(me)!==-1)break;me=B()}}}function V(se){const le=d.getTokenValue();return se?j(le):h(le),B(),!0}function K(){switch(d.getToken()){case 11:{let se=0;try{se=JSON.parse(d.getTokenValue()),typeof se!="number"&&(z(2),se=0)}catch{z(2)}j(se);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return B(),!0}function ie(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),d.getToken()===6?(Z(":"),B(),re()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ge(){n(),B();let se=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(se||z(4,[],[]),Z(","),B(),d.getToken()===2&&F)break}else se&&z(6,[],[]);ie()||z(4,[],[2,5]),se=!0}return g(),d.getToken()!==2?z(7,[2],[]):B(),!0}function ue(){P(),B();let se=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(se||z(4,[],[]),Z(","),B(),d.getToken()===4&&F)break}else se&&z(6,[],[]);re()||z(4,[],[4,5]),se=!0}return N(),d.getToken()!==4?z(8,[4],[]):B(),!0}function re(){switch(d.getToken()){case 3:return ue();case 1:return ge();case 10:return V(!0);default:return K()}}return B(),d.getToken()===17?a.allowEmptyContent?!0:(z(4,[],[]),!1):re()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=E;function b(r,s){const a=C(r),d=[];let o,u=0,n;do switch(n=a.getPosition(),o=a.scan(),o){case 12:case 13:case 17:u!==n&&d.push(r.substring(u,n)),s!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,s)),u=a.getPosition();break}while(o!==17);return d.join("")}e.stripComments=b;function w(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Ie[28],Ce([1,0]),function(ee,e){"use strict";var i,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,t,c){let l=f.get(t);return l===void 0&&(l=c,f.set(t,l)),l}e.getOrSet=L;function C(f){const t=[];return f.forEach((c,l)=>{t.push(`${l} => ${c}`)}),`Map(${f.size}) {${t.join(", ")}}`}e.mapToString=C;function O(f){const t=[];return f.forEach(c=>{t.push(c)}),`Set(${f.size}) {${t.join(", ")}}`}e.setToString=O;class S{constructor(t,c){this.uri=t,this.value=c}}class k{constructor(t,c){this[i]="ResourceMap",t instanceof k?(this.b=new Map(t.b),this.c=c??k.a):(this.b=new Map,this.c=t??k.a)}set(t,c){return this.b.set(this.c(t),new S(t,c)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[l,p]of this.b)t(p.value,p.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=k,k.a=f=>f.toString();class M{constructor(t,c){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new k(t):(this.a=new k(c),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,c){this.a.forEach((l,p)=>t.call(c,p,p,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var D;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class m{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,c=0){const l=this.a.get(t);if(!!l)return c!==0&&this.j(l,c),l.value}set(t,c,l=0){let p=this.a.get(t);if(p)p.value=c,l!==0&&this.j(p,l);else{switch(p={key:t,value:c,next:void 0,previous:void 0},l){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(t,p),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.a.get(t);if(!!c)return this.a.delete(t),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,c){const l=this.e;let p=this.b;for(;p;){if(c?t.bind(c)(p.value,p.key,this):t(p.value,p.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,c=this.e;let l=this.b;const p={[Symbol.iterator](){return p},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return p}values(){const t=this,c=this.e;let l=this.b;const p={[Symbol.iterator](){return p},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return p}entries(){const t=this,c=this.e;let l=this.b;const p={[Symbol.iterator](){return p},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return p}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.b,l=this.size;for(;c&&l>t;)this.a.delete(c.key),c=c.next,l--;this.b=c,this.d=l,c&&(c.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const c=t.next,l=t.previous;if(!c||!l)throw new Error("Invalid list");c.previous=l,l.next=c}t.next=void 0,t.previous=void 0,this.e++}j(t,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.b)return;const l=t.next,p=t.previous;t===this.c?(p.next=void 0,this.c=p):(l.previous=p,p.next=l),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(c===2){if(t===this.c)return;const l=t.next,p=t.previous;t===this.b?(l.previous=void 0,this.b=l):(l.previous=p,p.next=l),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((c,l)=>{t.push([l,c])}),t}fromJSON(t){this.clear();for(const[c,l]of t)this.set(c,l)}}e.LinkedMap=m;class v extends m{constructor(t,c=1){super(),this.k=t,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=v}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[110],Ce([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,De){for(var ke=0;ke<De.length;ke++){var oe=De[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Te,oe.key,oe)}}function i(Te,De,ke){return De&&e(Te.prototype,De),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function T(Te,De){if(!!Te){if(typeof Te=="string")return y(Te,De);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return y(Te,De)}}function y(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var ke=0,oe=new Array(De);ke<De;ke++)oe[ke]=Te[ke];return oe}function L(Te,De){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=T(Te))||De&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var oe=0;return function(){return oe>=Te.length?{done:!0}:{done:!1,value:Te[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=C();function O(Te){ee.defaults=Te}var S=/[&<>"']/,k=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(De){return m[De]};function f(Te,De){if(De){if(S.test(Te))return Te.replace(k,v)}else if(M.test(Te))return Te.replace(D,v);return Te}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Te){return Te.replace(t,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function p(Te,De){Te=typeof Te=="string"?Te:Te.source,De=De||"";var ke={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(l,"$1"),Te=Te.replace(ce,Y),ke},getRegex:function(){return new RegExp(Te,De)}};return ke}var E=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,De,ke){if(Te){var oe;try{oe=decodeURIComponent(c(ke)).replace(E,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!b.test(ke)&&(ke=o(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var r={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Te,De){r[" "+Te]||(s.test(Te)?r[" "+Te]=Te+"/":r[" "+Te]=g(Te,"/",!0)),Te=r[" "+Te];var ke=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Te.replace(a,"$1")+De:De.charAt(0)==="/"?ke?De:Te.replace(d,"$1")+De:Te+De}var u={exec:function(){}};function n(Te){for(var De=1,ke,oe;De<arguments.length;De++){ke=arguments[De];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(Te[oe]=ke[oe])}return Te}function h(Te,De){var ke=Te.replace(/\|/g,function(Y,I,$){for(var H=!1,q=I;--q>=0&&$[q]==="\\";)H=!H;return H?"|":" |"}),oe=ke.split(/ \|/),ce=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function g(Te,De,ke){var oe=Te.length;if(oe===0)return"";for(var ce=0;ce<oe;){var Y=Te.charAt(oe-ce-1);if(Y===De&&!ke)ce++;else if(Y!==De&&ke)ce++;else break}return Te.slice(0,oe-ce)}function P(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var ke=Te.length,oe=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===De[0])oe++;else if(Te[ce]===De[1]&&(oe--,oe<0))return ce;return-1}function N(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Te,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Te),De>>=1,Te+=Te;return ke+Te}function Z(Te,De,ke,oe){var ce=De.href,Y=De.title?f(De.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){oe.state.inLink=!0;var $={type:"link",raw:ke,href:ce,title:Y,text:I,tokens:oe.inlineTokens(I)};return oe.state.inLink=!1,$}return{type:"image",raw:ke,href:ce,title:Y,text:f(I)}}function G(Te,De){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return De;var oe=ke[1];return De.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var R=function(){function Te(ke){this.options=ke||ee.defaults}var De=Te.prototype;return De.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},De.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:g(Y,`
`)}}},De.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var Y=ce[0],I=G(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},De.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=g(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},De.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},De.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},De.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var Y,I,$,H,q,J,de,Se,ae,ve,be,ze,He=ce[1].trim(),tt=He.length>1,xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(ze=!1,!(!(ce=et.exec(oe))||this.rules.block.hr.test(oe)));){if(Y=ce[0],oe=oe.substring(Y.length),Se=ce[2].split(`
`,1)[0],ae=oe.split(`
`,1)[0],this.options.pedantic?(H=2,be=Se.trimLeft()):(H=ce[2].search(/[^ ]/),H=H>4?1:H,be=Se.slice(H),H+=ce[1].length),J=!1,!Se&&/^ *$/.test(ae)&&(Y+=ae+`
`,oe=oe.substring(ae.length+1),ze=!0),!ze)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");oe&&(ve=oe.split(`
`,1)[0],Se=ve,this.options.pedantic&&(Se=Se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(Se)||st.test(Se)||it.test(Se)||dt.test(oe)));){if(Se.search(/[^ ]/)>=H||!Se.trim())be+=`
`+Se.slice(H);else if(!J)be+=`
`+Se;else break;!J&&!Se.trim()&&(J=!0),Y+=ve+`
`,oe=oe.substring(ve.length+1)}xe.loose||(de?xe.loose=!0:/\n *\n *$/.test(Y)&&(de=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&($=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:be}),xe.raw+=Y}xe.items[xe.items.length-1].raw=Y.trimRight(),xe.items[xe.items.length-1].text=be.trimRight(),xe.raw=xe.raw.trimRight();var X=xe.items.length;for(q=0;q<X;q++){this.lexer.state.top=!1,xe.items[q].tokens=this.lexer.blockTokens(xe.items[q].text,[]);var Q=xe.items[q].tokens.filter(function(Ne){return Ne.type==="space"}),pe=Q.every(function(Ne){for(var $e=Ne.raw.split(""),je=0,Je=L($e),nt;!(nt=Je()).done;){var wt=nt.value;if(wt===`
`&&(je+=1),je>1)return!0}return!1});!xe.loose&&Q.length&&pe&&(xe.loose=!0,xe.items[q].loose=!0)}return xe}},De.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},De.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},De.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var Y={type:"table",header:h(ce[1]).map(function(de){return{text:de}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,H,q,J;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=h(Y.rows[$],Y.header.length).map(function(de){return{text:de}});for(I=Y.header.length,H=0;H<I;H++)Y.header[H].tokens=this.lexer.inline(Y.header[H].text);for(I=Y.rows.length,H=0;H<I;H++)for(J=Y.rows[H],q=0;q<J.length;q++)J[q].tokens=this.lexer.inline(J[q].text);return Y}}},De.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},De.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},De.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},De.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},De.tag=function(oe){var ce=this.rules.inline.tag.exec(oe);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},De.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=g(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=P(ce[2],"()");if($>-1){var H=ce[0].indexOf("!")===0?5:4,q=H+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,q).trim(),ce[3]=""}}var J=ce[2],de="";if(this.options.pedantic){var Se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);Se&&(J=Se[1],de=Se[3])}else de=ce[3]?ce[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(Y)?J=J.slice(1):J=J.slice(1,-1)),Z(ce,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},De.reflink=function(oe,ce){var Y;if((Y=this.rules.inline.reflink.exec(oe))||(Y=this.rules.inline.nolink.exec(oe))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return Z(Y,I,Y[0],this.lexer)}},De.emStrong=function(oe,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(oe);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var H=I[0].length-1,q,J,de=H,Se=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*oe.length+H);(I=ae.exec(ce))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(J=q.length,I[3]||I[4]){de+=J;continue}else if((I[5]||I[6])&&H%3&&!((H+J)%3)){Se+=J;continue}if(de-=J,!(de>0)){if(J=Math.min(J,J+de+Se),Math.min(H,J)%2){var ve=oe.slice(1,H+I.index+J);return{type:"em",raw:oe.slice(0,H+I.index+J+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=oe.slice(2,H+I.index+J-1);return{type:"strong",raw:oe.slice(0,H+I.index+J+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},De.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=f(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},De.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},De.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},De.autolink=function(oe,ce){var Y=this.rules.inline.autolink.exec(oe);if(Y){var I,$;return Y[2]==="@"?(I=f(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=f(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},De.url=function(oe,ce){var Y;if(Y=this.rules.inline.url.exec(oe)){var I,$;if(Y[2]==="@")I=f(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var H;do H=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(H!==Y[0]);I=f(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},De.inlineText=function(oe,ce){var Y=this.rules.inline.text.exec(oe);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]:I=f(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Te}(),A={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};A._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,A._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,A.def=p(A.def).replace("label",A._label).replace("title",A._title).getRegex(),A.bullet=/(?:[*+-]|\d{1,9}[.)])/,A.listItemStart=p(/^( *)(bull) */).replace("bull",A.bullet).getRegex(),A.list=p(A.list).replace(/bull/g,A.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+A.def.source+")").getRegex(),A._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",A._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,A.html=p(A.html,"i").replace("comment",A._comment).replace("tag",A._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),A.paragraph=p(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.blockquote=p(A.blockquote).replace("paragraph",A.paragraph).getRegex(),A.normal=n({},A),A.gfm=n({},A.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),A.gfm.table=p(A.gfm.table).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.gfm.paragraph=p(A._paragraph).replace("hr",A.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",A.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",A._tag).getRegex(),A.pedantic=n({},A.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",A._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:p(A.normal._paragraph).replace("hr",A.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",A.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=p(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=p(A._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=p(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=p(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=p(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=p(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=p(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=p(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=p(F.reflink).replace("label",F._label).replace("ref",A._label).getRegex(),F.nolink=p(F.nolink).replace("ref",A._label).getRegex(),F.reflinkSearch=p(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:p(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=p(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:p(F.br).replace("{2,}","*").getRegex(),text:p(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var De="",ke,oe,ce=Te.length;for(ke=0;ke<ce;ke++)oe=Te.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var V=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ee.defaults,this.options.tokenizer=this.options.tokenizer||new R,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:A.normal,inline:F.normal};this.options.pedantic?(oe.block=A.pedantic,oe.inline=F.pedantic):this.options.gfm&&(oe.block=A.gfm,this.options.breaks?oe.inline=F.breaks:oe.inline=F.gfm),this.tokenizer.rules=oe}Te.lex=function(oe,ce){var Y=new Te(ce);return Y.lex(oe)},Te.lexInline=function(oe,ce){var Y=new Te(ce);return Y.inlineTokens(oe)};var De=Te.prototype;return De.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},De.blockTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(de,Se,ae){return Se+"    ".repeat(ae.length)});for(var I,$,H,q;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(I=de.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(oe)){oe=oe.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(H=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,Se=oe.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(ve){ae=ve.call({lexer:this},Se),typeof ae=="number"&&ae>=0&&(de=Math.min(de,ae))}),de<1/0&&de>=0&&(H=oe.substring(0,de+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){$=ce[ce.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),q=H.length!==oe.length,oe=oe.substring(I.raw.length);continue}if(I=this.tokenizer.text(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(oe){var J="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,ce},De.inline=function(oe,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:oe,tokens:ce}),ce},De.inlineTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,H,q=oe,J,de,Se;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ae.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,J.index)+"["+j("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,J.index)+"["+j("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,J.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(de||(Se=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(oe,q,Se)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(oe,z)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(oe,z))){oe=oe.substring(I.raw.length),ce.push(I);continue}if(H=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,ze=oe.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},ze),typeof He=="number"&&He>=0&&(be=Math.min(be,He))}),be<1/0&&be>=0&&(H=oe.substring(0,be+1))}(),I=this.tokenizer.inlineText(H,B)){oe=oe.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Se=I.raw.slice(-1)),de=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(oe){var ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ce},i(Te,null,[{key:"rules",get:function(){return{block:A,inline:F}}}]),Te}(),K=function(){function Te(ke){this.options=ke||ee.defaults}var De=Te.prototype;return De.code=function(oe,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(oe,I);$!=null&&$!==oe&&(Y=!0,oe=$)}return oe=oe.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+f(I,!0)+'">'+(Y?oe:f(oe,!0))+`</code></pre>
`:"<pre><code>"+(Y?oe:f(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+oe+"</h"+ce+`>
`}return"<h"+ce+">"+oe+"</h"+ce+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+oe+"</"+I+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+oe+("</"+Y+`>
`)},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ce,Y){if(oe=w(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<a href="'+f(oe)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},De.image=function(oe,ce,Y){if(oe=w(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<img src="'+oe+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},De.text=function(oe){return oe},Te}(),ie=function(){function Te(){}var De=Te.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ce,Y){return""+Y},De.image=function(oe,ce,Y){return""+Y},De.br=function(){return""},Te}(),ge=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ce){var Y=oe,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[oe];do I++,Y=oe+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[oe]=I,this.seen[Y]=0),Y},De.slug=function(oe,ce){ce===void 0&&(ce={});var Y=this.serialize(oe);return this.getNextSafeSlug(Y,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||ee.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ge}Te.parse=function(oe,ce){var Y=new Te(ce);return Y.parse(oe)},Te.parseInline=function(oe,ce){var Y=new Te(ce);return Y.parseInline(oe)};var De=Te.prototype;return De.parse=function(oe,ce){ce===void 0&&(ce=!0);var Y="",I,$,H,q,J,de,Se,ae,ve,be,ze,He,tt,xe,et,it,dt,Oe,st,X=oe.length;for(I=0;I<X;I++){if(be=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(st=this.options.extensions.renderers[be.type].call({parser:this},be),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Y+=st||"";continue}switch(be.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(be.tokens),be.depth,c(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ae="",Se="",q=be.header.length,$=0;$<q;$++)Se+=this.renderer.tablecell(this.parseInline(be.header[$].tokens),{header:!0,align:be.align[$]});for(ae+=this.renderer.tablerow(Se),ve="",q=be.rows.length,$=0;$<q;$++){for(de=be.rows[$],Se="",J=de.length,H=0;H<J;H++)Se+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:be.align[H]});ve+=this.renderer.tablerow(Se)}Y+=this.renderer.table(ae,ve);continue}case"blockquote":{ve=this.parse(be.tokens),Y+=this.renderer.blockquote(ve);continue}case"list":{for(ze=be.ordered,He=be.start,tt=be.loose,q=be.items.length,ve="",$=0;$<q;$++)et=be.items[$],it=et.checked,dt=et.task,xe="",et.task&&(Oe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Oe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Oe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Oe}):xe+=Oe),xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(xe,dt,it);Y+=this.renderer.list(ve,ze,He);continue}case"html":{Y+=this.renderer.html(be.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;I+1<X&&oe[I+1].type==="text";)be=oe[++I],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Y+=ce?this.renderer.paragraph(ve):ve;continue}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return Y},De.parseInline=function(oe,ce){ce=ce||this.renderer;var Y="",I,$,H,q=oe.length;for(I=0;I<q;I++){if($=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(H=this.options.extensions.renderers[$.type].call({parser:this},$),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=H||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var J='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return Y},Te}();function re(Te,De,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=n({},re.defaults,De||{}),N(De),ke){var oe=De.highlight,ce;try{ce=V.lex(Te,De)}catch(q){return ke(q)}var Y=function(J){var de;if(!J)try{De.walkTokens&&re.walkTokens(ce,De.walkTokens),de=ue.parse(ce,De)}catch(Se){J=Se}return De.highlight=oe,J?ke(J):ke(null,de)};if(!oe||oe.length<3||(delete De.highlight,!ce.length))return Y();var I=0;re.walkTokens(ce,function(q){q.type==="code"&&(I++,setTimeout(function(){oe(q.text,q.lang,function(J,de){if(J)return Y(J);de!=null&&de!==q.text&&(q.text=de,q.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+f(q.message+"",!0)+"</pre>";throw q}try{var H=V.lex(Te,De);if(De.walkTokens){if(De.async)return Promise.all(re.walkTokens(H,De.walkTokens)).then(function(){return ue.parse(H,De)}).catch($);re.walkTokens(H,De.walkTokens)}return ue.parse(H,De)}catch(q){$(q)}}re.options=re.setOptions=function(Te){return n(re.defaults,Te),O(re.defaults),re},re.getDefaults=C,re.defaults=ee.defaults,re.use=function(){for(var Te=arguments.length,De=new Array(Te),ke=0;ke<Te;ke++)De[ke]=arguments[ke];var oe=n.apply(void 0,[{}].concat(De)),ce=re.defaults.extensions||{renderers:{},childTokens:{}},Y;De.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var q=ce.renderers?ce.renderers[H.name]:null;q?ce.renderers[H.name]=function(){for(var J=arguments.length,de=new Array(J),Se=0;Se<J;Se++)de[Se]=arguments[Se];var ae=H.renderer.apply(this,de);return ae===!1&&(ae=q.apply(this,de)),ae}:ce.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[H.level]?ce[H.level].unshift(H.tokenizer):ce[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ce.startBlock?ce.startBlock.push(H.start):ce.startBlock=[H.start]:H.level==="inline"&&(ce.startInline?ce.startInline.push(H.start):ce.startInline=[H.start]))}H.childTokens&&(ce.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=re.defaults.renderer||new K,q=function(Se){var ae=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),ze=0;ze<ve;ze++)be[ze]=arguments[ze];var He=I.renderer[Se].apply(H,be);return He===!1&&(He=ae.apply(H,be)),He}};for(var J in I.renderer)q(J);oe.renderer=H}(),I.tokenizer&&function(){var H=re.defaults.tokenizer||new R,q=function(Se){var ae=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),ze=0;ze<ve;ze++)be[ze]=arguments[ze];var He=I.tokenizer[Se].apply(H,be);return He===!1&&(He=ae.apply(H,be)),He}};for(var J in I.tokenizer)q(J);oe.tokenizer=H}(),I.walkTokens){var $=re.defaults.walkTokens;oe.walkTokens=function(H){var q=[];return q.push(I.walkTokens.call(this,H)),$&&(q=q.concat($.call(this,H))),q}}Y&&(oe.extensions=ce),re.setOptions(oe)})},re.walkTokens=function(Te,De){for(var ke=[],oe=function(){var $=Y.value;switch(ke=ke.concat(De.call(re,$)),$.type){case"table":{for(var H=L($.header),q;!(q=H()).done;){var J=q.value;ke=ke.concat(re.walkTokens(J.tokens,De))}for(var de=L($.rows),Se;!(Se=de()).done;)for(var ae=Se.value,ve=L(ae),be;!(be=ve()).done;){var ze=be.value;ke=ke.concat(re.walkTokens(ze.tokens,De))}break}case"list":{ke=ke.concat(re.walkTokens($.items,De));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[$.type]?re.defaults.extensions.childTokens[$.type].forEach(function(He){ke=ke.concat(re.walkTokens($[He],De))}):$.tokens&&(ke=ke.concat(re.walkTokens($.tokens,De)))}},ce=L(Te),Y;!(Y=ce()).done;)oe();return ke},re.parseInline=function(Te,De){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=n({},re.defaults,De||{}),N(De);try{var ke=V.lexInline(Te,De);return De.walkTokens&&re.walkTokens(ke,De.walkTokens),ue.parseInline(ke,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+f(oe.message+"",!0)+"</pre>";throw oe}},re.Parser=ue,re.parser=ue.parse,re.Renderer=K,re.TextRenderer=ie,re.Lexer=V,re.lexer=V.lex,re.Tokenizer=R,re.Slugger=ge,re.parse=re;var se=re.options,le=re.setOptions,_=re.use,me=re.walkTokens,we=re.parseInline,Me=re,We=ue.parse,Qe=V.lex;ee.Lexer=V,ee.Parser=ue,ee.Renderer=K,ee.Slugger=ge,ee.TextRenderer=ie,ee.Tokenizer=R,ee.getDefaults=C,ee.lexer=Qe,ee.marked=re,ee.options=se,ee.parse=Me,ee.parseInline=we,ee.parser=We,ee.setOptions=le,ee.use=_,ee.walkTokens=me,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ie[111],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(O,S,k){return Math.min(Math.max(O,S),k)}e.clamp=i;function T(O,S){return(S+O%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ee(y){const L=[];typeof y=="number"&&L.push("code/timeOrigin",y);function C(S){L.push(S,Date.now())}function O(){const S=[];for(let k=0;k<L.length;k+=2)S.push({name:L[k],startTime:L[k+1]});return S}return{mark:C,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(y+C.startTime)});return L}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=i(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var T in i)(typeof exports=="object"?exports:ee)[T]=i[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return ee[T].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=ee,i.c=e,i.d=function(T,y,L){i.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:L})},i.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},i.t=function(T,y){if(1&y&&(T=i(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)i.d(L,C,function(O){return T[O]}.bind(null,C));return L},i.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return i.d(y,"a",y),y},i.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},i.p="",i(i.s=0)}([function(ee,e,i){(function(T){var y;e=ee.exports=_,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],S=e.src=[],k=0,M=k++;S[M]="0|[1-9]\\d*";var D=k++;S[D]="[0-9]+";var m=k++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=k++;S[v]="("+S[M]+")\\.("+S[M]+")\\.("+S[M]+")";var f=k++;S[f]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var t=k++;S[t]="(?:"+S[M]+"|"+S[m]+")";var c=k++;S[c]="(?:"+S[D]+"|"+S[m]+")";var l=k++;S[l]="(?:-("+S[t]+"(?:\\."+S[t]+")*))";var p=k++;S[p]="(?:-?("+S[c]+"(?:\\."+S[c]+")*))";var E=k++;S[E]="[0-9A-Za-z-]+";var b=k++;S[b]="(?:\\+("+S[E]+"(?:\\."+S[E]+")*))";var w=k++,r="v?"+S[v]+S[l]+"?"+S[b]+"?";S[w]="^"+r+"$";var s="[v=\\s]*"+S[f]+S[p]+"?"+S[b]+"?",a=k++;S[a]="^"+s+"$";var d=k++;S[d]="((?:<|>)?=?)";var o=k++;S[o]=S[D]+"|x|X|\\*";var u=k++;S[u]=S[M]+"|x|X|\\*";var n=k++;S[n]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[l]+")?"+S[b]+"?)?)?";var h=k++;S[h]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[p]+")?"+S[b]+"?)?)?";var g=k++;S[g]="^"+S[d]+"\\s*"+S[n]+"$";var P=k++;S[P]="^"+S[d]+"\\s*"+S[h]+"$";var N=k++;S[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=k++;S[j]="(?:~>?)";var Z=k++;S[Z]="(\\s*)"+S[j]+"\\s+",O[Z]=new RegExp(S[Z],"g");var G=k++;S[G]="^"+S[j]+S[n]+"$";var R=k++;S[R]="^"+S[j]+S[h]+"$";var A=k++;S[A]="(?:\\^)";var F=k++;S[F]="(\\s*)"+S[A]+"\\s+",O[F]=new RegExp(S[F],"g");var B=k++;S[B]="^"+S[A]+S[n]+"$";var z=k++;S[z]="^"+S[A]+S[h]+"$";var V=k++;S[V]="^"+S[d]+"\\s*("+s+")$|^$";var K=k++;S[K]="^"+S[d]+"\\s*("+r+")$|^$";var ie=k++;S[ie]="(\\s*)"+S[d]+"\\s*("+s+"|"+S[n]+")",O[ie]=new RegExp(S[ie],"g");var ge=k++;S[ge]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var ue=k++;S[ue]="^\\s*("+S[h]+")\\s+-\\s+("+S[h]+")\\s*$";var re=k++;S[re]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)y(se,S[se]),O[se]||(O[se]=new RegExp(S[se]));function le(ae,ve){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>L||!(ve?O[a]:O[w]).test(ae))return null;try{return new _(ae,ve)}catch{return null}}function _(ae,ve){if(ae instanceof _){if(ae.loose===ve)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof _))return new _(ae,ve);y("SemVer",ae,ve),this.loose=ve;var be=ae.trim().match(ve?O[a]:O[w]);if(!be)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var He=+ze;if(He>=0&&He<C)return He}return ze}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=le,e.valid=function(ae,ve){var be=le(ae,ve);return be?be.version:null},e.clean=function(ae,ve){var be=le(ae.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return y("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),we(this.major,ae.major)||we(this.minor,ae.minor)||we(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],ze=ae.prerelease[ve];if(y("prerelease compare",ve,be,ze),be===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(be===void 0)return-1;if(be!==ze)return we(be,ze)}while(++ve)},_.prototype.inc=function(ae,ve){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ve,be,ze){typeof be=="string"&&(ze=be,be=void 0);try{return new _(ae,be).inc(ve,ze).version}catch{return null}},e.diff=function(ae,ve){if(Te(ae,ve))return null;var be=le(ae),ze=le(ve);if(be.prerelease.length||ze.prerelease.length){for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==ze[He])return"pre"+He;return"prerelease"}for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==ze[He])return He},e.compareIdentifiers=we;var me=/^[0-9]+$/;function we(ae,ve){var be=me.test(ae),ze=me.test(ve);return be&&ze&&(ae=+ae,ve=+ve),be&&!ze?-1:ze&&!be?1:ae<ve?-1:ae>ve?1:0}function Me(ae,ve,be){return new _(ae,be).compare(new _(ve,be))}function We(ae,ve,be){return Me(ae,ve,be)>0}function Qe(ae,ve,be){return Me(ae,ve,be)<0}function Te(ae,ve,be){return Me(ae,ve,be)===0}function De(ae,ve,be){return Me(ae,ve,be)!==0}function ke(ae,ve,be){return Me(ae,ve,be)>=0}function oe(ae,ve,be){return Me(ae,ve,be)<=0}function ce(ae,ve,be,ze){var He;switch(ve){case"===":typeof ae=="object"&&(ae=ae.version),typeof be=="object"&&(be=be.version),He=ae===be;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof be=="object"&&(be=be.version),He=ae!==be;break;case"":case"=":case"==":He=Te(ae,be,ze);break;case"!=":He=De(ae,be,ze);break;case">":He=We(ae,be,ze);break;case">=":He=ke(ae,be,ze);break;case"<":He=Qe(ae,be,ze);break;case"<=":He=oe(ae,be,ze);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function Y(ae,ve){if(ae instanceof Y){if(ae.loose===ve)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,ve);y("comparator",ae,ve),this.loose=ve,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ae,ve){return we(ve,ae)},e.major=function(ae,ve){return new _(ae,ve).major},e.minor=function(ae,ve){return new _(ae,ve).minor},e.patch=function(ae,ve){return new _(ae,ve).patch},e.compare=Me,e.compareLoose=function(ae,ve){return Me(ae,ve,!0)},e.rcompare=function(ae,ve,be){return Me(ve,ae,be)},e.sort=function(ae,ve){return ae.sort(function(be,ze){return e.compare(be,ze,ve)})},e.rsort=function(ae,ve){return ae.sort(function(be,ze){return e.rcompare(be,ze,ve)})},e.gt=We,e.lt=Qe,e.eq=Te,e.neq=De,e.gte=ke,e.lte=oe,e.cmp=ce,e.Comparator=Y;var I={};function $(ae,ve){if(ae instanceof $)return ae.loose===ve?ae:new $(ae.raw,ve);if(ae instanceof Y)return new $(ae.value,ve);if(!(this instanceof $))return new $(ae,ve);if(this.loose=ve,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function H(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function q(ae,ve,be,ze,He,tt,xe,et,it,dt,Oe,st,X){return((ve=H(be)?"":H(ze)?">="+be+".0.0":H(He)?">="+be+"."+ze+".0":">="+ve)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Oe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Oe+"-"+st:"<="+et)).trim()}function J(ae,ve){for(var be=0;be<ae.length;be++)if(!ae[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<ae.length;be++)if(y(ae[be].semver),ae[be].semver!==I&&ae[be].semver.prerelease.length>0){var ze=ae[be].semver;if(ze.major===ve.major&&ze.minor===ve.minor&&ze.patch===ve.patch)return!0}return!1}return!0}function de(ae,ve,be){try{ve=new $(ve,be)}catch{return!1}return ve.test(ae)}function Se(ae,ve,be,ze){var He,tt,xe,et,it;switch(ae=new _(ae,ze),ve=new $(ve,ze),be){case">":He=We,tt=oe,xe=Qe,et=">",it=">=";break;case"<":He=Qe,tt=ke,xe=We,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(ae,ve,ze))return!1;for(var dt=0;dt<ve.set.length;++dt){var Oe=ve.set[dt],st=null,X=null;if(Oe.forEach(function(Q){Q.semver===I&&(Q=new Y(">=0.0.0")),st=st||Q,X=X||Q,He(Q.semver,st.semver,ze)?st=Q:xe(Q.semver,X.semver,ze)&&(X=Q)}),st.operator===et||st.operator===it||(!X.operator||X.operator===et)&&tt(ae,X.semver)||X.operator===it&&xe(ae,X.semver))return!1}return!0}Y.prototype.parse=function(ae){var ve=this.loose?O[V]:O[K],be=ae.match(ve);if(!be)throw new TypeError("Invalid comparator: "+ae);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new _(be[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return y("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new _(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,ve){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new $(ae.value,ve),de(this.value,be,ve);if(ae.operator==="")return be=new $(this.value,ve),de(ae.semver,be,ve);var ze=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,ve)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return ze||He||tt&&xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ae){var ve=this.loose;ae=ae.trim(),y("range",ae,ve);var be=ve?O[ue]:O[ge];ae=ae.replace(be,q),y("hyphen replace",ae),ae=ae.replace(O[ie],"$1$2$3"),y("comparator trim",ae,O[ie]),ae=(ae=(ae=ae.replace(O[Z],"$1~")).replace(O[F],"$1^")).split(/\s+/).join(" ");var ze=ve?O[V]:O[K],He=ae.split(" ").map(function(tt){return function(xe,et){return y("comp",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Oe){return function(st,X){y("caret",st,X);var Q=X?O[z]:O[B];return st.replace(Q,function(pe,Ne,$e,je,Je){var nt;return y("caret",st,pe,Ne,$e,je,Je),H(Ne)?nt="":H($e)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":H(je)?nt=Ne==="0"?">="+Ne+"."+$e+".0 <"+Ne+"."+(+$e+1)+".0":">="+Ne+"."+$e+".0 <"+(+Ne+1)+".0.0":Je?(y("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=Ne==="0"?$e==="0"?">="+Ne+"."+$e+"."+je+Je+" <"+Ne+"."+$e+"."+(+je+1):">="+Ne+"."+$e+"."+je+Je+" <"+Ne+"."+(+$e+1)+".0":">="+Ne+"."+$e+"."+je+Je+" <"+(+Ne+1)+".0.0"):(y("no pr"),nt=Ne==="0"?$e==="0"?">="+Ne+"."+$e+"."+je+" <"+Ne+"."+$e+"."+(+je+1):">="+Ne+"."+$e+"."+je+" <"+Ne+"."+(+$e+1)+".0":">="+Ne+"."+$e+"."+je+" <"+(+Ne+1)+".0.0"),y("caret return",nt),nt})}(Oe,dt)}).join(" ")}(xe,et),y("caret",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Oe){return function(st,X){var Q=X?O[R]:O[G];return st.replace(Q,function(pe,Ne,$e,je,Je){var nt;return y("tilde",st,pe,Ne,$e,je,Je),H(Ne)?nt="":H($e)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":H(je)?nt=">="+Ne+"."+$e+".0 <"+Ne+"."+(+$e+1)+".0":Je?(y("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=">="+Ne+"."+$e+"."+je+Je+" <"+Ne+"."+(+$e+1)+".0"):nt=">="+Ne+"."+$e+"."+je+" <"+Ne+"."+(+$e+1)+".0",y("tilde return",nt),nt})}(Oe,dt)}).join(" ")}(xe,et),y("tildes",xe),xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Oe){return function(st,X){st=st.trim();var Q=X?O[P]:O[g];return st.replace(Q,function(pe,Ne,$e,je,Je,nt){y("xRange",st,pe,Ne,$e,je,Je,nt);var wt=H($e),yt=wt||H(je),Ct=yt||H(Je);return Ne==="="&&Ct&&(Ne=""),wt?pe=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Ct?(yt&&(je=0),Ct&&(Je=0),Ne===">"?(Ne=">=",yt?($e=+$e+1,je=0,Je=0):Ct&&(je=+je+1,Je=0)):Ne==="<="&&(Ne="<",yt?$e=+$e+1:je=+je+1),pe=Ne+$e+"."+je+"."+Je):yt?pe=">="+$e+".0.0 <"+(+$e+1)+".0.0":Ct&&(pe=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),y("xRange return",pe),pe})}(Oe,dt)}).join(" ")}(xe,et),y("xrange",xe),xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(O[re],"")}(xe,et),y("stars",xe),xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(ze)})),He=He.map(function(tt){return new Y(tt,ve)})},$.prototype.intersects=function(ae,ve){if(!(ae instanceof $))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ze){return ae.set.some(function(He){return He.every(function(tt){return ze.intersects(tt,ve)})})})})},e.toComparators=function(ae,ve){return new $(ae,ve).set.map(function(be){return be.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var ve=0;ve<this.set.length;ve++)if(J(this.set[ve],ae))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(ae,ve,be){var ze=null,He=null;try{var tt=new $(ve,be)}catch{return null}return ae.forEach(function(xe){tt.test(xe)&&(ze&&He.compare(xe)!==-1||(He=new _(ze=xe,be)))}),ze},e.minSatisfying=function(ae,ve,be){var ze=null,He=null;try{var tt=new $(ve,be)}catch{return null}return ae.forEach(function(xe){tt.test(xe)&&(ze&&He.compare(xe)!==1||(He=new _(ze=xe,be)))}),ze},e.validRange=function(ae,ve){try{return new $(ae,ve).range||"*"}catch{return null}},e.ltr=function(ae,ve,be){return Se(ae,ve,"<",be)},e.gtr=function(ae,ve,be){return Se(ae,ve,">",be)},e.outside=Se,e.prerelease=function(ae,ve){var be=le(ae,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ae,ve,be){return ae=new $(ae,be),ve=new $(ve,be),ae.intersects(ve)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var ve=ae.match(O[N]);return ve==null?null:le((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,T,y=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function O(c){if(i===setTimeout)return setTimeout(c,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(c,0);try{return i(c,0)}catch{try{return i.call(null,c,0)}catch{return i.call(this,c,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var S,k=[],M=!1,D=-1;function m(){M&&S&&(M=!1,S.length?k=S.concat(k):D=-1,k.length&&v())}function v(){if(!M){var c=O(m);M=!0;for(var l=k.length;l;){for(S=k,k=[];++D<l;)S&&S[D].run();D=-1,l=k.length}S=null,M=!1,function(p){if(T===clearTimeout)return clearTimeout(p);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(p);try{T(p)}catch{try{return T.call(null,p)}catch{return T.call(this,p)}}}(c)}}function f(c,l){this.fun=c,this.array=l}function t(){}y.nextTick=function(c){var l=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)l[p-1]=arguments[p];k.push(new f(c,l)),k.length!==1||M||O(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=t,y.addListener=t,y.once=t,y.off=t,y.removeListener=t,y.removeAllListeners=t,y.emit=t,y.prependListener=t,y.prependOnceListener=t,y.listeners=function(c){return[]},y.binding=function(c){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(c){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ie[112],Ce([1,0,11,7]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(b){const w=b;return w?typeof w.read=="function":!1}e.isReadable=y;function L(b){const w=b;return w?[w.on,w.pause,w.resume,w.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function C(b){const w=b;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function O(b,w){return new S(b,w)}e.newWriteableStream=O;class S{constructor(w,r){this.e=w,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(r=>r(w))}h(w){this.c.error.length===0?(0,i.onUnexpectedError)(w):this.c.error.slice(0).forEach(r=>r(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,r){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(w,r){if(this.a.destroyed)return;let s;switch(w){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(r);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(b,w){const r=[];let s;for(;(s=b.read())!==null;)r.push(s);return w(r)}e.consumeReadable=k;function M(b,w,r){const s=[];let a;for(;(a=b.read())!==null&&s.length<r;)s.push(a);return a===null&&s.length>0?w(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return b.read()}}}e.peekReadable=M;function D(b,w){return new Promise((r,s)=>{const a=[];m(b,{onData:d=>{w&&a.push(d)},onError:d=>{w?s(d):r(void 0)},onEnd:()=>{r(w?w(a):void 0)}})})}e.consumeStream=D;function m(b,w){let r=!1;return b.on("error",s=>{r||w.onError(s)}),b.on("end",()=>{r||w.onEnd()}),b.on("data",s=>{r||w.onData(s)}),(0,T.toDisposable)(()=>r=!0)}e.listenStream=m;function v(b,w){return new Promise((r,s)=>{const a=new T.DisposableStore,d=[],o=h=>{if(d.push(h),d.length>w)return a.dispose(),b.pause(),r({stream:b,buffer:d,ended:!1})},u=h=>s(h),n=()=>r({stream:b,buffer:d,ended:!0});a.add((0,T.toDisposable)(()=>b.removeListener("error",u))),b.on("error",u),a.add((0,T.toDisposable)(()=>b.removeListener("end",n))),b.on("end",n),a.add((0,T.toDisposable)(()=>b.removeListener("data",o))),b.on("data",o)})}e.peekStream=v;function f(b,w){const r=O(w);return r.end(b),r}e.toStream=f;function t(){const b=O(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=t;function c(b){let w=!1;return{read:()=>w?null:(w=!0,b)}}e.toReadable=c;function l(b,w,r){const s=O(r);return m(b,{onData:a=>s.write(w.data(a)),onError:a=>s.error(w.error?w.error(a):a),onEnd:()=>s.end()}),s}e.transform=l;function p(b,w,r){let s=!1;return{read:()=>{const a=w.read();return s?a:(s=!0,a!==null?r([b,a]):b)}}}e.prefixedReadable=p;function E(b,w,r){let s=!1;const a=O(r);return m(w,{onData:d=>s?a.write(d):(s=!0,a.write(r([b,d]))),onError:d=>a.error(d),onEnd:()=>{s||(s=!0,a.write(b)),a.end()}}),a}e.prefixedStream=E}),define(Ie[24],Ce([1,0,112]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,L;class C{static alloc(h){return T?new C(Buffer.allocUnsafe(h)):new C(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new C(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(h)):(y||(y=new TextEncoder),new C(y.encode(h)))}static fromByteArray(h){const g=C.alloc(h.length);for(let P=0,N=h.length;P<N;P++)g.buffer[P]=h[P];return g}static concat(h,g){if(typeof g>"u"){g=0;for(let j=0,Z=h.length;j<Z;j++)g+=h[j].byteLength}const P=C.alloc(g);let N=0;for(let j=0,Z=h.length;j<Z;j++){const G=h[j];P.set(G,N),N+=G.byteLength}return P}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=C.alloc(this.byteLength);return h.set(this),h}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,g){return new C(this.buffer.subarray(h,g))}set(h,g){if(h instanceof C)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,g){M(this.buffer,h,g)}readUInt32LE(h){return D(this.buffer,h)}writeUInt32LE(h,g){m(this.buffer,h,g)}readUInt8(h){return v(this.buffer,h)}writeUInt8(h,g){f(this.buffer,h,g)}}e.VSBuffer=C;function O(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0}e.readUInt16LE=O;function S(n,h,g){n[g+0]=h&255,h=h>>>8,n[g+1]=h&255}e.writeUInt16LE=S;function k(n,h){return n[h]*2**24+n[h+1]*2**16+n[h+2]*2**8+n[h+3]}e.readUInt32BE=k;function M(n,h,g){n[g+3]=h,h=h>>>8,n[g+2]=h,h=h>>>8,n[g+1]=h,h=h>>>8,n[g]=h}e.writeUInt32BE=M;function D(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0|n[h+2]<<16>>>0|n[h+3]<<24>>>0}e.readUInt32LE=D;function m(n,h,g){n[g+0]=h&255,h=h>>>8,n[g+1]=h&255,h=h>>>8,n[g+2]=h&255,h=h>>>8,n[g+3]=h&255}e.writeUInt32LE=m;function v(n,h){return n[h]}e.readUInt8=v;function f(n,h,g){n[g]=h}e.writeUInt8=f;function t(n){return i.consumeReadable(n,h=>C.concat(h))}e.readableToBuffer=t;function c(n){return i.toReadable(n)}e.bufferToReadable=c;function l(n){return i.consumeStream(n,h=>C.concat(h))}e.streamToBuffer=l;async function p(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await l(n.stream)])}e.bufferedStreamToBuffer=p;function E(n){return i.toStream(n,h=>C.concat(h))}e.bufferToStream=E;function b(n){return i.transform(n,{data:h=>typeof h=="string"?C.fromString(h):C.wrap(h)},h=>C.concat(h))}e.streamToBufferReadableStream=b;function w(n){return i.newWriteableStream(h=>C.concat(h),n)}e.newWriteableBufferStream=w;function r(n,h){return i.prefixedReadable(n,h,g=>C.concat(g))}e.prefixedBufferReadable=r;function s(n,h){return i.prefixedStream(n,h,g=>C.concat(g))}e.prefixedBufferStream=s;function a(n){let h=0,g=0,P=0;const N=new Uint8Array(Math.floor(n.length/4*3)),j=G=>{switch(g){case 3:N[P++]=h|G,g=0;break;case 2:N[P++]=h|G>>>2,h=G<<6,g=3;break;case 1:N[P++]=h|G>>>4,h=G<<4,g=2;break;default:h=G<<2,g=1}};for(let G=0;G<n.length;G++){const R=n.charCodeAt(G);if(R>=65&&R<=90)j(R-65);else if(R>=97&&R<=122)j(R-97+26);else if(R>=48&&R<=57)j(R-48+52);else if(R===43||R===45)j(62);else if(R===47||R===95)j(63);else{if(R===61)break;throw new SyntaxError(`Unexpected base64 character ${n[G]}`)}}const Z=P;for(;g>0;)j(0);return C.wrap(N).slice(0,Z)}e.decodeBase64=a;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},h=!0,g=!1){const P=g?o:d;let N="";const j=n.byteLength%3;let Z=0;for(;Z<n.byteLength-j;Z+=3){const G=n[Z+0],R=n[Z+1],A=n[Z+2];N+=P[G>>>2],N+=P[(G<<4|R>>>4)&63],N+=P[(R<<2|A>>>6)&63],N+=P[A&63]}if(j===1){const G=n[Z+0];N+=P[G>>>2],N+=P[G<<4&63],h&&(N+="==")}else if(j===2){const G=n[Z+0],R=n[Z+1];N+=P[G>>>2],N+=P[(G<<4|R>>>4)&63],N+=P[R<<2&63],h&&(N+="=")}return N}e.encodeBase64=u}),define(Ie[34],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return i.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(O){for(let S=0;S<O.length;S++)O[S]=Math.floor(Math.random()*256);return O};const L=new Uint8Array(16),C=[];for(let O=0;O<256;O++)C.push(O.toString(16).padStart(2,"0"));return function(){y(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,k="";return k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k}}()}),define(Ie[113],Ce([1,0,16,34]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(O){return{id:(0,T.generateUuid)(),asString:async()=>O,asFile:()=>{},value:typeof O=="string"?O:void 0}}e.createStringDataTransferItem=y;function L(O,S,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:O,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=L;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const M=this.a.get(S);M?M.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const M of k)yield[S,M]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,M]of this.entries())S(M,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:O=>(0,i.distinct)(O.map(S=>S.toString())).join(`\r
`),split:O=>O.split(`\r
`),parse:O=>e.UriList.split(O).filter(S=>!S.startsWith("#"))})}),define(Ie[114],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[115],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class T{constructor(O){if(this.e=null,this.f=!1,this.open=O.open,this.close=O.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(O.notIn))for(let S=0,k=O.notIn.length;S<k;S++)switch(O.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(O,S){if(O.getTokenCount()===0)return!0;const k=O.findTokenIndexAtOffset(S-2),M=O.getStandardTokenType(k);return this.isOK(M)}g(O,S){for(let k=O;k<=S;k++){const M=String.fromCharCode(k);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of O)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function L(C,O,S){C.has(O)?C.get(O).push(S):C.set(O,[S])}}),define(Ie[116],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ie[117],Ce([1,0,116]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,L=y*24,C=L*7,O=L*30,S=L*365;function k(D,m,v){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,i.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,i.localize)(1,null);let t;return f<T?(t=f,m?t===1?v?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):v?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?v?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):v?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):f<y?(t=Math.floor(f/T),m?t===1?v?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):v?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?v?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):v?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):f<L?(t=Math.floor(f/y),m?t===1?v?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):v?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?v?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):v?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):f<C?(t=Math.floor(f/L),m?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):f<O?(t=Math.floor(f/C),m?t===1?v?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):v?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?v?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):v?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):f<S?(t=Math.floor(f/O),m?t===1?v?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):v?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?v?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):v?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(f/S),m?t===1?v?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):v?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?v?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):v?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function M(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Ie[118],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ie[45],Ce([1,0,16,9,118]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,m){return m&&(D.stack||D.stacktrace)?y.localize(0,null,O(D),C(D.stack)||C(D.stacktrace)):O(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function O(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,m=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const v=i.coalesce(D),f=S(v[0],m);return v.length>1?y.localize(4,null,f,v.length):f}if(T.isString(D))return D;if(D.detail){const v=D.detail;if(v.error)return L(v.error,m);if(v.exception)return L(v.exception,m)}return D.stack?L(D,m):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S;function k(D){const m=D;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function M(D,m){let v;return typeof D=="string"?v=new Error(D):v=D,v.actions=m,v}e.createErrorWithActions=M}),define(Ie[62],Ce([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(M){const D=(0,i.extname)(M),m=T[D.toLowerCase()];return m!==void 0?m:C(M)}e.getMediaOrTextMime=L;function C(M){const D=(0,i.extname)(M);return y[D.toLowerCase()]}e.getMediaMime=C;function O(M){for(const D in y)if(y[D]===M)return D}e.getExtensionForMimeType=O;const S=/^(.+)\/(.+?)(;.+)?$/;function k(M,D){const m=S.exec(M);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:D?void 0:M}e.normalizeMimeType=k}),define(Ie[39],Ce([1,0,19,21,10,9]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(o){return o===47||o===92}e.isPathSeparator=C;function O(o){return o.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=O;function S(o){return o.indexOf("/")===-1&&(o=O(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=S;function k(o,u=i.posix.sep){if(!o)return"";const n=o.length,h=o.charCodeAt(0);if(C(h)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let P=3;const N=P;for(;P<n&&!C(o.charCodeAt(P));P++);if(N!==P&&!C(o.charCodeAt(P+1))){for(P+=1;P<n;P++)if(C(o.charCodeAt(P)))return o.slice(0,P+1).replace(/[\\/]/g,u)}}return u}else if(l(h)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<n;g++)if(C(o.charCodeAt(g)))return o.slice(0,g+1)}return""}e.getRoot=k;function M(o){if(!T.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let n=2;const h=n;for(;n<o.length&&(u=o.charCodeAt(n),u!==92);n++);return!(h===n||(u=o.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=M;const D=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(o,u=T.isWindows){const n=u?D:m;return!(!o||o.length===0||/^\s+$/.test(o)||(n.lastIndex=0,n.test(o))||u&&v.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=f;function t(o,u,n){const h=o===u;return!n||h?h:!o||!u?!1:(0,y.equalsIgnoreCase)(o,u)}e.isEqual=t;function c(o,u,n,h=i.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let P=u.length;return u.charAt(u.length-1)===h&&P--,o.charAt(P)===h}return u.charAt(u.length-1)!==h&&(u+=h),o.indexOf(u)===0}e.isEqualOrParent=c;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function p(o,u){return T.isWindows&&o.endsWith(":")&&(o+=i.sep),(0,i.isAbsolute)(o)||(o=(0,i.join)(u,o)),o=(0,i.normalize)(o),T.isWindows?(o=(0,y.rtrim)(o,i.sep),o.endsWith(":")&&(o+=i.sep)):(o=(0,y.rtrim)(o,i.sep),o||(o=i.sep)),o}e.sanitizeFilePath=p;function E(o){const u=(0,i.normalize)(o);return T.isWindows?o.length>3?!1:b(u)&&(o.length===2||u.charCodeAt(2)===92):u===i.posix.sep}e.isRootOrDriveLetter=E;function b(o,u=T.isWindows){return u?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=b;function w(o){return b(o)?o[0]:void 0}e.getDriveLetter=w;function r(o,u,n){return u.length>o.length?-1:o===u?0:(n&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=r;function s(o){const u=o.split(":");let n,h,g;for(const P of u){const N=Number(P);(0,L.isNumber)(N)?h===void 0?h=N:g===void 0&&(g=N):n=n?[n,P].join(":"):P}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(o,u,n=8){let h="";for(let P=0;P<n;P++)h+=a.charAt(Math.floor(Math.random()*a.length));let g;return u?g=`${u}-${h}`:g=h,o?(0,i.join)(o,g):g}e.randomPath=d}),define(Ie[119],Ce([1,0,28,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(I,$){for(let H=0,q=Y.length;H<q;H++){const J=Y[H](I,$);if(J)return J}return null}}e.or=y,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Y,I,$){if(!$||$.length<I.length)return null;let H;return Y?H=T.startsWithIgnoreCase($,I):H=$.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function C(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=C;function O(Y,I){return S(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=O;function S(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]===I[H]){let q=null;return(q=S(Y,I,$+1,H+1))?l({start:H,end:H+1},q):null}return S(Y,I,$,H+1)}function k(Y){return 97<=Y&&Y<=122}function M(Y){return 65<=Y&&Y<=90}e.isUpper=M;function D(Y){return 48<=Y&&Y<=57}function m(Y){return Y===32||Y===9||Y===10||Y===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>v.add(Y.charCodeAt(0)));function f(Y){return m(Y)||v.has(Y)}function t(Y,I){return Y===I||f(Y)&&f(I)}function c(Y){return k(Y)||M(Y)||D(Y)}function l(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function p(Y,I){for(let $=I;$<Y.length;$++){const H=Y.charCodeAt($);if(M(H)||D(H)||$>0&&!c(Y.charCodeAt($-1)))return $}return Y.length}function E(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]!==I[H].toLowerCase())return null;{let q=null,J=H+1;for(q=E(Y,I,$+1,H+1);!q&&(J=p(I,J))<I.length;)q=E(Y,I,$+1,J),J++;return q===null?null:l({start:H,end:H+1},q)}}function b(Y){let I=0,$=0,H=0,q=0,J=0;for(let be=0;be<Y.length;be++)J=Y.charCodeAt(be),M(J)&&I++,k(J)&&$++,c(J)&&H++,D(J)&&q++;const de=I/Y.length,Se=$/Y.length,ae=H/Y.length,ve=q/Y.length;return{upperPercent:de,lowerPercent:Se,alphaPercent:ae,numericPercent:ve}}function w(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function r(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:H,numericPercent:q}=Y;return $>.2&&I<.8&&H>.6&&q<.2}function s(Y){let I=0,$=0,H=0,q=0;for(let J=0;J<Y.length;J++)H=Y.charCodeAt(J),M(H)&&I++,k(H)&&$++,m(H)&&q++;return(I===0||$===0)&&q===0?Y.length<=30:I<=5}function a(Y,I){if(!I||(I=I.trim(),I.length===0)||!s(Y)||I.length>60)return null;const $=b(I);if(!r($)){if(!w($))return null;I=I.toLowerCase()}let H=null,q=0;for(Y=Y.toLowerCase();q<I.length&&(H=E(Y,I,0,q))===null;)q=p(I,q+1);return H}e.matchesCamelCase=a;function d(Y,I,$=!1){if(!I||I.length===0)return null;let H=null,q=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();q<I.length&&(H=o(Y,I,0,q,$))===null;)q=u(I,q+1);return H}e.matchesWords=d;function o(Y,I,$,H,q){if($===Y.length)return[];if(H===I.length)return null;if(t(Y.charCodeAt($),I.charCodeAt(H))){let J=null,de=H+1;if(J=o(Y,I,$+1,H+1,q),!q)for(;!J&&(de=u(I,de))<I.length;)J=o(Y,I,$+1,de,q),de++;return J?Y.charCodeAt($)!==I.charCodeAt(H)?J:l({start:H,end:H+1},J):null}else return null}function u(Y,I){for(let $=I;$<Y.length;$++)if(f(Y.charCodeAt($))||$>0&&f(Y.charCodeAt($-1)))return $;return Y.length}const n=y(e.matchesPrefix,a,C),h=y(e.matchesPrefix,a,O),g=new i.LRUCache(1e4);function P(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let H=g.get(Y);H||(H=new RegExp(T.convertSimple2RegExpPattern(Y),"i"),g.set(Y,H));const q=H.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?h(Y,I):n(Y,I)}e.matchesFuzzy=P;function N(Y,I){const $=We(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?Z($):null}e.matchesFuzzy2=N;function j(Y,I,$,H,q,J){const de=Math.min(13,Y.length);for(;$<de;$++){const Se=We(Y,I,$,H,q,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Se)return Se}return[0,J]}e.anyScore=j;function Z(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let H=Y.length-1;H>1;H--){const q=Y[H]+$,J=I[I.length-1];J&&J.end===q?J.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=Z;const G=128;function R(){const Y=[],I=[];for(let $=0;$<=G;$++)I[$]=0;for(let $=0;$<=G;$++)Y.push(I.slice(0));return Y}function A(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const F=A(2*G),B=A(2*G),z=R(),V=R(),K=R(),ie=!1;function ge(Y,I,$,H,q){function J(Se,ae,ve=" "){for(;Se.length<ae;)Se=ve+Se;return Se}let de=` |   |${H.split("").map(Se=>J(Se,3)).join("|")}
`;for(let Se=0;Se<=$;Se++)Se===0?de+=" |":de+=`${I[Se-1]}|`,de+=Y[Se].slice(0,q+1).map(ae=>J(ae.toString(),3)).join("|")+`
`;return de}function ue(Y,I,$,H){Y=Y.substr(I),$=$.substr(H),console.log(ge(V,Y,Y.length,$,$.length)),console.log(ge(K,Y,Y.length,$,$.length)),console.log(ge(z,Y,Y.length,$,$.length))}function re(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise($)}}function se(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function le(Y,I,$){return I[Y]!==$[Y]}function _(Y,I,$,H,q,J,de=!1){for(;I<$&&q<J;)Y[I]===H[q]&&(de&&(F[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=_;var me;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(me||(me={}));var we;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(we=e.FuzzyScore||(e.FuzzyScore={}));class Me{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}e.FuzzyScoreOptions=Me,Me.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(Y,I,$,H,q,J,de=Me.default){const Se=Y.length>G?G:Y.length,ae=H.length>G?G:H.length;if($>=Se||J>=ae||Se-$>ae-J||!_(I,$,Se,q,J,ae,!0))return;Qe(Se,ae,$,J,I,q);let ve=1,be=1,ze=$,He=J;const tt=[!1];for(ve=1,ze=$;ze<Se;ve++,ze++){const Oe=F[ze],st=B[ze],X=ze+1<Se?B[ze+1]:ae;for(be=Oe-J+1,He=Oe;He<X;be++,He++){let Q=Number.MIN_SAFE_INTEGER,pe=!1;He<=st&&(Q=Te(Y,I,ze,$,H,q,He,ae,J,z[ve-1][be-1]===0,tt));let Ne=0;Q!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ne=Q+V[ve-1][be-1]);const $e=He>Oe,je=$e?V[ve][be-1]+(z[ve][be-1]>0?-5:0):0,Je=He>Oe+1&&z[ve][be-1]>0,nt=Je?V[ve][be-2]+(z[ve][be-2]>0?-5:0):0;if(Je&&(!$e||nt>=je)&&(!pe||nt>=Ne))V[ve][be]=nt,K[ve][be]=3,z[ve][be]=0;else if($e&&(!pe||je>=Ne))V[ve][be]=je,K[ve][be]=2,z[ve][be]=0;else if(pe)V[ve][be]=Ne,K[ve][be]=1,z[ve][be]=z[ve-1][be-1]+1;else throw new Error("not possible")}}if(ie&&ue(Y,$,H,J),!tt[0]&&!de.firstMatchCanBeWeak)return;ve--,be--;const xe=[V[ve][be],J];let et=0,it=0;for(;ve>=1;){let Oe=be;do{const st=K[ve][Oe];if(st===3)Oe=Oe-2;else if(st===2)Oe=Oe-1;else break}while(Oe>=1);et>1&&I[$+ve-1]===q[J+be-1]&&!le(Oe+J-1,H,q)&&et+1>z[ve][Oe]&&(Oe=be),Oe===be?et++:et=1,it||(it=Oe),ve--,be=Oe-1,xe.push(be)}ae===Se&&de.boostFullMatch&&(xe[0]+=2);const dt=it-Se;return xe[0]-=dt,xe}e.fuzzyScore=We;function Qe(Y,I,$,H,q,J){let de=Y-1,Se=I-1;for(;de>=$&&Se>=H;)q[de]===J[Se]&&(B[de]=Se,de--),Se--}function Te(Y,I,$,H,q,J,de,Se,ae,ve,be){if(I[$]!==J[de])return Number.MIN_SAFE_INTEGER;let ze=1,He=!1;return de===$-H?ze=Y[$]===q[de]?7:5:le(de,q,J)&&(de===0||!le(de-1,q,J))?(ze=Y[$]===q[de]?7:5,He=!0):re(J,de)&&(de===0||!re(J,de-1))?ze=5:(re(J,de-1)||se(J,de-1))&&(ze=5,He=!0),ze>1&&$===H&&(be[0]=!0),He||(He=le(de,q,J)||re(J,de-1)||se(J,de-1)),$===H?de>ae&&(ze-=He?3:5):ve?ze+=He?2:0:ze+=He?0:1,de+1===Se&&(ze-=He?3:5),ze}function De(Y,I,$,H,q,J,de){return oe(Y,I,$,H,q,J,!0,de)}e.fuzzyScoreGracefulAggressive=De;function ke(Y,I,$,H,q,J,de){return oe(Y,I,$,H,q,J,!1,de)}e.fuzzyScoreGraceful=ke;function oe(Y,I,$,H,q,J,de,Se){let ae=We(Y,I,$,H,q,J,Se);if(ae&&!de)return ae;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let be=$+1;be<ve;be++){const ze=ce(Y,be);if(ze){const He=We(ze,ze.toLowerCase(),$,H,q,J,Se);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],H=Y[I+1];if($!==H)return Y.slice(0,I)+H+$+Y.slice(I+2)}}),define(Ie[120],Ce([1,0,121,119,10]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",C=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${C.source}`,"g");function S(c){return c.replace(O,(l,p)=>p?l:`\\${l}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${C.source}`,"g");function M(c){return c.replace(k,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=M;const D=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function m(c){return c.indexOf(L)===-1?c:c.replace(D,(l,p,E,b)=>E?l:p||b||"")}e.stripIcons=m;const v=new RegExp(`\\$\\(${i.CSSIcon.iconNameCharacter}+\\)`,"g");function f(c){v.lastIndex=0;let l="";const p=[];let E=0;for(;;){const b=v.lastIndex,w=v.exec(c),r=c.substring(b,w?.index);if(r.length>0){l+=r;for(let s=0;s<r.length;s++)p.push(E)}if(!w)break;E+=w[0].length}return{text:l,iconOffsets:p}}e.parseLabelWithIcons=f;function t(c,l,p=!1){const{text:E,iconOffsets:b}=l;if(!b||b.length===0)return(0,T.matchesFuzzy)(c,E,p);const w=(0,y.ltrim)(E," "),r=E.length-w.length,s=(0,T.matchesFuzzy)(c,w,p);if(s)for(const a of s){const d=b[a.start+r]+r;a.start+=d,a.end+=d}return s}e.matchesFuzzyIconAware=t}),define(Ie[29],Ce([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const L="error",C="warning",O="warn",S="info",k="ignore";function M(m){return m?i.equalsIgnoreCase(L,m)?y.Error:i.equalsIgnoreCase(C,m)||i.equalsIgnoreCase(O,m)?y.Warning:i.equalsIgnoreCase(S,m)?y.Info:y.Ignore:y.Ignore}y.fromValue=M;function D(m){switch(m){case y.Error:return L;case y.Warning:return C;case y.Info:return S;default:return k}}y.toString=D}(T||(T={})),e.default=T}),define(Ie[46],Ce([1,0,16,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const f=v.charCodeAt(0),t=this.b.charCodeAt(this.c);return f-t}value(){return this.b[this.c]}}e.StringIterator=y;class L{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.compareSubstring)(v,this.b,0,v.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class C{constructor(v=!0,f=!0){this.f=v,this.g=f}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let f=v.length-1;f>=0;f--,this.c--){const t=this.b.charCodeAt(f);if(!(t===47||this.f&&t===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.compareSubstring)(v,this.b,0,v.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var O;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(O||(O={}));class S{constructor(v,f){this.f=v,this.g=f,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.compare)(v,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(M||(M={}));class D{static forUris(v=()=>!1,f=()=>!1){return new D(new S(v,f))}static forPaths(v=!1){return new D(new C(void 0,!v))}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new L)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,f){if(f){const t=f.slice(0);(0,i.shuffle)(t);for(const c of t)this.set(c,v)}else{const t=v.slice(0);(0,i.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(v,f){const t=this.b.reset(v);let c;this.c||(this.c=new k,this.c.segment=t.value());const l=[];for(c=this.c;;){const E=t.cmp(c.segment);if(E>0)c.left||(c.left=new k,c.left.segment=t.value()),l.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new k,c.right.segment=t.value()),l.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new k,c.mid.segment=t.value()),l.push([0,c]),c=c.mid;else break}const p=c.value;c.value=f,c.key=v;for(let E=l.length-1;E>=0;E--){const b=l[E][1];b.updateHeight();const w=b.balanceFactor();if(w<-1||w>1){const r=l[E][0],s=l[E+1][0];if(r===1&&s===1)l[E][1]=b.rotateLeft();else if(r===-1&&s===-1)l[E][1]=b.rotateRight();else if(r===1&&s===-1)b.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=b.rotateLeft();else if(r===-1&&s===1)b.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=b.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return p}get(v){return this.d(v)?.value}d(v){const f=this.b.reset(v);let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else break}return t}has(v){const f=this.d(v);return!(f?.value===void 0&&f?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,f){const t=this.b.reset(v),c=[];let l=this.c;for(;l;){const p=t.cmp(l.segment);if(p>0)c.push([-1,l]),l=l.left;else if(p<0)c.push([1,l]),l=l.right;else if(t.hasNext())t.next(),c.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const p=this.f(l.right);if(p.key){const{key:E,value:b,segment:w}=p;this.e(p.key,!1),l.key=E,l.value=b,l.segment=w}}else{const p=l.left??l.right;if(c.length>0){const[E,b]=c[c.length-1];switch(E){case-1:b.left=p;break;case 0:b.mid=p;break;case 1:b.right=p;break}}else this.c=p}for(let p=c.length-1;p>=0;p--){const E=c[p][1];E.updateHeight();const b=E.balanceFactor();if(b>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),c[p][1]=E.rotateLeft()):b<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),c[p][1]=E.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this.c=c[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const f=this.b.reset(v);let t=this.c,c;for(;t;){const l=f.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(f.hasNext())f.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(v){const f=this.b.reset(v);let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.g(t.mid):void 0}}forEach(v){for(const[f,t]of this)v(t,f)}*[Symbol.iterator](){yield*this.g(this.c)}g(v){const f=[];return this.h(v,f),f[Symbol.iterator]()}h(v,f){!v||(v.left&&this.h(v.left,f),v.value&&f.push([v.key,v.value]),v.mid&&this.h(v.mid,f),v.right&&this.h(v.right,f))}_isBalanced(){const v=f=>{if(!f)return!0;const t=f.balanceFactor();return t<-1||t>1?!1:v(f.left)&&v(f.right)};return v(this.c)}}e.TernarySearchTree=D}),define(Ie[81],Ce([1,0,24,10,2]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,O)}e.stringify=L;function C(k){let M=JSON.parse(k);return M=S(M),M}e.parse=C;function O(k,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,T.regExpFlags)(M)}:M}function S(k,M=0){if(!k||M>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=S(k[D],M+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=S(k[D],M+1))}return k}e.revive=S}),define(Ie[13],Ce([1,0,21,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,M,D){this.a[k]=M,this.b[k]=D}setConnectionToken(k,M){this.c[k]=M}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const M=k.authority;let D=this.a[M];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const m=this.b[M],v=this.c[M];let f=`path=${encodeURIComponent(k.path)}`;return typeof v=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),T.URI.from({scheme:i.isWeb?this.d:y.vscodeRemoteResource,authority:`${D}:${m}`,path:this.f,query:f})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const M=this.b(k,ee);return this.uriToBrowserUri(M)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const M=this.b(k,ee);return this.uriToFileUri(M)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,M){return T.URI.isUri(k)?k:T.URI.parse(M.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var O;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const M="vscode-coi";function D(v){let f;typeof v=="string"?f=new URL(v).searchParams:v instanceof URL?f=v.searchParams:T.URI.isUri(v)&&(f=new URL(v.toString(!0)).searchParams);const t=f?.get(M);if(!!t)return k.get(t)}S.getHeadersFromQuery=D;function m(v,f,t){if(!globalThis.crossOriginIsolated)return;const c=f&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(M,c):v[M]=c}S.addSearchParam=m})(O=e.COI||(e.COI={}))}),define(Ie[22],Ce([1,0,39,13,19,21,10,2]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,O.uriToFsPath)(v,!0)}e.originalFSPath=S;class k{constructor(f){this.a=f}compare(f,t,c=!1){return f===t?0:(0,C.compare)(this.getComparisonKey(f,c),this.getComparisonKey(t,c))}isEqual(f,t,c=!1){return f===t?!0:!f||!t?!1:this.getComparisonKey(f,c)===this.getComparisonKey(t,c)}getComparisonKey(f,t=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,t,c=!1){if(f.scheme===t.scheme){if(f.scheme===T.Schemas.file)return i.isEqualOrParent(S(f),S(t),this.a(f))&&f.query===t.query&&(c||f.fragment===t.fragment);if((0,e.isEqualAuthority)(f.authority,t.authority))return i.isEqualOrParent(f.path,t.path,this.a(f),"/")&&f.query===t.query&&(c||f.fragment===t.fragment)}return!1}joinPath(f,...t){return O.URI.joinPath(f,...t)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let t;return f.scheme===T.Schemas.file?t=O.URI.file(y.dirname(S(f))).path:(t=y.posix.dirname(f.path),f.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),t="/")),f.with({path:t})}normalizePath(f){if(!f.path.length)return f;let t;return f.scheme===T.Schemas.file?t=O.URI.file(y.normalize(S(f))).path:t=y.posix.normalize(f.path),f.with({path:t})}relativePath(f,t){if(f.scheme!==t.scheme||!(0,e.isEqualAuthority)(f.authority,t.authority))return;if(f.scheme===T.Schemas.file){const p=y.relative(S(f),S(t));return L.isWindows?i.toSlashes(p):p}let c=f.path||"/";const l=t.path||"/";if(this.a(f)){let p=0;for(const E=Math.min(c.length,l.length);p<E&&!(c.charCodeAt(p)!==l.charCodeAt(p)&&c.charAt(p).toLowerCase()!==l.charAt(p).toLowerCase());p++);c=l.substr(0,p)+c.substr(p)}return y.posix.relative(c,l)}resolvePath(f,t){if(f.scheme===T.Schemas.file){const c=O.URI.file(y.resolve(S(f),t));return f.with({authority:c.authority,path:c.path})}return t=i.toPosixPath(t),f.with({path:y.posix.resolve(f.path,t)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,t){return f===t||f!==void 0&&t!==void 0&&(0,C.equalsIgnoreCase)(f,t)}hasTrailingPathSeparator(f,t=y.sep){if(f.scheme===T.Schemas.file){const c=S(f);return c.length>i.getRoot(c).length&&c[c.length-1]===t}else{const c=f.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,t=y.sep){return(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,t=y.sep){let c=!1;if(f.scheme===T.Schemas.file){const l=S(f);c=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===t}else{t="/";const l=f.path;c=l.length===1&&l.charCodeAt(l.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(v=>v.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(v,f){const t=[];for(let c=0;c<v.length;c++){const l=f(v[c]);v.some((p,E)=>E===c?!1:(0,e.isEqualOrParent)(l,f(p)))||t.push(v[c])}return t}e.distinctParents=M;var D;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function f(t){const c=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(E=>{const[b,w]=E.split(":");b&&w&&c.set(b,w)});const p=t.path.substring(0,t.path.indexOf(";"));return p&&c.set(v.META_DATA_MIME,p),c}v.parseMetaData=f})(D=e.DataUri||(e.DataUri={}));function m(v,f,t){if(f){let c=v.path;return c&&c[0]!==y.posix.sep&&(c=y.posix.sep+c),v.with({scheme:t,authority:f,path:c})}return v.with({scheme:t})}e.toLocalResource=m}),define(Ie[14],Ce([1,0,20,11,5,7,22,21]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(le){return!!le&&typeof le.then=="function"}e.isThenable=S;function k(le){const _=new i.CancellationTokenSource,me=le(_.token),we=new Promise((Me,We)=>{const Qe=_.token.onCancellationRequested(()=>{Qe.dispose(),_.dispose(),We(new T.CancellationError)});Promise.resolve(me).then(Te=>{Qe.dispose(),_.dispose(),Me(Te)},Te=>{Qe.dispose(),_.dispose(),We(Te)})});return new class{cancel(){_.cancel()}then(Me,We){return we.then(Me,We)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=k;function M(le,_,me){return new Promise((we,Me)=>{const We=_.onCancellationRequested(()=>{We.dispose(),we(me)});le.then(we,Me).finally(()=>We.dispose())})}e.raceCancellation=M;function D(le,_){return new Promise((me,we)=>{const Me=_.onCancellationRequested(()=>{Me.dispose(),we(new T.CancellationError)});le.then(me,we).finally(()=>Me.dispose())})}e.raceCancellationError=D;async function m(le){let _=-1;const me=le.map((Me,We)=>Me.then(Qe=>(_=We,Qe))),we=await Promise.race(me);return le.forEach((Me,We)=>{We!==_&&Me.cancel()}),we}e.raceCancellablePromises=m;function v(le,_,me){let we;const Me=setTimeout(()=>{we?.(void 0),me?.()},_);return Promise.race([le.finally(()=>clearTimeout(Me)),new Promise(We=>we=We)])}e.raceTimeout=v;function f(le){return new Promise((_,me)=>{const we=le();S(we)?we.then(_,me):_(we)})}e.asPromise=f;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(_){if(this.a){if(this.d=_,!this.b){const me=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(me,me).then(we)})}return new Promise((me,we)=>{this.b.then(me,we)})}return this.a=_(),new Promise((me,we)=>{this.a.then(Me=>{this.a=null,me(Me)},Me=>{this.a=null,we(Me)})})}}e.Throttler=t;class c{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.Sequencer=c;class l{constructor(){this.a=new Map}queue(_,me){const Me=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(_)===Me&&this.a.delete(_)});return this.a.set(_,Me),Me}}e.SequencerByKey=l;const p=(le,_)=>{let me=!0;const we=setTimeout(()=>{me=!1,_()},le);return{isTriggered:()=>me,dispose:()=>{clearTimeout(we),me=!1}}},E=le=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,le())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class b{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,me=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise((Me,We)=>{this.d=Me,this.f=We}).then(()=>{if(this.b=null,this.d=null,this.g){const Me=this.g;return this.g=null,Me()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=me===e.MicrotaskDelay?E(we):p(me,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(_){this.a=new b(_),this.b=new t}trigger(_,me){return this.a.trigger(()=>this.b.queue(_),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class r{constructor(){this.a=!1,this.b=new Promise((_,me)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class s extends r{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function a(le,_){return _?new Promise((me,we)=>{const Me=setTimeout(()=>{We.dispose(),me()},le),We=_.onCancellationRequested(()=>{clearTimeout(Me),We.dispose(),we(new T.CancellationError)})}):k(me=>a(le,me))}e.timeout=a;function d(le,_=0){const me=setTimeout(le,_);return(0,L.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=d;function o(le){const _=[];let me=0;const we=le.length;function Me(){return me<we?le[me++]():null}function We(Qe){Qe!=null&&_.push(Qe);const Te=Me();return Te?Te.then(We):Promise.resolve(_)}return Promise.resolve(null).then(We)}e.sequence=o;function u(le,_=we=>!!we,me=null){let we=0;const Me=le.length,We=()=>{if(we>=Me)return Promise.resolve(me);const Qe=le[we++];return Promise.resolve(Qe()).then(De=>_(De)?Promise.resolve(De):We())};return We()}e.first=u;function n(le,_=we=>!!we,me=null){if(le.length===0)return Promise.resolve(me);let we=le.length;const Me=()=>{we=-1;for(const We of le)We.cancel?.()};return new Promise((We,Qe)=>{for(const Te of le)Te.then(De=>{--we>=0&&_(De)?(Me(),We(De)):we===0&&We(me)}).catch(De=>{--we>=0&&(Me(),Qe(De))})})}e.firstParallel=n;class h{constructor(_){this.a=0,this.d=_,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(_){return this.a++,new Promise((me,we)=>{this.f.push({factory:_,c:me,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const _=this.f.shift();this.b++;const me=_.factory();me.then(_.c,_.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const _=new K;return this.b.add(_),_.p}d(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueFor(_,me=C.extUri){const we=me.getComparisonKey(_);let Me=this.a.get(we);return Me||(Me=new g,y.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,Me)),Me}f(){!this.d()||this.g()}g(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.g()}}e.ResourceQueue=P;class N{constructor(_,me){this.a=-1,typeof _=="function"&&typeof me=="number"&&this.setIfNotSet(_,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},me)}setIfNotSet(_,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},me))}}e.TimeoutTimer=N;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(_,me){this.cancel(),this.a=setInterval(()=>{_()},me)}}e.IntervalTimer=j;class Z{constructor(_,me){this.b=-1,this.a=_,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class G{constructor(_,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=_,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class R extends Z{constructor(_,me){super(_,me),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=R;class A extends L.Disposable{constructor(_,me){super(),this.g=_,this.h=me,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(..._),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=A,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,O.setTimeout0)(()=>{if(_)return;const me=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(le,_)=>{const me=requestIdleCallback(le,typeof _=="number"?{timeout:_}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(me))}}}}();class F{constructor(_){this.d=!1,this.a=()=>{try{this.f=_()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function B(le,_,me){let we;for(let Me=0;Me<me;Me++)try{return await le()}catch(We){we=We,await a(_)}throw we}e.retry=B;class z{hasPending(_){return this.a?typeof _=="number"?this.a.taskId===_:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(_,me,we){return this.a={taskId:_,cancel:()=>we?.(),promise:me},me.then(()=>this.d(_),()=>this.d(_)),me}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this.b)this.b.run=_;else{let me,we;const Me=new Promise((We,Qe)=>{me=We,we=Qe});this.b={run:_,promise:Me,promiseResolve:me,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class V{constructor(_,me=()=>Date.now()){this.d=_,this.f=me,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((_,me)=>{this.a=_,this.b=me})}complete(_){return new Promise(me=>{this.a(_),this.f=!0,me()})}error(_){return new Promise(me=>{this.b(_),this.d=!0,me()})}cancel(){new Promise(_=>{this.b(new T.CancellationError),this.d=!0,_()})}}e.DeferredPromise=K;var ie;(function(le){async function _(we){let Me;const We=await Promise.all(we.map(Qe=>Qe.then(Te=>Te,Te=>{Me||(Me=Te)})));if(typeof Me<"u")throw Me;return We}le.settled=_;function me(we){return new Promise(async(Me,We)=>{try{await we(Me,We)}catch(Qe){We(Qe)}})}le.withAsyncBody=me})(ie=e.Promises||(e.Promises={}));var ge;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(ge||(ge={}));class ue{static fromArray(_){return new ue(me=>{me.emitMany(_)})}static fromPromise(_){return new ue(async me=>{me.emitMany(await _)})}static fromPromises(_){return new ue(async me=>{await Promise.all(_.map(async we=>me.emitOne(await we)))})}static merge(_){return new ue(async me=>{await Promise.all(_.map(async we=>{for await(const Me of we)me.emitOne(Me)}))})}constructor(_){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const me={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(_(me)),this.j()}catch(we){this.k(we)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(_,me){return new ue(async we=>{for await(const Me of _)we.emitOne(me(Me))})}map(_){return ue.map(this,_)}static filter(_,me){return new ue(async we=>{for await(const Me of _)me(Me)&&we.emitOne(Me)})}filter(_){return ue.filter(this,_)}static coalesce(_){return ue.filter(_,me=>!!me)}coalesce(){return ue.coalesce(this)}static async toPromise(_){const me=[];for await(const we of _)me.push(we);return me}toPromise(){return ue.toPromise(this)}g(_){this.a===0&&(this.b.push(_),this.f.fire())}h(_){this.a===0&&(this.b=this.b.concat(_),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(_){this.a===0&&(this.a=2,this.d=_,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class re extends ue{constructor(_,me){super(me),this.l=_}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function se(le){const _=new i.CancellationTokenSource,me=le(_.token);return new re(_,async we=>{const Me=_.token.onCancellationRequested(()=>{Me.dispose(),_.dispose(),we.reject(new T.CancellationError)});try{for await(const We of me){if(_.token.isCancellationRequested)return;we.emitOne(We)}Me.dispose(),_.dispose()}catch(We){Me.dispose(),_.dispose(),we.reject(We)}})}e.createCancelableAsyncIterable=se}),define(Ie[122],Ce([1,0,14,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(h,g,P=!1){const N=h||"",j=g||"",Z=y.value.collator.compare(N,j);return y.value.collatorIsNumeric&&Z===0&&N!==j?N<j?-1:1:Z}e.compareFileNames=O;function S(h,g){const P=L.value.collator;return h=h||"",g=g||"",b(P,h,g)}e.compareFileNamesDefault=S;function k(h,g){const P=L.value.collator;return h=h||"",g=g||"",a(h,g)||b(P,h,g)}e.compareFileNamesUpper=k;function M(h,g){const P=L.value.collator;return h=h||"",g=g||"",s(h,g)||b(P,h,g)}e.compareFileNamesLower=M;function D(h,g){return h=h||"",g=g||"",h===g?0:h<g?-1:1}e.compareFileNamesUnicode=D;function m(h,g){const[P,N]=p(h),[j,Z]=p(g);let G=y.value.collator.compare(N,Z);if(G===0){if(y.value.collatorIsNumeric&&N!==Z)return N<Z?-1:1;if(G=y.value.collator.compare(P,j),y.value.collatorIsNumeric&&G===0&&P!==j)return P<j?-1:1}return G}e.compareFileExtensions=m;function v(h,g){h=h||"",g=g||"";const P=E(h),N=E(g),j=L.value.collator,Z=C.value.collator;return b(Z,P,N)||b(j,h,g)}e.compareFileExtensionsDefault=v;function f(h,g){h=h||"",g=g||"";const P=E(h),N=E(g),j=L.value.collator,Z=C.value.collator;return b(Z,P,N)||a(h,g)||b(j,h,g)}e.compareFileExtensionsUpper=f;function t(h,g){h=h||"",g=g||"";const P=E(h),N=E(g),j=L.value.collator,Z=C.value.collator;return b(Z,P,N)||s(h,g)||b(j,h,g)}e.compareFileExtensionsLower=t;function c(h,g){h=h||"",g=g||"";const P=E(h).toLowerCase(),N=E(g).toLowerCase();return P!==N?P<N?-1:1:h!==g?h<g?-1:1:0}e.compareFileExtensionsUnicode=c;const l=/^(.*?)(\.([^.]*))?$/;function p(h,g=!1){const P=h?l.exec(h):[];let N=[P&&P[1]||"",P&&P[3]||""];return g&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function E(h){const g=h?l.exec(h):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function b(h,g,P){const N=h.compare(g,P);return N!==0?N:g.length!==P.length?g.length<P.length?-1:1:0}function w(h){const g=h.charAt(0);return g.toLocaleUpperCase()!==g}function r(h){const g=h.charAt(0);return g.toLocaleLowerCase()!==g}function s(h,g){return w(h)&&r(g)?-1:r(h)&&w(g)?1:0}function a(h,g){return r(h)&&w(g)?-1:w(h)&&r(g)?1:0}function d(h,g,P=!1){return P||(h=h&&h.toLowerCase(),g=g&&g.toLowerCase()),h===g?0:h<g?-1:1}function o(h,g,P=!1){const N=h.split(T.sep),j=g.split(T.sep),Z=N.length-1,G=j.length-1;let R,A;for(let F=0;;F++){if(R=Z===F,A=G===F,R&&A)return O(N[F],j[F],P);if(R)return-1;if(A)return 1;const B=d(N[F],j[F],P);if(B!==0)return B}}e.comparePaths=o;function u(h,g,P){const N=h.toLowerCase(),j=g.toLowerCase(),Z=n(h,g,P);if(Z)return Z;const G=N.endsWith(P),R=j.endsWith(P);if(G!==R)return G?-1:1;const A=O(N,j);return A!==0?A:N.localeCompare(j)}e.compareAnything=u;function n(h,g,P){const N=h.toLowerCase(),j=g.toLowerCase(),Z=N.startsWith(P),G=j.startsWith(P);if(Z!==G)return Z?-1:1;if(Z&&G){if(N.length<j.length)return-1;if(N.length>j.length)return 1}return 0}e.compareByPrefix=n}),define(Ie[35],Ce([1,0,16,14,39,28,19,21,10]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",D="[^/\\\\]",m=/\//g;function v(K,ie){switch(K){case 0:return"";case 1:return`${D}*?`;default:return`(?:${M}|${D}+${M}${ie?`|${M}${D}+`:""})*?`}}function f(K,ie){if(!K)return[];const ge=[];let ue=!1,re=!1,se="";for(const le of K){switch(le){case ie:if(!ue&&!re){ge.push(se),se="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":re=!0;break;case"]":re=!1;break}se+=le}return se&&ge.push(se),ge}e.splitGlobAware=f;function t(K){if(!K)return"";let ie="";const ge=f(K,e.GLOB_SPLIT);if(ge.every(ue=>ue===e.GLOBSTAR))ie=".*";else{let ue=!1;ge.forEach((re,se)=>{if(re===e.GLOBSTAR){if(ue)return;ie+=v(2,se===ge.length-1)}else{let le=!1,_="",me=!1,we="";for(const Me of re){if(Me!=="}"&&le){_+=Me;continue}if(me&&(Me!=="]"||!we)){let We;Me==="-"?We=Me:(Me==="^"||Me==="!")&&!we?We="^":Me===e.GLOB_SPLIT?We="":We=(0,S.escapeRegExpCharacters)(Me),we+=We;continue}switch(Me){case"{":le=!0;continue;case"[":me=!0;continue;case"}":{ie+=`(?:${f(_,",").map(Te=>t(Te)).join("|")})`,le=!1,_="";break}case"]":{ie+="["+we+"]",me=!1,we="";break}case"?":ie+=D;continue;case"*":ie+=v(1);continue;default:ie+=(0,S.escapeRegExpCharacters)(Me)}}se<ge.length-1&&(ge[se+1]!==e.GLOBSTAR||se+2<ge.length)&&(ie+=M)}ue=re===e.GLOBSTAR})}return ie}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),s=function(){return!1},a=function(){return null};function d(K,ie){if(!K)return a;let ge;typeof K!="string"?ge=K.pattern:ge=K,ge=ge.trim();const ue=`${ge}_${!!ie.trimForExclusions}`;let re=r.get(ue);if(re)return o(re,K);let se;return c.test(ge)?re=n(ge.substr(4),ge):(se=l.exec(u(ge,ie)))?re=h(se[1],ge):(ie.trimForExclusions?E:p).test(ge)?re=g(ge,ie):(se=b.exec(u(ge,ie)))?re=P(se[1].substr(1),ge,!0):(se=w.exec(u(ge,ie)))?re=P(se[1],ge,!1):re=N(ge),r.set(ue,re),o(re,K)}function o(K,ie){if(typeof ie=="string")return K;const ge=function(ue,re){return(0,y.isEqualOrParent)(ue,ie.base,!O.isLinux)?K((0,S.ltrim)(ue.substr(ie.base.length),C.sep),re):null};return ge.allBasenames=K.allBasenames,ge.allPaths=K.allPaths,ge.basenames=K.basenames,ge.patterns=K.patterns,ge}function u(K,ie){return ie.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function n(K,ie){return function(ge,ue){return typeof ge=="string"&&ge.endsWith(K)?ie:null}}function h(K,ie){const ge=`/${K}`,ue=`\\${K}`,re=function(le,_){return typeof le!="string"?null:_?_===K?ie:null:le===K||le.endsWith(ge)||le.endsWith(ue)?ie:null},se=[K];return re.basenames=se,re.patterns=[ie],re.allBasenames=se,re}function g(K,ie){const ge=z(K.slice(1,-1).split(",").map(_=>d(_,ie)).filter(_=>_!==a),K),ue=ge.length;if(!ue)return a;if(ue===1)return ge[0];const re=function(_,me){for(let we=0,Me=ge.length;we<Me;we++)if(ge[we](_,me))return K;return null},se=ge.find(_=>!!_.allBasenames);se&&(re.allBasenames=se.allBasenames);const le=ge.reduce((_,me)=>me.allPaths?_.concat(me.allPaths):_,[]);return le.length&&(re.allPaths=le),re}function P(K,ie,ge){const ue=C.sep===C.posix.sep,re=ue?K:K.replace(m,C.sep),se=C.sep+re,le=C.posix.sep+K;let _;return ge?_=function(me,we){return typeof me=="string"&&(me===re||me.endsWith(se)||!ue&&(me===K||me.endsWith(le)))?ie:null}:_=function(me,we){return typeof me=="string"&&(me===re||!ue&&me===K)?ie:null},_.allPaths=[(ge?"*/":"./")+K],_}function N(K){try{const ie=new RegExp(`^${t(K)}$`);return function(ge){return ie.lastIndex=0,typeof ge=="string"&&ie.test(ge)?K:null}}catch{return a}}function j(K,ie,ge){return!K||typeof ie!="string"?!1:Z(K)(ie,void 0,ge)}e.match=j;function Z(K,ie={}){if(!K)return s;if(typeof K=="string"||G(K)){const ge=d(K,ie);if(ge===a)return s;const ue=function(re,se){return!!ge(re,se)};return ge.allBasenames&&(ue.allBasenames=ge.allBasenames),ge.allPaths&&(ue.allPaths=ge.allPaths),ue}return F(K,ie)}e.parse=Z;function G(K){const ie=K;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=G;function R(K){return K.allBasenames||[]}e.getBasenameTerms=R;function A(K){return K.allPaths||[]}e.getPathTerms=A;function F(K,ie){const ge=z(Object.getOwnPropertyNames(K).map(_=>B(_,K[_],ie)).filter(_=>_!==a)),ue=ge.length;if(!ue)return a;if(!ge.some(_=>!!_.requiresSiblings)){if(ue===1)return ge[0];const _=function(Me,We){let Qe;for(let Te=0,De=ge.length;Te<De;Te++){const ke=ge[Te](Me,We);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(Qe||(Qe=[]),Qe.push(ke))}return Qe?(async()=>{for(const Te of Qe){const De=await Te;if(typeof De=="string")return De}return null})():null},me=ge.find(Me=>!!Me.allBasenames);me&&(_.allBasenames=me.allBasenames);const we=ge.reduce((Me,We)=>We.allPaths?Me.concat(We.allPaths):Me,[]);return we.length&&(_.allPaths=we),_}const re=function(_,me,we){let Me,We;for(let Qe=0,Te=ge.length;Qe<Te;Qe++){const De=ge[Qe];De.requiresSiblings&&we&&(me||(me=(0,C.basename)(_)),Me||(Me=me.substr(0,me.length-(0,C.extname)(_).length)));const ke=De(_,me,Me,we);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(We||(We=[]),We.push(ke))}return We?(async()=>{for(const Qe of We){const Te=await Qe;if(typeof Te=="string")return Te}return null})():null},se=ge.find(_=>!!_.allBasenames);se&&(re.allBasenames=se.allBasenames);const le=ge.reduce((_,me)=>me.allPaths?_.concat(me.allPaths):_,[]);return le.length&&(re.allPaths=le),re}function B(K,ie,ge){if(ie===!1)return a;const ue=d(K,ge);if(ue===a)return a;if(typeof ie=="boolean")return ue;if(ie){const re=ie.when;if(typeof re=="string"){const se=(le,_,me,we)=>{if(!we||!ue(le,_))return null;const Me=re.replace("$(basename)",()=>me),We=we(Me);return(0,T.isThenable)(We)?We.then(Qe=>Qe?K:null):We?K:null};return se.requiresSiblings=!0,se}}return ue}function z(K,ie){const ge=K.filter(_=>!!_.basenames);if(ge.length<2)return K;const ue=ge.reduce((_,me)=>{const we=me.basenames;return we?_.concat(we):_},[]);let re;if(ie){re=[];for(let _=0,me=ue.length;_<me;_++)re.push(ie)}else re=ge.reduce((_,me)=>{const we=me.patterns;return we?_.concat(we):_},[]);const se=function(_,me){if(typeof _!="string")return null;if(!me){let Me;for(Me=_.length;Me>0;Me--){const We=_.charCodeAt(Me-1);if(We===47||We===92)break}me=_.substr(Me)}const we=ue.indexOf(me);return we!==-1?re[we]:null};se.basenames=ue,se.patterns=re,se.allBasenames=ue;const le=K.filter(_=>!_.basenames);return le.push(se),le}function V(K,ie){return(0,i.equals)(K,ie,(ge,ue)=>typeof ge=="string"&&typeof ue=="string"?ge===ue:typeof ge!="string"&&typeof ue!="string"?ge.base===ue.base&&ge.pattern===ue.pattern:!1)}e.patternsEquals=V}),define(Ie[82],Ce([1,0,11,120,22,10,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var O;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(O=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",p=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(l,p=0){return this.value+=m(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,p){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(l,p,E){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,p){const E=new RegExp((0,L.escapeRegExpCharacters)(p),"g");return l.replace(E,(b,w)=>l.charAt(w-1)!=="\\"?`\\${b}`:b)}}e.MarkdownString=S;function k(c){return M(c)?!c.value:Array.isArray(c)?c.every(k):!0}e.isEmptyMarkdownString=k;function M(c){return c instanceof S?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=M;function D(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,y.isEqual)(C.URI.from(c.baseUri),C.URI.from(l.baseUri)))}e.markdownStringEqual=D;function m(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function v(c){return c.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=v;function f(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function t(c){const l=[],p=c.split("|").map(b=>b.trim());c=p[0];const E=p[1];if(E){const b=/height=(\d+)/.exec(E),w=/width=(\d+)/.exec(E),r=b?b[1]:"",s=w?w[1]:"",a=isFinite(parseInt(s)),d=isFinite(parseInt(r));a&&l.push(`width="${s}"`),d&&l.push(`height="${r}"`)}return{href:c,dimensions:l}}e.parseHrefAndDimensions=t}),define(Ie[83],Ce([1,0,16,39,19,21,22,10]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(a,d){const{os:o,tildify:u,relative:n}=d;if(n){const P=k(a,n,o);if(typeof P=="string")return P}let h=a.fsPath;if(o===1&&!L.isWindows?h=h.replace(/\//g,"\\"):o!==1&&L.isWindows&&(h=h.replace(/\\/g,"/")),o!==1&&u?.userHome){const P=u.userHome.fsPath;let N;a.scheme!==u.userHome.scheme&&a.path.startsWith(y.posix.sep)?N=u.userHome.with({path:a.path}).fsPath:N=a.fsPath,h=m(N,P,o)}return(o===1?y.win32:y.posix).normalize(M(h,o===1))}e.getPathLabel=S;function k(a,d,o){const u=o===1?y.win32:y.posix,n=o===3?C.extUri:C.extUriIgnorePathCase,h=d.getWorkspace(),g=(0,i.firstOrDefault)(h.folders);if(!g)return;a.scheme!==g.uri.scheme&&a.path.startsWith(y.posix.sep)&&(a=g.uri.with({path:a.path}));const P=d.getWorkspaceFolder(a);if(!P)return;let N;if(n.isEqual(P.uri,a)?N="":N=n.relativePath(P.uri,a)??"",N&&(N=u.normalize(N)),h.folders.length>1&&!d.noPrefix){const j=P.name?P.name:n.basenameOrAuthority(P.uri);N=N?`${j} \u2022 ${N}`:j}return N}function M(a,d=L.isWindows){return(0,T.hasDriveLetter)(a,d)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=M;let D=Object.create(null);function m(a,d,o=L.OS){if(o===1||!a||!d)return a;let u=D.original===d?D.normalized:void 0;u||(u=d,L.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,O.rtrim)(u,y.posix.sep)}${y.posix.sep}`,D={original:d,normalized:u});let n=a;return L.isWindows&&(n=(0,T.toSlashes)(n)),(o===3?n.startsWith(u):(0,O.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:a}e.tildify=m;function v(a,d){return a.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=v;const f="\u2026",t="\\\\",c="~";function l(a,d=y.sep){const o=new Array(a.length);let u=!1;for(let n=0;n<a.length;n++){const h=a[n];if(h===""){o[n]=`.${d}`;continue}if(!h){o[n]=h;continue}u=!0;let g="",P=h;P.indexOf(t)===0?(g=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(d)===0?(g=P.substr(0,P.indexOf(d)+d.length),P=P.substr(P.indexOf(d)+d.length)):P.indexOf(c)===0&&(g=P.substr(0,P.indexOf(c)+c.length),P=P.substr(P.indexOf(c)+c.length));const N=P.split(d);for(let j=1;u&&j<=N.length;j++)for(let Z=N.length-j;u&&Z>=0;Z--){u=!1;let G=N.slice(Z,Z+j).join(d);for(let R=0;!u&&R<a.length;R++)if(R!==n&&a[R]&&a[R].indexOf(G)>-1){const A=Z+j===N.length,F=Z>0&&a[R].indexOf(d)>-1?d+G:G,B=a[R].endsWith(F);u=!A||B}if(!u){let R="";(N[0].endsWith(":")||g!=="")&&(Z===1&&(Z=0,j++,G=N[0]+d+G),Z>0&&(R=N[0]+d),R=g+R),Z>0&&(R=R+f+d),R=R+G,Z+j<N.length&&(R=R+d+f),o[n]=R}}u&&(o[n]=h)}return o}e.shorten=l;var p;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function E(a,d=Object.create(null)){const o=[];let u=!1,n="";for(const h of a)if(h==="$"||u&&h==="{")n&&o.push({value:n,type:p.TEXT}),n="",u=!0;else if(h==="}"&&u){const g=d[n];if(typeof g=="string")g.length&&o.push({value:g,type:p.VARIABLE});else if(g){const P=o[o.length-1];(!P||P.type!==p.SEPARATOR)&&o.push({value:g.label,type:p.SEPARATOR})}n="",u=!1}else n+=h;return n&&!u&&o.push({value:n,type:p.TEXT}),o.filter((h,g)=>{if(h.type===p.SEPARATOR){const P=o[g-1],N=o[g+1];return[P,N].every(j=>j&&(j.type===p.VARIABLE||j.type===p.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=E;function b(a,d){return L.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):a.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function w(a,d){return L.isMacintosh||d?a.replace(/\(&&\w\)|&&/g,""):L.isWindows?a.replace(/&&|&/g,o=>o==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(a){const d=a.indexOf("/")!==-1?y.posix:y.win32,o=d.basename(a),u=d.dirname(a);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=s}),define(Ie[123],Ce([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(M){return M.toJSON()}class y{constructor(D){this.a=D}transformIncoming(D){const m=this.a.transformIncoming(D);return m===D?D:T(i.URI.from(m))}transformOutgoing(D){const m=this.a.transformOutgoing(D);return m===D?D:T(i.URI.from(m))}transformOutgoingURI(D){const m=this.a.transformOutgoing(D);return m===D?D:i.URI.from(m)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(M){return M}transformOutgoing(M){return M}transformOutgoingURI(M){return M}transformOutgoingScheme(M){return M}};function L(M,D,m){if(!M||m>200)return null;if(typeof M=="object"){if(M instanceof i.URI)return D.transformOutgoing(M);for(const v in M)if(Object.hasOwnProperty.call(M,v)){const f=L(M[v],D,m+1);f!==null&&(M[v]=f)}}return null}function C(M,D){const m=L(M,D,0);return m===null?M:m}e.transformOutgoingURIs=C;function O(M,D,m,v){if(!M||v>200)return null;if(typeof M=="object"){if(M.$mid===1)return m?i.URI.revive(D.transformIncoming(M)):D.transformIncoming(M);for(const f in M)if(Object.hasOwnProperty.call(M,f)){const t=O(M[f],D,m,v+1);t!==null&&(M[f]=t)}}return null}function S(M,D){const m=O(M,D,!1,0);return m===null?M:m}e.transformIncomingURIs=S;function k(M,D){const m=O(M,D,!0,0);return m===null?M:m}e.transformAndReviveIncomingURIs=k}),define(Ie[124],Ce([1,0,35,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(L,C,O,S,k,M){if(Array.isArray(L)){let D=0;for(const m of L){const v=y(m,C,O,S,k,M);if(v===10)return v;v>D&&(D=v)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===O?10:0:0;if(L){const{language:D,pattern:m,scheme:v,hasAccessToAllModels:f,notebookType:t}=L;if(!S&&!f)return 0;t&&k&&(C=k);let c=0;if(v)if(v===C.scheme)c=10;else if(v==="*")c=5;else return 0;if(D)if(D===O)c=10;else if(D==="*")c=Math.max(c,5);else return 0;if(t)if(t===M)c=10;else if(t==="*"&&M!==void 0)c=Math.max(c,5);else return 0;if(m){let l;if(typeof m=="string"?l=m:l={...m,base:(0,T.normalize)(m.base)},l===C.fsPath||(0,i.match)(l,C.fsPath))c=10;else return 0}return c}else return 0}}e.score=y}),define(Ie[84],Ce([1,0,24,21]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(y||(y={}));function L(D){for(let m=0,v=D.length;m<v;m+=4){const f=D[m+0],t=D[m+1],c=D[m+2],l=D[m+3];D[m+0]=l,D[m+1]=c,D[m+2]=t,D[m+3]=f}}function C(D){const m=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.isLittleEndian()||L(m),i.VSBuffer.wrap(m)}function O(D){const m=D.buffer;if(T.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function S(D){const m=new Uint32Array(k(D));let v=0;if(m[v++]=D.id,D.type==="full")m[v++]=1,m[v++]=D.data.length,m.set(D.data,v),v+=D.data.length;else{m[v++]=2,m[v++]=D.deltas.length;for(const f of D.deltas)m[v++]=f.start,m[v++]=f.deleteCount,f.data?(m[v++]=f.data.length,m.set(f.data,v),v+=f.data.length):m[v++]=0}return C(m)}e.encodeSemanticTokensDto=S;function k(D){let m=0;if(m+=1+1,D.type==="full")m+=1+D.data.length;else{m+=1,m+=(1+1+1)*D.deltas.length;for(const v of D.deltas)v.data&&(m+=v.data.length)}return m}function M(D){const m=O(D);let v=0;const f=m[v++];if(m[v++]===1){const p=m[v++],E=m.subarray(v,v+p);return v+=p,{id:f,type:"full",data:E}}const c=m[v++],l=[];for(let p=0;p<c;p++){const E=m[v++],b=m[v++],w=m[v++];let r;w>0&&(r=m.subarray(v,v+w),v+=w),l[p]={start:E,deleteCount:b,data:r}}return{id:f,type:"delta",deltas:l}}e.decodeSemanticTokensDto=M}),define(Ie[125],Ce([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ie[126],Ce([1,0,125,21,127,16,23,114]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class D{constructor(Q,pe,Ne,$e){this.id=Q,this.name=pe,this.defaultValue=Ne,this.schema=$e}applyUpdate(Q,pe){return v(Q,pe)}compute(Q,pe,Ne){return Ne}}class m{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=m;function v(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new m(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Ne=Array.isArray(X)&&Array.isArray(Q)&&L.equals(X,Q);return new m(Q,!Ne)}let pe=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const $e=v(X[Ne],Q[Ne]);$e.didChange&&(X[Ne]=$e.newValue,pe=!0)}return new m(X,pe)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return v(Q,pe)}validate(Q){return this.defaultValue}}class t{constructor(Q,pe,Ne,$e){this.id=Q,this.name=pe,this.defaultValue=Ne,this.schema=$e}applyUpdate(Q,pe){return v(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,Ne){return Ne}}function c(X,Q){return typeof X>"u"?Q:X==="false"?!1:Boolean(X)}e.boolean=c;class l extends t{constructor(Q,pe,Ne,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Ne),super(Q,pe,Ne,$e)}validate(Q){return c(Q,this.defaultValue)}}function p(X,Q,pe,Ne){if(typeof X>"u")return Q;let $e=parseInt(X,10);return isNaN($e)?Q:($e=Math.max(pe,$e),$e=Math.min(Ne,$e),$e|0)}e.clampedInt=p;class E extends t{static clampedInt(Q,pe,Ne,$e){return p(Q,pe,Ne,$e)}constructor(Q,pe,Ne,$e,je,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Ne,Je.minimum=$e,Je.maximum=je),super(Q,pe,Ne,Je),this.minimum=$e,this.maximum=je}validate(Q){return E.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class b extends t{static clamp(Q,pe,Ne){return Q<pe?pe:Q>Ne?Ne:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const Ne=parseFloat(Q);return isNaN(Ne)?pe:Ne}constructor(Q,pe,Ne,$e,je){typeof je<"u"&&(je.type="number",je.default=Ne),super(Q,pe,Ne,je),this.validationFn=$e}validate(Q){return this.validationFn(b.float(Q,this.defaultValue))}}class w extends t{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,Ne,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Ne),super(Q,pe,Ne,$e)}validate(Q){return w.string(Q,this.defaultValue)}}function r(X,Q,pe){return typeof X!="string"||pe.indexOf(X)===-1?Q:X}e.stringSet=r;class s extends t{constructor(Q,pe,Ne,$e,je=void 0){typeof je<"u"&&(je.type="string",je.enum=$e,je.default=Ne),super(Q,pe,Ne,je),this.c=$e}validate(Q){return r(Q,this.defaultValue,this.c)}}class a extends D{constructor(Q,pe,Ne,$e,je,Je,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=$e),super(Q,pe,Ne,nt),this.c=je,this.d=Je}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function d(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class u extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(X){switch(X){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function N(X){switch(X){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class j extends f{constructor(){super(135)}compute(Q,pe,Ne){const $e=["monaco-editor"];return pe.get(36)&&$e.push(pe.get(36)),Q.extraEditorClassName&&$e.push(Q.extraEditorClassName),pe.get(70)==="default"?$e.push("mouse-default"):pe.get(70)==="copy"&&$e.push("mouse-copy"),pe.get(105)&&$e.push("showUnused"),pe.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class Z extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,pe,Ne){return Ne&&Q.emptySelectionClipboard}}class G extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class R extends D{constructor(){super(48,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?R.OFF:Q==="true"?R.ON:Q:Boolean(Q)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class A extends D{constructor(){super(51,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?A.OFF:Q==="true"?A.TRANSLATE:Q:Boolean(Q)?A.TRANSLATE:A.OFF}compute(Q,pe,Ne){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=A,A.OFF="normal",A.TRANSLATE="translate";class F extends f{constructor(){super(47)}compute(Q,pe,Ne){return Q.fontInfo}}class B extends t{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(Q){const pe=b.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp(pe,6,100)}compute(Q,pe,Ne){return Q.fontInfo.fontSize}}class z extends D{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(E.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class V extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:i.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:r(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??r(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??r(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??r(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??r(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??r(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends D{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:E.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky),above:c(pe.above,this.defaultValue.above)}}}var ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class ge extends f{constructor(){super(138)}compute(Q,pe,Ne){return ge.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?pe-1:0,$e=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),je=Math.floor(Q.viewLineCount/$e);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ne,desiredRatio:$e,minimapLineCount:je}}static c(Q,pe){const Ne=Q.outerWidth,$e=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Je=pe.stableMinimapLayoutInput,nt=Je&&Q.outerHeight===Je.outerHeight&&Q.lineHeight===Je.lineHeight&&Q.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Je.pixelRatio&&Q.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Q.minimap.enabled===Je.minimap.enabled&&Q.minimap.side===Je.minimap.side&&Q.minimap.size===Je.minimap.size&&Q.minimap.showSlider===Je.minimap.showSlider&&Q.minimap.renderCharacters===Je.minimap.renderCharacters&&Q.minimap.maxColumn===Je.minimap.maxColumn&&Q.minimap.scale===Je.minimap.scale&&Q.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Q.isViewportWrapping===Je.isViewportWrapping,wt=Q.lineHeight,yt=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let at=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ut=Q.minimap.maxColumn,Ft=Q.minimap.size,Mt=Q.minimap.side,ht=Q.verticalScrollbarWidth,It=Q.viewLineCount,Bt=Q.remainingWidth,Nt=Q.isViewportWrapping,Ge=lt?2:3;let Pt=Math.floor(je*$e);const Lt=Pt/je;let Ht=!1,ft=!1,Tt=Ge*at,ye=at/je,Pe=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:bt,desiredRatio:Et,minimapLineCount:kt}=ge.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Ct,height:$e,lineHeight:wt,pixelRatio:je});if(It/kt>1)Ht=!0,ft=!0,at=1,Tt=1,ye=at/je;else{let vt=!1,mt=at+1;if(Ft==="fit"){const Vt=Math.ceil((It+bt)*Tt);Nt&&nt&&Bt<=pe.stableFitRemainingWidth?(vt=!0,mt=pe.stableFitMaxMinimapScale):vt=Vt>Pt}if(Ft==="fill"||vt){Ht=!0;const Vt=at;Tt=Math.min(wt*je,Math.max(1,Math.floor(1/Et))),Nt&&nt&&Bt<=pe.stableFitRemainingWidth&&(mt=pe.stableFitMaxMinimapScale),at=Math.min(mt,Math.max(1,Math.floor(Tt/Ge))),at>Vt&&(Pe=Math.min(2,at/Vt)),ye=at/je/Pe,Pt=Math.ceil(Math.max(Ze,It+bt)*Tt),Nt?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=Bt,pe.stableFitMaxMinimapScale=at):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const fe=Math.floor(Ut*ye),x=Math.min(fe,Math.max(0,Math.floor((Bt-ht-2)*ye/(yt+ye)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(je*x);const Le=Ae/je;Ae=Math.floor(Ae*Pe);const Xe=lt?1:2,Be=Mt==="left"?0:Ne-x-ht;return{renderMinimap:Xe,minimapLeft:Be,minimapWidth:x,minimapHeightIsEditorHeight:Ht,minimapIsSampling:ft,minimapScale:at,minimapLineHeight:Tt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(Q,pe){const Ne=pe.outerWidth|0,$e=pe.outerHeight|0,je=pe.lineHeight|0,Je=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,wt=pe.maxDigitWidth,yt=pe.pixelRatio,Ct=pe.viewLineCount,lt=Q.get(130),at=lt==="inherit"?Q.get(129):lt,Ut=at==="inherit"?Q.get(125):at,Ft=Q.get(128),Mt=pe.isDominatedByLongLines,ht=Q.get(54),It=Q.get(64).renderType!==0,Bt=Q.get(65),Nt=Q.get(99),Ge=Q.get(69),Pt=Q.get(97),Lt=Pt.verticalScrollbarSize,Ht=Pt.verticalHasArrows,ft=Pt.arrowSize,Tt=Pt.horizontalScrollbarSize,ye=Q.get(40),Pe=Q.get(104)!=="never";let fe=Q.get(62);ye&&Pe&&(fe+=16);let x=0;if(It){const St=Math.max(Je,Bt);x=Math.round(St*wt)}let Ae=0;ht&&(Ae=je);let Le=0,Xe=Le+Ae,Be=Xe+x,Ze=Be+fe;const bt=Ne-Ae-x-fe;let Et=!1,kt=!1,pt=-1;at==="inherit"&&Mt?(Et=!0,kt=!0):Ut==="on"||Ut==="bounded"?kt=!0:Ut==="wordWrapColumn"&&(pt=Ft);const vt=ge.c({outerWidth:Ne,outerHeight:$e,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:yt,scrollBeyondLastLine:Nt,minimap:Ge,verticalScrollbarWidth:Lt,viewLineCount:Ct,remainingWidth:bt,isViewportWrapping:kt},pe.memory||new M);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Le+=vt.minimapWidth,Xe+=vt.minimapWidth,Be+=vt.minimapWidth,Ze+=vt.minimapWidth);const mt=bt-vt.minimapWidth,Vt=Math.max(1,Math.floor((mt-Lt-2)/nt)),si=Ht?ft:0;return kt&&(pt=Math.max(1,Vt),Ut==="bounded"&&(pt=Math.min(pt,Ft))),{width:Ne,height:$e,glyphMarginLeft:Le,glyphMarginWidth:Ae,lineNumbersLeft:Xe,lineNumbersWidth:x,decorationsLeft:Be,decorationsWidth:fe,contentLeft:Ze,contentWidth:mt,minimap:vt,viewportColumn:Vt,isWordWrapMinified:Et,isViewportWrapping:kt,wrappingColumn:pt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:Tt,overviewRuler:{top:si,width:Lt,height:$e-2*si,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends D{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,pe,Ne){return pe.get(2)===2?"advanced":Ne}}class re extends D{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class se extends D{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:c(pe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:i.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:r(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(pe.fontFamily,this.defaultValue.fontFamily),padding:c(pe.padding,this.defaultValue.padding)}}}class _ extends D{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):E.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,Ne){return Ne<0?E.clampedInt(-Ne*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ne}}class me extends b{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>b.clamp(Q,0,150),{markdownDescription:i.localize(60,null)})}compute(Q,pe,Ne){return Q.fontInfo.lineHeight}}class we extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:Q.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:c(pe.enabled,this.defaultValue.enabled),autohide:c(pe.autohide,this.defaultValue.autohide),size:r(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(pe.side,this.defaultValue.side,["right","left"]),showSlider:r(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(pe.scale,1,1,3),maxColumn:E.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(X){return X==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class We extends D{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:E.clampedInt(pe.top,0,0,1e3),bottom:E.clampedInt(pe.bottom,0,0,1e3)}}}class Qe extends D{constructor(){const Q={enabled:!0,cycle:!1};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(Q,pe,Ne){return Q.pixelRatio}}class De extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:i.localize(79,null)},comments:{anyOf:pe,default:Q.comments,description:i.localize(80,null)},other:{anyOf:pe,default:Q.other,description:i.localize(81,null)}},default:Q,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const yt=Q?"on":"off";return{comments:yt,strings:yt,other:yt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:Ne,strings:$e}=Q,je=["on","inline","off"];let Je,nt,wt;return typeof pe=="boolean"?Je=pe?"on":"off":Je=r(pe,this.defaultValue.other,je),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=r(Ne,this.defaultValue.comments,je),typeof $e=="boolean"?wt=$e?"on":"off":wt=r($e,this.defaultValue.strings,je),{other:Je,comments:nt,strings:wt}}}var ke;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends D{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(Q){let pe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,Ne=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ne}}}function ce(X){const Q=X.get(92);return Q==="editable"?X.get(86):Q!=="on"}e.filterValidationDecorations=ce;class Y extends D{constructor(){const Q=[],pe={type:"number",description:i.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:Q,description:i.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const Ne of Q)if(typeof Ne=="number")pe.push({column:E.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const $e=Ne;pe.push({column:E.clampedInt($e.column,0,0,1e4),color:$e.color})}return pe.sort((Ne,$e)=>Ne.column-$e.column),pe}return this.defaultValue}}function I(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,Ne=E.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=E.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:E.clampedInt(pe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:E.clampedInt(pe.verticalSliderSize,$e,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(108,null)}})}applyUpdate(Q,pe){let Ne=!1;pe.allowedCharacters&&Q&&(C.equals(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},Ne=!0)),pe.allowedLocales&&Q&&(C.equals(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},Ne=!0));const $e=super.applyUpdate(Q,pe);return Ne?new m($e.newValue,!0):$e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:Se(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Se(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Se(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const Ne={};for(const[$e,je]of Object.entries(Q))je===!0&&(Ne[$e]=!0);return Ne}}class q extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:r(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class J extends D{constructor(){const Q={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:c(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class de extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:Q.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:Q.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:Q.highlightActiveIndentation,description:i.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:Se(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Se(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Se(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Se(X,Q,pe){const Ne=pe.indexOf(X);return Ne===-1?Q:pe[Ne]}class ae extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:Q.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.selectQuickSuggestions":{type:"boolean",default:Q.selectQuickSuggestions,markdownDescription:i.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:r(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:c(pe.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:r(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends D{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(170,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends f{constructor(){super(137)}compute(Q,pe,Ne){return pe.get(86)?!0:Q.tabFocusMode}}var ze;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(ze=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(171,null),i.localize(172,null),i.localize(173,null),i.localize(174,null)],description:i.localize(175,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,Ne){return pe.get(2)===2?0:Ne}}class tt extends f{constructor(){super(139)}compute(Q,pe,Ne){const $e=pe.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class xe extends D{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(176,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.colorDecoratorsLimit=18]="colorDecoratorsLimit",X[X.columnSelection=19]="columnSelection",X[X.comments=20]="comments",X[X.contextmenu=21]="contextmenu",X[X.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",X[X.cursorBlinking=23]="cursorBlinking",X[X.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",X[X.cursorStyle=25]="cursorStyle",X[X.cursorSurroundingLines=26]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",X[X.cursorWidth=28]="cursorWidth",X[X.disableLayerHinting=29]="disableLayerHinting",X[X.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",X[X.domReadOnly=31]="domReadOnly",X[X.dragAndDrop=32]="dragAndDrop",X[X.dropIntoEditor=33]="dropIntoEditor",X[X.emptySelectionClipboard=34]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",X[X.extraEditorClassName=36]="extraEditorClassName",X[X.fastScrollSensitivity=37]="fastScrollSensitivity",X[X.find=38]="find",X[X.fixedOverflowWidgets=39]="fixedOverflowWidgets",X[X.folding=40]="folding",X[X.foldingStrategy=41]="foldingStrategy",X[X.foldingHighlight=42]="foldingHighlight",X[X.foldingImportsByDefault=43]="foldingImportsByDefault",X[X.foldingMaximumRegions=44]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=46]="fontFamily",X[X.fontInfo=47]="fontInfo",X[X.fontLigatures=48]="fontLigatures",X[X.fontSize=49]="fontSize",X[X.fontWeight=50]="fontWeight",X[X.fontVariations=51]="fontVariations",X[X.formatOnPaste=52]="formatOnPaste",X[X.formatOnType=53]="formatOnType",X[X.glyphMargin=54]="glyphMargin",X[X.gotoLocation=55]="gotoLocation",X[X.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",X[X.hover=57]="hover",X[X.inDiffEditor=58]="inDiffEditor",X[X.inlineSuggest=59]="inlineSuggest",X[X.letterSpacing=60]="letterSpacing",X[X.lightbulb=61]="lightbulb",X[X.lineDecorationsWidth=62]="lineDecorationsWidth",X[X.lineHeight=63]="lineHeight",X[X.lineNumbers=64]="lineNumbers",X[X.lineNumbersMinChars=65]="lineNumbersMinChars",X[X.linkedEditing=66]="linkedEditing",X[X.links=67]="links",X[X.matchBrackets=68]="matchBrackets",X[X.minimap=69]="minimap",X[X.mouseStyle=70]="mouseStyle",X[X.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=72]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",X[X.multiCursorModifier=74]="multiCursorModifier",X[X.multiCursorPaste=75]="multiCursorPaste",X[X.multiCursorLimit=76]="multiCursorLimit",X[X.occurrencesHighlight=77]="occurrencesHighlight",X[X.overviewRulerBorder=78]="overviewRulerBorder",X[X.overviewRulerLanes=79]="overviewRulerLanes",X[X.padding=80]="padding",X[X.parameterHints=81]="parameterHints",X[X.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",X[X.quickSuggestions=84]="quickSuggestions",X[X.quickSuggestionsDelay=85]="quickSuggestionsDelay",X[X.readOnly=86]="readOnly",X[X.renameOnType=87]="renameOnType",X[X.renderControlCharacters=88]="renderControlCharacters",X[X.renderFinalNewline=89]="renderFinalNewline",X[X.renderLineHighlight=90]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=92]="renderValidationDecorations",X[X.renderWhitespace=93]="renderWhitespace",X[X.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",X[X.roundedSelection=95]="roundedSelection",X[X.rulers=96]="rulers",X[X.scrollbar=97]="scrollbar",X[X.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=99]="scrollBeyondLastLine",X[X.scrollPredominantAxis=100]="scrollPredominantAxis",X[X.selectionClipboard=101]="selectionClipboard",X[X.selectionHighlight=102]="selectionHighlight",X[X.selectOnLineNumbers=103]="selectOnLineNumbers",X[X.showFoldingControls=104]="showFoldingControls",X[X.showUnused=105]="showUnused",X[X.snippetSuggestions=106]="snippetSuggestions",X[X.smartSelect=107]="smartSelect",X[X.smoothScrolling=108]="smoothScrolling",X[X.stickyScroll=109]="stickyScroll",X[X.stickyTabStops=110]="stickyTabStops",X[X.stopRenderingLineAfter=111]="stopRenderingLineAfter",X[X.suggest=112]="suggest",X[X.suggestFontSize=113]="suggestFontSize",X[X.suggestLineHeight=114]="suggestLineHeight",X[X.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",X[X.suggestSelection=116]="suggestSelection",X[X.tabCompletion=117]="tabCompletion",X[X.tabIndex=118]="tabIndex",X[X.unicodeHighlighting=119]="unicodeHighlighting",X[X.unusualLineTerminators=120]="unusualLineTerminators",X[X.useShadowDOM=121]="useShadowDOM",X[X.useTabStops=122]="useTabStops",X[X.wordBreak=123]="wordBreak",X[X.wordSeparators=124]="wordSeparators",X[X.wordWrap=125]="wordWrap",X[X.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=128]="wordWrapColumn",X[X.wordWrapOverride1=129]="wordWrapOverride1",X[X.wordWrapOverride2=130]="wordWrapOverride2",X[X.wrappingIndent=131]="wrappingIndent",X[X.wrappingStrategy=132]="wrappingStrategy",X[X.showDeprecated=133]="showDeprecated",X[X.inlayHints=134]="inlayHints",X[X.editorClassName=135]="editorClassName",X[X.pixelRatio=136]="pixelRatio",X[X.tabFocusMode=137]="tabFocusMode",X[X.layoutInfo=138]="layoutInfo",X[X.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(177,null)})),acceptSuggestionOnEnter:Oe(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(178,null),""],markdownDescription:i.localize(179,null)})),accessibilitySupport:Oe(new o),accessibilityPageSize:Oe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(180,null),tags:["accessibility"]})),ariaLabel:Oe(new w(4,"ariaLabel",i.localize(181,null))),autoClosingBrackets:Oe(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(182,null),i.localize(183,null),""],description:i.localize(184,null)})),autoClosingDelete:Oe(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(185,null),""],description:i.localize(186,null)})),autoClosingOvertype:Oe(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(187,null),""],description:i.localize(188,null)})),autoClosingQuotes:Oe(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoIndent:Oe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[i.localize(192,null),i.localize(193,null),i.localize(194,null),i.localize(195,null),i.localize(196,null)],description:i.localize(197,null)})),automaticLayout:Oe(new l(10,"automaticLayout",!1)),autoSurround:Oe(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(198,null),i.localize(199,null),i.localize(200,null),""],description:i.localize(201,null)})),bracketPairColorization:Oe(new J),bracketPairGuides:Oe(new de),stickyTabStops:Oe(new l(110,"stickyTabStops",!1,{description:i.localize(202,null)})),codeLens:Oe(new l(14,"codeLens",!0,{description:i.localize(203,null)})),codeLensFontFamily:Oe(new w(15,"codeLensFontFamily","",{description:i.localize(204,null)})),codeLensFontSize:Oe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(205,null)})),colorDecorators:Oe(new l(17,"colorDecorators",!0,{description:i.localize(206,null)})),colorDecoratorsLimit:Oe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(207,null)})),columnSelection:Oe(new l(19,"columnSelection",!1,{description:i.localize(208,null)})),comments:Oe(new u),contextmenu:Oe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new l(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(209,null)})),cursorBlinking:Oe(new a(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(210,null)})),cursorSmoothCaretAnimation:Oe(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(211,null),i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),cursorStyle:Oe(new a(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:i.localize(215,null)})),cursorSurroundingLines:Oe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(216,null)})),cursorSurroundingLinesStyle:Oe(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(217,null),i.localize(218,null)],description:i.localize(219,null)})),cursorWidth:Oe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(220,null)})),disableLayerHinting:Oe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new l(31,"domReadOnly",!1)),dragAndDrop:Oe(new l(32,"dragAndDrop",!0,{description:i.localize(221,null)})),emptySelectionClipboard:Oe(new Z),dropIntoEditor:Oe(new xe),stickyScroll:Oe(new se),experimentalWhitespaceRendering:Oe(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(222,null),i.localize(223,null),i.localize(224,null)],description:i.localize(225,null)})),extraEditorClassName:Oe(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Oe(new b(37,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:i.localize(226,null)})),find:Oe(new G),fixedOverflowWidgets:Oe(new l(39,"fixedOverflowWidgets",!1)),folding:Oe(new l(40,"folding",!0,{description:i.localize(227,null)})),foldingStrategy:Oe(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(228,null),i.localize(229,null)],description:i.localize(230,null)})),foldingHighlight:Oe(new l(42,"foldingHighlight",!0,{description:i.localize(231,null)})),foldingImportsByDefault:Oe(new l(43,"foldingImportsByDefault",!1,{description:i.localize(232,null)})),foldingMaximumRegions:Oe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(233,null)})),unfoldOnClickAfterEndOfLine:Oe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(234,null)})),fontFamily:Oe(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(235,null)})),fontInfo:Oe(new F),fontLigatures2:Oe(new R),fontSize:Oe(new B),fontWeight:Oe(new z),fontVariations:Oe(new A),formatOnPaste:Oe(new l(52,"formatOnPaste",!1,{description:i.localize(236,null)})),formatOnType:Oe(new l(53,"formatOnType",!1,{description:i.localize(237,null)})),glyphMargin:Oe(new l(54,"glyphMargin",!0,{description:i.localize(238,null)})),gotoLocation:Oe(new V),hideCursorInOverviewRuler:Oe(new l(56,"hideCursorInOverviewRuler",!1,{description:i.localize(239,null)})),hover:Oe(new K),inDiffEditor:Oe(new l(58,"inDiffEditor",!1)),letterSpacing:Oe(new b(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>b.clamp(X,-5,20),{description:i.localize(240,null)})),lightbulb:Oe(new re),lineDecorationsWidth:Oe(new _),lineHeight:Oe(new me),lineNumbers:Oe(new oe),lineNumbersMinChars:Oe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new l(66,"linkedEditing",!1,{description:i.localize(241,null)})),links:Oe(new l(67,"links",!0,{description:i.localize(242,null)})),matchBrackets:Oe(new s(68,"matchBrackets","always",["always","near","never"],{description:i.localize(243,null)})),minimap:Oe(new we),mouseStyle:Oe(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new b(71,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:i.localize(244,null)})),mouseWheelZoom:Oe(new l(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(245,null)})),multiCursorMergeOverlapping:Oe(new l(73,"multiCursorMergeOverlapping",!0,{description:i.localize(246,null)})),multiCursorModifier:Oe(new a(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[i.localize(247,null),i.localize(248,null)],markdownDescription:i.localize(249,null)})),multiCursorPaste:Oe(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(250,null),i.localize(251,null)],markdownDescription:i.localize(252,null)})),multiCursorLimit:Oe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(253,null)})),occurrencesHighlight:Oe(new l(77,"occurrencesHighlight",!0,{description:i.localize(254,null)})),overviewRulerBorder:Oe(new l(78,"overviewRulerBorder",!0,{description:i.localize(255,null)})),overviewRulerLanes:Oe(new E(79,"overviewRulerLanes",3,0,3)),padding:Oe(new We),parameterHints:Oe(new Qe),peekWidgetDefaultFocus:Oe(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(256,null),i.localize(257,null)],description:i.localize(258,null)})),definitionLinkOpensInPeek:Oe(new l(83,"definitionLinkOpensInPeek",!1,{description:i.localize(259,null)})),quickSuggestions:Oe(new De),quickSuggestionsDelay:Oe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(260,null)})),readOnly:Oe(new l(86,"readOnly",!1)),renameOnType:Oe(new l(87,"renameOnType",!1,{description:i.localize(261,null),markdownDeprecationMessage:i.localize(262,null)})),renderControlCharacters:Oe(new l(88,"renderControlCharacters",!0,{description:i.localize(263,null),restricted:!0})),renderFinalNewline:Oe(new s(89,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(264,null)})),renderLineHighlight:Oe(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(265,null)],description:i.localize(266,null)})),renderLineHighlightOnlyWhenFocus:Oe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(267,null)})),renderValidationDecorations:Oe(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(268,null),i.localize(269,null),i.localize(270,null),""],description:i.localize(271,null)})),revealHorizontalRightPadding:Oe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new l(95,"roundedSelection",!0,{description:i.localize(272,null)})),rulers:Oe(new Y),scrollbar:Oe(new $),scrollBeyondLastColumn:Oe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(273,null)})),scrollBeyondLastLine:Oe(new l(99,"scrollBeyondLastLine",!0,{description:i.localize(274,null)})),scrollPredominantAxis:Oe(new l(100,"scrollPredominantAxis",!0,{description:i.localize(275,null)})),selectionClipboard:Oe(new l(101,"selectionClipboard",!0,{description:i.localize(276,null),included:T.isLinux})),selectionHighlight:Oe(new l(102,"selectionHighlight",!0,{description:i.localize(277,null)})),selectOnLineNumbers:Oe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(278,null),i.localize(279,null),i.localize(280,null)],description:i.localize(281,null)})),showUnused:Oe(new l(105,"showUnused",!0,{description:i.localize(282,null)})),showDeprecated:Oe(new l(133,"showDeprecated",!0,{description:i.localize(283,null)})),inlayHints:Oe(new le),snippetSuggestions:Oe(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null),i.localize(287,null)],description:i.localize(288,null)})),smartSelect:Oe(new ve),smoothScrolling:Oe(new l(108,"smoothScrolling",!1,{description:i.localize(289,null)})),stopRenderingLineAfter:Oe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new ae),inlineSuggest:Oe(new q),suggestFontSize:Oe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(290,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(291,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new l(115,"suggestOnTriggerCharacters",!0,{description:i.localize(292,null)})),suggestSelection:Oe(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(293,null),i.localize(294,null),i.localize(295,null)],description:i.localize(296,null)})),tabCompletion:Oe(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(297,null),i.localize(298,null),i.localize(299,null)],description:i.localize(300,null)})),tabIndex:Oe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new H),unusualLineTerminators:Oe(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null)],description:i.localize(304,null)})),useShadowDOM:Oe(new l(121,"useShadowDOM",!0)),useTabStops:Oe(new l(122,"useTabStops",!0,{description:i.localize(305,null)})),wordBreak:Oe(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(306,null),i.localize(307,null)],description:i.localize(308,null)})),wordSeparators:Oe(new w(124,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(309,null)})),wordWrap:Oe(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null),i.localize(312,null),i.localize(313,null)],description:i.localize(314,null)})),wordWrapBreakAfterCharacters:Oe(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(315,null)})),wordWrapOverride1:Oe(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new j),pixelRatio:Oe(new Te),tabFocusMode:Oe(new be),layoutInfo:Oe(new ge),wrappingInfo:Oe(new tt),wrappingIndent:Oe(new He),wrappingStrategy:Oe(new ue)}}),define(Ie[128],Ce([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[129],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[130],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[131],Ce([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ie[132],Ce([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ie[133],Ce([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ie[134],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[135],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[136],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[137],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[138],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[139],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[140],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[141],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ie[142],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[143],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[144],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[145],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[146],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[147],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[148],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[149],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(L,C){this.a.set(L,C)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const C in L.contributes){const O=this.a.get(C);if(!O)continue;const S=L.contributes[C],k=Array.isArray(S)?S:[S];try{O(k,L.activationEvents)}catch(M){(0,i.onUnexpectedError)(M)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ie[150],Ce([1,0,22,29,130,248]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||C.test(l)}e.isValidVersionStr=S;function k(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=l.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function M(l){if(!l)return null;const p=l.majorBase,E=l.majorMustEqual,b=l.minorBase;let w=l.minorMustEqual;const r=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(p===0||(w=!1),s=!1);let a=0;if(l.preRelease){const d=O.exec(l.preRelease);if(d){const[,o,u,n]=d;a=Date.UTC(Number(o),Number(u)-1,Number(n))}}return{majorBase:p,majorMustEqual:E,minorBase:b,minorMustEqual:w,patchBase:r,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=M;function D(l,p,E){let b;typeof l=="string"?b=M(k(l)):b=l;let w;p instanceof Date?w=p.getTime():typeof p=="string"&&(w=new Date(p).getTime());let r;if(typeof E=="string"?r=M(k(E)):r=E,!b||!r)return!1;const s=b.majorBase,a=b.minorBase,d=b.patchBase;let o=r.majorBase,u=r.minorBase,n=r.patchBase;const h=r.notBefore;let g=r.majorMustEqual,P=r.minorMustEqual,N=r.patchMustEqual;return r.isMinimum?s>o?!0:s<o?!1:a>u?!0:a<u||w&&w<h?!1:d>=n:(s===1&&o===0&&(!g||!P||!N)&&(o=1,u=0,n=0,g=!0,P=!1,N=!1),s<o?!1:s>o?!g:a<u?!1:a>u?!P:d<n?!1:d>n?!N:!(w&&w<h))}e.isValidVersion=D;function m(l,p,E,b,w){const r=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return r.push([T.default.Error,y.localize(0,null)]),r;if(typeof b.name!="string")return r.push([T.default.Error,y.localize(1,null,"name")]),r;if(typeof b.version!="string")return r.push([T.default.Error,y.localize(2,null,"version")]),r;if(!b.engines)return r.push([T.default.Error,y.localize(3,null,"engines")]),r;if(typeof b.engines.vscode!="string")return r.push([T.default.Error,y.localize(4,null,"engines.vscode")]),r;if(typeof b.extensionDependencies<"u"&&!c(b.extensionDependencies))return r.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),r;if(typeof b.activationEvents<"u"){if(!c(b.activationEvents))return r.push([T.default.Error,y.localize(6,null,"activationEvents")]),r;if(typeof b.main>"u"&&typeof b.browser>"u")return r.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),r}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&r.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return r.push([T.default.Error,y.localize(9,null,"main")]),r;{const d=(0,i.joinPath)(E,b.main);(0,i.isEqualOrParent)(d,E)||r.push([T.default.Warning,y.localize(10,null,d.path,E.path)])}if(typeof b.activationEvents>"u")return r.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),r}if(typeof b.browser<"u"){if(typeof b.browser!="string")return r.push([T.default.Error,y.localize(12,null,"browser")]),r;{const d=(0,i.joinPath)(E,b.browser);(0,i.isEqualOrParent)(d,E)||r.push([T.default.Warning,y.localize(13,null,d.path,E.path)])}if(typeof b.activationEvents>"u")return r.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),r}if(!L.valid(b.version))return r.push([T.default.Error,y.localize(15,null)]),r;const s=[];if(!v(l,p,b,w,s))for(const d of s)r.push([T.default.Error,d]);return r}e.validateExtensionManifest=m;function v(l,p,E,b,w){return b||typeof E.main>"u"&&typeof E.browser>"u"?!0:t(l,p,E.engines.vscode,w)}e.isValidExtensionVersion=v;function f(l,p,E){return l==="*"||t(p,E,l)}e.isEngineValid=f;function t(l,p,E,b=[]){const w=M(k(E));if(!w)return b.push(y.localize(16,null,E)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return b.push(y.localize(17,null,E)),!1}else if(!w.majorMustEqual)return b.push(y.localize(18,null,E)),!1;return D(l,p,w)?!0:(b.push(y.localize(19,null,l,E)),!1)}function c(l){if(!Array.isArray(l))return!1;for(let p=0,E=l.length;p<E;p++)if(typeof l[p]!="string")return!1;return!0}}),define(Ie[85],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,L=[],C=!1){this.ctor=y,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=i}),define(Ie[63],Ce([1,0,85]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function L(O,S,k){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],Boolean(k))),T.push([O,S])}e.registerSingleton=L;function C(){return T}e.getSingletonServiceDescriptors=C}),define(Ie[151],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const O=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(C);O.outgoing.set(S.key,S),S.incoming.set(O.key,O)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const O of this.a.values())O.outgoing.delete(C),O.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let O=this.a.get(C);return O||(O=new i(C,L),this.a.set(C,O)),O}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,O]of this.a)L.push(`${C}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const O=new Set([L]),S=this.c(C,O);if(S)return S}}c(L,C){for(const[O,S]of L.outgoing){if(C.has(O))return[...C,O].join(" -> ");C.add(O);const k=this.c(S,C);if(k)return k;C.delete(O)}}}e.Graph=T}),define(Ie[3],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function O(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=O})(i=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,O,S){O[i.DI_TARGET]===O?O[i.DI_DEPENDENCIES].push({id:C,index:S}):(O[i.DI_DEPENDENCIES]=[{id:C,index:S}],O[i.DI_TARGET]=O)}function y(C){if(i.serviceIds.has(C))return i.serviceIds.get(C);const O=function(S,k,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(O,S,M)};return O.toString=()=>C,i.serviceIds.set(C,O),O}e.createDecorator=y;function L(C){return C}e.refineServiceDecorator=L}),define(Ie[40],Ce([1,0,9,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=L;function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var O;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(l,p){const E=Object.create(null);for(const b in l)M(E,b,l[b],p);return E}e.toValuesTree=k;function M(l,p,E,b){const w=p.split("."),r=w.pop();let s=l;for(let a=0;a<w.length;a++){const d=w[a];let o=s[d];switch(typeof o){case"undefined":o=s[d]=Object.create(null);break;case"object":break;default:b(`Ignoring ${p} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[r]=E}catch{b(`Ignoring ${p} as ${w.join(".")} is ${JSON.stringify(s)}`)}else b(`Ignoring ${p} as ${w.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=M;function D(l,p){const E=p.split(".");m(l,E)}e.removeFromValueTree=D;function m(l,p){const E=p.shift();if(p.length===0){delete l[E];return}if(Object.keys(l).indexOf(E)!==-1){const b=l[E];typeof b=="object"&&!Array.isArray(b)&&(m(b,p),Object.keys(b).length===0&&delete l[E])}}function v(l,p,E){function b(s,a){let d=s;for(const o of a){if(typeof d!="object"||d===null)return;d=d[o]}return d}const w=p.split("."),r=b(l,w);return typeof r>"u"?E:r}e.getConfigurationValue=v;function f(l,p,E){Object.keys(p).forEach(b=>{b!=="__proto__"&&(b in l?i.isObject(l[b])&&i.isObject(p[b])?f(l[b],p[b],E):E&&(l[b]=p[b]):l[b]=p[b])})}e.merge=f;function t(l,p,E){const b=l.inspect(p),w=l.inspect(E);return typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:b.defaultValue}e.getMigratedSettingValue=t;function c(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(Ie[41],Ce([1,0,21,10,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const C=Object.prototype.hasOwnProperty;var O;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(O=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return m.INSTANCE}static has(R){return v.create(R)}static equals(R,A){return f.create(R,A)}static notEquals(R,A){return l.create(R,A)}static regex(R,A){return a.create(R,A)}static in(R,A){return t.create(R,A)}static notIn(R,A){return c.create(R,A)}static not(R){return p.create(R)}static and(...R){return u.create(R,null,!0)}static or(...R){return n.create(R,null,!0)}static greater(R,A){return b.create(R,A)}static greaterEquals(R,A){return w.create(R,A)}static smaller(R,A){return r.create(R,A)}static smallerEquals(R,A){return s.create(R,A)}static deserialize(R,A=!1){if(!!R)return this.c(R,A)}static c(R,A){const F=R.split("||");return n.create(F.map(B=>this.d(B,A)),null,!0)}static d(R,A){const F=R.split("&&");return u.create(F.map(B=>this.f(B,A)),null,!0)}static f(R,A){if(R=R.trim(),R.indexOf("!=")>=0){const F=R.split("!=");return l.create(F[0].trim(),this.g(F[1],A))}if(R.indexOf("==")>=0){const F=R.split("==");return f.create(F[0].trim(),this.g(F[1],A))}if(R.indexOf("=~")>=0){const F=R.split("=~");return a.create(F[0].trim(),this.h(F[1],A))}if(R.indexOf(" not in ")>=0){const F=R.split(" not in ");return c.create(F[0].trim(),this.g(F[1],A))}if(R.indexOf(" in ")>=0){const F=R.split(" in ");return t.create(F[0].trim(),this.g(F[1],A))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const F=R.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const F=R.split(">");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const F=R.split("<=");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const F=R.split("<");return r.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(R)?p.create(R.substr(1).trim()):v.create(R)}static g(R,A){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const F=/^'([^']*)'$/.exec(R);return F?F[1].trim():R}static h(R,A){if((0,T.isFalsyOrWhitespace)(R)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=R.indexOf("/"),B=R.lastIndexOf("/");if(F===B||F<0){if(A)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const z=R.slice(F+1,B),V=R[B+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(K){if(A)throw new Error(`bad regexp-value '${R}', parse error: ${K}`);return console.warn(`bad regexp-value '${R}', parse error: ${K}`),null}}}e.ContextKeyExpr=S;function k(G,R){const A=G?G.substituteConstants():void 0,F=R?R.substituteConstants():void 0;return!A&&!F?!0:!A||!F?!1:A.equals(F)}e.expressionsAreEqualWithConstantSubstitution=k;function M(G,R){return G.cmp(R)}class D{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class m{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{static create(R,A=null){const F=L.get(R);return typeof F=="boolean"?F?m.INSTANCE:D.INSTANCE:new v(R,A)}constructor(R,A){this.key=R,this.c=A,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?m.INSTANCE:D.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=v;class f{static create(R,A,F=null){if(typeof A=="boolean")return A?v.create(R,F):p.create(R,F);const B=L.get(R);return typeof B=="boolean"?A===(B?"true":"false")?m.INSTANCE:D.INSTANCE:new f(R,A,F)}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const A=R?"true":"false";return this.d===A?m.INSTANCE:D.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class t{static create(R,A){return new t(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:P(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const A=R.getValue(this.f),F=R.getValue(this.d);return Array.isArray(A)?A.includes(F):typeof F=="string"&&typeof A=="object"&&A!==null?C.call(A,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=c.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=t;class c{static create(R,A){return new c(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=11,this.c=t.create(R,A)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=c;class l{static create(R,A,F=null){if(typeof A=="boolean")return A?p.create(R,F):v.create(R,F);const B=L.get(R);return typeof B=="boolean"?A===(B?"true":"false")?D.INSTANCE:m.INSTANCE:new l(R,A,F)}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const A=R?"true":"false";return this.d===A?D.INSTANCE:m.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class p{static create(R,A=null){const F=L.get(R);return typeof F=="boolean"?F?D.INSTANCE:m.INSTANCE:new p(R,A)}constructor(R,A){this.c=R,this.d=A,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:g(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=L.get(this.c);return typeof R=="boolean"?R?D.INSTANCE:m.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function E(G,R){if(typeof G=="string"){const A=parseFloat(G);isNaN(A)||(G=A)}return typeof G=="string"||typeof G=="number"?R(G):D.INSTANCE}class b{static create(R,A,F=null){return E(A,B=>new b(R,B,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=b;class w{static create(R,A,F=null){return E(A,B=>new w(R,B,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class r{static create(R,A,F=null){return E(A,B=>new r(R,B,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=r;class s{static create(R,A,F=null){return E(A,B=>new s(R,B,F))}constructor(R,A,F){this.c=R,this.d=A,this.f=F,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:P(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class a{static create(R,A){return new a(R,A)}constructor(R,A){this.d=R,this.f=A,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const A=this.f?this.f.source:"",F=R.f?R.f.source:"";return A<F?-1:A>F?1:0}equals(R){if(R.type===this.type){const A=this.f?this.f.source:"",F=R.f?R.f.source:"";return this.d===R.d&&A===F}return!1}substituteConstants(){return this}evaluate(R){const A=R.getValue(this.d);return this.f?this.f.test(A):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=a;class d{static create(R){return new d(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(R){return new d(this.c.map(R))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function o(G){let R=null;for(let A=0,F=G.length;A<F;A++){const B=G[A].substituteConstants();if(G[A]!==B&&R===null){R=[];for(let z=0;z<A;z++)R[z]=G[z]}R!==null&&(R[A]=B)}return R===null?G:R}class u{static create(R,A,F){return u.d(R,A,F)}constructor(R,A){this.expr=R,this.c=A,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const B=M(this.expr[A],R.expr[A]);if(B!==0)return B}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(R.expr[A]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:u.create(R,this.c,!1)}evaluate(R){for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].evaluate(R))return!1;return!0}static d(R,A,F){const B=[];let z=!1;for(const V of R)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return D.INSTANCE;if(V.type===6){B.push(...V.expr);continue}B.push(V)}if(B.length===0&&z)return m.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(M);for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];for(;B.length>1;){const V=B[B.length-1];if(V.type!==9)break;B.pop();const K=B.pop(),ie=B.length===0,ge=n.create(V.expr.map(ue=>u.create([ue,K],null,F)),null,ie);ge&&(B.push(ge),B.sort(M))}if(B.length===1)return B[0];if(F){for(let V=0;V<B.length;V++)for(let K=V+1;K<B.length;K++)if(B[V].negate().equals(B[K]))return D.INSTANCE;if(B.length===1)return B[0]}return new u(B,A)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const A of this.expr)R.push(...A.keys());return R}map(R){return new u(this.expr.map(A=>A.map(R)),null)}negate(){if(!this.c){const R=[];for(const A of this.expr)R.push(A.negate());this.c=n.create(R,this,!0)}return this.c}}class n{static create(R,A,F){return n.d(R,A,F)}constructor(R,A){this.expr=R,this.c=A,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const B=M(this.expr[A],R.expr[A]);if(B!==0)return B}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(R.expr[A]))return!1;return!0}return!1}substituteConstants(){const R=o(this.expr);return R===this.expr?this:n.create(R,this.c,!1)}evaluate(R){for(let A=0,F=this.expr.length;A<F;A++)if(this.expr[A].evaluate(R))return!0;return!1}static d(R,A,F){let B=[],z=!1;if(R){for(let V=0,K=R.length;V<K;V++){const ie=R[V];if(!!ie){if(ie.type===0){z=!0;continue}if(ie.type===1)return m.INSTANCE;if(ie.type===9){B=B.concat(ie.expr);continue}B.push(ie)}}if(B.length===0&&z)return D.INSTANCE;B.sort(M)}if(B.length!==0){if(B.length===1)return B[0];for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];if(F){for(let V=0;V<B.length;V++)for(let K=V+1;K<B.length;K++)if(B[V].negate().equals(B[K]))return m.INSTANCE;if(B.length===1)return B[0]}return new n(B,A)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const A of this.expr)R.push(...A.keys());return R}map(R){return new n(this.expr.map(A=>A.map(R)),null)}negate(){if(!this.c){const R=[];for(const A of this.expr)R.push(A.negate());for(;R.length>1;){const A=R.shift(),F=R.shift(),B=[];for(const z of Z(A))for(const V of Z(F))B.push(u.create([z,V],null,!1));R.unshift(n.create(B,null,!1))}this.c=n.create(R,this,!0)}return this.c}}class h extends v{static all(){return h.d.values()}constructor(R,A,F){super(R,null),this.f=A,typeof F=="object"?h.d.push({...F,key:R}):F!==!0&&h.d.push({key:R,description:F,type:A!=null?typeof A:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return f.create(this.key,R)}notEqualsTo(R){return l.create(this.key,R)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function g(G,R){return G<R?-1:G>R?1:0}function P(G,R,A,F){return G<A?-1:G>A?1:R<F?-1:R>F?1:0}function N(G,R){if(G.type===0||R.type===1)return!0;if(G.type===9)return R.type===9?j(G.expr,R.expr):!1;if(R.type===9){for(const A of R.expr)if(N(G,A))return!0;return!1}if(G.type===6){if(R.type===6)return j(R.expr,G.expr);for(const A of G.expr)if(N(A,R))return!0;return!1}return G.equals(R)}e.implies=N;function j(G,R){let A=0,F=0;for(;A<G.length&&F<R.length;){const B=G[A].cmp(R[F]);if(B<0)return!1;B===0&&A++,F++}return A===G.length}function Z(G){return G.type===9?G.expr:[G]}}),define(Ie[152],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[86],Ce([1,0,129,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(l,p){switch(l){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function O(l,p){return p==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=O;function S(l,p,E){return O(p,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:k(E).includes(l)}e.isTargetPlatformCompatible=S;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function M(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=M;var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var t;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(p,E){super(p),this.code=E,this.name=E}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,131,3]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var M;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(M=e.FileType||(e.FileType={}));var D;(function(z){z[z.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var m;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=v;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function c(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function p(z){return v(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(V,K){super(V),this.code=K}}e.FileSystemProviderError=b;function w(z,V){const K=new b(z.toString(),V);return s(K,V),K}e.createFileSystemProviderError=w;function r(z){return z||w((0,O.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=r;function s(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=s;function a(z){if(!z)return E.Unknown;if(z instanceof b)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return E.Unknown;switch(V[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=a;function d(z){if(z instanceof P)return z.fileOperationResult;switch(a(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var o;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class u{constructor(V,K,ie){this.resource=V,this.operation=K,this.target=ie}isOperation(V){return this.operation===V}}e.FileOperationEvent=u;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class h{constructor(V,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const ie=new Map;for(const ge of V){const ue=ie.get(ge.type);switch(ue?ue.push([ge.resource,ge]):ie.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,ue]of ie)switch(ge){case 1:this.a=i.TernarySearchTree.forUris(()=>K),this.a.fill(ue);break;case 0:this.b=i.TernarySearchTree.forUris(()=>K),this.b.fill(ue);break;case 2:this.c=i.TernarySearchTree.forUris(()=>K),this.c.fill(ue);break}}contains(V,...K){return this.d(V,{includeChildren:!1},...K)}affects(V,...K){return this.d(V,{includeChildren:!0},...K)}d(V,K,...ie){if(!V)return!1;const ge=ie.length>0;return!!((!ge||ie.includes(1))&&(this.a?.get(V)||K.includeChildren&&this.a?.findSuperstr(V))||(!ge||ie.includes(0))&&(this.b?.get(V)||K.includeChildren&&this.b?.findSuperstr(V))||(!ge||ie.includes(2))&&(this.c?.findSubstr(V)||K.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function g(z,V,K){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),K?(0,y.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=g;class P extends Error{constructor(V,K,ie){super(V),this.fileOperationResult=K,this.options=ie}}e.FileOperationError=P;class N extends P{constructor(V,K,ie){super(V,2,ie),this.stat=K}}e.NotModifiedSinceFileOperationError=N;var j;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Z;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=G;async function R(z,V){if(!V.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(K=>{const ie=V.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===z.scheme&&ge.added&&(ie.dispose(),K())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class A{static formatSize(V){return(0,L.isNumber)(V)||(V=0),V<A.KB?(0,O.localize)(1,null,V.toFixed(0)):V<A.MB?(0,O.localize)(2,null,(V/A.KB).toFixed(2)):V<A.GB?(0,O.localize)(3,null,(V/A.MB).toFixed(2)):V<A.TB?(0,O.localize)(4,null,(V/A.GB).toFixed(2)):(0,O.localize)(5,null,(V/A.TB).toFixed(2))}}e.ByteSize=A,A.KB=1024,A.MB=A.KB*A.KB,A.GB=A.MB*A.KB,A.TB=A.GB*A.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(z){return{maxFileSize:z===0?300*A.MB:16*A.GB,maxHeapSize:z===0?700*A.MB:2*700*A.MB}}e.getPlatformLimits=B}),define(Ie[64],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this.a=new Map;for(const[L,C]of y)this.set(L,C)}set(y,L){const C=this.a.get(y);return this.a.set(y,L),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=i}),define(Ie[153],Ce([1,0,14,11,7,85,151,3,64,154]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const M=!1;class D extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new S.ServiceCollection,l=!1,p,E=M){this.f=c,this.g=l,this.h=p,this.i=E,this.o=new Set,this.f.set(O.IInstantiationService,this),this._globalGraph=E?p?._globalGraph??new C.Graph(b=>b):void 0}createChild(c){return new m(c,this.g,this,this.i)}invokeFunction(c,...l){const p=f.traceInvocation(this.i,c);let E=!1;try{return c({get:w=>{if(E)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const r=this.m(w,p);if(!r)throw new Error(`[invokeFunction] unknown service '${w}'`);return r}},...l)}finally{E=!0,p.stop()}}createInstance(c,...l){let p,E;return c instanceof L.SyncDescriptor?(p=f.traceCreation(this.i,c.ctor),E=this.j(c.ctor,c.staticArguments.concat(l),p)):(p=f.traceCreation(this.i,c),E=this.j(c,l,p)),p.stop(),E}j(c,l=[],p){const E=O._util.getServiceDependencies(c).sort((r,s)=>r.index-s.index),b=[];for(const r of E){const s=this.m(r.id,p);s||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`,!1),b.push(s)}const w=E.length>0?E[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${c.name} at position ${w+1} conflicts with ${l.length} static arguments`);const r=w-l.length;r>0?l=l.concat(new Array(r)):l=l.slice(0,w)}return Reflect.construct(c,l.concat(b))}k(c,l){if(this.f.get(c)instanceof L.SyncDescriptor)this.f.set(c,l);else if(this.h)this.h.k(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const l=this.f.get(c);return!l&&this.h?this.h.l(c):l}m(c,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const p=this.l(c);return p instanceof L.SyncDescriptor?this.q(c,p,l.branch(c,!0)):(l.branch(c,!1),p)}q(c,l,p){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,l,p)}finally{this.o.delete(c)}}r(c,l,p){const E=new C.Graph(r=>r.id.toString());let b=0;const w=[{id:c,desc:l,_trace:p}];for(;w.length;){const r=w.pop();if(E.lookupOrInsertNode(r),b++>1e3)throw new D(E);for(const s of O._util.getServiceDependencies(r.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),a instanceof L.SyncDescriptor){const d={id:s.id,desc:a,_trace:r._trace.branch(s.id,!0)};E.insertEdge(r,d),w.push(d)}}}for(;;){const r=E.roots();if(r.length===0){if(!E.isEmpty())throw new D(E);break}for(const{data:s}of r){if(this.l(s.id)instanceof L.SyncDescriptor){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}E.removeNode(s)}}return this.l(c)}s(c,l,p=[],E,b){if(this.f.get(c)instanceof L.SyncDescriptor)return this.t(c,l,p,E,b);if(this.h)return this.h.s(c,l,p,E,b);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(c,l,p=[],E,b){if(E){const w=new m(void 0,this.g,this,this.i);w.c=String(c);const r=new Map,s=new i.IdleValue(()=>{const a=w.j(l,p,b);for(const[d,o]of r){const u=a[d];if(typeof u=="function")for(const n of o)u.apply(a,n)}return r.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let n=r.get(d);return n||(n=new k.LinkedList,r.set(d,n)),(g,P,N)=>{const j=n.push([g,P,N]);return(0,y.toDisposable)(j)}}if(d in a)return a[d];const o=s.value;let u=o[d];return typeof u!="function"||(u=u.bind(o),a[d]=u),u},set(a,d,o){return s.value[d]=o,!0},getPrototypeOf(a){return l.prototype}})}else return this.j(l,p,b)}u(c,l){if(l&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=m;var v;(function(t){t[t.None=0]="None",t[t.Creation=1]="Creation",t[t.Invocation=2]="Invocation",t[t.Branch=3]="Branch"})(v||(v={}));class f{static traceInvocation(c,l){return c?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(c,l){return c?new f(1,l.name):f.c}constructor(c,l){this.type=c,this.name=l,this.g=Date.now(),this.h=[]}branch(c,l){const p=new f(3,c.toString());return this.h.push([c,l,p]),p}stop(){const c=Date.now()-this.g;f.f+=c;let l=!1;function p(b,w){const r=[],s=new Array(b+1).join("	");for(const[a,d,o]of w.h)if(d&&o){l=!0,r.push(`${s}CREATES -> ${a}`);const u=p(b+1,o);u&&r.push(u)}else r.push(`${s}uses -> ${a}`);return r.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(c>2||l)&&f.all.add(E.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ie[12],Ce([1,0,45,5,7,28,21,2,3]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var M;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(M=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=M.Info;function D(u,n,h){switch(n){case M.Trace:u.trace(h);break;case M.Debug:u.debug(h);break;case M.Info:u.info(h);break;case M.Warning:u.warn(h);break;case M.Error:u.error(h);break;case M.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=D;function m(u){let n="";for(let h=0;h<u.length;h++){let g=u[h];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}n+=(h>0?" ":"")+g}return n}e.format=m;class v extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==M.Off&&this.b<=n}}e.AbstractLogger=v;class f extends v{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...h){this.f(M.Trace)&&this.g(M.Trace,m([n,...h]))}debug(n,...h){this.f(M.Debug)&&this.g(M.Debug,m([n,...h]))}info(n,...h){this.f(M.Info)&&this.g(M.Info,m([n,...h]))}warn(n,...h){this.f(M.Warning)&&this.g(M.Warning,m([n,...h]))}error(n,...h){if(this.f(M.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.g(M.Error,m(g))}else this.g(M.Error,m([n,...h]))}flush(){}}e.AbstractMessageLogger=f;class t extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...h){this.f(M.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}debug(n,...h){this.f(M.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}info(n,...h){this.f(M.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...h):console.log(`[main ${k()}]`,n,...h))}warn(n,...h){this.f(M.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,n,...h):console.warn(`[main ${k()}]`,n,...h))}error(n,...h){this.f(M.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,n,...h):console.error(`[main ${k()}]`,n,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class c extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...h){this.f(M.Trace)&&console.log("%cTRACE","color: #888",n,...h)}debug(n,...h){this.f(M.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...h)}info(n,...h){this.f(M.Info)&&console.log("%c INFO","color: #33f",n,...h)}warn(n,...h){this.f(M.Warning)&&console.log("%c WARN","color: #993",n,...h)}error(n,...h){this.f(M.Error)&&console.log("%c  ERR","color: #f33",n,...h)}dispose(){}flush(){}}e.ConsoleLogger=c;class l extends v{constructor(n,h=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(h)}trace(n,...h){this.f(M.Trace)&&this.g.log(M.Trace,[this.h(n),...h])}debug(n,...h){this.f(M.Debug)&&this.g.log(M.Debug,[this.h(n),...h])}info(n,...h){this.f(M.Info)&&this.g.log(M.Info,[this.h(n),...h])}warn(n,...h){this.f(M.Warning)&&this.g.log(M.Warning,[this.h(n),...h])}error(n,...h){this.f(M.Error)&&this.g.log(M.Error,[this.h(n),...h])}h(n){return typeof n=="string"?n:(0,i.toErrorMessage)(n,this.f(M.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class p extends v{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const h of this.g)h.setLevel(n);super.setLevel(n)}trace(n,...h){for(const g of this.g)g.trace(n,...h)}debug(n,...h){for(const g of this.g)g.debug(n,...h)}info(n,...h){for(const g of this.g)g.info(n,...h)}warn(n,...h){for(const g of this.g)g.warn(n,...h)}error(n,...h){for(const g of this.g)g.error(n,...h)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=p;class E extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...h){this.b.trace(n,...h)}debug(n,...h){this.b.debug(n,...h)}info(n,...h){this.b.info(n,...h)}warn(n,...h){this.b.warn(n,...h)}error(n,...h){this.b.error(n,...h)}flush(){this.b.flush()}}e.LogService=E;class b extends y.Disposable{constructor(n,h){super(),this.c=n,this.b=new L.ResourceMap,this.B(h(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,h,g){let P=this.b.get(n)?.logger;return P||(g=h?.always?M.Trace:g,P=this.f(n,g??this.c,h),this.b.set(n,{logger:P,logLevel:g})),P}setLevel(n,h){const g=O.URI.isUri(n)?n:void 0,P=g?h:n;if(g){const N=this.b.get(g);N&&N.logLevel!==P&&(N.logLevel=P,N.logger.setLevel(P))}else this.c=P,this.b.forEach(({logLevel:N,logger:j})=>{N===void 0&&j.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return M.Info}trace(n,...h){}debug(n,...h){}info(n,...h){}warn(n,...h){}error(n,...h){}critical(n,...h){}dispose(){}flush(){}}e.NullLogger=w;class r extends w{}e.NullLogService=r;class s extends b{constructor(){super(M.Info,T.Event.None)}f(n,h,g){return new w}}e.NullLoggerService=s;function a(u){if(u.verbose)return M.Trace;if(typeof u.logLevel=="string"){const n=o(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function d(u){switch(u){case M.Trace:return"trace";case M.Debug:return"debug";case M.Info:return"info";case M.Warning:return"warn";case M.Error:return"error";case M.Off:return"off"}}e.LogLevelToString=d;function o(u){switch(u){case"trace":return M.Trace;case"debug":return M.Debug;case"info":return M.Info;case"warn":return M.Warning;case"error":return M.Error;case"critical":return M.Error;case"off":return M.Off}}e.parseLogLevel=o}),define(Ie[87],Ce([1,0,29,132,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(f,t){return t-f}S.compare=k;const M=Object.create(null);M[S.Error]=(0,T.localize)(0,null),M[S.Warning]=(0,T.localize)(1,null),M[S.Info]=(0,T.localize)(2,null);function D(f){return M[f]||""}S.toString=D;function m(f){switch(f){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=m;function v(f){switch(f){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=v}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(S){const k="";function M(m){return D(m,!0)}S.makeKey=M;function D(m,v){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(C.toString(m.severity)):f.push(k),m.message&&v?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}S.makeKeyOptionalMessage=D})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ie[155],Ce([1,0,5,29,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new S,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=O;class S{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=S}),define(Ie[88],Ce([1,0,10,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function L(k,M){return T.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,M):(0,i.startsWithIgnoreCase)(k,M+":")}e.matchesScheme=L;function C(k,...M){return M.some(D=>L(k,D))}e.matchesSomeScheme=C;function O(k,M){return k.with({fragment:`${M.startLineNumber},${M.startColumn}${M.endLineNumber?`-${M.endLineNumber}${M.endColumn?`,${M.endColumn}`:""}`:""}`})}e.withSelection=O;function S(k){let M;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return D&&(M={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},k=k.with({fragment:""})),{selection:M,uri:k}}e.extractSelection=S}),define(Ie[156],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,T){var y=arguments.length,L=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,i):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,T);else for(var O=ee.length-1;O>=0;O--)(C=ee[O])&&(L=(y<3?C(L):y>3?C(e,i,L):C(e,i))||L);return y>3&&L&&Object.defineProperty(e,i,L),L},Ve=this&&this.__param||function(ee,e){return function(i,T){e(i,T,ee)}};define(Ie[157],Ce([1,0,14,20,7,3]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var C;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.Progress=O,O.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(D,m){super(),this.a=new i.DeferredPromise,m.withProgress(D,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends y.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new y.DisposableStore)}start(D){this.stop();const m=++this.a,v=new T.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>v.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:v.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,47,9]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,O){i.ok(T.isString(C)),i.ok(T.isObject(O)),i.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,O)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(Ie[89],Ce([1,0,5,30]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[y(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;T.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[90],Ce([1,0,16,5,9,128,40,89,30]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=S.Registry.as(O.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const a=this.k(r,s);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(r){const s=this.l(r);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const a=[];a.push(...this.l(s)),a.push(...this.k(r,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,i.distinct)(a)})}registerDefaultConfigurations(r){const s=[],a=[];for(const{overrides:d,source:o}of r)for(const u in d)if(s.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.a.get(u),h=n?.valuesSources??new Map;if(o)for(const j of Object.keys(d[u]))h.set(j,o);const g={...n?.value||{},...d[u]};this.a.set(u,{source:o,value:g,valuesSources:h});const P=(0,C.getLanguageTagSettingPlainKey)(u),N={type:"object",default:g,description:L.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(o)?void 0:o,defaultValueSource:o};a.push(...t(u)),this.d[u]=N,this.b.properties[u]=N}else{this.a.set(u,{value:d[u],source:o});const n=this.d[u];n&&(this.s(u,n),this.o(u,n))}this.registerOverrideIdentifiers(a),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const s=[];for(const{overrides:a,source:d}of r)for(const o in a){const u=this.a.get(o),n=y.isString(d)?d:d?.id,h=y.isString(u?.source)?u?.source:u?.source?.id;if(n===h)if(s.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const g=this.d[o];g&&(this.s(o,g),this.o(o,g))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){for(const s of r)this.h.add(s);this.q()}k(r,s){const a=[];return r.forEach(d=>{a.push(...this.m(d,s,d.extensionInfo,d.restrictedProperties)),this.c.push(d),this.n(d)}),a}l(r){const s=[],a=d=>{if(d.properties)for(const o in d.properties){s.push(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.p(o,d.properties[o])}d.allOf?.forEach(o=>a(o))};for(const d of r){a(d);const o=this.c.indexOf(d);o!==-1&&this.c.splice(o,1)}return s}m(r,s=!0,a,d,o=3){o=y.isUndefinedOrNull(r.scope)?o:r.scope;const u=[],n=r.properties;if(n)for(const g in n){const P=n[g];if(s&&E(g,P)){delete n[g];continue}if(P.source=a,P.defaultDefaultValue=n[g].default,this.s(g,P),e.OVERRIDE_PROPERTY_REGEX.test(g)?P.scope=void 0:(P.scope=y.isUndefinedOrNull(P.scope)?o:P.scope,P.restricted=y.isUndefinedOrNull(P.restricted)?!!d?.includes(g):P.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.f[g]=n[g],delete n[g];continue}else this.d[g]=n[g],n[g].policy?.name&&this.e.set(n[g].policy.name,g);!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),u.push(g)}const h=r.allOf;if(h)for(const g of h)u.push(...this.m(g,s,a,d,o));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(r){const s=a=>{const d=a.properties;if(d)for(const u in d)this.o(u,d[u]);a.allOf?.forEach(s)};s(r)}o(r,s){switch(e.allSettings.properties[r]=s,s.scope){case 1:e.applicationSettings.properties[r]=s;break;case 2:e.machineSettings.properties[r]=s;break;case 6:e.machineOverridableSettings.properties[r]=s;break;case 3:e.windowSettings.properties[r]=s;break;case 4:e.resourceSettings.properties[r]=s;break;case 5:e.resourceSettings.properties[r]=s,this.g.properties[r]=s;break}}p(r,s){switch(delete e.allSettings.properties[r],s.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.g.properties[r];break}}q(){for(const r of this.h.values()){const s=`[${r}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this.i.fire()}r(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this.i.fire()}s(r,s){const a=this.a.get(r);let d=a?.value,o=a?.source;y.isUndefined(d)&&(d=s.defaultDefaultValue,o=void 0),y.isUndefined(d)&&(d=l(s.type)),s.default=d,s.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(w){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let s=f.exec(w);for(;s?.length;){const a=s[1].trim();a&&r.push(a),s=f.exec(w)}}return(0,i.distinct)(r)}e.overrideIdentifiersFromKey=t;function c(w){return w.reduce((r,s)=>`${r}[${s}]`,"")}e.keyFromOverrideIdentifiers=c;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const p=new m;S.Registry.add(e.Extensions.Configuration,p);function E(w,r){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):p.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,w,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.validateProperty=E;function b(){const w=[],r=p.getConfigurationProperties();for(const s of Object.keys(r))w.push([s,r[s].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(Ie[158],Ce([1,0,16,5,109,7,28,23,9,2,40,90,30]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(s={},a=[],d=[],o){this.c=s,this.d=a,this.f=d,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof v)return a;const d=new f("");return d.parseRaw(a),d.configurationModel});this.g=s.reduce((a,d)=>d===a?d:a.merge(d),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,M.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const d=this.rawConfiguration.getValue(s),o=a?this.rawConfiguration.getOverrideValue(s,a):void 0,u=a?this.rawConfiguration.override(a).getValue(s):d;return{value:d,override:o,merged:u}}getOverrideValue(s,a){const d=this.l(a);return d?s?(0,M.getConfigurationValue)(d,s):d:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const d of this.overrides)d.identifiers.includes(s)&&a.push(...d.keys);return i.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return i.distinct(s)}override(s){let a=this.b.get(s);return a||(a=this.h(s),this.b.set(s,a)),a}merge(...s){const a=O.deepClone(this.contents),d=O.deepClone(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const n of s)if(u.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const h of n.overrides){const[g]=d.filter(P=>i.equals(P.identifiers,h.identifiers));g?(this.j(g.contents,h.contents),g.keys.push(...h.keys),g.keys=i.distinct(g.keys)):d.push(O.deepClone(h))}for(const h of n.keys)o.indexOf(h)===-1&&o.push(h)}return new v(a,o,d,u.every(n=>n instanceof v)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new v(O.deepClone(this.contents),[...this.keys],O.deepClone(this.overrides))}h(s){const a=this.l(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const d={};for(const o of i.distinct([...Object.keys(this.contents),...Object.keys(a)])){let u=this.contents[o];const n=a[o];n&&(typeof u=="object"&&typeof n=="object"?(u=O.deepClone(u),this.j(u,n)):u=n),d[o]=u}return new v(d,this.keys,this.overrides)}j(s,a){for(const d of Object.keys(a)){if(d in s&&S.isObject(s[d])&&S.isObject(a[d])){this.j(s[d],a[d]);continue}s[d]=O.deepClone(a[d])}}k(s){return this.a&&!Object.isFrozen(s)?O.deepFreeze(s):s}l(s){let a=null,d=null;const o=u=>{u&&(d?this.j(d,u):d=O.deepClone(u))};for(const u of this.overrides)i.equals(u.identifiers,[s])?a=u.contents:u.identifiers.includes(s)&&o(u.contents);return o(a),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,a){this.m(s),(0,M.addToValueTree)(this.contents,s,a,d=>{throw new Error(d)})}removeValue(s){this.n(s)&&(0,M.removeFromValueTree)(this.contents,s)}m(s){let a=this.keys.length;for(let d=0;d<a;d++)s.indexOf(this.keys[d])===0&&(a=d);this.keys.splice(a,1,s)}n(s){const a=this.keys.indexOf(s);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=v;class f{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!S.isUndefinedOrNull(s)){const d=this.g(s);this.parseRaw(d,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:d,keys:o,overrides:u,restricted:n,hasExcludedProperties:h}=this.h(s,a);this.b=new v(d,o,u,h?[s]:void 0),this.c=n||[]}g(s){let a={},d=null,o=[];const u=[],n=[];function h(P){Array.isArray(o)?o.push(P):d!==null&&(o[d]=P)}const g={onObjectBegin:()=>{const P={};h(P),u.push(o),o=P,d=null},onObjectProperty:P=>{d=P},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const P=[];h(P),u.push(o),o=P,d=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:h,onError:(P,N,j)=>{n.push({error:P,offset:N,length:j})}};if(s)try{y.visit(s,g),a=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return a}h(s,a){const d=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),o=this.j(s,d,!0,a);s=o.raw;const u=(0,M.toValuesTree)(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),n=Object.keys(s),h=this.l(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:u,keys:n,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(s,a,d,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:u};const n={},h=[];for(const g in s)if(D.OVERRIDE_PROPERTY_REGEX.test(g)&&d){const P=this.j(s[g],a,!1,o);n[g]=P.raw,u=u||P.hasExcludedProperties,h.push(...P.restricted)}else{const P=a[g],N=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&h.push(g),(N===void 0||o.scopes===void 0||o.scopes.includes(N))&&!(o.skipRestricted&&P?.restricted)?n[g]=s[g]:u=!0}return{raw:n,restricted:h,hasExcludedProperties:u}}l(s,a){const d=[];for(const o of Object.keys(s))if(D.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const n in s[o])u[n]=s[o][n];d.push({identifiers:(0,D.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,M.toValuesTree)(u,a)})}return d}}e.ConfigurationModelParser=f;class t extends L.Disposable{constructor(s,a,d,o){super(),this.f=s,this.g=a,this.h=o,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class c{constructor(s,a,d,o,u,n,h,g,P,N,j,Z,G){this.a=s,this.b=a,this.value=d,this.overrideIdentifiers=o,this.c=u,this.d=n,this.f=h,this.g=g,this.h=P,this.j=N,this.k=j,this.l=Z,this.m=G}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(s,a,d,o,u=new v,n=new v,h=new C.ResourceMap,g=new v,P=new C.ResourceMap,N=!0){this.c=s,this.d=a,this.f=d,this.g=o,this.h=u,this.j=n,this.l=h,this.m=g,this.n=P,this.p=N,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(s,a,d){return this.s(s,a,d).getValue(s)}updateValue(s,a,d={}){let o;d.resource?(o=this.n.get(d.resource),o||(o=new v,this.n.set(d.resource,o))):o=this.m,a===void 0?o.removeValue(s):o.setValue(s,a),d.resource||(this.a=null)}inspect(s,a,d){const o=this.s(s,a,d),u=this.w(a.resource,d),n=a.resource?this.n.get(a.resource)||this.m:this.m,h=new Set;for(const g of o.overrides)for(const P of g.identifiers)o.getOverrideValue(s,P)!==void 0&&h.add(P);return new c(s,a,o.getValue(s),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,u?u.freeze():void 0,n.inspect(s,a.overrideIdentifier))}keys(s){const a=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.l.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const d=[];if(!a){const{added:o,updated:u,removed:n}=b(this.c,s);a=[...o,...u,...n]}for(const o of a)for(const u of(0,D.overrideIdentifiersFromKey)(o)){const n=this.c.getKeysForOverrideIdentifier(u),h=s.getKeysForOverrideIdentifier(u),g=[...h.filter(P=>n.indexOf(P)===-1),...n.filter(P=>h.indexOf(P)===-1),...n.filter(P=>!O.equals(this.c.override(u).getValue(P),s.override(u).getValue(P)))];d.push([u,g])}return this.updateDefaultConfiguration(s),{keys:a,overrides:d}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:d,removed:o}=b(this.d,s),u=[...a,...d,...o];return u.length&&this.updatePolicyConfiguration(s),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:d,removed:o,overrides:u}=b(this.applicationConfiguration,s),n=[...a,...d,...o];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:d,removed:o,overrides:u}=b(this.localUserConfiguration,s),n=[...a,...d,...o];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:u}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:d,removed:o,overrides:u}=b(this.remoteUserConfiguration,s),n=[...a,...d,...o];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:u}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:d,removed:o,overrides:u}=b(this.workspaceConfiguration,s),n=[...a,...d,...o];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:u}}compareAndUpdateFolderConfiguration(s,a){const d=this.r.get(s),{added:o,updated:u,removed:n,overrides:h}=b(d,a),g=[...o,...u,...n];return(g.length||!d)&&this.updateFolderConfiguration(s,a),{keys:g,overrides:h}}compareAndDeleteFolderConfiguration(s){const a=this.r.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:d,updated:o,removed:u,overrides:n}=b(a,void 0);return{keys:[...d,...o,...u],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,a,d){let o=this.t(a,d);return a.overrideIdentifier&&(o=o.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(o=o.merge(this.d)),o}t({resource:s},a){let d=this.u();if(a&&s){const o=a.getFolder(s);o&&(d=this.v(o.uri)||d);const u=this.n.get(s);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let a=this.b.get(s);if(!a){const d=this.u(),o=this.l.get(s);o?(a=d.merge(o),this.p&&(a=a.freeze()),this.b.set(s,a)):a=d}return a}w(s,a){if(a&&s){const d=a.getFolder(s);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,a)=>{const{contents:d,overrides:o,keys:u}=this.l.get(a);return s.push([a,{contents:d,overrides:o,keys:u}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(a=>s.add(a)),this.userConfiguration.freeze().keys.forEach(a=>s.add(a)),this.j.freeze().keys.forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(d=>s.add(d))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(d=>s.add(d))),[...s.values()]}y(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(d=>a.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(d=>a.add(d)),this.j.getKeysForOverrideIdentifier(s).forEach(d=>a.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(s).forEach(o=>a.add(o))),[...a.values()]}static parse(s){const a=this.z(s.defaults),d=this.z(s.policy),o=this.z(s.application),u=this.z(s.user),n=this.z(s.workspace),h=s.folders.reduce((g,P)=>(g.set(k.URI.revive(P[0]),this.z(P[1])),g),new C.ResourceMap);return new l(a,d,o,u,new v,n,h,new v,new C.ResourceMap,!1)}static z(s){return new v(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=l;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,a=new Map;for(const o of r)o.keys.forEach(u=>s.add(u)),o.overrides.forEach(([u,n])=>{const h=(0,C.getOrSet)(a,u,new Set);n.forEach(g=>h.add(g))});const d=[];return a.forEach((o,u)=>d.push([u,[...o.values()]])),{keys:[...s.values()],overrides:d}}e.mergeChanges=p;class E{constructor(s,a,d,o){this.change=s,this.b=a,this.c=d,this.d=o,this.f=void 0;const u=new Set;s.keys.forEach(h=>u.add(h)),s.overrides.forEach(([,h])=>h.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const n=new v;this.affectedKeys.forEach(h=>n.setValue(h,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(s,a){if(this.g(this.a,s)){if(a){const d=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.b?.workspace):void 0,o=this.c.getValue(s,a,this.d);return!O.equals(d,o)}return!0}return!1}g(s,a){let d=(0,M.toValuesTree)({[a]:!0},()=>{}),o;for(;typeof d=="object"&&(o=Object.keys(d)[0]);){if(s=s[o],!s)return!1;d=d[o]}return!0}}e.ConfigurationChangeEvent=E;function b(r,s){const{added:a,removed:d,updated:o}=w(s?.rawConfiguration,r?.rawConfiguration),u=[],n=r?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const g=h.filter(P=>!n.includes(P));for(const P of g)u.push([P,s.getKeysForOverrideIdentifier(P)])}if(r){const g=n.filter(P=>!h.includes(P));for(const P of g)u.push([P,r.getKeysForOverrideIdentifier(P)])}if(s&&r){for(const g of n)if(h.includes(g)){const P=w({contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});u.push([g,[...P.added,...P.removed,...P.updated]])}}return{added:a,removed:d,updated:o,overrides:u}}function w(r,s){const a=r?s?r.keys.filter(u=>s.keys.indexOf(u)===-1):[...r.keys]:[],d=s?r?s.keys.filter(u=>r.keys.indexOf(u)===-1):[...s.keys]:[],o=[];if(r&&s){for(const u of s.keys)if(r.keys.indexOf(u)!==-1){const n=(0,M.getConfigurationValue)(s.contents,u),h=(0,M.getConfigurationValue)(r.contents,u);O.equals(n,h)||o.push(u)}}return{added:a,removed:d,updated:o}}}),define(Ie[91],Ce([1,0,11,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(O){return O instanceof L&&O._code===y.NotAvailable}static isTemporarilyNotAvailable(O){return O instanceof L&&O._code===y.TemporarilyNotAvailable}static isNoResolverFound(O){return O instanceof L&&O._code===y.NoResolverFound}static isHandled(O){return O instanceof L&&O.isHandled}constructor(O,S=y.Unknown,k){super(O),this._message=O,this._code=S,this._detail=k,this.isHandled=S===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(Ie[48],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const M=k.indexOf("+");return M<0?k:k.substr(0,M)}e.getRemoteName=y;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function C(k){const{host:M,port:D}=S(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:D}}e.parseAuthorityWithPort=C;function O(k,M){let{host:D,port:m}=S(k);return typeof m>"u"&&(m=M),{host:D,port:m}}e.parseAuthorityWithOptionalPort=O;function S(k){const M=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,48]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));var S;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,c){if(typeof t>"u"||t===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof t=="string"||typeof c=="string"){const l=typeof t=="string"?t:t.value,p=typeof c=="string"?c:c.value;return i.equalsIgnoreCase(l,p)}return t.c===c.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=k;function M(f){return D(f)}e.isApplicationScopedExtension=M;function D(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(f,t){if(t){const c=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return f.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[159],Ce([1,0,21,49,2,34]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function O(k,M,D,m,v,f,t,c,l,p){const E=Object.create(null);E["common.machineId"]=t,E.sessionID=(0,L.generateUuid)()+Date.now(),E.commitHash=v,E.version=f,E["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=T.platform,E["common.nodeArch"]=m,E["common.product"]=p||"desktop",c&&(E["common.msftInternal"]=c);let b=0;const w=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const r=C(D);r&&(E["common.platformDetail"]=r);try{const s=await k.readFile(y.URI.file(l));E["common.source"]=s.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=O;function S(k){const M=T.env.USERDNSDOMAIN;if(!M)return!1;const D=M.toLowerCase();return k.some(m=>D===m)}e.verifyMicrosoftInternalDomain=S}),define(Ie[160],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[50],Ce([1,0,23,9,40,48,159,160]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(u){this.value=u}}e.TrustedTelemetryValue=S;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(u,n){return Promise.resolve(void 0)}publicLog2(u,n){return this.publicLog(u,n)}publicLogError(u,n){return Promise.resolve(void 0)}publicLogError2(u,n){return this.publicLogError(u,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class M{async publicLog(u,n,h){}async publicLogError(u,n,h){}}e.NullEndpointTelemetryService=M,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(o,u){return u.onDidChangeConfiguration(n=>{n.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(n.source),configurationKeys:E(n.sourceConfig)})})}e.configurationTelemetry=D;function m(o,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!o.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=m;function v(o,u){return!(u.isBuilt||u.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=v;function f(o){const u=o.getValue(O.TELEMETRY_SETTING_ID),n=o.getValue("telemetry.enableCrashReporter");if(o.getValue(O.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function t(o){const u={},n={},h={};p(o,h);for(let g in h){g=g.length>150?g.substr(g.length-149):g;const P=h[g];typeof P=="number"?n[g]=P:typeof P=="boolean"?n[g]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${P.length}`),u[g]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(u[g]=P)}return{properties:u,measurements:n}}e.validateTelemetryData=t;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(o){if(!o)return"none";const u=(0,L.getRemoteName)(o);return c.has(u)?u:"other"}e.cleanRemoteAuthority=l;function p(o,u,n=0,h){if(!!o)for(const g of Object.getOwnPropertyNames(o)){const P=o[g],N=h?h+g:g;Array.isArray(P)?u[N]=(0,i.safeStringify)(P):P instanceof Date?u[N]=P.toISOString():(0,T.isObject)(P)?n<2?p(P,u,n+1,N+"."):u[N]=(0,i.safeStringify)(P):u[N]=P}}function E(o){if(!o)return[];const u=[];return b(u,"",o),u}function b(o,u,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(h=>b(o,u?`${u}.${h}`:h,n[h])):o.push(u)}function w(o,u){const n=o.msftInternalDomains||[],h=u.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(n)||h}e.isInternalTelemetry=w;function r(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=r;function s(o,u){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let n=o;const h=[];for(const j of u)for(;;){const Z=j.exec(o);if(!Z)break;h.push([Z.index,j.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(n="";;){const j=P.exec(o);if(!j)break;const Z=h.some(([G,R])=>j.index<R&&G<P.lastIndex);!g.test(j[0])&&!Z&&(n+=o.substring(N,j.index)+"<REDACTED: user-file-path>",N=P.lastIndex)}return N<o.length&&(n+=o.substr(N)),n}function a(o){if(!o)return o;const u=o.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return o}function d(o,u){return(0,i.cloneAndChange)(o,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let h=n.replaceAll("%20"," ");h=s(h,u);for(const g of u)h=h.replace(g,"");return h=a(h),h}})}e.cleanData=d}),define(Ie[161],Ce([1,0,10,86,26,21,2,11,49,50]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function M(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,i.compareIgnoreCase)(a.id,d.id)===0}e.areSameExtensions=M;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(d){const o=d.manifest?d.manifest.version:d.version,u=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new m(d.identifier,o,u)}static parse(d){const o=D.exec(d);return o&&o[1]&&o[2]?new m({id:o[1]},o[2],o[4]||void 0):null}constructor(d,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof m?M(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.ExtensionKey=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(a){const d=v.exec(a);return d&&d[1]?[c(d[1]),d[2]]:[c(a),void 0]}e.getIdAndVersion=f;function t(a,d){return`${a}.${d}`}e.getExtensionId=t;function c(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function l(a,d){return c(t(a,d))}e.getGalleryExtensionId=l;function p(a,d){const o=[],u=n=>{for(const h of o)if(h.some(g=>M(d(g),d(n))))return h;return null};for(const n of a){const h=u(n);h?h.push(n):o.push([n])}return o}e.groupByExtension=p;function E(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function b(a){return{id:new k.TrustedTelemetryValue(a.identifier.id),name:new k.TrustedTelemetryValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function w(a,d){const o=[],u=d.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const n=u.shift();if(n&&o.every(h=>!M(h.identifier,{id:n}))){const h=a.filter(g=>M(g.identifier,{id:n}));h.length===1&&(o.push(h[0]),u.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=w;async function r(a,d){if(!L.isLinux)return!1;let o;try{o=(await a.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await a.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){d.debug("Error while getting the os-release file.",(0,O.getErrorMessage)(n))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function s(a,d){const o=await r(a,d),u=(0,T.getTargetPlatform)(o?"alpine":L.platform,S.arch);return d.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=s}),define(Ie[162],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,L,C=5){const O=L(S=>{const k=typeof S=="string"?S:S.data;let M=this.a.get(y);if(M){M.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(y),C);M={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(y),O.dispose()}},this.a.set(y,M)});return O}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const L=this.a.get(y);L&&(this.a.delete(y),this.b(y,L.data.join("")))}}e.TerminalDataBufferer=i}),define(Ie[163],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function T(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ie[65],Ce([1,0,121,5,7,3,30,163]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var S;(function(c){function l(p){return p&&typeof p=="object"&&typeof p.id=="string"}c.isThemeColor=l})(S=e.ThemeColor||(e.ThemeColor={}));function k(c){return{id:c}}e.themeColorFromId=k;var M;(function(c){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||S.isThemeColor(d.color))}c.isThemeIcon=l;const p=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function E(d){const o=p.exec(d);if(!o)return;const[,u]=o;return{id:u}}c.fromString=E;function b(d){return{id:d}}c.fromId=b;function w(d,o){let u=d.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),o&&(u=`${u}~${o}`),{id:u}}c.modify=w;function r(d){const o=d.id.lastIndexOf("~");if(o!==-1)return d.id.substring(o+1)}c.getModifier=r;function s(d,o){return d.id===o.id&&d.color?.id===o.color?.id}c.isEqual=s;function a(d,o){return{id:d.id,color:o?k(o):void 0}}c.asThemeIcon=a,c.asClassNameArray=i.CSSIcon.asClassNameArray,c.asClassName=i.CSSIcon.asClassName,c.asCSSSelector=i.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function D(c){switch(c){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case O.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const p=this.a.indexOf(l);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const v=new m;C.Registry.add(e.Extensions.ThemingContribution,v);function f(c){return v.onColorThemeChange(c)}e.registerThemingParticipant=f;class t extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,p){let E=this.h.getColor(l);return E&&p&&(E=p(E,this.h)),E?E.toString():null}}e.Themable=t}),define(Ie[164],Ce([1,0,5,40,3,12]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(t){t.Http="http",t.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=D;function m(t,c,l,p){if(l===1)return!1;if(l===2&&D(c)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.isPortPrivileged=m;class v{constructor(c,l,p){this.remoteAddress=c,this.localAddress=l,this.b=p,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=v;let f=class{constructor(c,l){this.i=c,this.j=l,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],l=Array.from(this.d.values());for(const p of l){const E=Array.from(p.values());for(const b of E){const w=await b.value;w&&c.push(w)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:l}of c.values())await l.then(p=>p?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,l,p,E,b){this.o(c,l,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:l,localAddress:p,privacy:E,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,l){(D(c)||M(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const p=this.q(c,l);if(p)return++p.refcount,p.value}openTunnel(c,l,p,E,b=!1,w,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${p} on local port ${E}.`),!c)return;if(l||(l="localhost"),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(c,l,p,E,b,w,r);return s?s.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const l=this.d.get(c.tunnelRemoteHost);if(l){const p=l.get(c.tunnelRemotePort);p&&(p.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,p))}}}}async n(c,l,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${l}.`);const E=p.value.then(async b=>{b&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(l),E}}async closeTunnel(c,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${l} `);const p=this.d.get(c);if(p&&p.has(l)){const E=p.get(l);E.refcount=0,await this.n(c,l,E)}}o(c,l,p){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(l,{refcount:1,value:p})}async p(c,l){const p=this.d.get(c);p&&(await p.get(l)||p.delete(l),p.size===0&&this.d.delete(c))}q(c,l){const p=[c];M(c)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):D(c)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const E=p.map(b=>this.d.get(b));for(const b of E){const w=b?.get(l);if(w)return w}}canTunnel(c){return!!k(c)}s(c,l,p,E,b,w,r){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${p} on local port ${E}.`);const s=p;this.h.add(s);const a=E===void 0?p:E,d={elevationRequired:b?this.isPortPrivileged(a):!1},o={remoteAddress:{host:l,port:p},localAddressPort:E,privacy:w,public:w?w!==O.Private:void 0,protocol:r},u=c.forwardPort(o,d);return u?(this.o(l,p,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),u}};f=qe([Ve(0,L.ILogService),Ve(1,T.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ie[165],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[166],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function L(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=L;function C(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=C;function O(S){return y(S)!==void 0}e.isVirtualWorkspace=O}),define(Ie[51],Ce([1,0,133,19,46,22,2,3,13]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,O.createDecorator)("contextService");function k(s){const a=s;return typeof a?.id=="string"&&C.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function M(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,T.basename)(s)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const d=s;if(d.configuration)return{id:d.id,configPath:d.configuration};if(d.folders.length===1)return{id:d.id,uri:d.folders[0].uri}}e.toWorkspaceIdentifier=M;function D(s){const a=s;return typeof a?.id=="string"&&C.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=D;function m(s){const a=s;if(a?.uri)return{id:a.id,uri:C.URI.revive(a.uri)};const d=s;if(d?.configPath)return{id:d.id,configPath:C.URI.revive(d.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=m;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function f(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=f;function t(s){const a=s;return!!(a&&typeof a=="object"&&C.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=t;class c{constructor(a,d,o,u,n){this.h=a,this.j=o,this.k=u,this.l=n,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class l{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,L.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function p(s){return new l({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(s,a){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,a.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function b(s){let a;return C.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=b;function w(s,a){return!E(s,a)&&!b(s)}e.isSavedWorkspace=w;function r(s){return(typeof s=="string"?(0,T.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ie[52],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const L=this.c++;return this.b.set(L,y),this.e(),L}get(y,L){return this.b.has(y)?this.b.get(y)[L]:void 0}delete(y){this.b.delete(y),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Ie[37],Ce([1,0,13,22,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(O=>{const S=this.b.get(O.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(O,S){S===null?this.b.delete(O.scheme):this.b.set(O.scheme,S)}isFreeScheme(O){return!this.b.has(O)&&!this.a.has(O)}getCapabilities(O){return this.b.get(O)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ie[167],Ce([1,0,14]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,O,S){this.h=new Map,this.a=C,this.b=O,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of k.values())M.complete()}catch(M){for(const D of k.values())D.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,O){let S=this.f[C];return typeof S>"u"&&(S=O),S}update(C,O){this.f[C]=O;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new i.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,O){super(C.identifier.value,!0,O),this.j=C}}e.ExtensionGlobalMemento=y}),define(Ie[168],Ce([1,0,5,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,O,S,k){const D=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(O.value,S,k);this.b.fire(D)}$acceptDirtyStateChanged(C,O){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(O)}$acceptModelSaved(C){const O=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(O.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ie[15],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[169],Ce([1,0,26,5]),function(ee,e,i,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(O,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(O.identifier),Ye(this,y,S,"f"),Re(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(O){return Re(this,y,"f").get(this.a,O)}store(O,S){return Re(this,y,"f").store(this.a,O,S)}delete(O){return Re(this,y,"f").delete(this.a,O)}}e.ExtensionSecrets=L,y=new WeakMap}),define(Ie[66],Ce([1,0,3,164,5,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=k;function M(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==T.TunnelPrivacyId.ConstantPrivate&&D.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=M})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let O=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,M){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,M){return{dispose:()=>{}}}async $providePortAttributes(k,M,D,m,v){return[]}async $forwardPort(k,M){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=qe([Ve(0,L.IExtHostRpcService)],O),e.ExtHostTunnelService=O}),define(Ie[53],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(Ie[170],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function y(O,S){if(S.serializeBuffersForPostMessage){const k=new T,M=(v,f)=>{if(f instanceof ArrayBuffer){const t=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(f)){const t=L(f);if(t){const c=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:t,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},D=JSON.stringify(O,M),m=k.buffers.map(v=>{const f=new Uint8Array(v);return i.VSBuffer.wrap(f)});return{message:D,buffers:m}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=y;function L(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(O,S){const k=S.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),M=S.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const f=v,{index:t}=f,c=k[t];if(f.view)switch(f.view.type){case 1:return new Int8Array(c,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return v}:void 0;return{message:JSON.parse(O,M),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ie[92],Ce([1,0,141,9,2,7,3,30,36,13]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var M;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(M=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(K){const ie=K;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=m;function v(K,ie,ge){for(const ue of ge.visibleEditorPanes)if(ue.group.id===ie&&K.matches(ue.input))return ue.getViewState()}e.findViewStateForEditor=v;function f(K){if(o(K))return!1;const ie=K;return y.URI.isUri(ie?.resource)}e.isResourceEditorInput=f;function t(K){if(o(K))return!1;const ie=K;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=t;function c(K){if(o(K)||t(K))return!1;const ie=K;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function l(K){if(o(K))return!1;const ie=K;return ie?ie.resource===void 0||ie.resource.scheme===k.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;const p=/Untitled-\d+/;function E(K){return K.scheme===k.Schemas.untitled&&K.path.length>1&&!p.test(K.path)}e.isUntitledWithAssociatedResource=E;function b(K){if(o(K))return!1;const ie=K;return y.URI.isUri(ie?.base?.resource)&&y.URI.isUri(ie?.input1?.resource)&&y.URI.isUri(ie?.input2?.resource)&&y.URI.isUri(ie?.result?.resource)}e.isResourceMergeEditorInput=b;var w;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var r;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.a=new Map}registerSource(ie,ge){let ue=this.a.get(ie);return ue||(ue={source:ie,label:ge},this.a.set(ie,ue)),ue.source}getSourceLabel(ie){return this.a.get(ie)?.label??ie}}e.SaveSourceRegistry=new s;var a;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends L.Disposable{}e.AbstractEditorInput=d;function o(K){return K instanceof d}e.isEditorInput=o;function u(K){const ie=K;return y.URI.isUri(ie?.preferredResource)}function n(K){const ie=K;return o(ie?.primary)&&o(ie?.secondary)}e.isSideBySideEditorInput=n;function h(K){const ie=K;return o(ie?.modified)&&o(ie?.original)}e.isDiffEditorInput=h;function g(K){return o(K?.editor)}e.isEditorInputWithOptions=g;function P(K){const ie=K;return g(K)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function N(K){const ie=K;return typeof ie?.groupId=="number"&&o(ie.editor)}e.isEditorIdentifier=N;var j;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var Z;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Z=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var G;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(G=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(ie,ge){if(!ie)return;if(b(ie))return e.EditorResourceAccessor.getOriginalUri(ie.result,ge);if(ge?.supportSideBySide){const{primary:re,secondary:se}=this.a(ie);if(re&&se){if(ge?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(re,{filterByScheme:ge.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===G.ANY)return this.getOriginalUri(re,{filterByScheme:ge.filterByScheme})??this.getOriginalUri(se,{filterByScheme:ge.filterByScheme});ie=ge.supportSideBySide===G.PRIMARY?re:se}}if(t(ie)||c(ie)||b(ie))return;const ue=u(ie)?ie.preferredResource:ie.resource;return!ue||!ge||!ge.filterByScheme?ue:this.b(ue,ge.filterByScheme)}a(ie){return n(ie)||c(ie)?{primary:ie.primary,secondary:ie.secondary}:h(ie)||t(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,ge){if(!ie)return;if(b(ie))return e.EditorResourceAccessor.getCanonicalUri(ie.result,ge);if(ge?.supportSideBySide){const{primary:re,secondary:se}=this.a(ie);if(re&&se){if(ge?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(re,{filterByScheme:ge.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===G.ANY)return this.getCanonicalUri(re,{filterByScheme:ge.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:ge.filterByScheme});ie=ge.supportSideBySide===G.PRIMARY?re:se}}if(t(ie)||c(ie)||b(ie))return;const ue=ie.resource;return!ue||!ge||!ge.filterByScheme?ue:this.b(ue,ge.filterByScheme)}b(ie,ge){if(Array.isArray(ge)){if(ge.some(ue=>ie.scheme===ue))return ie}else if(ge===ie.scheme)return ie}}e.EditorResourceAccessor=new R;var A;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(A=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(ie){const ge=this.a=ie.get(C.IInstantiationService);for(const[ue,re]of this.c)this.e(ue,re,ge);this.c.clear()}e(ie,ge,ue){const re=ue.createInstance(ge);this.d.set(ie,re)}registerFileEditorFactory(ie){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ie}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(ie,ge){if(this.c.has(ie)||this.d.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.a?this.e(ie,ge,this.a):this.c.set(ie,ge),(0,L.toDisposable)(()=>{this.c.delete(ie),this.d.delete(ie)})}getEditorSerializer(ie){return this.d.get(typeof ie=="string"?ie:ie.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new F);async function B(K,ie,ge){return!K||!K.length?[]:await Promise.all(K.map(async ue=>{const re=y.URI.revive(ue.fileUri);if(!re){ge.info("Cannot resolve the path because it is not valid.",ue);return}if(!await ie.canHandleResource(re)){ge.info("Cannot resolve the path because it cannot be handled",ue);return}let le=ue.exists,_=ue.type;if(typeof le!="boolean"||typeof _!="number")try{_=(await ie.stat(re)).isDirectory?S.FileType.Directory:S.FileType.Unknown,le=!0}catch(we){ge.error(we),le=!1}if(!le&&ue.openOnlyIfExists){ge.info("Cannot resolve the path because it does not exist",ue);return}if(_===S.FileType.Directory){ge.info("Cannot resolve the path because it is a directory",ue);return}const me={...ue.options,pinned:!0};return le?{resource:re,options:me}:{resource:re,options:me,forceUntitled:!0}}))}e.pathsToEditors=B;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function V(K){const ie=K;if(!ie)return!1;const ge=ie;if(ge.modified)return V(ge.modified);const ue=ie;return!!(ue.contributionsState&&ue.viewState&&Array.isArray(ue.cursorState))}e.isTextEditorViewState=V}),define(Ie[171],Ce([1,0,5,14,142]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(O){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=O}onEvent(O){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=O}onRequest(O){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.s("response",O)}sendRequest(O,S,k,M){const D={command:O};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof M=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(D.seq);if(v){this.f.delete(D.seq);const f={type:"response",seq:0,request_seq:D.seq,success:!1,command:O,message:(0,y.localize)(0,null,M,O)};v(f)}},M)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(O){this.j?this.j(O):(this.k.push(O),this.k.length===1&&this.q())}o(O,S){return O.type!=="event"||S.type!=="event"}async q(){let O;for(;this.k.length;){if((!O||this.o(this.k[0],O))&&await(0,T.timeout)(0),O=this.k.shift(),!O)return;switch(O.type){case"event":this.i?.(O);break;case"request":this.g?.(O);break;case"response":{const S=O,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(O,S){S.type=O,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((S,k)=>O.set(k,S)),await(0,T.timeout)(500),O.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ie[172],Ce([1,0,143,41,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const L=m=>i.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var C;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(C=e.State||(e.State={}));function O(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var S;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var M;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(M=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var D;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[173],Ce([1,0,10,2,19,23,13]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function S(a,d,o){return a.replace(O,function(u,n){return d&&n.length>0&&n[0]!=="_"?u:o&&o.hasOwnProperty(n)?o[n]:u})}e.formatPII=S;function k(a){const d={};for(const o of Object.keys(a))o.startsWith("!")||(d[o]=a[o]);return d}e.filterExceptionsFromTelemetry=k;function M(a){return a.configuration.request==="attach"&&!D(a)&&(!a.parentSession||M(a.parentSession))}e.isSessionAttach=M;function D(a){let d=a.configuration.type;if(!!d)return d==="vslsShare"&&(d=a.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(d,"extensionhost")||(0,i.equalsIgnoreCase)(d,"pwa-extensionhost")?a:a.parentSession?D(a.parentSession):void 0}e.getExtensionHostDebugSession=D;function m(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=m;function v(a,d,o){let u,n=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=h.exec(a);){const P=g.index+1,N=P+g[0].length;if(P<=d&&N>=o){u=g[0],n=P;break}}if(u){const P=/\w+/g;let N=null;for(;(N=P.exec(u))&&!(N.index+1+n+N[0].length>=o););N&&(u=u.substring(0,P.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(a){return!!(a&&a.match(f))}e.isUri=t;function c(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(t(a.path))return T.URI.parse(a.path);if((0,y.isAbsolute)(a.path))return T.URI.file(a.path)}return a.path}function l(a){if(typeof a.path=="object"){const d=T.URI.revive(a.path);if(d)return d.scheme===C.Schemas.file?d.fsPath:d.toString()}return a.path}function p(a,d){const o=d?c:l,u=(0,L.deepClone)(a);return b(u,(n,h)=>{n&&h&&(h.path=o(h))}),u}e.convertToDAPaths=p;function E(a,d){const o=d?c:l,u=(0,L.deepClone)(a);return b(u,(n,h)=>{!n&&h&&(h.path=o(h))}),u}e.convertToVSCPaths=E;function b(a,d){switch(a.type){case"event":{const o=a;switch(o.event){case"output":d(!1,o.body.source);break;case"loadedSource":d(!1,o.body.source);break;case"breakpoint":d(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=a;switch(o.command){case"setBreakpoints":d(!0,o.arguments.source);break;case"breakpointLocations":d(!0,o.arguments.source);break;case"source":d(!0,o.arguments.source);break;case"gotoTargets":d(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const o=a;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":o.body.sources.forEach(u=>d(!1,u));break;case"scopes":o.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":o.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":o.body?.instructions.forEach(n=>d(!1,n.location));break;default:break}break}}}function w(a){return a.filter(d=>!d.presentation?.hidden).sort((d,o)=>d.presentation?o.presentation?d.presentation.group?o.presentation.group?d.presentation.group!==o.presentation.group?d.presentation.group.localeCompare(o.presentation.group):r(d.presentation.order,o.presentation.order):-1:o.presentation.group?1:r(d.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=w;function r(a,d){return typeof a!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:a-d}async function s(a,d){const o=a.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(o!=="none"&&(await d.saveAll(),o==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===C.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(Ie[67],Ce([1,0,24,35,174,62,13,19,21,41]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var M;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var v;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(v=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var p;(function(B){B.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),K=7;function ie(_,me){const we=me.toString(K),We=`${we.length<z.length?z[we.length-1]:"z"}${we}s${(0,i.encodeBase64)(i.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:B.scheme,fragment:We})}B.generate=ie;function ge(_){if(_.scheme!==B.scheme)return;const me=_.fragment.indexOf("s");if(me<0)return;const we=parseInt(_.fragment.substring(0,me).replace(V,""),K),Me=(0,i.decodeBase64)(_.fragment.substring(me+1)).toString();if(!isNaN(we))return{handle:we,notebook:_.with({scheme:Me,fragment:null})}}B.parse=ge;function ue(_,me){return _.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${_.scheme!==C.Schemas.file?_.scheme:""}`})}B.generateCellOutputUri=ue;function re(_){if(_.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!me)return;const we=me[1]&&me[1]!==""?me[1]:void 0,Me=me[2];return{outputId:we,notebook:_.with({scheme:Me||C.Schemas.file,fragment:null})}}B.parseCellOutputUri=re;function se(_,me,we){return B.generate(_,me).with({scheme:we})}B.generateCellPropertyUri=se;function le(_,me){if(_.scheme===me)return B.parse(_.with({scheme:B.scheme}))}B.parseCellPropertyUri=le})(p=e.CellUri||(e.CellUri={}));const E=B=>S.isWindows?B.replace(/\//g,"\\"):B;class b{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(z)].map(K=>({pattern:K,matches:T.parse(E(K))}))}sort(z){const V=new Map(y.Iterable.map(z,ie=>[ie,E(ie)]));let K=[];for(const{matches:ie}of this.d)for(const[ge,ue]of V)if(ie(ue)){K.push(ge),V.delete(ge);break}return V.size&&(K=K.concat([...V.keys()].sort((ie,ge)=>this.e.indexOf(ie)-this.e.indexOf(ge)))),K}prioritize(z,V){const K=this.f(z);if(K===-1){this.d.unshift({pattern:z,matches:T.parse(E(z))});return}const ie=new Set(V.map(ue=>this.f(ue,K)));ie.delete(-1);const ge=Array.from(ie).sort();this.d.splice(K+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,V=this.d.length){const K=E(z);for(let ie=0;ie<V;ie++)if(this.d[ie].matches(K))return ie;return-1}}e.MimeTypeDisplayOrder=b;function w(B,z,V,K=(ie,ge)=>ie===ge){const ie=[];function ge(se,le,_){if(le===0&&_.length===0)return;const me=ie[ie.length-1];me&&me.start+me.deleteCount===se?(me.deleteCount+=le,me.toInsert.push(..._)):ie.push({start:se,deleteCount:le,toInsert:_})}let ue=0,re=0;for(;;){if(ue===B.length){ge(ue,0,z.slice(re));break}if(re===z.length){ge(ue,B.length-ue,[]);break}const se=B[ue],le=z[re];if(K(se,le)){ue+=1,re+=1;continue}V(le)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[le]),re+=1)}return ie}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(B){const z=B;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=s;function a(B,z,V){if(Array.isArray(B.viewType)&&B.viewType.indexOf(z)>=0||B.viewType===z)return!0;if(B.filenamePattern){const K=s(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=s(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(T.match(K,(0,O.basename)(V.fsPath).toLowerCase()))return!(ie&&T.match(ie,(0,O.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(z){return`${o.d}${z}`}static parse(z){if(z.startsWith(o.d))return z.substring(o.d.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o.d="notebook/";function u(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=u;const n=new TextDecoder;function h(B){const z=[];let V=!1;for(const K of B)(z.length===0||V)&&(z.push(K),V=!0);return j(z),F(i.VSBuffer.concat(z.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=h;const g=`${String.fromCharCode(27)}[A`,P=g.split("").map(B=>B.charCodeAt(0)),N=10;function j(B){B.forEach((z,V)=>{if(V===0||z.length<g.length)return;const K=B[V-1],ie=z.subarray(0,g.length);if(ie[0]===P[0]&&ie[1]===P[1]&&ie[2]===P[2]){const ge=K.lastIndexOf(N);if(ge===-1)return;B[V-1]=K.subarray(0,ge),B[V]=z.subarray(g.length)}})}function Z(B){let z=B;do B=z,z=B.replace(/[^\n]\x08/gm,"");while(z.length<B.length);return B}function G(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const z=B.match(/^(.*)\r+/m)[1];let V=B.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return B}const R="\b".charCodeAt(0),A="\r".charCodeAt(0);function F(B){return!B.buffer.includes(R)&&!B.buffer.includes(A)?B:i.VSBuffer.fromString(G(Z(n.decode(B.buffer))))}}),define(Ie[175],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ie[176],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=i;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(O=>[O[0],i(O[1].map)])}e.serializeEnvironmentVariableCollections=y;function L(C){return new Map(C.map(O=>[O[0],{map:T(O[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ie[42],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,O,S=C.parent){if(C._isRoot)return new y([O]);const k=[C.id];for(let M=S;M&&M.id!==O;M=M.parent)k.push(M.id);return k.push(O),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const O=C.indexOf("\0");return O===-1?C:C.slice(0,O)}static fromString(C){return new y(C.split("\0"))}static join(C,O){return new y([...C.path,O])}static joinToString(C,O){return C.toString()+"\0"+O}static parentId(C){const O=C.lastIndexOf("\0");return O===-1?void 0:C.slice(0,O)}static compare(C,O){return C===O?0:O.startsWith(C+"\0")?2:C.startsWith(O+"\0")?3:1}constructor(C,O=C.length){if(this.path=C,this.d=O,C.length===0||O<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let O=0;O<C.d&&O<this.d;O++)if(C.path[O]!==this.path[O])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(Ie[54],Ce([1,0,2,55,42]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var C;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var O;(function(u){u.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),u.deserialize=n=>({range:T.Range.lift(n.range),uri:i.URI.revive(n.uri)})})(O=e.IRichLocation||(e.IRichLocation={}));var S;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(u){u.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&O.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&O.deserialize(n.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const M=(u,n)=>`${n?"s":"e"}${u}`;e.getMarkId=M;var D;(function(u){u.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&O.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&O.deserialize(n.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(u){u.serialize=n=>n.type===0?k.serialize(n):D.serialize(n),u.deserialize=n=>n.type===0?k.deserialize(n):D.deserialize(n)})(m=e.ITestMessage||(e.ITestMessage={}));var v;(function(u){u.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),u.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.serialize)}),u.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",t=(u,n)=>u+f+n;e.namespaceTestTag=t;const c=u=>{const n=u.indexOf(f);return{ctrlId:u.slice(0,n),tagId:u.slice(n+1)}};e.denamespaceTestTag=c;var l;(function(u){u.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),u.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?i.URI.revive(n.uri):void 0,range:n.range?T.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(l=e.ITestItem||(e.ITestItem={}));var p;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var E;(function(u){u.serialize=n=>({expand:n.expand,item:l.serialize(n.item)}),u.deserialize=n=>({controllerId:y.TestId.root(n.item.extId),expand:n.expand,item:l.deserialize(n.item)})})(E=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(u){u.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},u.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?T.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,n)=>{n.expand!==void 0&&(u.expand=n.expand),n.item!==void 0&&(u.item=u.item?Object.assign(u.item,n.item):n.item)};e.applyTestItemUpdate=w;var r;(function(u){u.serializeWithoutMessages=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serializeWithoutMessages),retired:n.retired}),u.serialize=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serialize),retired:n.retired}),u.deserialize=n=>({...E.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var s;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=n=>n.op===0?{op:n.op,item:E.deserialize(n.item)}:n.op===1?{op:n.op,item:b.deserialize(n.item)}:n.op===2?{op:n.op,uri:i.URI.revive(n.uri),docv:n.docv}:n,u.serialize=n=>n.op===0?{op:n.op,item:E.serialize(n.item)}:n.op===1?{op:n.op,item:b.serialize(n.item)}:n})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class o{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const g of n)switch(g.op){case 0:this.j(E.deserialize(g.item),h);break;case 1:this.k(b.deserialize(g.item),h);break;case 3:this.l(g.itemId,h);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}h.complete?.()}j(n,h){const g=y.TestId.parentId(n.item.extId)?.toString();let P;if(!g)P=this.p(n),this.f.add(P),this.d.set(n.item.extId,P);else if(this.d.has(g)){const N=this.d.get(g);N.children.add(n.item.extId),P=this.p(n,N),this.d.set(n.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(P),n.expand===2&&this.g++,P}k(n,h){const g=this.d.get(n.extId);if(!!g)return n.expand!==void 0&&(g.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,n),h.update?.(g),g}l(n,h){const g=this.d.get(n);if(!g)return;const P=y.TestId.parentId(g.item.extId)?.toString();P?this.d.get(P).children.delete(g.item.extId):this.f.delete(g);const N=[[n]];for(;N.length;)for(const j of N.pop()){const Z=this.d.get(j);Z&&(N.push(Z.children),this.d.delete(j),h.remove?.(Z,Z!==g),Z.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=o}),define(Ie[68],Ce([1,0,14,5,7,47,54,42]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(p,E)=>p===E,D=Object.entries({range:(p,E)=>p===E?!0:!p||!E?!1:p.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(p,E)=>!(p.length!==E.length||p.some(b=>!E.includes(b)))}),m=(p,E)=>{let b;for(const[w,r]of D)r(p[w],E[w])||(b?b[w]=E[w]:b={[w]:E[w]});return b};class v extends y.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const b of this.tree.values())this.G(b)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const b of this.k)if(b.op===2&&b.uri===E.uri){b.docv=E.docv;return}break}case 1:{const b=this.k[this.k.length-1];if(b){if(b.op===1&&b.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(b.item,E.item);return}if(b.op===0&&b.item.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(b.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,b){const w=this.tree.get(E);if(!!w){if((w.expandLevels===void 0||b>w.expandLevels)&&(w.expandLevels=b),w.expand===1){const r=this.I(w);return r.isOpen()?this.H(w,b-1):r.wait().then(()=>this.H(w,b-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,b-1)):this.H(w,b-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,b){switch(b.op){case 3:this.L(O.TestId.joinToString(E.fullId,b.id));break;case 0:this.u(b.item,E);break;case 5:for(const w of b.ops)this.p(E,w);break;case 1:this.w(b.new,b.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:b.update}});break;case 6:this.s(E.actual.uri);break;default:(0,L.assertNever)(b)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,b){const w=O.TestId.fromExtHostTestItem(E,this.root.id,b?.actual),r=this.m.getApiFor(E);r.parent&&r.parent!==b?.actual&&this.m.getChildren(r.parent).delete(E.id);let s=this.tree.get(w.toString());if(!s){s={fullId:w,actual:E,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(E,b),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(E)}}),this.F(E,s,b);return}if(s.actual===E){this.D(E,s,b);return}if(s.actual.uri?.toString()!==E.uri?.toString())return this.L(w.toString()),this.u(E,b);const a=this.m.getChildren(s.actual),d=s.actual,o=m(this.m.toITestItem(d),this.m.toITestItem(E));this.m.getApiFor(d).listener=void 0,s.actual=E,s.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(E.tags,d.tags,w.toString()),delete o.tags),this.p(s,{op:4,update:o})),this.F(E,s,b);for(const[u,n]of a)this.m.getChildren(E).get(n.id)||this.L(O.TestId.joinToString(w,n.id));this.s(s.actual.uri)}w(E,b,w){const r=new Set(b.map(s=>s.id));for(const s of E)r.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:w,item:{tags:E.map(s=>(0,C.namespaceTestTag)(this.m.controllerId,s.id))}}}),r.forEach(this.z,this)}y(E){const b=this.j.get(E.id);b?b.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const b=this.j.get(E);b&&!--b.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,E)}))}C(E,b){this.m.getApiFor(E).parent=b&&b.actual!==this.root?b.actual:void 0}D(E,b,w){this.C(E,w);const r=this.m.getApiFor(E);r.parent=w?.actual,r.listener=s=>this.p(b,s),this.G(b)}F(E,b,w){this.D(E,b,w);for(const[r,s]of this.m.getChildren(E))this.u(s,b)}G(E){let b;this.h?E.resolveBarrier?b=E.resolveBarrier.isOpen()?3:2:b=E.actual.canResolveChildren?1:0:b=0,b!==E.expand&&(E.expand=b,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:b}}),b===1&&E.expandLevels!==void 0&&this.I(E))}H(E,b){if(b<0)return;const w=[];for(const[r,s]of this.m.getChildren(E.actual)){const a=this.expand(O.TestId.joinToString(E.fullId,s.id),b);(0,i.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const s=new i.Barrier;return s.open(),s}E.expand=2,this.J(E);const b=E.resolveBarrier=new i.Barrier,w=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let r;try{r=this.h(E.actual===this.root?void 0:E.actual)}catch(s){w(s)}return(0,i.isThenable)(r)?r.catch(w).then(()=>{b.open(),this.G(E)}):(b.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const b=this.tree.get(E);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const w=[b];for(;w.length;){const r=w.pop();if(!!r){this.m.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.z(s.id);this.tree.delete(r.fullId.toString());for(const[s,a]of this.m.getChildren(r.actual))w.push(this.tree.get(O.TestId.joinToString(r.fullId,a.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=v;class f extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=f;class t extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=t;class c extends Error{constructor(E,b,w){super(`TestItem with ID "${E}" is from controller "${b}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=c;const l=(p,E,b)=>{let w=new Map;return{get size(){return w.size},forEach(r,s){for(const a of w.values())r.call(s,a,this)},[Symbol.iterator](){return w.entries()},replace(r){const s=new Map,a=new Set(w.keys()),d={op:5,ops:[]};for(const o of r){if(!(o instanceof b))throw new t(o.id);const u=E(o).controllerId;if(u!==p.controllerId)throw new c(o.id,u,p.controllerId);if(s.has(o.id))throw new f(o.id);s.set(o.id,o),a.delete(o.id),d.ops.push({op:0,item:o})}for(const o of a.keys())d.ops.push({op:3,id:o});p.listener?.(d),w=s},add(r){if(!(r instanceof b))throw new t(r.id);w.set(r.id,r),p.listener?.({op:0,item:r})},delete(r){w.delete(r)&&p.listener?.({op:3,id:r})},get(r){return w.get(r)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(Ie[93],Ce([1,0,68]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,O)=>{const S={controllerId:O};return T.set(C,S),S};e.createPrivateApiFor=y;const L=C=>{const O=T.get(C);if(!O)throw new i.InvalidTestItemError(C?.id||"<unknown>");return O};e.getPrivateApiFor=L}),define(Ie[69],Ce([1,0,13,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(O,S){return O.scheme===i.Schemas.http||O.scheme===i.Schemas.https?O:(S&&S.authority&&S.isRemote&&O.scheme===i.Schemas.file&&(O=T.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:O.path})),T.URI.from({scheme:i.Schemas.https,authority:`${O.scheme}+${L(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=y;function L(O){return O.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(O){return O.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ie[177],Ce([1,0,5,7,69]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(O,S,k){this.d=O,this.e=S,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const M=S.getVisibleTextEditors();for(const D of this.c.values())M.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,S,k,M,D){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===O){m=E;break}if(!m)throw new Error("not a visible editor");const v=this,f=this.a++,t=new i.Emitter,c=new i.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,y.asWebviewUri)(E,v.f)}get cspSource(){return y.webviewGenericCspSource}set options(E){this.b=E,v.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,v.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return t.event}postMessage(E){return v.d.$postMessage(f,E)}},p=new class{constructor(){this.editor=O,this.line=S,this.height=k,this.webview=l,this.onDidDispose=c.event}dispose(){v.c.has(f)&&(v.c.delete(f),v.d.$disposeEditorInset(f),c.fire(),c.dispose(),t.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,S+1,k,M||{},D.identifier,D.extensionLocation),this.c.set(f,{editor:O,inset:p,onDidReceiveMessage:t}),p}$onDidDispose(O){const S=this.c.get(O);S&&S.inset.dispose()}$onDidReceiveMessage(O,S){this.c.get(O)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(Ie[178],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,O){super(O),this.variable=C}}e.VariableError=y}),define(Ie[179],Ce([1,0,19,49,9,23,21,83,146,178,10]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(v,f,t,c){this.g=new Map,this.a=v,this.b=f,this.d=t,c&&(this.c=c.then(l=>this.h(l)))}h(v){if(C.isWindows){const f=Object.create(null);return Object.keys(v).forEach(t=>{f[t.toLowerCase()]=v[t]}),f}return v}resolveWithEnvironment(v,f,t){return this.j({env:this.h(v),userHome:void 0},f?f.uri:void 0,t)}async resolveAsync(v,f){const t={env:await this.c,userHome:await this.d};return this.j(t,v?v.uri:void 0,f)}async i(v,f,t,c){const l=L.deepClone(f);C.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):C.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):C.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,v?v.uri:void 0,l,t,c)}async resolveAnyAsync(v,f,t){return this.i(v,f,t)}async resolveAnyMap(v,f,t){const c=new Map;return{newConfig:await this.i(v,f,t,c),resolvedVariables:c}}resolveWithInteractionReplace(v,f,t,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,f,t,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,f){if(this.g.has(v))throw new Error("Variable "+v+" is contributed twice.");this.g.set(v,f)}async j(v,f,t,c,l){if(y.isString(t))return this.l(v,f,t,c,l);if(Array.isArray(t))return Promise.all(t.map(p=>this.j(v,f,p,c,l)));if(y.isObject(t)){const p=Object.create(null),E=await Promise.all(Object.keys(t).map(async b=>[await this.l(v,f,b,c,l),await this.j(v,f,t[b],c,l)]));for(const[b,w]of E)p[b]=w;return p}return t}l(v,f,t,c,l){return(0,M.replaceAsync)(t,D.VARIABLE_REGEXP,async(p,E)=>{if(E.includes(D.VARIABLE_LHS))return p;let b=await this.n(v,p,E,f,c);return l?.set(E,b),b!==p&&y.isString(b)&&b.match(D.VARIABLE_REGEXP)&&(b=await this.l(v,f,b,c,l)),b})}m(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async n(v,f,t,c,l){let p;const E=t.split(":");E.length>1&&(t=E[0],p=E[1]);const b=s=>{const a=this.a.getFilePath();if(a)return(0,O.normalizeDriveLetter)(a);throw new k.VariableError(s,(0,S.localize)(0,null,f))},w=s=>{const a=b(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,O.normalizeDriveLetter)(d)}throw new k.VariableError(s,(0,S.localize)(1,null,f,i.basename(a)))},r=s=>{if(p){const a=this.a.getFolderUri(p);if(a)return a;throw new k.VariableError(s,(0,S.localize)(2,null,f,p))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(s,(0,S.localize)(3,null,f)):new k.VariableError(s,(0,S.localize)(4,null,f))};switch(t){case"env":if(p){if(v.env){const s=v.env[C.isWindows?p.toLowerCase():p];if(y.isString(s))return s}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(p){const s=this.a.getConfigurationValue(c,p);if(y.isUndefinedOrNull(s))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,f,p));if(y.isObject(s))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,f,p));return s}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,p,l,"command");case"input":return this.o(k.VariableKind.Input,f,p,l,"input");case"extensionInstallFolder":if(p){const s=await this.a.getExtension(p);if(!s)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,p));return this.m(s.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.m(r(k.VariableKind.WorkspaceFolder)));case"cwd":return c||p?(0,O.normalizeDriveLetter)(this.m(r(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.normalizeDriveLetter)(i.basename(this.m(r(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return b(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||p?i.relative(this.m(r(k.VariableKind.RelativeFile)),b(k.VariableKind.RelativeFile)):b(k.VariableKind.RelativeFile);case"relativeFileDirname":{const s=i.dirname(b(k.VariableKind.RelativeFileDirname));if(c||p){const a=i.relative(this.m(r(k.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return i.dirname(b(k.VariableKind.FileDirname));case"fileExtname":return i.extname(b(k.VariableKind.FileExtname));case"fileBasename":return i.basename(b(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=i.basename(b(k.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-i.extname(s).length)}case"fileDirnameBasename":return i.basename(i.dirname(b(k.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||f}case"execInstallFolder":{const s=this.a.getAppRoot();return s||f}case"pathSeparator":return i.sep;default:try{const s=p?`${t}:${p}`:t;return this.o(k.VariableKind.Unknown,f,s,l,void 0)}catch{return f}}}}o(v,f,t,c,l){if(t&&c){const p=l===void 0?c[t]:c[l+":"+t];if(typeof p=="string")return p;throw new k.VariableError(v,(0,S.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[94],Ce([1,0,3,92]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const t=f;return(0,T.isEditorInput)(t?.editor)&&(0,T.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var M;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const t=f;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=m;function v(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=v}),define(Ie[180],Ce([1,0,3,94]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(L){const C=L;return typeof L=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ie[181],Ce([1,0,3,152]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(T.IEnvironmentService)}),define(Ie[95],Ce([1,0,26,5,19]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=L;class C{static isHostExtension(D,m,v){if(m.getExtensionDescription(D))return!1;const f=v.getExtensionDescription(D);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(D){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let m of D.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,m){this.d=k(this.d,m),this.d=this.d.concat(D);const v=C.j(this.d);return this.d=k(this.d,v.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new L(v)}static j(D){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,p){this.addNode(l),this.addNode(p),this.c.has(l)?this.c.get(l).push(p):this.c.set(l,[p])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,p){const E=m.getArcs(l);for(let b=0;b<E.length;b++)if(!p.has(E[b]))return!1;return!0}getNodes(){return this.e}},v=new Map;for(const l of D){const p=i.ExtensionIdentifier.toKey(l.identifier);if(v.set(p,l),l.extensionDependencies)for(const E of l.extensionDependencies){const b=i.ExtensionIdentifier.toKey(E);m.addArc(p,b)}}const f=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>f.add(l));const t=m.getNodes().filter(l=>!f.has(l));let c;do{c=!1;for(let l=0;l<t.length;l++){const p=t[l];m.hasOnlyGoodArcs(p,f)&&(t.splice(l,1),l--,f.add(p),c=!0)}}while(c);return t.map(l=>v.get(l))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(i.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const m=this.g.get(D);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const m=this.e.get(i.ExtensionIdentifier.toKey(D));return m||void 0}getExtensionDescriptionByUUID(D){for(const m of this.f)if(m.uuid===D)return m}getExtensionDescriptionByIdOrUUID(D,m){return this.getExtensionDescription(D)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=C;var O;(function(M){M[M.Builtin=0]="Builtin",M[M.User=1]="User",M[M.Dev=2]="Dev"})(O||(O={}));function S(M,D){const m=M.isBuiltin?0:M.isUnderDevelopment?2:1,v=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(m!==v)return m-v;const f=y.posix.basename(M.extensionLocation.path),t=y.posix.basename(D.extensionLocation.path);return f<t?-1:f>t?1:0}function k(M,D){const m=new Set;return D.forEach(v=>m.add(i.ExtensionIdentifier.toKey(v))),M.filter(v=>!m.has(i.ExtensionIdentifier.toKey(v.identifier)))}}),define(Ie[70],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function C(k){const M=i.VSBuffer.alloc(1);switch(k){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=C;function O(k,M){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=O;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[71],Ce([1,0,3,5,12,27,70,48,50,23,2]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class{constructor(t,c){this.i=t,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=c.createLogger(M.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(t,c,l){const p=this.getTelemetryDetails(),E=new m(c,l,t,this.g,this.f,this.getBuiltInCommonProperties(t),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled});return this.h.set(t.identifier.value,E),E.apiTelemetryLogger}$initializeTelemetryLevel(t,c,l){this.d=t,this.f=c,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const c={};switch(c["common.extname"]=t.name,c["common.extversion"]=t.version,c["common.vscodemachineid"]=this.i.telemetryInfo.machineId,c["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,c["common.vscodeversion"]=this.i.version,c["common.isnewappinstall"]=v(this.i.telemetryInfo.firstSessionDate),c["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:c["common.uikind"]="web";break;case C.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,O.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),c}$onDidChangeTelemetryLevel(t){this.e=this.getTelemetryConfiguration(),this.d=t;const c=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(t,c){const l=this.h.get(t.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(c),!0)}};D=qe([Ve(0,L.IExtHostInitDataService),Ve(1,y.ILoggerService)],D),e.ExtHostTelemetry=D;class m{constructor(t,c,l,p,E,b,w){this.g=l,this.h=p,this.i=E,this.j=b,this.b=new T.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.e=c?.ignoreBuiltInCommonProperties??!1,this.f=c?.additionalCommonProperties,this.a=t,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(t,c){this.d&&(this.c={isUsageEnabled:t,isErrorsEnabled:c},this.b.fire(this.d))}mixInCommonPropsAndCleanData(t){let c=t.properties??t;return c=(0,S.cleanData)(c,[]),this.f&&(c=(0,k.mixin)(c,this.f)),this.e||(c=(0,k.mixin)(c,this.j)),t.properties?t.properties=c:t=c,t}k(t,c){this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.a.logEvent(t,c),this.h.trace(t,c)}logUsage(t,c){!this.c.isUsageEnabled||this.k(t,c)}logError(t,c){!this.c.isErrorsEnabled||(typeof t=="string"?this.k(t,c):this.a.logError(t,c))}get apiTelemetryLogger(){if(!this.d){const t=this,c={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.c.isUsageEnabled},get isErrorsEnabled(){return t.c.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.b.event.bind(t)};this.d=Object.freeze(c)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function v(f){const t=Date.now()-new Date(f).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ie[25],Ce([1,0,5,2,3,26,161]),function(ee,e,i,T,y,L,C){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class M{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=M;class D{constructor(u){this.dependency=u}}e.MissingExtensionDependency=D;var m;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=v;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,n){const h=[],g=[],P=[],N=[],j=l(this.c),Z=l(u),G=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.c){const z=Z.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){h.push(B.identifier),j.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}if(!G(B,z)){h.push(B.identifier),j.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of u){const z=j.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){g.push(B);continue}if(!G(z,B)){h.push(z.identifier),j.delete(L.ExtensionIdentifier.toKey(z.identifier));continue}}const R=c(this.d),A=c(n);for(const B of this.d)A.has(L.ExtensionIdentifier.toKey(B))||P.push(B);for(const B of n)R.has(L.ExtensionIdentifier.toKey(B))||N.push(B);const F={toRemove:h,toAdd:g,myToRemove:P,myToAdd:N};return this.delta(F),F}delta(u){const{toRemove:n,toAdd:h,myToRemove:g,myToAdd:P}=u,N=c(n),j=c(g);for(let Z=0;Z<this.c.length;Z++)N.has(L.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)j.has(L.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of h)this.c.push(Z);for(const Z of P)this.d.push(Z)}containsExtension(u){for(const n of this.d)if(L.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=f;class t{constructor(u){if(this[O]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,n){this.c.forEach(h=>u.call(n,h,h,this))}*entries(){for(const[u,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=t;function c(o){const u=new Set;for(const n of o)u.add(L.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=c;function l(o){const u=new Map;for(const n of o)u.set(L.ExtensionIdentifier.toKey(n.identifier),n);return u}function p(o,u){return o.enabledApiProposals?o.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=p;function E(o,u){if(!p(o,u))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=E;class b{constructor(u,n,h,g){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=h,this.activationReason=g}}e.ActivationTimes=b;class w{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function a(o,u){return{identifier:new L.ExtensionIdentifier((0,C.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!u,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=a;class d{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(Ie[182],Ce([1,0,11,95,26,25,12,14]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(l,p,E,b){this.startup=l,this.codeLoadingTime=p,this.activateCallTime=E,this.activateResolvedTime=b}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,p){return l===-1||p===-1?-1:p-l}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class M{constructor(l,p,E,b,w,r){this.activationFailed=l,this.activationFailedError=p,this.activationTimes=E,this.module=b,this.exports=w,this.subscriptions=r}}e.ActivatedExtension=M;class D extends M{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class m extends M{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class v extends M{constructor(l){super(!0,l,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(l,p,E,b){this.g=b,this.a=l,this.b=p,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,p]of this.d)p.dispose()}isActivated(l){const p=this.d.get(y.ExtensionIdentifier.toKey(l));return Boolean(p&&p.value)}getActivatedExtension(l){const p=this.d.get(y.ExtensionIdentifier.toKey(l));if(!p||!p.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return p.value}async activateByEvent(l,p){if(this.f[l])return;const E=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(E.map(b=>({id:b.identifier,reason:{startup:p,extensionId:b.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,p){const E=this.a.getExtensionDescription(l);if(!E)throw new Error(`Extension '${l}' is not known`);return this.h([{id:E.identifier,reason:p}])}async h(l){const p=l.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(p.map(E=>E.wait()))}j(l){if(this.d.has(y.ExtensionIdentifier.toKey(l.id)))return this.d.get(y.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const p=this.a.getExtensionDescription(l.id);if(!p){const w=new Error(`Cannot activate unknown extension '${l.id.value}'`),r=this.k(l,null,[],new v(w));return this.c.onExtensionActivationError(l.id,w,new L.MissingExtensionDependency(l.id.value)),r}const E=[],b=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const w of b){if(this.m(w))continue;const r=this.d.get(y.ExtensionIdentifier.toKey(w));if(r){E.push(r);continue}if(this.l(w)){E.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:l.reason}));continue}const s=this.a.getExtensionDescription(w);if(s){if(!s.main&&!s.browser)continue;E.push(this.j({id:s.identifier,reason:l.reason}));continue}const a=p.displayName||p.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${w}'`),o=this.k(l,p.displayName,[],new v(d));return this.c.onExtensionActivationError(p.identifier,d,new L.MissingExtensionDependency(w)),o}return this.k(l,p.displayName,E,null)}k(l,p,E,b){const w=new t(l.id,p,l.reason,E,b,this.c,this.g);return this.d.set(y.ExtensionIdentifier.toKey(l.id),w),w}l(l){return T.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const p=this.b.getExtensionDescription(l);return p?!p.main&&!p.browser:!1}};f=qe([Ve(3,C.ILogService)],f),e.ExtensionsActivator=f;let t=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,p,E,b,w,r,s){this.c=l,this.d=p,this.f=E,this.g=b,this.h=w,this.j=r,this.k=s,this.a=new O.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const p=this.g[l];if(p.value&&!p.value.activationFailed){this.g.splice(l,1),l--;continue}if(p.value&&p.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);E.detail=p.value.activationFailedError,this.h=new v(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const p=new Error;if(l&&l.name&&(p.name=l.name),l&&l.message?p.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(p.stack=l.stack),this.h=new v(p),this.b&&i.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};t=qe([Ve(6,C.ILogService)],t)}),define(Ie[183],Ce([1,0,12,27,25]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(O,S){super(O.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};L=qe([Ve(0,i.ILoggerService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[6],Ce([1,0,16,11,82,28,62,10,9,2,34,36,91,67,25]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f){"use strict";var t,c,l,p,E,b,w,r,s,a,d,o,u,n,h,g,P,N,j,Z,G,R,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(W){return Object.assign(W,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(W,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[te,...Ee]=arguments;return Reflect.construct(W,Ee,te.constructor)}}})}var B;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W[W.Command=0]="Command",W[W.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=b=class{static from(...U){let te=U;return new b(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}constructor(U){t.set(this,void 0),Ye(this,t,U,"f")}dispose(){typeof Re(this,t,"f")=="function"&&(Re(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,V=b=qe([F],V),e.Disposable=V;let K=w=class{static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ke=U[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ke=U[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(U){if(!U)return!1;if(U instanceof w)return!0;const{line:te,character:Ee}=U;return typeof te=="number"&&typeof Ee=="number"}static of(U){if(U instanceof w)return U;if(this.isPosition(U))return new w(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=U,this.e=te}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,te=0){if(U===null||te===null)throw(0,T.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&te===0?this:new w(this.line+Ee,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,T.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),Ee===this.line&&te===this.character?this:new w(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};K=w=qe([F],K),e.Position=K;let ie=r=class{static isRange(U){return U instanceof r?!0:U?K.isPosition(U.start)&&K.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,te,Ee,Ke){let _e,ot;if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new K(U,te),ot=new K(Ee,Ke)):K.isPosition(U)&&K.isPosition(te)&&(_e=K.of(U),ot=K.of(te)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):K.isPosition(U)?!(K.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const te=K.Max(U.start,this.c),Ee=K.Min(U.end,this.e);if(!te.isAfter(Ee))return new r(te,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=K.Min(U.start,this.c),Ee=K.Max(U.end,this.end);return new r(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,te=this.end){if(U===null||te===null)throw(0,T.illegalArgument)();let Ee;return U?K.isPosition(U)?Ee=U:(Ee=U.start||this.start,te=U.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new r(Ee,te)}toJSON(){return[this.start,this.end]}};ie=r=qe([F],ie),e.Range=ie;let ge=s=class extends ie{static isSelection(U){return U instanceof s?!0:U?ie.isRange(U)&&K.isPosition(U.anchor)&&K.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,te,Ee,Ke){let _e,ot;if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new K(U,te),ot=new K(Ee,Ke)):K.isPosition(U)&&K.isPosition(te)&&(_e=K.of(U),ot=K.of(te)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ge=s=qe([F],ge),e.Selection=ge;class ue{constructor(U,te,Ee){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ee)))throw(0,T.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=ue;class re extends Error{static NotAvailable(U,te){return new re(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new re(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,te=m.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,re.prototype)}}e.RemoteAuthorityResolverError=re;var se;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var le;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let _=a=class{static isTextEdit(U){return U instanceof a?!0:U?ie.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new a(U,te)}static insert(U,te){return a.replace(new ie(U,U),te)}static delete(U){return a.replace(U,"")}static setEndOfLine(U){const te=new a(new ie(new K(0,0),new K(0,0)),"");return te.newEol=U,te}get range(){return this.c}set range(U){if(U&&!ie.isRange(U))throw(0,T.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.illegalArgument)("newEol");this.f=U}constructor(U,te){this.c=U,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};_=a=qe([F],_),e.TextEdit=_;let me=d=class{static isNotebookCellEdit(U){return U instanceof d?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,te){return new d(U,te)}static insertCells(U,te){return new d(new Kt(U,U),te)}static deleteCells(U){return new d(U,[])}static updateCellMetadata(U,te){const Ee=new d(new Kt(U,U),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(U){const te=new d(new Kt(0,0),[]);return te.newNotebookMetadata=U,te}constructor(U,te){this.range=U,this.newCells=te}};me=d=qe([F],me),e.NotebookEdit=me;class we{static isSnippetTextEdit(U){return U instanceof we?!0:U?ie.isRange(U.range)&&Qe.isSnippetString(U.snippet):!1}static replace(U,te){return new we(U,te)}static insert(U,te){return we.replace(new ie(U,U),te)}constructor(U,te){this.range=U,this.snippet=te}}e.SnippetTextEdit=we;var Me;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Me=e.FileEditType||(e.FileEditType={}));let We=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,te,Ee,Ke){this.c.push({_type:1,from:U,to:te,options:Ee,metadata:Ke})}createFile(U,te,Ee){this.c.push({_type:1,from:void 0,to:U,options:te,metadata:Ee})}deleteFile(U,te,Ee){this.c.push({_type:1,from:U,to:void 0,options:te,metadata:Ee})}e(U,te,Ee){this.c.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}f(U,te,Ee,Ke){const _e=te.start,ot=te.end;(_e!==ot||Ee.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:ot-_e,cells:Ee,metadata:Ke})}g(U,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:te,metadata:Ee}})}replace(U,te,Ee,Ke){this.c.push({_type:2,uri:U,edit:new _(te,Ee),metadata:Ke})}insert(U,te,Ee,Ke){this.replace(U,new ie(te,te),Ee,Ke)}delete(U,te,Ee){this.replace(U,te,"",Ee)}has(U){return this.c.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,_e;if(Array.isArray(Ee)?(Ke=Ee[0],_e=Ee[1]):Ke=Ee,me.isNotebookCellEdit(Ke)){if(U.scheme===v.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,_e):this.f(U,Ke.range,Ke.newCells,_e)}else we.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:Ke,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[Ee]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===U.toString()&&te.push(Ee.edit);return te}entries(){const U=new L.ResourceMap;for(const te of this.c)if(te._type===2){let Ee=U.get(te.uri);Ee||(Ee=[te.uri,[]],U.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};We=qe([F],We),e.WorkspaceEdit=We;let Qe=o=class{static isSnippetString(U){return U instanceof o?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=o.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this.e++){if(typeof U=="function"){const Ee=new o;Ee.e=this.e,U(Ee),this.e=Ee.e,U=Ee.value}else U=o.c(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this.e++){const Ee=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const Ee=new o;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Qe=o=qe([F],Qe),e.SnippetString=Qe;var Te;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=u=class{static isLocation(U){return U instanceof u?!0:U?ie.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,te){if(this.uri=U,te)if(ie.isRange(te))this.range=ie.of(te);else if(K.isPosition(te))this.range=new ie(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=u=qe([F],ke),e.Location=ke;let oe=class{static is(U){return U?typeof U.message=="string"&&U.location&&ie.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,te){this.location=U,this.message=te}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};oe=qe([F],oe),e.DiagnosticRelatedInformation=oe;let ce=class{constructor(U,te,Ee=De.Error){if(!ie.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=Ee}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,i.equals)(U.tags,te.tags)&&(0,i.equals)(U.relatedInformation,te.relatedInformation,oe.isEqual)}};ce=qe([F],ce),e.Diagnostic=ce;let Y=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Y=qe([F],Y),e.Hover=Y;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,te=I.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([F],$),e.DocumentHighlight=$;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(W){W[W.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let J=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,te,Ee,Ke,_e){this.name=U,this.kind=te,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ke?this.location=Ke:Ee instanceof ie&&(this.location=new ke(Ke,Ee)),n.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};J=n=qe([F],J),e.SymbolInformation=J;let de=h=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(h.validate)}constructor(U,te,Ee,Ke,_e){this.name=U,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=_e,this.children=[],h.validate(this)}};de=h=qe([F],de),e.DocumentSymbol=de;var Se;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,te){this.title=U,this.kind=te}};ae=qe([F],ae),e.CodeAction=ae;let ve=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};ve.c=".",ve=g=qe([F],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=qe([F],be),e.SelectionRange=be;class ze{constructor(U,te,Ee,Ke,_e,ot){this.kind=U,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=ze;class He{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=tt;var xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};et=qe([F],et),e.CodeLens=et;let it=P=class{static isMarkdownString(U){return U instanceof P?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,te=!1){c.set(this,void 0),Ye(this,c,new y.MarkdownString(U,{supportThemeIcons:te}),"f")}get value(){return Re(this,c,"f").value}set value(U){Re(this,c,"f").value=U}get isTrusted(){return Re(this,c,"f").isTrusted}set isTrusted(U){Re(this,c,"f").isTrusted=U}get supportThemeIcons(){return Re(this,c,"f").supportThemeIcons}set supportThemeIcons(U){Re(this,c,"f").supportThemeIcons=U}get supportHtml(){return Re(this,c,"f").supportHtml}set supportHtml(U){Re(this,c,"f").supportHtml=U}get baseUri(){return Re(this,c,"f").baseUri}set baseUri(U){Re(this,c,"f").baseUri=U}appendText(U){return Re(this,c,"f").appendText(U),this}appendMarkdown(U){return Re(this,c,"f").appendMarkdown(U),this}appendCodeblock(U,te){return Re(this,c,"f").appendCodeblock(te??"",U),this}};c=new WeakMap,it=P=qe([F],it),e.MarkdownString=it;let dt=class{constructor(U,te){this.label=U,this.documentation=te}};dt=qe([F],dt),e.ParameterInformation=dt;let Oe=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Oe=qe([F],Oe),e.SignatureInformation=Oe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([F],st),e.SignatureHelp=st;var X;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(U){this.value=U}};pe=qe([F],pe),e.InlayHintLabelPart=pe;let Ne=class{constructor(U,te,Ee){this.position=U,this.label=te,this.kind=Ee}};Ne=qe([F],Ne),e.InlayHint=Ne;var $e;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(W){W[W.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([F],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};wt=qe([F],wt),e.CompletionList=wt;let yt=class{constructor(U,te,Ee){this.insertText=U,this.range=te,this.command=Ee}};yt=qe([F],yt),e.InlineSuggestion=yt;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([F],Ct),e.InlineSuggestionList=Ct;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ut;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Mt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Mt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ht;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ht=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var It;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(It=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function U(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=U}(ht=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,te){if(te&&!k.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.target=te}};Nt=qe([F],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,te,Ee,Ke){this.red=U,this.green=te,this.blue=Ee,this.alpha=Ke}};Ge=qe([F],Ge),e.Color=Ge;let Pt=class{constructor(U,te){if(te&&!(te instanceof Ge))throw(0,T.illegalArgument)("color");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.color=te}};Pt=qe([F],Pt),e.ColorInformation=Pt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.illegalArgument)("label");this.label=U}};Lt=qe([F],Lt),e.ColorPresentation=Lt;var Ht;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var ft;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Tt;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(Tt=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(U,te,Ee){if(this.startIndex=U,this.length=te,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class fe{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=fe;var x;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Ae;var Le;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var Xe;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Xe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=N=class{static from(U){switch(U){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this.c=U}get id(){return this.c}};Be.Clean=new N("clean","Clean"),Be.Build=new N("build","Build"),Be.Rebuild=new N("rebuild","Rebuild"),Be.Test=new N("test","Test"),Be=N=qe([F],Be),e.TaskGroup=Be;function Ze(W){let U="";for(let te=0;te<W.length;te++)U+=W[te].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,te,Ee){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=U,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const te of this.e)U.push(te);return Ze(U)}};bt=qe([F],bt),e.ProcessExecution=bt;let Et=class{constructor(U,te,Ee){if(this.f=[],Array.isArray(te)){if(!U)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U,this.f=te,this.g=Ee}else{if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U,this.g=te}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)U.push(typeof te=="string"?te:te.value);return Ze(U)}};Et=qe([F],Et),e.ShellExecution=Et;var kt;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(kt=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class vt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=vt;let mt=j=class{constructor(U,te,Ee,Ke,_e,ot){this.j=!1,this.k=this.definition=U;let ut;typeof te=="string"?(this.m=this.name=te,this.t=this.source=Ee,this.execution=Ke,ut=_e,this.j=!0):te===pt.Global||te===pt.Workspace?(this.target=te,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot):(this.target=te,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:j.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:j.f,id:this.n.computeId()}:this.n instanceof vt?this.k={type:j.c,id:this.n.computeId()}:this.k={type:j.g,id:(0,M.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const te=this.k.type;(j.g===te||j.e===te||j.f===te||j.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};mt.c="customExecution",mt.e="process",mt.f="shell",mt.g="$empty",mt=j=qe([F],mt),e.Task=mt;var Vt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(Vt=e.ProgressLocation||(e.ProgressLocation={}));var si;(function(W){function U(te){const Ee=te;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}W.isViewBadge=U})(si=e.ViewBadge||(e.ViewBadge={}));let St=Z=class{static isTreeItem(U,te){if(U instanceof Z)return!0;const Ee=U;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<ti.None&&Ee.collapsibleState>ti.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ke=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==oi.Checked&&Ke!==oi.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(U,te=ti.None){this.collapsibleState=te,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};St=Z=qe([F],St),e.TreeItem=St;var ti;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(ti=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var oi;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(oi=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,te){this.value=U,this.id=te??(0,M.generateUuid)()}};Yt=qe([F],Yt),e.DataTransferItem=Yt;let bi=class{constructor(U){l.set(this,new Map);for(const[te,Ee]of U??[]){const Ke=Re(this,l,"f").get(te);Ke?Ke.push(Ee):Re(this,l,"f").set(te,[Ee])}}get(U){return Re(this,l,"f").get(U)?.[0]}set(U,te){Re(this,l,"f").set(U,[te])}forEach(U,te){for(const[Ee,Ke]of Re(this,l,"f"))for(const _e of Ke)U.call(te,_e,Ee,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,te]of Re(this,l,"f"))for(const Ee of te)yield[U,Ee]}};bi=qe([F],bi),e.DataTransfer=bi;let At=class{constructor(U){this.insertText=U}};At=qe([F],At),e.DocumentDropEdit=At;let ai=class{constructor(U){this.insertText=U}};ai=qe([F],ai),e.DocumentPasteEdit=ai;let jt=class{constructor(U,te){this.id=U,this.color=te}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};jt=qe([F],jt),e.ThemeIcon=jt,jt.File=new jt("file"),jt.Folder=new jt("folder");let Jt=class{constructor(U){this.id=U}};Jt=qe([F],Jt),e.ThemeColor=Jt;var ci;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(ci=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,te){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([F],ct),e.RelativePattern=ct;let Zt=class{constructor(U,te,Ee,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,M.generateUuid)()),this.c}};Zt=qe([F],Zt),e.Breakpoint=Zt;let qt=class extends Zt{constructor(U,te,Ee,Ke,_e){if(super(te,Ee,Ke,_e),U===null)throw(0,T.illegalArgument)("location");this.location=U}};qt=qe([F],qt),e.SourceBreakpoint=qt;let Xt=class extends Zt{constructor(U,te,Ee,Ke,_e){super(te,Ee,Ke,_e),this.functionName=U}};Xt=qe([F],Xt),e.FunctionBreakpoint=Xt;let ui=class extends Zt{constructor(U,te,Ee,Ke,_e,ot,ut){if(super(Ke,_e,ot,ut),!te)throw(0,T.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=Ee}};ui=qe([F],ui),e.DataBreakpoint=ui;let Ei=class{constructor(U,te,Ee){this.command=U,this.args=te||[],this.options=Ee}};Ei=qe([F],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(U,te){this.port=U,this.host=te}};li=qe([F],li),e.DebugAdapterServer=li;let wi=class{constructor(U){this.path=U}};wi=qe([F],wi),e.DebugAdapterNamedPipeServer=wi;let di=class{constructor(U){this.implementation=U}};di=qe([F],di),e.DebugAdapterInlineImplementation=di;let ei=class{constructor(U,te){this.range=U,this.expression=te}};ei=qe([F],ei),e.EvaluatableExpression=ei;var Li;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(U,te){this.range=U,this.text=te}};ii=qe([F],ii),e.InlineValueText=ii;let ni=class{constructor(U,te,Ee=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=Ee}};ni=qe([F],ni),e.InlineValueVariableLookup=ni;let Si=class{constructor(U,te){this.range=U,this.expression=te}};Si=qe([F],Si),e.InlineValueEvaluatableExpression=Si;let yi=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};yi=qe([F],yi),e.InlineValueContext=yi;var ri;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Di=G=class extends Error{static FileExists(U){return new G(U,D.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(U){return new G(U,D.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(U){return new G(U,D.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(U){return new G(U,D.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(U){return new G(U,D.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(U){return new G(U,D.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(U,te=D.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Di=G=qe([F],Di),e.FileSystemError=Di;let Ii=class{constructor(U,te,Ee){this.start=U,this.end=te,this.kind=Ee}};Ii=qe([F],Ii),e.FoldingRange=Ii;var Ui;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Ui=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $i;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})($i=e.CommentMode||(e.CommentMode={}));var Ci;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Ci=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=Ai;function Ri(W){return typeof W>"u"||(0,S.isStringArray)(W)}class Ue{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let te=0,Ee=U.tokenTypes.length;te<Ee;te++)this.j.set(U.tokenTypes[te],te);for(let te=0,Ee=U.tokenModifiers.length;te<Ee;te++)this.k.set(U.tokenModifiers[te],te)}}push(U,te,Ee,Ke,_e){if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,te,Ee,Ke,_e);if(ie.isRange(U)&&typeof te=="string"&&Ri(Ee))return this.m(U,te,Ee);throw(0,T.illegalArgument)()}m(U,te,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,_e=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(te);let Ot=0;if(Ee)for(const Wt of Ee){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Wt);Ot|=1<<Gt>>>0}this.n(Ke,_e,ot,ut,Ot)}n(U,te,Ee,Ke,_e){if(this.f&&(U<this.c||U===this.c&&te<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Wt=0,Gt=0;for(let xt=0;xt<Ot;xt++){let Qt=this.g[5*xt],Ti=this.g[5*xt+1];Qt===0?(Qt=Wt,Ti+=Gt):Qt+=Wt,this.g[5*xt]=Qt,this.g[5*xt+1]=Ti,Wt=Qt,Gt=Ti}}let ot=U,ut=te;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=Ee,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=U,this.e=te}static o(U){const te=[],Ee=U.length/5|0;for(let ut=0;ut<Ee;ut++)te[ut]=ut;te.sort((ut,Ot)=>{const Wt=U[5*ut],Gt=U[5*Ot];if(Wt===Gt){const xt=U[5*ut+1],Qt=U[5*Ot+1];return xt-Qt}return Wt-Gt});const Ke=new Uint32Array(U.length);let _e=0,ot=0;for(let ut=0;ut<Ee;ut++){const Ot=5*te[ut],Wt=U[Ot+0],Gt=U[Ot+1],xt=U[Ot+2],Qt=U[Ot+3],Ti=U[Ot+4],tn=Wt-_e,Tn=tn===0?Gt-ot:Gt,Pi=5*ut;Ke[Pi+0]=tn,Ke[Pi+1]=Tn,Ke[Pi+2]=xt,Ke[Pi+3]=Qt,Ke[Pi+4]=Ti,_e=Wt,ot=Gt}return Ke}build(U){return this.f?new zt(new Uint32Array(this.g),U):new zt(Ue.o(this.g),U)}}e.SemanticTokensBuilder=Ue;class zt{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=zt;class Oi{constructor(U,te,Ee){this.start=U,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=Oi;class gt{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=gt;var zi;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(zi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hi=class{constructor(){}};hi.Back={iconPath:new jt("arrow-left")},hi=qe([F],hi),e.QuickInputButtons=hi;var Fi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Wi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var fi;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class Hi{static validate(U){if(typeof U.badge=="string"){let te=(0,O.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,O.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!jt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,te,Ee){this.badge=U,this.tooltip=te,this.color=Ee}}e.FileDecoration=Hi;let ki=class{constructor(U){this.kind=U}};ki=qe([F],ki),e.ColorTheme=ki;var Vi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Vi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");U<=te?(this.c=U,this.e=te):(this.c=te,this.e=U)}with(U){let te=this.c,Ee=this.e;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(Ee=U.end),te===this.c&&Ee===this.e?this:new Kt(te,Ee)}}e.NotebookRange=Kt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>mi.isNotebookCellData(te))}static isNotebookCellData(U){return!0}constructor(U,te,Ee,Ke,_e,ot,ut){this.kind=U,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=_e??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class ji{constructor(U){this.cells=U}}e.NotebookData=ji;class $t{static isNotebookCellOutputItem(U){return U instanceof $t?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return $t.json(te,"application/vnd.code.notebook.error")}static stdout(U){return $t.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return $t.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new $t(U,te)}static text(U,te=C.Mimes.text){const Ee=Re($t,p,"f",E).encode(String(U));return new $t(Ee,te)}static json(U,te="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return $t.text(Ee,te)}constructor(U,te){this.data=U,this.mime=te;const Ee=(0,C.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=$t,p=$t,E={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,te=!1){const Ee=new Set,Ke=new Set;for(let _e=0;_e<U.length;_e++){const ot=U[_e],ut=(0,C.normalizeMimeType)(ot.mime);if(!Ee.has(ut)||(0,v.isTextStreamMime)(ut)){Ee.add(ut);continue}Ke.add(_e),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((_e,ot)=>!Ke.has(ot))}constructor(U,te,Ee){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,M.generateUuid)(),this.metadata=te??Ee)}}e.NotebookCellOutput=gi;var qi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(qi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ki;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fe{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=Fe;var rt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(U,te=[]){this.uri=U,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=Rt;class on{constructor(U){this.label=U}}e.NotebookKernelSourceAction=on;let Gi=class{constructor(U,te){this.label=U,this.timestamp=te}};Gi=qe([F],Gi),e.TimelineItem=Gi;var an;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(an=e.ExtensionMode||(e.ExtensionMode={}));var cn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var un;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(un=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=ln;class dn{constructor(U,te){this.c=U,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=dn;var hn;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(hn=e.TestResultState||(e.TestResultState={}));var fn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(fn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xi=class{constructor(U=void 0,te=void 0,Ee=void 0){this.include=U,this.exclude=te,this.profile=Ee}};xi=qe([F],xi),e.TestRunRequest=xi;let Xi=R=class{static diff(U,te,Ee){const Ke=new R(U);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(U){this.message=U}};Xi=R=qe([F],Xi),e.TestMessage=Xi;let Qi=class{constructor(U){this.id=U}};Qi=qe([F],Qi),e.TestTag=Qi;let pi=class{constructor(U,te){this.covered=U,this.total=te}};pi=qe([F],pi),e.CoveredCount=pi;let _i=A=class{static fromDetails(U,te){const Ee=new pi(0,0),Ke=new pi(0,0),_e=new pi(0,0);for(const ut of te)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const Ot of ut.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const ot=new A(U,Ee,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=te,ot}constructor(U,te,Ee,Ke){this.uri=U,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ke}};_i=A=qe([F],_i),e.FileCoverage=_i;let Yi=class{constructor(U,te,Ee=[]){this.executionCount=U,this.location=te,this.branches=Ee}};Yi=qe([F],Yi),e.StatementCoverage=Yi;let Ji=class{constructor(U,te){this.executionCount=U,this.location=te}};Ji=qe([F],Ji),e.BranchCoverage=Ji;let Zi=class{constructor(U,te){this.executionCount=U,this.location=te}};Zi=qe([F],Zi),e.FunctionCoverage=Zi;var mn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(mn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var gn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(gn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var pn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(pn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class vn{constructor(U,te,Ee,Ke,_e,ot){this.kind=U,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=vn;class bn{constructor(U){this.uri=U}}e.TextTabInput=bn;class En{constructor(U,te){this.original=U,this.modified=te}}e.TextDiffTabInput=En;class wn{constructor(U,te,Ee,Ke){this.base=U,this.input1=te,this.input2=Ee,this.result=Ke}}e.TextMergeTabInput=wn;class Sn{constructor(U,te){this.uri=U,this.viewType=te}}e.CustomEditorTabInput=Sn;class yn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=yn;class Dn{constructor(U,te){this.uri=U,this.notebookType=te}}e.NotebookEditorTabInput=Dn;class In{constructor(U,te,Ee){this.original=U,this.modified=te,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=In;class Cn{constructor(){}}e.TerminalEditorTabInput=Cn;class kn{constructor(U,te){this.uri=U,this.inputBoxUri=te}}e.InteractiveWindowInput=kn}),define(Ie[96],Ce([1,0,47,13,10,249,127,6,16]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function M(f,t){t?k.set(f,t):k.delete(f)}e.setWordDefinitionFor=M;function D(f){return k.get(f)}class m extends L.MirrorTextModel{constructor(t,c,l,p,E,b,w,r){super(c,l,p,E),this.m=t,this.p=b,this.q=w,this.notebook=r,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(t){return(0,S.equals)(this.d,t)}get document(){if(!this.a){const t=this;this.a={get uri(){return t.c},get fileName(){return t.c.fsPath},get isUntitled(){return t.c.scheme===T.Schemas.untitled},get languageId(){return t.p},get version(){return t.g},get isClosed(){return t.b},get isDirty(){return t.q},save(){return t.r()},getText(c){return c?t.s(c):t.getText()},get eol(){return t.f===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return t.d.length},lineAt(c){return t.t(c)},offsetAt(c){return t.u(c)},positionAt(c){return t.v(c)},validateRange(c){return t.w(c)},validatePosition(c){return t.x(c)},getWordRangeAtPosition(c,l){return t.y(c,l)}}}return Object.freeze(this.a)}_acceptLanguageId(t){(0,i.ok)(!this.b),this.p=t}_acceptIsDirty(t){(0,i.ok)(!this.b),this.q=t}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(t){const c=this.w(t);if(c.isEmpty)return"";if(c.isSingleLine)return this.d[c.start.line].substring(c.start.character,c.end.character);const l=this.f,p=c.start.line,E=c.end.line,b=[];b.push(this.d[p].substring(c.start.character));for(let w=p+1;w<E;w++)b.push(this.d[w]);return b.push(this.d[E].substring(0,c.end.character)),b.join(l)}t(t){let c;if(t instanceof O.Position?c=t.line:typeof t=="number"&&(c=t),typeof c!="number"||c<0||c>=this.d.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new v(c,this.d[c],c===this.d.length-1)}u(t){return t=this.x(t),this.k(),this.h.getPrefixSum(t.line-1)+t.character}v(t){t=Math.floor(t),t=Math.max(0,t),this.k();const c=this.h.getIndexOf(t),l=this.d[c.index].length;return new O.Position(c.index,Math.min(c.remainder,l))}w(t){if(!(t instanceof O.Range))throw new Error("Invalid argument");const c=this.x(t.start),l=this.x(t.end);return c===t.start&&l===t.end?t:new O.Range(c.line,c.character,l.line,l.character)}x(t){if(!(t instanceof O.Position))throw new Error("Invalid argument");if(this.d.length===0)return t.with(0,0);let{line:c,character:l}=t,p=!1;if(c<0)c=0,l=0,p=!0;else if(c>=this.d.length)c=this.d.length-1,l=this.d[c].length,p=!0;else{const E=this.d[c].length;l<0?(l=0,p=!0):l>E&&(l=E,p=!0)}return p?new O.Position(c,l):t}y(t,c){const l=this.x(t);if(!c)c=D(this.p);else if((0,y.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const p=(0,C.getWordAtText)(l.character+1,(0,C.ensureValidWordDefinition)(c),this.d[l.line],0);if(p)return new O.Range(l.line,p.startColumn-1,l.line,p.endColumn-1)}}e.ExtHostDocumentData=m;class v{constructor(t,c,l){this.a=t,this.b=c,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=v}),define(Ie[184],Ce([1,0,6,15,5]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(O){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(O){let S;switch(O){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ie[8],Ce([1,0,16,24,113,185,82,28,110,81,62,23,9,2,55,72,87,93,92,67,42,54,180,6]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ye){function Pe(x){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:Xe,positionColumn:Be}=x,Ze=new s.Position(Ae-1,Le-1),bt=new s.Position(Xe-1,Be-1);return new s.Selection(Ze,bt)}ye.to=Pe;function fe(x){const{anchor:Ae,active:Le}=x;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=fe})(a=e.Selection||(e.Selection={}));var d;(function(ye){function Pe(x){if(!x)return;const{start:Ae,end:Le}=x;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=Pe;function fe(x){if(!x)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:Xe,endColumn:Be}=x;return new s.Range(Ae-1,Le-1,Xe-1,Be-1)}ye.to=fe})(d=e.Range||(e.Range={}));var o;(function(ye){function Pe(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ye.to=Pe})(o=e.TokenType||(e.TokenType={}));var u;(function(ye){function Pe(x){return new s.Position(x.lineNumber-1,x.column-1)}ye.to=Pe;function fe(x){return{lineNumber:x.line+1,column:x.character+1}}ye.from=fe})(u=e.Position||(e.Position={}));var n;(function(ye){function Pe(Ae,Le){return(0,i.coalesce)((0,i.asArray)(Ae).map(Xe=>fe(Xe,Le)))}ye.from=Pe;function fe(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:x(Ae.scheme,Le),pattern:Q.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function x(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(n=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(ye){function Pe(x){switch(x){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function fe(x){switch(x){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ye){function Pe(x){let Ae;return x.code&&((0,m.isString)(x.code)||(0,m.isNumber)(x.code)?Ae=String(x.code):Ae={value:String(x.code.value),target:x.code.target}),{...d.from(x.range),message:x.message,source:x.source,code:Ae,severity:N.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(P.from),tags:Array.isArray(x.tags)?(0,i.coalesce)(x.tags.map(h.from)):void 0}}ye.from=Pe;function fe(x){const Ae=new s.Diagnostic(d.to(x),x.message,N.to(x.severity));return Ae.source=x.source,Ae.code=(0,m.isString)(x.code)?x.code:x.code?.value,Ae.relatedInformation=x.relatedInformation&&x.relatedInformation.map(P.to),Ae.tags=x.tags&&(0,i.coalesce)(x.tags.map(h.to)),Ae}ye.to=fe})(g=e.Diagnostic||(e.Diagnostic={}));var P;(function(ye){function Pe(x){return{...d.from(x.location.range),message:x.message,resource:x.location.uri}}ye.from=Pe;function fe(x){return new s.DiagnosticRelatedInformation(new s.Location(x.resource,d.to(x)),x.message)}ye.to=fe})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var N;(function(ye){function Pe(x){switch(x){case s.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Pe;function fe(x){switch(x){case c.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ye.to=fe})(N=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var j;(function(ye){function Pe(x){return typeof x=="number"&&x>=s.ViewColumn.One?x-1:x===s.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ye.from=Pe;function fe(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(j=e.ViewColumn||(e.ViewColumn={}));function Z(ye){return typeof ye.range<"u"}function G(ye){return ye.length===0?!0:!!Z(ye[0])}e.isDecorationOptionsArr=G;var R;(function(ye){function Pe(Be){return Be.map(ye.from)}ye.fromMany=Pe;function fe(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function x(Be){let Ze;if(fe(Be)){const{language:pt,value:vt}=Be;Ze={value:"```"+pt+`
`+vt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const Et=pt=>{try{let vt=v.URI.parse(pt,!0);vt=vt.with({query:Ae(vt.query,bt)}),bt[pt]=vt}catch{}return""},kt=new S.marked.Renderer;return kt.link=Et,kt.image=pt=>typeof pt=="string"?Et(C.parseHrefAndDimensions(pt).href):"",(0,S.marked)(Ze.value,{renderer:kt}),Ze}ye.from=x;function Ae(Be,Ze){if(!Be)return Be;let bt;try{bt=(0,k.parse)(Be)}catch{}if(!bt)return Be;let Et=!1;return bt=(0,D.cloneAndChange)(bt,kt=>{if(v.URI.isUri(kt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=kt,Et=!0,pt}else return}),Et?JSON.stringify(bt):Be}function Le(Be){const Ze=new s.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?v.URI.from(Be.baseUri):void 0,Ze}ye.to=Le;function Xe(Be){if(!!Be)return typeof Be=="string"?Be:ye.from(Be)}ye.fromStrict=Xe})(R=e.MarkdownString||(e.MarkdownString={}));function A(ye){return G(ye)?ye.map(Pe=>({range:d.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?R.fromMany(Pe.hoverMessage):Pe.hoverMessage?R.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:d.from(Pe)}))}e.fromRangeOrRangeWithMessage=A;function F(ye){return typeof ye>"u"?ye:typeof ye=="string"?v.URI.file(ye):ye}e.pathOrURIToURI=F;var B;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?F(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Pe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(ye){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(ye){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(ye){function Pe(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:d.from(x.range)}}ye.from=Pe;function fe(x){const Ae=new s.TextEdit(d.to(x.range),x.text);return Ae.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Ae}ye.to=fe})(ie=e.TextEdit||(e.TextEdit={}));var ge;(function(ye){function Pe(x,Ae){const Le={edits:[]};if(x instanceof s.WorkspaceEdit){const Xe=new O.ResourceSet;for(const Be of x._allEntries())Be._type===1&&v.URI.isUri(Be.to)&&Be.from===void 0&&Xe.add(Be.to);for(const Be of x._allEntries())Be._type===1?Le.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Le.edits.push({resource:Be.uri,textEdit:ie.from(Be.edit),versionId:Xe.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Le.edits.push({resource:Be.uri,textEdit:{range:d.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Xe.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Le.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Le.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(wt.from)}})}return Le}ye.from=Pe;function fe(x){const Ae=new s.WorkspaceEdit;for(const Le of x.edits)Le.textEdit?Ae.replace(v.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(v.URI.revive(Le.oldResource),v.URI.revive(Le.newResource),Le.options);return Ae}ye.to=fe})(ge=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(ye){const Pe=Object.create(null);Pe[s.SymbolKind.File]=0,Pe[s.SymbolKind.Module]=1,Pe[s.SymbolKind.Namespace]=2,Pe[s.SymbolKind.Package]=3,Pe[s.SymbolKind.Class]=4,Pe[s.SymbolKind.Method]=5,Pe[s.SymbolKind.Property]=6,Pe[s.SymbolKind.Field]=7,Pe[s.SymbolKind.Constructor]=8,Pe[s.SymbolKind.Enum]=9,Pe[s.SymbolKind.Interface]=10,Pe[s.SymbolKind.Function]=11,Pe[s.SymbolKind.Variable]=12,Pe[s.SymbolKind.Constant]=13,Pe[s.SymbolKind.String]=14,Pe[s.SymbolKind.Number]=15,Pe[s.SymbolKind.Boolean]=16,Pe[s.SymbolKind.Array]=17,Pe[s.SymbolKind.Object]=18,Pe[s.SymbolKind.Key]=19,Pe[s.SymbolKind.Null]=20,Pe[s.SymbolKind.EnumMember]=21,Pe[s.SymbolKind.Struct]=22,Pe[s.SymbolKind.Event]=23,Pe[s.SymbolKind.Operator]=24,Pe[s.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}ye.from=fe;function x(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return s.SymbolKind.Property}ye.to=x})(ue=e.SymbolKind||(e.SymbolKind={}));var re;(function(ye){function Pe(x){switch(x){case s.SymbolTag.Deprecated:return 1}}ye.from=Pe;function fe(x){switch(x){case 1:return s.SymbolTag.Deprecated}}ye.to=fe})(re=e.SymbolTag||(e.SymbolTag={}));var se;(function(ye){function Pe(x){return{name:x.name,kind:ue.from(x.kind),tags:x.tags&&x.tags.map(re.from),containerName:x.containerName,location:Me.from(x.location)}}ye.from=Pe;function fe(x){const Ae=new s.SymbolInformation(x.name,ue.to(x.kind),x.containerName,Me.to(x.location));return Ae.tags=x.tags&&x.tags.map(re.to),Ae}ye.to=fe})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(ye){function Pe(x){const Ae={name:x.name||"!!MISSING: name!!",detail:x.detail,range:d.from(x.range),selectionRange:d.from(x.selectionRange),kind:ue.from(x.kind),tags:x.tags?.map(re.from)??[]};return x.children&&(Ae.children=x.children.map(Pe)),Ae}ye.from=Pe;function fe(x){const Ae=new s.DocumentSymbol(x.name,x.detail,ue.to(x.kind),d.to(x.range),d.to(x.selectionRange));return(0,i.isNonEmptyArray)(x.tags)&&(Ae.tags=x.tags.map(re.to)),x.children&&(Ae.children=x.children.map(fe)),Ae}ye.to=fe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var _;(function(ye){function Pe(x){const Ae=new s.CallHierarchyItem(ue.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}ye.to=Pe;function fe(x,Ae,Le){if(Ae=Ae??x._sessionId,Le=Le??x._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:x.name,detail:x.detail,kind:ue.from(x.kind),uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(re.from)}}ye.from=fe})(_=e.CallHierarchyItem||(e.CallHierarchyItem={}));var me;(function(ye){function Pe(fe){return new s.CallHierarchyIncomingCall(_.to(fe.from),fe.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(me=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(ye){function Pe(fe){return new s.CallHierarchyOutgoingCall(_.to(fe.to),fe.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Me;(function(ye){function Pe(x){return{range:x.range&&d.from(x.range),uri:x.uri}}ye.from=Pe;function fe(x){return new s.Location(v.URI.revive(x.uri),d.to(x.range))}ye.to=fe})(Me=e.location||(e.location={}));var We;(function(ye){function Pe(x){const Ae=x,Le=x;return{originSelectionRange:Ae.originSelectionRange?d.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:d.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?d.from(Ae.targetSelectionRange):void 0}}ye.from=Pe;function fe(x){return{targetUri:v.URI.revive(x.uri),targetRange:d.to(x.range),targetSelectionRange:x.targetSelectionRange?d.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?d.to(x.originSelectionRange):void 0}}ye.to=fe})(We=e.DefinitionLink||(e.DefinitionLink={}));var Qe;(function(ye){function Pe(x){return{range:d.from(x.range),contents:R.fromMany(x.contents)}}ye.from=Pe;function fe(x){return new s.Hover(x.contents.map(R.to),d.to(x.range))}ye.to=fe})(Qe=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(x){return{range:d.from(x.range),expression:x.expression}}ye.from=Pe;function fe(x){return new s.EvaluatableExpression(d.to(x.range),x.expression)}ye.to=fe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(ye){function Pe(x){if(x instanceof s.InlineValueText)return{type:"text",range:d.from(x.range),text:x.text};if(x instanceof s.InlineValueVariableLookup)return{type:"variable",range:d.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function fe(x){switch(x.type){case"text":return{range:d.to(x.range),text:x.text};case"variable":return{range:d.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:d.to(x.range),expression:x.expression}}}ye.to=fe})(De=e.InlineValue||(e.InlineValue={}));var ke;(function(ye){function Pe(x){return{frameId:x.frameId,stoppedLocation:d.from(x.stoppedLocation)}}ye.from=Pe;function fe(x){return new s.InlineValueContext(x.frameId,d.to(x.stoppedLocation))}ye.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(ye){function Pe(x){return{range:d.from(x.range),kind:x.kind}}ye.from=Pe;function fe(x){return new s.DocumentHighlight(d.to(x.range),x.kind)}ye.to=fe})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(ye){function Pe(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ye.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Pe(fe){return{triggerKind:ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Pe})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Pe(x){switch(x){case s.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function fe(x){switch(x){case 1:return s.CompletionItemTag.Deprecated}}ye.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ye){const Pe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}ye.from=fe;const x=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ae(Le){return x.get(Le)??s.CompletionItemKind.Property}ye.to=Ae})($=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(fe,x){const Ae=new s.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=$.to(fe.kind),Ae.tags=fe.tags?.map(I.to),Ae.detail=fe.detail,Ae.documentation=C.isMarkdownString(fe.documentation)?R.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,f.Range.isIRange(fe.range)?Ae.range=d.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:d.to(fe.range.insert),replacing:d.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new s.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof s.Range?new s.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Le=>ie.to(Le))),Ae.command=x&&fe.command?x.fromInternal(fe.command):void 0,Ae}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var q;(function(ye){function Pe(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:R.fromStrict(x.documentation)}}ye.from=Pe;function fe(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?R.to(x.documentation):x.documentation}}ye.to=fe})(q=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(ye){function Pe(x){return{label:x.label,documentation:R.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(q.from):[],activeParameter:x.activeParameter}}ye.from=Pe;function fe(x){return{label:x.label,documentation:C.isMarkdownString(x.documentation)?R.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(q.to):[],activeParameter:x.activeParameter}}ye.to=fe})(J=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ye){function Pe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(J.from):[]}}ye.from=Pe;function fe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(J.to):[]}}ye.to=fe})(de=e.SignatureHelp||(e.SignatureHelp={}));var Se;(function(ye){function Pe(fe,x){const Ae=new s.InlayHint(u.to(x.position),typeof x.label=="string"?x.label:x.label.map(ae.to.bind(void 0,fe)),x.kind&&ve.to(x.kind));return Ae.textEdits=x.textEdits&&x.textEdits.map(ie.to),Ae.tooltip=C.isMarkdownString(x.tooltip)?R.to(x.tooltip):x.tooltip,Ae.paddingLeft=x.paddingLeft,Ae.paddingRight=x.paddingRight,Ae}ye.to=Pe})(Se=e.InlayHint||(e.InlayHint={}));var ae;(function(ye){function Pe(fe,x){const Ae=new s.InlayHintLabelPart(x.label);return Ae.tooltip=C.isMarkdownString(x.tooltip)?R.to(x.tooltip):x.tooltip,t.Command.is(x.command)&&(Ae.command=fe.fromInternal(x.command)),x.location&&(Ae.location=Me.to(x.location)),Ae}ye.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(ye){function Pe(x){return x}ye.from=Pe;function fe(x){return x}ye.to=fe})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(ye){function Pe(x){return{range:d.from(x.range),url:x.target,tooltip:x.tooltip}}ye.from=Pe;function fe(x){let Ae;if(x.url)try{Ae=typeof x.url=="string"?v.URI.parse(x.url,!0):v.URI.revive(x.url)}catch{}return new s.DocumentLink(d.to(x.range),Ae)}ye.to=fe})(be=e.DocumentLink||(e.DocumentLink={}));var ze;(function(ye){function Pe(x){const Ae=new s.ColorPresentation(x.label);return x.textEdit&&(Ae.textEdit=ie.to(x.textEdit)),x.additionalTextEdits&&(Ae.additionalTextEdits=x.additionalTextEdits.map(Le=>ie.to(Le))),Ae}ye.to=Pe;function fe(x){return{label:x.label,textEdit:x.textEdit?ie.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Ae=>ie.from(Ae)):void 0}}ye.from=fe})(ze=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(x){return new s.Color(x[0],x[1],x[2],x[3])}ye.to=Pe;function fe(x){return[x.red,x.green,x.blue,x.alpha]}ye.from=fe})(He=e.Color||(e.Color={}));var tt;(function(ye){function Pe(x){return{range:d.from(x.range)}}ye.from=Pe;function fe(x){return new s.SelectionRange(d.to(x.range))}ye.to=fe})(tt=e.SelectionRange||(e.SelectionRange={}));var xe;(function(ye){function Pe(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(x){switch(x){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function fe(x){switch(x){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ye.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(x){if(x===s.EndOfLine.CRLF)return 1;if(x===s.EndOfLine.LF)return 0}ye.from=Pe;function fe(x){if(x===1)return s.EndOfLine.CRLF;if(x===0)return s.EndOfLine.LF}ye.to=fe})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Oe;(function(ye){function Pe(fe){const x={start:fe.start+1,end:fe.end+1};return fe.kind&&(x.kind=st.from(fe.kind)),x}ye.from=Pe})(Oe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Pe(fe){if(fe)switch(fe){case s.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}ye.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(ye){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?d.from(fe.selection):void 0,override:typeof fe.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(ye){function Pe(Le){return Le instanceof s.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||x(Le)?new s.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=Pe;function fe(Le){const Xe=Le;return Xe?v.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function x(Le){const Xe=Le;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new s.RelativePattern(v.URI.revive(Le.baseUri),Le.pattern)}ye.to=Ae})(Q=e.GlobPattern||(e.GlobPattern={}));var pe;(function(ye){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const x=fe;return{language:x.language,scheme:x.scheme,pattern:Q.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ye.from=Pe})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ye){function Pe(x){return{start:x.start,end:x.end}}ye.from=Pe;function fe(x){return new s.NotebookRange(x.start,x.end)}ye.to=fe})(Ne=e.NotebookRange||(e.NotebookRange={}));var $e;(function(ye){function Pe(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ye.to=Pe;function fe(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ye.from=fe})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(ye){function Pe(fe){if(fe===E.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===E.NotebookCellExecutionState.Pending)return;if(fe===E.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(ye){function Pe(x){switch(x){case s.NotebookCellKind.Markup:return E.CellKind.Markup;case s.NotebookCellKind.Code:default:return E.CellKind.Code}}ye.from=Pe;function fe(x){switch(x){case E.CellKind.Markup:return s.NotebookCellKind.Markup;case E.CellKind.Code:default:return s.NotebookCellKind.Code}}ye.to=fe})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(x){const Ae={metadata:x.metadata??Object.create(null),cells:[]};for(const Le of x.cells)s.NotebookCellData.validate(Le),Ae.cells.push(wt.from(Le));return Ae}ye.from=Pe;function fe(x){const Ae=new s.NotebookData(x.cells.map(wt.to));return(0,m.isEmptyObject)(x.metadata)||(Ae.metadata=x.metadata),Ae}ye.to=fe})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(ye){function Pe(x){return{cellKind:Je.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:$e.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Ct.from):[]}}ye.from=Pe;function fe(x){return new s.NotebookCellData(Je.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Ct.to):void 0,x.metadata,x.internalMetadata?$e.to(x.internalMetadata):void 0)}ye.to=fe})(wt=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(ye){function Pe(x){return{mime:x.mime,valueBytes:T.VSBuffer.wrap(x.data)}}ye.from=Pe;function fe(x){return new s.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}ye.to=fe})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ye){function Pe(x){return{outputId:x.id,items:x.items.map(yt.from),metadata:x.metadata}}ye.from=Pe;function fe(x){const Ae=x.items.map(yt.to);return new s.NotebookCellOutput(Ae,x.outputId,x.metadata)}ye.to=fe})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Ae){return x(Ae)?{include:(0,m.withNullAsUndefined)(Q.from(Ae.include)),exclude:(0,m.withNullAsUndefined)(Q.from(Ae.exclude))}:(0,m.withNullAsUndefined)(Q.from(Ae))}ye.from=Pe;function fe(Ae){return x(Ae)?{include:Q.to(Ae.include),exclude:Q.to(Ae.exclude)}:Q.to(Ae)}ye.to=fe;function x(Ae){const Le=Ae;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(fe,x,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Le,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ut;(function(ye){function Pe(fe,x,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:x.toInternal(Le,Ae),label:fe.label,description:fe.description,detail:fe.detail}}ye.from=Pe})(Ut=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(ye){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Pe})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Mt;(function(ye){function Pe(x){return{uri:x.uri,provides:x.provides}}ye.from=Pe;function fe(x){return new s.NotebookRendererScript(v.URI.revive(x.uri),x.provides)}ye.to=fe})(Mt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ht;(function(ye){function Pe(x){return{message:R.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:d.from(x.location.range),uri:x.location.uri}}}ye.from=Pe;function fe(x){const Ae=new s.TestMessage(typeof x.message=="string"?x.message:R.to(x.message));return Ae.actualOutput=x.actual,Ae.expectedOutput=x.expected,Ae.location=x.location?Me.to(x.location):void 0,Ae}ye.to=fe})(ht=e.TestMessage||(e.TestMessage={}));var It;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var Bt;(function(ye){function Pe(x){const Ae=(0,l.getPrivateApiFor)(x).controllerId;return{extId:b.TestId.fromExtHostTestItem(x,Ae).toString(),label:x.label,uri:v.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Le=>It.namespace(Ae,Le.id)),range:f.Range.lift(d.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&R.fromStrict(x.error)||null}}ye.from=Pe;function fe(x){return{parent:void 0,error:void 0,id:b.TestId.fromString(x.extId).localId,label:x.label,uri:v.URI.revive(x.uri),tags:(x.tags||[]).map(Ae=>{const{tagId:Le}=It.denamespace(Ae);return new s.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ye.toPlain=fe})(Bt=e.TestItem||(e.TestItem={})),function(ye){function Pe(x){return{id:x.id}}ye.from=Pe;function fe(x){return new s.TestTag(x.id)}ye.to=fe}(It=e.TestTag||(e.TestTag={}));var Nt;(function(ye){const Pe=(x,Ae)=>{const Le=[];for(const[Be,Ze]of Ae)b.TestId.compare(Ze.item.extId,Be)===2&&(Ae.delete(Be),Le.push(Ze));const Xe={...Bt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(ht.to)})),children:Le.map(Be=>Pe(Be,Ae))};for(const Be of Xe.children)Be.parent=Xe;return Xe};function fe(x){const Ae=[],Le=new Map;for(const Xe of x.items){Le.set(Xe.item.extId,Xe);const Be=b.TestId.root(Xe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:x.completedAt,results:Ae.map(Xe=>Pe(Xe,Le))}}ye.to=fe})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?u.from(Le):d.from(Le)}function x(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}ye.fromDetailed=x;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(x)}}ye.fromFile=Ae})(Ge=e.TestCoverage||(e.TestCoverage={}));var Pt;(function(ye){function Pe(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Pt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(ye){function Pe(x){const Ae=new s.TypeHierarchyItem(ue.to(x.kind),x.name,x.detail||"",v.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Ae._sessionId=x._sessionId,Ae._itemId=x._itemId,Ae}ye.to=Pe;function fe(x,Ae,Le){if(Ae=Ae??x._sessionId,Le=Le??x._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ue.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(re.from)}}ye.from=fe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(ye){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Pe})(Ht=e.ViewBadge||(e.ViewBadge={}));var ft;(function(ye){function Pe(Le,Xe,Be){const Ze=Xe.fileData;return Ze?new class extends s.DataTransferItem{asFile(){return{name:Ze.name,uri:v.URI.revive(Ze.uri),data:(0,L.once)(()=>Be())}}}("",Xe.id):Le===M.Mimes.uriList&&Xe.uriListData?new s.DataTransferItem(Ae(Xe.uriListData)):new s.DataTransferItem(Xe.asString)}ye.to=Pe;async function fe(Le,Xe){const Be=await Xe.asString();if(Le===M.Mimes.uriList)return{id:Xe.id,asString:"",fileData:void 0,uriListData:x(Be)};const Ze=Xe.asFile();return{id:Xe.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function x(Le){return y.UriList.split(Le).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return v.URI.parse(Xe)}catch{}return Xe})}function Ae(Le){return y.UriList.create(Le.map(Xe=>typeof Xe=="string"?Xe:v.URI.revive(Xe)))}})(ft=e.DataTransferItem||(e.DataTransferItem={}));var Tt;(function(ye){function Pe(x,Ae){const Le=x.items.map(([Xe,Be])=>[Xe,ft.to(Xe,Be,()=>Ae(Be.id))]);return new s.DataTransfer(Le)}ye.toDataTransfer=Pe;async function fe(x){const Ae={items:[]},Le=[];return x.forEach((Xe,Be)=>{Le.push((async()=>{Ae.items.push([Be,await ft.from(Be,Xe)])})())}),await Promise.all(Le),Ae}ye.toDataTransferDTO=fe})(Tt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[186],Ce([1,0,2,11,6,8,154]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(k,M,D,m={timeout:1500,errors:3}){this.c=k,this.d=M,this.f=D,this.g=m,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(M,D,m)=>{const f={dispose:this.a.push([M,D,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,M){const D=i.URI.revive(k);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const t of[...this.a]){if(m)break;const c=this.d.getDocument(D),l=await this.h(t,{document:c,reason:L.TextDocumentSaveReason.to(M)});f.push(l)}}finally{clearTimeout(v)}return f}h([k,M,D],m){const v=this.b.get(k);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(D,k,M,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const t=this.b.get(k);this.b.set(k,t?t+1:1),typeof t=="number"&&t>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,M,D,m){const v=[],f=Date.now(),{document:t,reason:c}=m,{version:l}=t,p=Object.freeze({document:t,reason:c,waitUntil(E){if(Object.isFrozen(v))throw(0,T.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(E))}});try{M.apply(D,[p])}catch(E){return Promise.reject(E)}return Object.freeze(v),new Promise((E,b)=>{const w=setTimeout(()=>b(new Error("timeout")),this.g.timeout);return Promise.all(v).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),E(r)}).catch(r=>{clearTimeout(w),b(r)})}).then(E=>{const b={edits:[]};for(const w of E)if(Array.isArray(w)&&w.every(r=>r instanceof y.TextEdit))for(const{newText:r,newEol:s,range:a}of w)b.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:r,eol:s&&L.EndOfLine.from(s)}});if(b.edits.length!==0)return l===t.version?this.f.$tryApplyWorkspaceEdit(b):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(Ie[187],Ce([1,0,13,2,8,6,67]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(D,m,v,f){this.start=D,this.deletedCount=m,this.deletedItems=v,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,m,v){this.notebook=D,this.h=m,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(y.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return D.g},set mime(f){D.g=f},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(v)}return this.f}setOutputs(D){this.a=D.map(y.NotebookCellOutput.to)}setOutputItems(D,m,v){const f=v.map(y.NotebookCellOutputItem.to),t=this.a.find(c=>c.id===D);if(t&&(m||(t.items.length=0),t.items.push(...f),t.items.length>1&&t.items.every(c=>C.isTextStreamMime(c.mime)))){const c=new Map,l=[];t.items.forEach(p=>{let E;c.has(p.mime)?E=c.get(p.mime):(E=[],c.set(p.mime,E),l.push(p.mime)),E.push(p.data)}),t.items.length=0,l.forEach(p=>{const E=C.compressOutputItemStreams(c.get(p));t.items.push({mime:p,data:E.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class k{constructor(D,m,v,f,t){this.k=D,this.l=m,this.m=v,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=t.viewType,this.f=Object.freeze(t.metadata??Object.create(null)),this.r([[0,0,t.cells]],!0,void 0),this.g=t.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,m={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===i.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(v){return v=D.n(v),D.b[v].apiCell},getCells(v){return(v?D.p(v):D.b).map(t=>t.apiCell)},save(){return D.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,m,v){this.g=D.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const f={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},t=[];for(const l of D.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===C.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===C.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===C.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),t.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),t.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const c=new Map;for(let l=0;l<t.length;l++){const p=t[l],E=c.get(p.cell);if(E===void 0){const b=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});c.set(p.cell,b-1)}else f.cellChanges[E]={...f.cellChanges[E],...p}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let m=D.start|0,v=D.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),D.with({start:m,end:v})}p(D){D=this.o(D);const m=[];for(let v=D.start;v<D.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,m,v){if(this.j)return;const f=[],t=[],c=[];if(D.reverse().forEach(l=>{const E=l[2].map(r=>{const s=new S(this,this.l,r);return m||t.push(S.asModelAddData(this.apiNotebook,r)),s}),b=new O(l[0],l[1],[],E),w=this.b.splice(l[0],l[1],...E);for(const r of w)c.push(r.uri),b.deletedItems.push(r.apiCell);f.push(b)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:c}),v)for(const l of f)v.push(l.asApiEvent())}s(D,m,v,f){const t=this.b.splice(D,m);this.b.splice(v,0,...t);const c=[new O(D,m,t.map(l=>l.apiCell),[]),new O(v,0,[],t)];for(const l of c)f.push(l.asApiEvent())}t(D,m){this.b[D].setOutputs(m)}u(D,m,v,f){this.b[D].setOutputItems(m,v,f)}v(D,m){const v=this.b[D];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(D,m){const v=this.b[D];v.apiCell.mime=m}x(D,m){this.b[D].setMetadata(m)}y(D,m){this.b[D].setInternalMetadata(m)}getCellFromApiCell(D){return this.b.find(m=>m.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(m=>m.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[97],Ce([1,0,11,8,6]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(O,S,k,M,D,m){this.id=O,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=M,this.c=m}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(S){this.selections=[S]},get selections(){return O.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");O.a=S,O.g(S)},get visibleRanges(){return O.b},revealRange(S,k){O.f.$tryRevealRange(O.id,T.NotebookRange.from(S),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(T.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ie[188],Ce([1,0,5,12,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(O,S){this.c=O,this.d=S,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,S);const k=this.d.getEditorById(O);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const S in O)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(O[S]))}};L=qe([Ve(0,T.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ie[189],Ce([1,0,8,157,136,20,61,11]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,f){const t=this.b++,{title:c,location:l,cancellable:p}=v,E={label:(0,y.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(t,{location:i.ProgressLocation.from(l),title:c,source:E,cancellable:p},m.isUnderDevelopment?void 0:m.identifier.value).catch(O.onUnexpectedExternalError),this.d(t,f,!!p)}d(m,v,f){let t;f&&(t=new L.CancellationTokenSource,this.c.set(m,t));const c=p=>{this.a.$progressEnd(p),this.c.delete(p),t?.dispose()};let l;try{l=v(new M(this.a,m),f&&t?t.token:L.CancellationToken.None)}catch(p){throw c(m),p}return l.then(p=>c(m),p=>c(m)),l}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.ExtHostProgress=S;function k(D,m){return D.message=m.message,typeof m.increment=="number"&&(typeof D.increment=="number"?D.increment+=m.increment:D.increment=m.increment),D}class M extends T.Progress{constructor(m,v){super(f=>this.throttledReport(f)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,C.throttle)(100,(D,m)=>k(D,m),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Ie[98],Ce([1,0,55,93,42,68,54,8,2]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,b,w,r)=>{let s=b;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!w(s,a)){const d=s;s=a,E.listener?.(r(a,d))}}}},M=(E,b)=>E===b,D={range:(E,b)=>E===b?!0:!E||!b?!1:E.isEqual(b),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(E,b)=>!(E.length!==b.length||E.some(w=>!b.find(r=>w.id===r.id)))},m=E=>b=>({op:4,update:E(b)}),v=(E,b)=>({range:(()=>{let w;const r=m(s=>({range:i.Range.lift(O.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return w},set(s){E.listener?.({op:6}),D.range(w,s)||(w=s,E.listener?.(r(s)))}}})(),label:k(E,b,D.label,m(w=>({label:w}))),description:k(E,void 0,D.description,m(w=>({description:w}))),sortText:k(E,void 0,D.sortText,m(w=>({sortText:w}))),canResolveChildren:k(E,!1,D.canResolveChildren,w=>({op:2,state:w})),busy:k(E,!1,D.busy,m(w=>({busy:w}))),error:k(E,void 0,D.error,m(w=>({error:O.MarkdownString.fromStrict(w)||null}))),tags:k(E,[],D.tags,(w,r)=>({op:1,new:w.map(O.TestTag.from),old:r.map(O.TestTag.from)}))}),f=E=>{const b=y.TestId.fromString(E.extId),w=new c(b.controllerId,b.localId,E.label,S.URI.revive(E.uri)||void 0);return w.range=O.Range.to(E.range||void 0),w.description=E.description||void 0,w.sortText=E.sortText||void 0,w.tags=E.tags.map(r=>O.TestTag.to({id:(0,C.denamespaceTestTag)(r).tagId})),w},t=E=>{let b;for(const w of E.tests){const r=f(w.item);(0,T.getPrivateApiFor)(r).parent=b,b=r}return b};e.toItemFromContext=t;class c{constructor(b,w,r,s){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,T.createPrivateApiFor)(this,b);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof l?void 0:a.parent}},children:{value:(0,L.createTestItemChildren)(a,T.getPrivateApiFor,c),enumerable:!0,writable:!1},...v(a,r)})}}e.TestItemImpl=c;class l extends c{constructor(b,w){super(b,b,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class p extends L.TestItemCollection{constructor(b,w,r){super({controllerId:b,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:T.getPrivateApiFor,getChildren:s=>s.children,root:new l(b,w),toITestItem:O.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(Ie[99],Ce([1,0,47,11,80,8,6]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class O{constructor(m,v,f){const t=O.c.nextId();m.$registerTextEditorDecorationType(v.identifier,t,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:t,dispose(){m.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=O,O.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let f=null;if(m instanceof C.Position)f=new C.Range(m,m);else if(m instanceof C.Range)f=m;else throw new Error("Unrecognized location");this.l(f,v,!1)}insert(m,v){this.k(),this.l(new C.Range(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof C.Range)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,f){const t=this.c.validateRange(m);this.g.push({range:t,text:v,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==C.EndOfLine.LF&&m!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=m}}class k{constructor(m,v,f,t){this.c=m,this.d=v,this._accept(f),this.e=t;const c=this;this.value={get tabSize(){return c.f},set tabSize(l){c.m(l)},get indentSize(){return c.g},set indentSize(l){c.o(l)},get insertSpaces(){return c.h},set insertSpaces(l){c.q(l)},get cursorStyle(){return c.j},set cursorStyle(l){c.s(l)},get lineNumbers(){return c.k},set lineNumbers(l){c.t(l)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}m(m){const v=this.l(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}o(m){const v=this.n(m);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const v=this.p(m);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let f=!1;if(typeof m.tabSize<"u"){const t=this.l(m.tabSize);t==="auto"?(f=!0,v.tabSize=t):typeof t=="number"&&this.f!==t&&(this.f=t,f=!0,v.tabSize=t)}if(typeof m.indentSize<"u"){const t=this.n(m.indentSize);t==="tabSize"?(f=!0,v.indentSize=t):typeof t=="number"&&this.g!==t&&(this.g=t,f=!0,v.indentSize=t)}if(typeof m.insertSpaces<"u"){const t=this.p(m.insertSpaces);t==="auto"?(f=!0,v.insertSpaces=t):this.h!==t&&(this.h=t,f=!0,v.insertSpaces=t)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(m,v){v.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class M{constructor(m,v,f,t,c,l,p,E){this.id=m,this.j=v,this.k=f,this.g=!1,this.h=new Set,this.c=c,this.d=new k(this.j,this.id,l,f),this.e=p,this.f=E;const b=this;this.value=Object.freeze({get document(){return t.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return b.c&&b.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");b.c=[w],b.l()},get selections(){return b.c},set selections(w){if(!Array.isArray(w)||w.some(r=>!(r instanceof C.Selection)))throw(0,T.illegalArgument)("selections");b.c=w,b.l()},get visibleRanges(){return b.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return b.d.value},set options(w){b.g||b.d.assign(w)},get viewColumn(){return b.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,r={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(t.getValue(),r);return w(s),b.m(s)},insertSnippet(w,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!r||Array.isArray(r)&&r.length===0)a=b.c.map(d=>L.Range.from(d));else if(r instanceof C.Position){const{lineNumber:d,column:o}=L.Position.from(r);a=[{startLineNumber:d,startColumn:o,endLineNumber:d,endColumn:o}]}else if(r instanceof C.Range)a=[L.Range.from(r)];else{a=[];for(const d of r)if(d instanceof C.Range)a.push(L.Range.from(d));else{const{lineNumber:o,column:u}=L.Position.from(d);a.push({startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u})}}return v.$tryInsertSnippet(m,t.getValue().version,w.value,a,s)},setDecorations(w,r){const s=r.length===0;s&&!b.h.has(w.key)||(s?b.h.delete(w.key):b.h.add(w.key),b.n(()=>{if(L.isDecorationOptionsArr(r))return v.$trySetDecorations(m,w.key,L.fromRangeOrRangeWithMessage(r));{const a=new Array(4*r.length);for(let d=0,o=r.length;d<o;d++){const u=r[d];a[4*d]=u.start.line+1,a[4*d+1]=u.start.character+1,a[4*d+2]=u.end.line+1,a[4*d+3]=u.end.character+1}return v.$trySetDecorationsFast(m,w.key,a)}}))},revealRange(w,r){b.n(()=>v.$tryRevealRange(m,L.Range.from(w),r||C.TextEditorRevealType.Default))},show(w){v.$tryShowEditor(m,L.ViewColumn.from(w))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const f=v.edits.map(c=>c.range);f.sort((c,l)=>c.end.line===l.end.line?c.end.character===l.end.character?c.start.line===l.start.line?c.start.character-l.start.character:c.start.line-l.start.line:c.end.character-l.end.character:c.end.line-l.end.line);for(let c=0,l=f.length-1;c<l;c++){const p=f[c].end;if(f[c+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=v.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,t,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.ExtHostTextEditor=M}),define(Ie[190],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[191],Ce([1,0,147,11,29,86,89,30,26,190,156,149]),function(ee,e,i,T,y,L,C,O,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=O.Registry.as(C.Extensions.JSONContribution);class v{constructor(w,r,s){this.a=w,this.b=r,this.c=s}d(w,r){this.a({type:w,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=v;class f{static a(w){const r=new Set;for(let s=0,a=w.length;s<a;s++)r.add(S.ExtensionIdentifier.toKey(w[s].description.identifier));return r}static compute(w,r){if(!w||!w.length)return new f(r,[]);if(!r||!r.length)return new f([],w);const s=this.a(w),a=this.a(r),d=r.filter(u=>!s.has(S.ExtensionIdentifier.toKey(u.description.identifier))),o=w.filter(u=>!a.has(S.ExtensionIdentifier.toKey(u.description.identifier)));return new f(d,o)}constructor(w,r){this.added=w,this.removed=r}}e.ExtensionPointUserDelta=f;class t{constructor(w,r){this.name=w,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=f.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=t;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const r=new t(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,r),w.activationEventsGenerator&&D.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,m.registerSchema(l,e.schema),r}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const E={ExtensionsRegistry:"ExtensionsRegistry"};O.Registry.add(E.ExtensionsRegistry,new p),e.ExtensionsRegistry=O.Registry.as(E.ExtensionsRegistry),m.registerSchema(l,e.schema),m.registerSchema(M.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[192],Ce([1,0,144,9,23,191,41,5]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(m){function v(f,t,c){if(!f)return;const l=T.isString(f.type)?f.type:void 0;if(!l||l.length===0){c.error(i.localize(3,null));return}const p=[];if(Array.isArray(f.required))for(const E of f.required)T.isString(E)&&p.push(E);return{extensionId:t.value,taskType:l,required:p,properties:f.properties?y.deepClone(f.properties):{},when:f.when?C.ContextKeyExpr.deserialize(f.when):void 0}}m.from=v})(k||(k={}));const M=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new O.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,f)=>{M.setHandler((t,c)=>{this.c=void 0;try{for(const l of c.removed){const p=l.value;for(const E of p)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of c.added){const p=l.value;for(const E of p){const b=k.from(E,l.description.identifier,l.collector);b&&(this.a[b.taskType]=b)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const f of this.all()){const t={type:"object",additionalProperties:!1};f.required.length>0&&(t.required=f.required.slice(0)),f.properties!==void 0?t.properties=y.deepClone(f.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[f.taskType]},v.push(t)}this.c={oneOf:v}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Ie[193],Ce([1,0,145,9,22,23,41,192]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function B(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var M;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(M=e.RevealKind||(e.RevealKind={})),function(F){function B(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(M=e.RevealKind||(e.RevealKind={}));var D;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function B(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function B(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(m=e.PanelKind||(e.PanelKind={}));var v;(function(F){F.defaults={echo:!0,reveal:M.Always,revealProblems:D.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function B(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function z(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(f=e.RuntimeType||(e.RuntimeType={}));var t;(function(F){function B(z){return T.isString(z)?z:z.value}F.value=B})(t=e.CommandString||(e.CommandString={}));var c;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=B;function z(V){if(V!==void 0)return T.isString(V)?B(V)?{_id:V,isDefault:!1}:void 0:V}F.from=z})(c=e.TaskGroup||(e.TaskGroup={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var p;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=B})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(F){F.parallel="parallel",F.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var b;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(b=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:b.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class r{constructor(B,z,V,K,ie,ge){this._label="",this._id=B,z&&(this._label=z),V&&(this.type=V),this.runOptions=K,this.configurationProperties=ie,this._source=ge}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,z=!1){if(B===void 0)return!1;if(T.isString(B))return B===this._label||B===this.configurationProperties.identifier||z&&B===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=r;class s extends r{constructor(B,z,V,K,ie,ge,ue,re){super(B,V,void 0,ue,re,z),this.command={},this._source=z,this.hasDefinedMatchers=ge,ie&&(this.command=ie)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case f.Shell:z="shell";break;case f.Process:z="process";break;case f.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(B){return B instanceof s}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new s(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=s;class a extends r{constructor(B,z,V,K,ie,ge,ue){super(B,V,K,ge,ue,z),this._source=z,this.configures=ie}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(V)}}e.ConfiguringTask=a;class d extends r{constructor(B,z,V,K,ie,ge,ue,re,se){super(B,V,K,re,se,z),this.defines=ie,this.hasDefinedMatchers=ue,this.command=ge,this.icon=se.icon,this.hide=se.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof d}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new d(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=d;class o extends r{constructor(B,z,V,K,ie,ge){super(B,V,K,ie,ge,z),this._source=z}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new o(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=o;var u;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(B){this.c=new Map;for(let z=0;z<B.length;z++)this.c.set(B[z].uri.toString(),z)}compare(B,z){const V=B.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(V&&K){let ie=this.c.get(V.uri.toString());ie=ie===void 0?0:ie+1;let ge=this.c.get(K.uri.toString());return ge=ge===void 0?0:ge+1,ie===ge?B._label.localeCompare(z._label):ie-ge}else return!V&&K?-1:V&&!K?1:0}}e.TaskSorter=h;var g;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(F){F.SingleRun="singleRun",F.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var N;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(F){function B(z,V,K,ie){if(V){const ge={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:K,__task:V};return z==="start"?ge.resolvedVariables=ie:z==="processStarted"?ge.processId=ie:z==="processEnded"&&(ge.exitCode=ie),Object.freeze(ge)}else return Object.freeze({kind:"changed"})}F.create=B})(j=e.TaskEvent||(e.TaskEvent={}));var Z;(function(F){function B(V){const K=Object.keys(V).sort();let ie="";for(const ge of K){let ue=V[ge];ue instanceof Object?ue=B(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ie+=ge+","+ue+","}return ie}function z(V){const ie={_key:B(V),type:V.taskType};return Object.assign(ie,V),ie}F.create=z})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var G;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(G=e.TaskSettingId||(e.TaskSettingId={}));var R;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(R=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var A;(function(F){function B(z,V){const K=O.TaskDefinitionRegistry.get(z.type);if(K===void 0){const re=L.deepClone(z);return delete re._key,Z.create(re)}const ie=Object.create(null);ie.type=K.taskType;const ge=new Set;K.required.forEach(re=>ge.add(re));const ue=K.properties;for(const re of Object.keys(ue)){const se=z[re];if(se!=null)ie[re]=se;else if(ge.has(re)){const le=ue[re];if(le.default!==void 0)ie[re]=L.deepClone(le.default);else switch(le.type){case"boolean":ie[re]=!1;break;case"number":case"integer":ie[re]=0;break;case"string":ie[re]="";break;default:V.error(i.localize(2,null,JSON.stringify(z,void 0,0),re));return}}}return Z.create(ie)}F.createTaskIdentifier=B})(A=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[194],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,O)=>{this.b=C,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,i.onUnexpectedError)(C))}then(C,O){return this.j().then(C,O)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=y}),define(Ie[43],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const T=[];function y(O){const S=new i(O);return T[S.nid]=S,S}e.createProxyIdentifier=y;function L(O){return T[O].sid}e.getStringIdentifierForProxy=L;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ie[4],Ce([1,0,43]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var L;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(c){return c._id=D.a++,c}}e.IdObject=D,D.a=0;var m;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[73],Ce([1,0,3,12,4,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,k,M){const D=this.d(S,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(O,S,k){}})}),define(Ie[195],Ce([1,0,5,4,6,26]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,M,D={}){const m=L.ExtensionIdentifier.toKey(S.identifier),v=this.f.get(m)||[],f=[...M].sort().join(" ");let t=v.find(c=>c.providerId===k&&c.scopes===f);if(t)return t.result;{const c=this.g(S,m,k,M,D);t={providerId:k,scopes:f,result:c},v.push(t),this.f.set(m,v);try{await c}finally{const l=v.findIndex(p=>p.providerId===k&&p.scopes===f);l>-1&&(v.splice(l),this.f.set(m,v))}return c}}async g(S,k,M,D,m={}){await this.a.$ensureProvider(M);const v=S.displayName||S.name;return this.a.$getSession(M,D,k,v,m)}async removeSession(S,k){const M=this.b.get(S);return M?M.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,M,D){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:M,options:D??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===S)||this.c.push({id:S,label:k});const m=M.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(S,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,D?.supportsMultipleAccounts??!1),new y.Disposable(()=>{m.dispose(),this.b.delete(S);const v=this.c.findIndex(f=>f.id===S);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[196],Ce([1,0,4,15,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(O,S){this.a=O.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O,S,k){const M=y.WorkspaceEdit.from(O,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,k?.isRefactoring??!1)}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ie[197],Ce([1,0,4]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const C=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(O){return C.$writeText(O)}})}}e.ExtHostClipboard=T});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[38],Ce([1,0,9,6,8,23,4,16,12,81,55,250,2,7,3,15,98,24,43,45,100,50]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w){"use strict";var r,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(g,P){r.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Ye(this,r,g.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=P,Ye(this,s,g.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,N=>{const j=this.c.get(N);return j?.result===u.Void?j:void 0},P),this.f=[{processArgument(N){return(0,k.revive)(N)}},{processArgument(N){return(0,L.cloneAndChange)(N,function(j){if(M.Range.isIRange(j))return y.Range.to(j);if(D.Position.isIPosition(j))return y.Position.to(j);if(M.Range.isIRange(j.range)&&m.URI.isUri(j.uri))return y.location.to(j);if(j instanceof l.VSBuffer)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const P=this.registerCommand(!1,g.id,async(...N)=>{const j=g.args.map((G,R)=>{if(!G.validate(N[R]))throw new Error(`Invalid argument '${G.name}' when running '${g.id}', received: ${N[R]}`);return G.convert(N[R])}),Z=await this.executeCommand(g.internalId,...j);return g.result.convert(Z,N,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new T.Disposable(()=>{P.dispose(),this.c.delete(g.id)})}registerCommand(g,P,N,j,Z,G){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:N,thisArg:j,description:Z,extension:G}),g&&Re(this,r,"f").$registerCommand(P),new T.Disposable(()=>{this.b.delete(P)&&g&&Re(this,r,"f").$unregisterCommand(P)})}executeCommand(g,...P){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,P,!0)}async g(g,P,N){if(this.b.has(g))return Re(this,r,"f").$fireCommandActivationEvent(g),this.h(g,P,!1);{let j=!1;const Z=(0,L.cloneAndChange)(P,function(G){if(G instanceof T.Position)return y.Position.from(G);if(G instanceof T.Range)return y.Range.from(G);if(G instanceof T.Location)return y.location.from(G);if(T.NotebookRange.isNotebookRange(G))return y.NotebookRange.from(G);if(G instanceof ArrayBuffer)return j=!0,l.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return j=!0,l.VSBuffer.wrap(G);if(G instanceof l.VSBuffer)return j=!0,G;if(!Array.isArray(G))return G});try{const G=await Re(this,r,"f").$executeCommand(g,j?new p.SerializableObjectWithBuffers(Z):Z,N);return(0,k.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(g,P,!1);throw G}}}async h(g,P,N){const j=this.b.get(g);if(!j)throw new Error("Unknown command");const{callback:Z,thisArg:G,description:R}=j;if(R)for(let F=0;F<R.args.length;F++)try{(0,i.validateConstraint)(P[F],R.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${R.args[F].name}' - ${R.args[F].description}`)}const A=b.StopWatch.create();try{return await Z.apply(G,P)}catch(F){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...P);B&&(g=B.command)}throw this.d.error(F,g,j.extension?.identifier),N?new class extends Error{constructor(){super((0,E.toErrorMessage)(F)),this.id=g,this.source=j.extension?.displayName??j.extension?.name}}:F}finally{this.j(j,g,A.elapsed())}}j(g,P,N){!g.extension||Re(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new w.TrustedTelemetryValue(P),duration:N})}$executeContributedCommand(g,...P){return this.d.trace("ExtHostCommands#$executeContributedCommand",g),this.b.has(g)?(P=P.map(N=>this.f.reduce((j,Z)=>Z.processArgument(j),N)),this.h(g,P,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Re(this,r,"f").$getCommands().then(P=>(g&&(P=P.filter(N=>N[0]!=="_")),P))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[P,N]of this.b){const{description:j}=N;j&&(g[P]=j)}return Promise.resolve(g)}};r=new WeakMap,s=new WeakMap,a=qe([Ve(0,t.IExtHostRpcService),Ve(1,S.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class d{constructor(g,P,N){this.d=g,this.f=P,this.g=N,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,P){if(!g)return;const N={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return N;const j=this.f(g.command);if(j)N.id=j.internalId,N.arguments=j.args.map((Z,G)=>Z.convert(g.arguments&&g.arguments[G]));else if((0,O.isNonEmptyArray)(g.arguments)){const Z=`${g.command}/${++this.c}`;this.b.set(Z,g),P.add((0,v.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),N.$ident=Z,N.id=this.delegatingCommandId,N.arguments=[Z],this.g.trace("CommandsConverter#CREATE",g.command,Z)}return N}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const P=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=d;class o{constructor(g,P,N,j){this.name=g,this.description=P,this.validate=N,this.convert=j}optional(){return new o(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,P){return new o(g??this.name,P??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",h=>m.URI.isUri(h),h=>h),o.Position=new o("position","A position in a text document",h=>T.Position.isPosition(h),y.Position.from),o.Range=new o("range","A range in a text document",h=>T.Range.isRange(h),y.Range.from),o.Selection=new o("selection","A selection in a text document",h=>T.Selection.isSelection(h),y.Selection.from),o.Number=new o("number","",h=>typeof h=="number",h=>h),o.String=new o("string","",h=>typeof h=="string",h=>h),o.CallHierarchyItem=new o("item","A call hierarchy item",h=>h instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",h=>h instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",h=>h instanceof c.TestItemImpl,y.TestItem.from);class u{constructor(g,P){this.description=g,this.convert=P}}e.ApiCommandResult=u,u.Void=new u("no result",h=>h);class n{constructor(g,P,N,j,Z){this.id=g,this.internalId=P,this.description=N,this.args=j,this.result=Z}}e.ApiCommand=n}),define(Ie[198],Ce([1,0,2,8,6,72,38,16,84,88,13]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",v(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,c)=>{if((0,O.isFalsyOrEmpty)(t))return;class l extends y.SymbolInformation{static to(E){const b=new l(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new y.Location(c[0],T.Range.to(E.range)));return b.detail=E.detail,b.range=b.location.range,b.selectionRange=T.Range.to(E.selectionRange),b.children=E.children?E.children.map(l.to):[],b}}return t.map(l.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",v(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",v(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",v(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(c=>y.Position.isPosition(c)),t=>t.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(c=>{let l;for(const p of c.reverse())l=new y.SelectionRange(T.Range.to(p),l);return l}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:T.Range.to(t.range),placeholder:t.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return T.WorkspaceEdit.to(t)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const c=(0,S.decodeSemanticTokensDto)(t);if(c.type==="full")return new y.SemanticTokens(c.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const c=(0,S.decodeSemanticTokensDto)(t);if(c.type==="full")return new y.SemanticTokens(c.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,c,l)=>{if(!t)return new y.CompletionList([]);const p=t.suggestions.map(E=>T.CompletionItem.to(E,l));return new y.CompletionList(p,t.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return T.SignatureHelp.to(t)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,c,l)=>v(p=>new y.CodeLens(T.Range.to(p.range),p.command&&l.fromInternal(p.command)))(t))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?T.Selection.from(t):T.Range.from(t)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,c,l)=>v(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(p.command)}else{const E=new y.CodeAction(p.title,p.kind?new y.CodeActionKind(p.kind):void 0);return p.edit&&(E.edit=T.WorkspaceEdit.to(p.edit)),p.command&&(E.command=l.fromInternal(p.command)),E.isPreferred=p.isPreferred,E}})(t))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(c=>new y.ColorInformation(T.Range.to(c.range),T.Color.to(c.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:T.Range.from(t.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,c,l)=>t.map(T.InlayHint.to.bind(void 0,l)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(c=>T.NotebookExclusiveDocumentPattern.to(c))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,M.Schemas.http,M.Schemas.https),t=>t),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],C.ApiCommandResult.Void)];class m{static register(c){D.forEach(c.registerApiCommand,c)}}e.ExtHostApiCommands=m;function v(t){return c=>{if(Array.isArray(c))return c.map(t)}}function f(t){if(!Array.isArray(t))return;const c=[];for(const l of t)L.isLocationLink(l)?c.push(T.DefinitionLink.to(l)):c.push(T.location.to(l));return c}}),define(Ie[199],Ce([1,0,14,61,5,7,2,72,26,8,6,25,4]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(f,t,c){const l=f.getProxy(m.MainContext.MainThreadComments);class p{constructor(){this.b=new Map,this.c=new Map,t.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this.b.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this.b.get(u.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.commentThreadHandle);return h?h.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);return h?u.$mid===8?h.value:{thread:h.value,text:u.text}:u}else if(u&&u.$mid===10){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const g=u.commentUniqueId,P=h.getCommentByUniqueId(g);return P||u}else if(u&&u.$mid===11){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const g=u.text,P=u.commentUniqueId,N=h.getCommentByUniqueId(P);return N?(typeof N.body=="string"?N.body=g:N.body=new M.MarkdownString(g),N):u}return u}})}createCommentController(u,n,h){const g=p.a++,P=new b(u,g,n,h);this.b.set(P.handle,P);const N=this.c.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return N.push(P),this.c.set(S.ExtensionIdentifier.toKey(u.identifier),N),P.value}$createCommentThreadTemplate(u,n,h){const g=this.b.get(u);!g||g.$createCommentThreadTemplate(n,h)}async $updateCommentThreadTemplate(u,n,h){const g=this.b.get(u);!g||g.$updateCommentThreadTemplate(n,h)}$deleteCommentThread(u,n){this.b.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,h){const g=this.b.get(u);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const P=c.getDocument(C.URI.revive(n));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(P,h)).then(N=>N?N.map(j=>k.Range.from(j)):void 0)}$toggleReaction(u,n,h,g,P){const N=this.b.get(u);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=N.getCommentThread(n);if(j){const Z=j.getCommentByUniqueId(g.uniqueIdInThread);if(N!==void 0&&Z&&N.reactionHandler)return N.reactionHandler(Z,s(P))}return Promise.resolve(void 0)})}dispose(){}}p.a=0;class E{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,n,h,g,P,N,j,Z){this.m=n,this.n=h,this.o=g,this.p=P,this.q=N,this.extensionDescription=j,this.r=Z,this.handle=E.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(n,this.handle,this.n,this.o,k.Range.from(this.p),j.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{l.$deleteCommentThread(n,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(R){G.range=R},get comments(){return G.comments},set comments(R){G.comments=R},get collapsibleState(){return G.collapsibleState},set collapsibleState(R){G.collapsibleState=R},get canReply(){return G.canReply},set canReply(R){G.canReply=R},get contextValue(){return G.contextValue},set contextValue(R){G.contextValue=R},get label(){return G.label},set label(R){G.label=R},get state(){return G.state},set state(R){G.state=R},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const u=h=>Object.prototype.hasOwnProperty.call(this.b,h),n={};u("range")&&(n.range=k.Range.from(this.p)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this.q.map(h=>w(this,h,this.k))),u("collapsibleState")&&(n.collapseState=a(this.g)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=d(this.h)),u("isTemplate")&&(n.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(u){for(const n of this.k){const h=n[0],g=n[1];if(u===g)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}E.a=0,qe([(0,T.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,n,h,g){this.f=u,this.g=n,this.h=h,this.i=g,this.a=new Map,l.$registerCommentController(this.handle,h,g);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(N){P.options=N},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(N){P.commentingRangeProvider=N},get reactionHandler(){return P.reactionHandler},set reactionHandler(N){P.reactionHandler=N},createCommentThread(N,j,Z){return P.createCommentThread(N,j,Z).value},dispose:()=>{P.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,h,g){if(typeof u=="string"){const P=new E(this.id,this.handle,u,n,h,g,this.f,!1);return this.a.set(P.handle,P),P}else{const P=new E(this.id,this.handle,void 0,u,n,h,this.f,!1);return this.a.set(P.handle,P),P}}$createCommentThreadTemplate(u,n){const h=new E(this.id,this.handle,void 0,C.URI.revive(u),k.Range.to(n),[],this.f,!0);return h.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(u,n){const h=this.a.get(u);h&&(h.range=k.Range.to(n))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(o,u,n){let h=n.get(u);h||(h=++o.commentHandle,n.set(u,h));const g=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:h,body:typeof u.body=="string"?u.body:k.MarkdownString.from(u.body),userName:u.author.name,userIconPath:g,label:u.label,commentReactions:u.reactions?u.reactions.map(P=>r(P)):void 0,timestamp:u.timestamp?.toJSON()}}function r(o){return{label:o.label,iconPath:o.iconPath?k.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function s(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?C.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function a(o){if(o!==void 0)switch(o){case M.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}function d(o){if(o!==void 0)switch(o){case M.CommentThreadState.Unresolved:return O.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return O.CommentThreadState.Resolved}return O.CommentThreadState.Unresolved}return new p}e.createExtHostComments=v}),define(Ie[200],Ce([1,0,23,4,27,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(M,D){this.a=M.getProxy(T.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,D){const m=this,v=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){m.e(M,D,v,arguments)}})}e(M,D,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(v,this.b)}),this.c&&this.f(M,m,v)}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const O=1e5;function S(k,M){const D=[];if(k.length)for(let m=0;m<k.length;m++){let v=k[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const f=v;f.stack?v=f.stack:v=f.toString()}D.push(v)}if(M){const m=new Error().stack;m&&D.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(D);return m.length>O?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[101],Ce([1,0,2,4,6,3,15,12,16,10,19,25]),function(ee,e,i,T,y,L,C,O,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Mi{constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const c=Mi.c++;this.f.set(c,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(c,t.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(c,null);return}const E=(0,S.asArray)(p);if(E.length<=Mi.d){this.g.$onDidChange(c,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const b=E.map(s=>({uri:s,rank:(0,k.count)(s.path,"/")})),w=(0,S.groupBy)(b,(s,a)=>s.rank-a.rank||(0,k.compare)(s.uri.path,a.uri.path)),r=[];e:for(const s of w){let a;for(const d of s){const o=(0,M.dirname)(d.uri.path);if(a!==o&&(a=o,r.push(d.uri)>=Mi.d))break e}}this.g.$onDidChange(c,r)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(f,t,c){if(!this.f.has(f))return Object.create(null);const l=Object.create(null),{provider:p,extensionDescription:E}=this.f.get(f);return await Promise.all(t.map(async b=>{try{const{uri:w,id:r}=b,s=await Promise.resolve(p.provideFileDecoration(i.URI.revive(w),c));if(!s)return;try{y.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.checkProposedApiEnabled)(E,"codiconDecoration"),l[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(a){this.h.warn(`INVALID decoration from extension '${E}': ${a}`)}}catch(w){this.h.error(w)}})),l}};m.c=0,m.d=250,m=qe([Ve(0,C.IExtHostRpcService),Ve(1,O.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[201],Ce([1,0,134,87,2,4,6,8,5,12,28,37]),function(ee,e,i,T,y,L,C,O,S,k,M,D){"use strict";var m,v,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(p,E,b,w,r,s,a){this.d=p,this.e=E,this.f=b,this.g=w,m.set(this,void 0),v.set(this,void 0),f.set(this,void 0),this.c=!1,Ye(this,f,new M.ResourceMap(d=>r.getComparisonKey(d)),"f"),Ye(this,m,s,"f"),Ye(this,v,a,"f")}dispose(){this.c||(Re(this,v,"f").fire([...Re(this,f,"f").keys()]),Re(this,m,"f")?.$clear(this.e),Re(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,E){if(!p){this.clear();return}this.h();let b=[];if(y.URI.isUri(p)){if(!E){this.delete(p);return}Re(this,f,"f").set(p,E.slice()),b=[p]}else if(Array.isArray(p)){b=[];let r;p=[...p].sort(t.j);for(const s of p){const[a,d]=s;if((!r||a.toString()!==r.toString())&&(r&&Re(this,f,"f").get(r).length===0&&Re(this,f,"f").delete(r),r=a,b.push(a),Re(this,f,"f").set(a,[])),d)Re(this,f,"f").get(a)?.push(...d);else{const o=Re(this,f,"f").get(a);o&&(o.length=0)}}}if(Re(this,v,"f").fire(b),!Re(this,m,"f"))return;const w=[];for(const r of b){let s=[];const a=Re(this,f,"f").get(r);if(a)if(a.length>this.f){s=[];const d=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const u of a)if(u.severity===d[o]&&s.push({...O.Diagnostic.from(u),modelVersionId:this.g(r)})===this.f)break e;s.push({severity:T.MarkerSeverity.Info,message:(0,i.localize)(0,null,a.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=a.map(d=>({...O.Diagnostic.from(d),modelVersionId:this.g(r)}));w.push([r,s])}Re(this,m,"f").$changeMany(this.e,w)}delete(p){this.h(),Re(this,v,"f").fire([p]),Re(this,f,"f").delete(p),Re(this,m,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Re(this,v,"f").fire([...Re(this,f,"f").keys()]),Re(this,f,"f").clear(),Re(this,m,"f")?.$clear(this.e)}forEach(p,E){this.h();for(const[b,w]of this)p.call(E,b,w,this)}*[(m=new WeakMap,v=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const p of Re(this,f,"f").keys())yield[p,this.get(p)]}get(p){this.h();const E=Re(this,f,"f").get(p);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(p){return this.h(),Array.isArray(Re(this,f,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,E){return p[0].toString()<E[0].toString()?-1:p[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=t;let c=class vi{static _mapper(p){const E=new M.ResourceMap;for(const b of p)E.set(b,b);return{uris:Object.freeze(Array.from(E.values()))}}constructor(p,E,b,w){this.h=E,this.j=b,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,vi._mapper),this.e=p.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,E){const{f:b,e:w,g:r,h:s,j:a,k:d}=this,o=new class{$changeMany(h,g){w.$changeMany(h,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,h,g.length===0?"CLEARING":g)}$clear(h){w.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,h)}dispose(){w.dispose()}};let u;if(!E)E="_generated_diagnostic_collection_name_#"+vi.c++,u=E;else if(!b.has(E))u=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do u=E+vi.c++;while(b.has(u))}return new class extends t{constructor(){super(E,u,vi.d,h=>d.getDocument(h)?.version,a.extUri,o,r),b.set(u,this)}dispose(){super.dispose(),b.delete(u)}}}getDiagnostics(p){if(p)return this.l(p);{const E=new Map,b=[];for(const w of this.f.values())w.forEach((r,s)=>{let a=E.get(r.toString());typeof a>"u"&&(a=b.length,E.set(r.toString(),a),b.push([r,[]])),b[a][1]=b[a][1].concat(...s)});return b}}l(p){let E=[];for(const b of this.f.values())b.has(p)&&(E=E.concat(b.get(p)));return E}$acceptMarkersChange(p){if(!this.m){const E="_generated_mirror",b=new t(E,E,vi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(E,b),this.m=b}for(const[E,b]of p)this.m.set(y.URI.revive(E),b.map(O.Diagnostic.to))}};c.c=0,c.d=1e3,c=qe([Ve(1,k.ILogService),Ve(2,D.IExtHostFileSystemInfo)],c),e.ExtHostDiagnostics=c}),define(Ie[202],Ce([1,0,2,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(O=>O?O.map(S=>i.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(O=>O?i.URI.revive(O):void 0)}}e.ExtHostDialogs=y}),define(Ie[203],Ce([1,0,11,2,6,4,13,20,10]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,m,v){this.d=m,this.e=v,this.b=new Map,this.c=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,m){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const v=k.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,D);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(t=>{if(t.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this.d.getDocument(t)&&this.$provideTextDocumentContent(v,t).then(c=>{if(!c&&typeof c!="string")return;const l=this.d.getDocument(t);if(!l)return;const p=(0,S.splitLines)(c);if(!l.equalLines(p))return this.c.$onVirtualDocumentChange(t,c)},i.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(D,m){const v=this.b.get(D);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive(m),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[204],Ce([1,0,5,7,2,4,96,8,9,23,6]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(v,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=v.getProxy(L.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const c of t)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const c of t)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const f=this.g.getDocument(v);if(f)return f}getDocument(v){const f=this.getDocumentData(v);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return f.document}ensureDocumentData(v){const f=this.g.getDocument(v);if(f)return Promise.resolve(f);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(c=>{this.h.delete(v.toString());const l=y.URI.revive(c);return(0,S.assertIsDefined)(this.g.getDocument(l))},c=>(this.h.delete(v.toString()),Promise.reject(c))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(f=>y.URI.revive(f))}$acceptModelLanguageChanged(v,f){const t=y.URI.revive(v),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(f),this.a.fire(c.document)}$acceptModelSaved(v){const f=y.URI.revive(v),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,f){const t=y.URI.revive(v),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");c._acceptIsDirty(f),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,f,t){const c=y.URI.revive(v),l=this.g.getDocument(c);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(f);let p;f.isUndoing?p=M.TextDocumentChangeReason.Undo:f.isRedoing&&(p=M.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:f.changes.map(E=>({range:O.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:p}))}setWordDefinitionFor(v,f){(0,C.setWordDefinitionFor)(v,f)}}e.ExtHostDocuments=D}),define(Ie[56],Ce([1,0,47,5,7,2,3,4,96,15,99,8,12,28,13,174,205]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(b){this.value=b,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(b,w){this.h=b,this.i=w,this.a=null,this.b=new Map,this.c=new v.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(b){this.acceptDocumentsAndEditorsDelta(b)}acceptDocumentsAndEditorsDelta(b){const w=[],r=[],s=[];if(b.removedDocuments)for(const a of b.removedDocuments){const d=L.URI.revive(a),o=this.c.get(d);o?.unref()&&(this.c.delete(d),w.push(o.value))}if(b.addedDocuments)for(const a of b.addedDocuments){const d=L.URI.revive(a.uri);let o=this.c.get(d);if(o&&d.scheme!==f.Schemas.vscodeNotebookCell&&d.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);o||(o=new l(new S.ExtHostDocumentData(this.h.getProxy(O.MainContext.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,o),r.push(o.value)),o.ref()}if(b.removedEditors)for(const a of b.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&s.push(d)}if(b.addedEditors)for(const a of b.addedEditors){const d=L.URI.revive(a.documentUri);i.ok(this.c.has(d),`document '${d}' does not exist`),i.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const o=this.c.get(d).value,u=new M.ExtHostTextEditor(a.id,this.h.getProxy(O.MainContext.MainThreadTextEditors),this.i,new c.Lazy(()=>o.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(n=>D.Range.to(n)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,u)}b.newActiveEditor!==void 0&&(i.ok(b.newActiveEditor===null||this.b.has(b.newActiveEditor),`active editor '${b.newActiveEditor}' does not exist`),this.a=b.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(s),b.removedDocuments&&this.e.fire(w),b.addedDocuments&&this.d.fire(r),(b.removedEditors||b.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),b.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(b){return this.c.get(b)?.value}allDocuments(){return t.Iterable.map(this.c.values(),b=>b.value)}getEditor(b){return this.b.get(b)}activeEditor(b){if(!this.a)return;const w=this.b.get(this.a);return b?w:w?.value}allEditors(){return[...this.b.values()]}};p=qe([Ve(0,k.IExtHostRpcService),Ve(1,m.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[57],Ce([1,0,8,4,2,5,3,6,15,9,79]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class D{constructor(c,l,p){this.e=p,this.d=l,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,l={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new O.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new O.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new O.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.WebviewEditorTabInput(this.b.input.viewType);case 4:return new O.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.TerminalEditorTabInput;case 9:return new O.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(c,l){this.c=[],this.d="",this.b=c,this.e=l;for(const p of c.tabs)p.isActive&&(this.d=p.id),this.c.push(new D(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,l={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return i.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(p=>p.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(p=>p.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const p=new D(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,p),c.tabDto.isActive&&(this.d=p.tabId),p}else if(c.kind===1){const p=this.c.splice(c.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(c.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,p),p}const l=this.c.find(p=>p.tabId===c.tabDto.id);if(!l)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(c.tabDto),l}activeTabId(){return this.d}}let v=class{constructor(c){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=c.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,l={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(p=>p.apiObject))},get activeTabGroup(){const p=c.d;return(0,k.assertIsDefined)(c.e.find(b=>b.groupId===p)?.apiObject)},close:async(p,E)=>{const b=Array.isArray(p)?p:[p];return b.length?f(b[0])?this.j(b,E):this.i(b,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(c){const l=new Set(this.e.map(a=>a.groupId)),p=new Set(c.map(a=>a.groupId)),E=(0,M.diffSets)(l,p),b=this.e.filter(a=>E.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],r=[];this.e=c.map(a=>{const d=new m(a,()=>this.d);return E.added.includes(d.groupId)?w.push(d.apiObject):r.push(d.apiObject),d});const s=(0,k.assertIsDefined)(c.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:w,closed:b,changed:r}))}$acceptTabGroupUpdate(c){const l=this.e.find(p=>p.groupId===c.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const l=this.e.find(E=>E.groupId===c.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const p=l.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(c){for(const l of this.e)for(const p of l.tabs)if(p.apiObject===c)return p}h(c){return this.e.find(l=>l.apiObject===c)}async i(c,l){const p=[];for(const E of c){const b=this.g(E);if(!b)throw new Error("Tab close: Invalid tab not found!");p.push(b.tabId)}return this.a.$closeTab(p,l)}async j(c,l){const p=[];for(const E of c){const b=this.h(E);if(!b)throw new Error("Group close: Invalid group not found!");p.push(b.groupId)}return this.a.$closeGroup(p,l)}};v=qe([Ve(0,S.IExtHostRpcService)],v),e.ExtHostEditorTabs=v;function f(t){return t.tabs!==void 0}}),define(Ie[206],Ce([1,0,2,4,7,6,8,251,10,24,25]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let c,l,p=14,E=14;for(const b of f){let w=c?(0,S.commonPrefixLength)(c,b):0;for(w===0?l=1:l=E;w<b.length;w++)w+1===b.length?(p=E,E=9):E+=1,t.push([l,b.toUpperCase().charCodeAt(w),E]),t.push([l,b.toLowerCase().charCodeAt(w),E]),l=E;c=b,E=p}t.push([9,58,10]),t.push([10,47,12]),this.b=new O.StateMachine(t)}}provideDocumentLinks(f){this.c();const t=[],c=O.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this.b);for(const l of c){const p=C.DocumentLink.to(l);p.target&&t.push(p)}return t}}class m{constructor(f,t){this.i=t,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,c,l={}){if(this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const p=this.h++;this.b.add(t),this.d.add(t),this.c.set(p,c);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof c.copy=="function"&&(E+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,M.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(p,t,E).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(w)});const b=c.onDidChangeFile(w=>{const r=[];for(const s of w){const{uri:a,type:d}=s;if(a.scheme!==t)continue;let o;switch(d){case L.FileChangeType.Changed:o=0;break;case L.FileChangeType.Created:o=1;break;case L.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:a,type:o})}this.a.$onFileSystemChange(p,r)});return(0,y.toDisposable)(()=>{b.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(f){const{type:t,ctime:c,mtime:l,size:p,permissions:E}=f;return{type:t,ctime:c,mtime:l,size:p,permissions:E}}$stat(f,t){return Promise.resolve(this.k(f).stat(i.URI.revive(t))).then(c=>m.j(c))}$readdir(f,t){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.k(f).readFile(i.URI.revive(t))).then(c=>k.VSBuffer.wrap(c))}$writeFile(f,t,c,l){return Promise.resolve(this.k(f).writeFile(i.URI.revive(t),c.buffer,l))}$delete(f,t,c){return Promise.resolve(this.k(f).delete(i.URI.revive(t),c))}$rename(f,t,c,l){return Promise.resolve(this.k(f).rename(i.URI.revive(t),i.URI.revive(c),l))}$copy(f,t,c,l){const p=this.k(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(i.URI.revive(t),i.URI.revive(c),l))}$mkdir(f,t){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(t)))}$watch(f,t,c,l){const p=this.k(f).watch(i.URI.revive(c),l);this.f.set(t,p)}$unwatch(f,t){const c=this.f.get(t);c&&(c.dispose(),this.f.delete(t))}$open(f,t,c){const l=this.k(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(t),c))}$close(f,t){const c=this.k(f);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(t))}$read(f,t,c,l){const p=this.k(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(l);return Promise.resolve(p.read(t,c,E.buffer,0,l)).then(b=>E.slice(0,b))}$write(f,t,c,l){const p=this.k(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(t,c,l.buffer,0,l.byteLength))}k(f){const t=this.c.get(f);if(!t){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return t}}e.ExtHostFileSystem=m}),define(Ie[58],Ce([1,0,4,36,6,24,3,15,37,7]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class _t{constructor(m,v){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{const c=f.b.get(t.scheme);if(!c)return await f.a.$stat(t);await f.a.$ensureActivation(t.scheme);const l=await c.stat(t);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(c){_t.c(c)}},async readDirectory(t){try{const c=f.b.get(t.scheme);return c?(await f.a.$ensureActivation(t.scheme),(await c.readDirectory(t)).slice()):await f.a.$readdir(t)}catch(c){return _t.c(c)}},async createDirectory(t){try{return await f.a.$mkdir(t)}catch(c){return _t.c(c)}},async readFile(t){try{const c=f.b.get(t.scheme);return c?(await f.a.$ensureActivation(t.scheme),(await c.readFile(t)).slice()):(await f.a.$readFile(t)).buffer}catch(c){return _t.c(c)}},async writeFile(t,c){try{return await f.a.$writeFile(t,L.VSBuffer.wrap(c))}catch(l){return _t.c(l)}},async delete(t,c){try{const l=f.b.get(t.scheme);return l?(await f.a.$ensureActivation(t.scheme),await l.delete(t,{recursive:!1,...c})):await f.a.$delete(t,{recursive:!1,useTrash:!1,...c})}catch(l){return _t.c(l)}},async rename(t,c,l){try{return await f.a.$rename(t,c,{overwrite:!1,...l})}catch(p){return _t.c(p)}},async copy(t,c,l){try{return await f.a.$copy(t,c,{overwrite:!1,...l})}catch(p){return _t.c(p)}},isWritableFileSystem(t){const c=v.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}static c(m){if(m instanceof y.FileSystemError)throw m;if(!(m instanceof Error))throw new y.FileSystemError(String(m));if(m.name==="ENOPRO")throw y.FileSystemError.Unavailable(m.message);switch(m.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(m.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(m.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(m.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(m.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(m.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(m.message);default:throw new y.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,v){return this.b.set(m,v),(0,k.toDisposable)(()=>this.b.delete(m))}};M=qe([Ve(0,O.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[207],Ce([1,0,5,35,2,4,8,6]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,m,v,f,t,c,l,p){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(D,v,t);this.g=0,c&&(this.g+=1),l&&(this.g+=2),p&&(this.g+=4);const b=(0,T.parse)(t),w=typeof t=="string",r=f(s=>{if(!c)for(const a of s.created){const d=y.URI.revive(a);b(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const a of s.changed){const d=y.URI.revive(a);b(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.b.fire(d)}if(!p)for(const a of s.deleted){const d=y.URI.revive(a);b(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=O.Disposable.from(E,this.a,this.b,this.c,r)}h(D,m,v){const f=O.Disposable.from();if(typeof v=="string")return f;const t=D.getProxy(L.MainContext.MainThreadFileSystem);let c=!1;(v.pattern.includes(T.GLOBSTAR)||v.pattern.includes(T.GLOB_SPLIT))&&(c=!0);const l=Math.random();return t.$watch(m.identifier.value,l,v.baseUri,{recursive:c,excludes:[]}),O.Disposable.from({dispose:()=>t.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(D,m,v){this.j=D,this.k=m,this.l=v,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,m,v,f,t,c){return new S(this.j,D,m,this.a.event,C.GlobPattern.from(v),f,t,c)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,m){switch(D){case 2:this.b.fire(Object.freeze({files:m.map(v=>({oldUri:y.URI.revive(v.source),newUri:y.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(v=>y.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(v=>y.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,m){return(v,f,t)=>{const c=function(p){v.call(f,p)};return c.extension=D,m.event(c,void 0,t)}}async $onWillRunFileOperation(D,m,v,f){switch(D){case 2:return await this.n(this.g,{files:m.map(t=>({oldUri:y.URI.revive(t.source),newUri:y.URI.revive(t.target)}))},v,f);case 1:return await this.n(this.i,{files:m.map(t=>y.URI.revive(t.target))},v,f);case 0:case 3:return await this.n(this.h,{files:m.map(t=>y.URI.revive(t.target))},v,f)}}async n(D,m,v,f){const t=new Set,c=[];if(await D.fireAsync(m,f,async(p,E)=>{const b=Date.now(),w=await Promise.resolve(p);w instanceof O.WorkspaceEdit&&(c.push([E.extension,w]),t.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-b>v&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||c.length===0)return;const l={edits:[]};for(const[,p]of c){const{edits:E}=C.WorkspaceEdit.from(p,{getTextDocumentVersion:b=>this.l.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(Ie[208],Ce([1,0,2,38]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,O,S,k,M){this.a=O,this.b=S,this.c=k;const D=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new T.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new T.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new T.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new T.ApiCommandResult("Notebook and input URI",m=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(C,O,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ie[209],Ce([1,0,7,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,C),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=y}),define(Ie[210],Ce([1,0,2,23,8,6,72,4,10,55,16,9,252,20,7,84,80,52,100,11,14,25]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const H=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(H,$);if(!(0,M.isFalsyOrEmpty)(q))return q[0]instanceof L.DocumentSymbol?q.map(y.DocumentSymbol.from):r.f(q)}static f(I){I=I.slice(0).sort((q,J)=>{let de=q.location.range.start.compareTo(J.location.range.start);return de===0&&(de=J.location.range.end.compareTo(q.location.range.end)),de});const $=[],H=[];for(const q of I){const J={name:q.name||"!!MISSING: name!!",kind:y.SymbolKind.from(q.kind),tags:q.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:y.Range.from(q.location.range),selectionRange:y.Range.from(q.location.range),children:[]};for(;;){if(H.length===0){H.push(J),$.push(J);break}const de=H[H.length-1];if(k.Range.containsRange(de.range,J.range)&&!k.Range.equalsRange(de.range,J.range)){de.children?.push(J),H.push(J);break}H.pop()}}return $}}class s{constructor(I,$,H){this.g=I,this.h=$,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const H=this.g.getDocument(I),q=await this.j.provideCodeLenses(H,$);if(!q||$.isCancellationRequested)return;const J=this.e.add(q),de=new f.DisposableStore;this.f.set(J,de);const Se={cacheId:J,lenses:[]};for(let ae=0;ae<q.length;ae++)Se.lenses.push({cacheId:[J,ae],range:y.Range.from(q[ae].range),command:this.h.toInternal(q[ae].command,de)});return Se}async resolveCodeLens(I,$){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let q;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?q=H:q=await this.j.resolveCodeLens(H,$),q||(q=H),$.isCancellationRequested)return;const J=I.cacheId&&this.f.get(I.cacheId[0]);if(!!J)return I.command=this.h.toInternal(q.command??s.d,J),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}s.d={command:"missing",title:"!!MISSING: command!!"};function a(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class d{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDefinition(q,J,H);return a(de)}}class o{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDeclaration(q,J,H);return a(de)}}class u{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideImplementation(q,J,H);return a(de)}}class n{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideTypeDefinition(q,J,H);return a(de)}}class h{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideHover(q,J,H);if(!(!de||(0,M.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=q.getWordRangeAtPosition(J)),de.range||(de.range=new L.Range(J,J)),y.Hover.from(de)}}class g{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideEvaluatableExpression(q,J,H);if(de)return y.EvaluatableExpression.from(de)}}class P{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,H,q){const J=this.d.getDocument(I),de=await this.e.provideInlineValues(J,y.Range.to($),y.InlineValueContext.to(H),q);if(Array.isArray(de))return de.map(Se=>y.InlineValue.from(Se))}}class N{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDocumentHighlights(q,J,H);if(Array.isArray(de))return de.map(y.DocumentHighlight.from)}}class j{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideLinkedEditingRanges(q,J,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,M.coalesce)(de.ranges.map(y.Range.from)),wordPattern:de.wordPattern}}}class Z{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,H,q){const J=this.d.getDocument(I),de=y.Position.to($),Se=await this.e.provideReferences(J,de,H,q);if(Array.isArray(Se))return Se.map(y.location.from)}}class G{constructor(I,$,H,q,J,de,Se){this.g=I,this.h=$,this.j=H,this.k=q,this.l=J,this.m=de,this.n=Se,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,H,q){const J=this.g.getDocument(I),de=m.Selection.isISelection($)?y.Selection.to($):y.Range.to($),Se=[];for(const tt of this.j.getDiagnostics(I))if(de.intersection(tt.range)&&Se.push(tt)>G.d)break;const ae={diagnostics:Se,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},ve=await this.k.provideCodeActions(J,de,ae,q);if(!(0,M.isNonEmptyArray)(ve)||q.isCancellationRequested)return;const be=this.e.add(ve),ze=new f.DisposableStore;this.f.set(be,ze);const He=[];for(let tt=0;tt<ve.length;tt++){const xe=ve[tt];!xe||(G.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,ze)})):(ae.only&&(xe.kind?ae.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[be,tt],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,ze),diagnostics:xe.diagnostics&&xe.diagnostics.map(y.Diagnostic.from),edit:xe.edit&&y.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:be,actions:He}}async resolveCodeAction(I,$){const[H,q]=I,J=this.e.get(H,q);if(!J||G.o(J)||!this.k.resolveCodeAction)return;const de=await this.k.resolveCodeAction(J,$)??J;return de?.edit?y.WorkspaceEdit.from(de.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}G.d=1e3;class R{constructor(I,$,H,q){this.d=I,this.e=$,this.f=H,this.g=q}async prepareDocumentPaste(I,$,H,q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(I),de=$.map(ae=>y.Range.to(ae)),Se=y.DataTransfer.toDataTransfer(H,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(J,de,Se,q),y.DataTransfer.toDataTransferDTO(Se)}async providePasteEdits(I,$,H,q,J){const de=this.e.getDocument($),Se=H.map(be=>y.Range.to(be)),ae=y.DataTransfer.toDataTransfer(q,async be=>(await this.d.$resolvePasteFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentPasteEdits(de,Se,ae,J);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class A{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideDocumentFormattingEdits(q,$,H);if(Array.isArray(J))return J.map(y.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,H,q){const J=this.d.getDocument(I),de=y.Range.to($),Se=await this.e.provideDocumentRangeFormattingEdits(J,de,H,q);if(Array.isArray(Se))return Se.map(y.TextEdit.from)}}class B{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,H,q,J){const de=this.d.getDocument(I),Se=y.Position.to($),ae=await this.e.provideOnTypeFormattingEdits(de,Se,H,q,J);if(Array.isArray(ae))return ae.map(y.TextEdit.from)}}class z{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const H=await this.e.provideWorkspaceSymbols(I,$);if(!(0,M.isNonEmptyArray)(H))return{symbols:[]};const q=this.d.add(H),J={cacheId:q,symbols:[]};for(let de=0;de<H.length;de++){const Se=H[de];if(!Se||!Se.name){this.f.warn("INVALID SymbolInformation",Se);continue}J.symbols.push({...y.WorkspaceSymbol.from(Se),cacheId:[q,de]})}return J}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const q=await this.e.resolveWorkspaceSymbol(H,$);return q&&(0,T.mixin)(I,y.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class V{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideRenameEdits(I,$,H,q){const J=this.d.getDocument(I),de=y.Position.to($);try{const Se=await this.e.provideRenameEdits(J,de,H,q);return Se?y.WorkspaceEdit.from(Se):void 0}catch(Se){const ae=V.g(Se);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(I,$,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),J=y.Position.to($);try{const de=await this.e.prepareRename(q,J,H);let Se,ae;if(L.Range.isRange(de)?(Se=de,ae=q.getText(de)):(0,D.isObject)(de)&&(Se=de.range,ae=de.placeholder),!Se||!ae)return;if(Se.start.line>J.line||Se.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Se),text:ae}}catch(de){const Se=V.g(de);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(de)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class K{constructor(I,$){this.resultId=I,this.tokens=$}}class ie{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,H){const q=this.f.getDocument(I),J=$!==0?this.d.get($):null;let de=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,J.resultId,H):await this.g.provideDocumentSemanticTokens(q,H);return J&&this.d.delete($),de?(de=ie.h(de),this.o(ie.n(J,de),de)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return ie.j(I)?ie.k(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):ie.l(I)?ie.m(I)?I:new L.SemanticTokensEdits(I.edits.map($=>new L.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!ie.j($)||!I||!I.tokens)return $;const H=I.tokens,q=H.length,J=$.data,de=J.length;let Se=0;const ae=Math.min(q,de);for(;Se<ae&&H[Se]===J[Se];)Se++;if(Se===q&&Se===de)return new L.SemanticTokensEdits([],$.resultId);let ve=0;const be=ae-Se;for(;ve<be&&H[q-ve-1]===J[de-ve-1];)ve++;return new L.SemanticTokensEdits([{start:Se,deleteCount:q-Se-ve,data:J.subarray(Se,de-ve)}],$.resultId)}o(I,$){if(ie.j(I)){const H=this.e++;return this.d.set(H,new K(I.resultId,I.data)),(0,t.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ie.l(I)){const H=this.e++;return ie.j($)?this.d.set(H,new K($.resultId,$.data)):this.d.set(H,new K(I.resultId)),(0,t.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class ge{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideDocumentRangeSemanticTokens(q,y.Range.to($),H);return J?this.f(J):null}f(I){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,H,q,J){this.f=I,this.g=$,this.h=H,this.j=q,this.k=J,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,H,q){const J=this.f.getDocument(I),de=y.Position.to($),Se=J.getWordRangeAtPosition(de)||new L.Range(de,de),ae=Se.with({end:de}),ve=new p.StopWatch(!0),be=await this.h.provideCompletionItems(J,de,q,y.CompletionContext.to(H));if(!be||q.isCancellationRequested)return;const ze=Array.isArray(be)?new L.CompletionList(be):be,He=ue.supportsResolving(this.h)?this.d.add(ze.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const xe=[],et={x:He,b:xe,a:{replace:y.Range.from(Se),insert:y.Range.from(ae)},c:ze.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<ze.items.length;it++){const dt=ze.items[it],Oe=this.l(dt,[He,it],ae,Se);xe.push(Oe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.h.resolveCompletionItem(H,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,H,q){const J=this.e.get($[0]);if(!J)throw Error("DisposableStore is missing...");const de=this.g.toInternal(I.command,J),Se={x:$,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=I.textEdit.newText):typeof I.insertText=="string"?Se.h=I.insertText:I.insertText instanceof L.SnippetString&&(Se.h=I.insertText.value,Se.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),L.Range.isRange(ae)?Se.j=y.Range.from(ae):ae&&(!H?.isEqual(ae.inserting)||!q?.isEqual(ae.replacing))&&(Se.j={insert:y.Range.from(ae.inserting),replace:y.Range.from(ae.replacing)}),Se}}class re{async provideInlineCompletions(I,$,H,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class se extends re{constructor(I,$,H,q){super(),this.f=I,this.g=$,this.h=H,this.j=q,this.d=new le,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,H,q){const J=this.g.getDocument(I),de=y.Position.to($),Se=await this.h.provideInlineCompletionItems(J,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},q);if(!Se||q.isCancellationRequested)return;const ae=Array.isArray(Se)?Se:Se.items,ve=this.e?Array.isArray(Se)?[]:Se.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:ae}),items:ae.map((He,tt)=>{let xe;He.command&&(be||(be=new f.DisposableStore),xe=this.j.toInternal(He.command,be));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(be||(be=new f.DisposableStore),this.j.toInternal(He,be)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const H=this.d.get(I)?.items[$];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class _{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,H,q){const J=this.e.getDocument(I),de=y.Position.to($),Se=this.g(H),ae=await this.f.provideSignatureHelp(J,de,q,Se);if(ae){const ve=this.d.add([ae]);return{...y.SignatureHelp.from(ae),id:ve}}}g(I){let $;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=H.activeSignature,$.activeParameter=H.activeParameter):$=H}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class me{constructor(I,$,H,q,J){this.f=I,this.g=$,this.h=H,this.j=q,this.k=J,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,H){const q=this.f.getDocument(I),J=y.Range.to($),de=await this.h.provideInlayHints(q,J,H);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(H.isCancellationRequested)return;const Se=this.d.add(de);this.e.set(Se,new f.DisposableStore);const ae={hints:[],cacheId:Se};for(let ve=0;ve<de.length;ve++)this.l(de[ve],J)&&ae.hints.push(this.m(de[ve],[Se,ve]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ae}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.h.resolveInlayHint(H,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const H=this.e.get($[0]);if(!H)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(J=>{const de={label:J.value};return de.tooltip=y.MarkdownString.fromStrict(J.tooltip),L.Location.isLocation(J.location)&&(de.location=y.location.from(J.location)),J.command&&(de.command=this.g.toInternal(J.command,H)),de}),q}}class we{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const H=this.e.getDocument(I),q=await this.f.provideDocumentLinks(H,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(we.g).map(y.DocumentLink.from)};{const J=this.d.add(q),de={links:[],cacheId:J};for(let Se=0;Se<q.length;Se++){if(!we.g(q[Se]))continue;const ae=y.DocumentLink.from(q[Se]);ae.cacheId=[J,Se],de.links.push(ae)}return de}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.f.resolveDocumentLink(H,$);if(!(!q||!we.g(q)))return y.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class Me{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const H=this.d.getDocument(I),q=await this.e.provideDocumentColors(H,$);return Array.isArray(q)?q.map(de=>({color:y.Color.from(de.color),range:y.Range.from(de.range)})):[]}async provideColorPresentations(I,$,H){const q=this.d.getDocument(I),J=y.Range.to($.range),de=y.Color.to($.color),Se=await this.e.provideColorPresentations(de,{document:q,range:J},H);if(!!Array.isArray(Se))return Se.map(y.ColorPresentation.from)}}class We{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideFoldingRanges(q,$,H);if(!!Array.isArray(J))return J.map(y.FoldingRange.from)}}class Qe{constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideSelectionRanges(I,$,H){const q=this.d.getDocument(I),J=$.map(y.Position.to),de=await this.e.provideSelectionRanges(q,J,H);if(!(0,M.isNonEmptyArray)(de))return[];if(de.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let ae=0;ae<J.length;ae++){const ve=[];Se.push(ve);let be=J[ae],ze=de[ae];for(;;){if(!ze.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(y.SelectionRange.from(ze)),!ze.parent)break;be=ze.range,ze=ze.parent}}return Se}}class Te{constructor(I,$){this.f=I,this.g=$,this.d=new c.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const q=this.f.getDocument(I),J=y.Position.to($),de=await this.g.prepareCallHierarchy(q,J,H);if(!de)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(de)?de.map(ae=>this.h(Se,ae)):[this.h(Se,de)]}async provideCallsTo(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(q,H);if(!!J)return J.map(de=>({from:this.h(I,de.from),fromRanges:de.fromRanges.map(Se=>y.Range.from(Se))}))}async provideCallsFrom(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(q,H);if(!!J)return J.map(de=>({to:this.h(I,de.to),fromRanges:de.fromRanges.map(Se=>y.Range.from(Se))}))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),q=y.CallHierarchyItem.from($,I,H.size.toString(36));return H.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class De{constructor(I,$){this.f=I,this.g=$,this.d=new c.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const q=this.f.getDocument(I),J=y.Position.to($),de=await this.g.prepareTypeHierarchy(q,J,H);if(!de)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(de)?de.map(ae=>this.h(Se,ae)):[this.h(Se,de)]}async provideSupertypes(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(q,H);if(!!J)return J.map(de=>this.h(I,de))}async provideSubtypes(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(q,H);if(!!J)return J.map(de=>this.h(I,de))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),q=y.TypeHierarchyItem.from($,I,H.size.toString(36));return H.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class ke{constructor(I,$,H,q){this.d=I,this.e=$,this.f=H,this.g=q}async provideDocumentOnDropEdits(I,$,H,q,J){const de=this.e.getDocument($),Se=y.Position.to(H),ae=y.DataTransfer.toDataTransfer(q,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentDropEdits(de,Se,ae,J);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class oe{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,H,q,J,de,Se,ae){this.g=$,this.h=H,this.j=q,this.k=J,this.l=de,this.m=Se,this.n=ae,this.f=new Map,this.e=I.getProxy(O.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new L.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,H,q,J,de=!1){const Se=this.f.get(I);if(!Se||!(Se.adapter instanceof $))return q;const ae=Date.now();de||this.l.trace(`[${Se.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ve=H(Se.adapter,Se.extension);return Promise.resolve(ve).catch(be=>{(0,E.isCancellationError)(be)||(this.l.error(`[${Se.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(Se.extension.identifier,be))}).finally(()=>{de||this.l.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),v.CancellationToken.isCancellationToken(J)?(0,b.raceCancellationError)(ve,J):ve}t(I,$){const H=this.q();return this.f.set(H,new oe(I,$)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,H,q){const J=this.t(new r(this.h,H),I),de=q&&q.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(J,this.o($),de),this.p(J)}$provideDocumentSymbols(I,$,H){return this.s(I,r,q=>q.provideDocumentSymbols(i.URI.revive($),H),void 0,H)}registerCodeLensProvider(I,$,H){const q=this.q(),J=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new oe(new s(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(q,this.o($),J);let de=this.p(q);if(J!==void 0){const Se=H.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(J));de=L.Disposable.from(de,Se)}return de}$provideCodeLenses(I,$,H){return this.s(I,s,q=>q.provideCodeLenses(i.URI.revive($),H),void 0,H)}$resolveCodeLens(I,$,H){return this.s(I,s,q=>q.resolveCodeLens($,H),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,s,H=>Promise.resolve(H.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,H){const q=this.t(new d(this.h,H),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,H,q){return this.s(I,d,J=>J.provideDefinition(i.URI.revive($),H,q),[],q)}registerDeclarationProvider(I,$,H){const q=this.t(new o(this.h,H),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,H,q){return this.s(I,o,J=>J.provideDeclaration(i.URI.revive($),H,q),[],q)}registerImplementationProvider(I,$,H){const q=this.t(new u(this.h,H),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,H,q){return this.s(I,u,J=>J.provideImplementation(i.URI.revive($),H,q),[],q)}registerTypeDefinitionProvider(I,$,H){const q=this.t(new n(this.h,H),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,H,q){return this.s(I,n,J=>J.provideTypeDefinition(i.URI.revive($),H,q),[],q)}registerHoverProvider(I,$,H,q){const J=this.t(new h(this.h,H),I);return this.e.$registerHoverProvider(J,this.o($)),this.p(J)}$provideHover(I,$,H,q){return this.s(I,h,J=>J.provideHover(i.URI.revive($),H,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,H,q){const J=this.t(new g(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(J,this.o($)),this.p(J)}$provideEvaluatableExpression(I,$,H,q){return this.s(I,g,J=>J.provideEvaluatableExpression(i.URI.revive($),H,q),void 0,q)}registerInlineValuesProvider(I,$,H,q){const J=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,H),I);this.e.$registerInlineValuesProvider(de,this.o($),J);let Se=this.p(de);if(J!==void 0){const ae=H.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(J));Se=L.Disposable.from(Se,ae)}return Se}$provideInlineValues(I,$,H,q,J){return this.s(I,P,de=>de.provideInlineValues(i.URI.revive($),H,q,J),void 0,J)}registerDocumentHighlightProvider(I,$,H){const q=this.t(new N(this.h,H),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,H,q){return this.s(I,N,J=>J.provideDocumentHighlights(i.URI.revive($),H,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,H){const q=this.t(new j(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,H,q){return this.s(I,j,async J=>{const de=await J.provideLinkedEditingRanges(i.URI.revive($),H,q);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ce.w(de.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,H){const q=this.t(new Z(this.h,H),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,H,q,J){return this.s(I,Z,de=>de.provideReferences(i.URI.revive($),H,q,J),void 0,J)}registerCodeActionProvider(I,$,H,q){const J=new f.DisposableStore,de=this.t(new G(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(de,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(Se=>Se.value),documentation:q?.documentation?.map(Se=>({kind:Se.kind.value,command:this.j.converter.toInternal(Se.command,J)}))},ce.u(I),Boolean(H.resolveCodeAction)),J.add(this.p(de)),J}$provideCodeActions(I,$,H,q,J){return this.s(I,G,de=>de.provideCodeActions(i.URI.revive($),H,q,J),void 0,J)}$resolveCodeAction(I,$,H){return this.s(I,G,q=>q.resolveCodeAction($,H),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,G,H=>Promise.resolve(H.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,H){const q=this.t(new A(this.h,H),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,H,q){return this.s(I,A,J=>J.provideDocumentFormattingEdits(i.URI.revive($),H,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,H){const q=this.t(new F(this.h,H),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,H,q,J){return this.s(I,F,de=>de.provideDocumentRangeFormattingEdits(i.URI.revive($),H,q,J),void 0,J)}registerOnTypeFormattingEditProvider(I,$,H,q){const J=this.t(new B(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(J,this.o($),q,I.identifier),this.p(J)}$provideOnTypeFormattingEdits(I,$,H,q,J,de){return this.s(I,B,Se=>Se.provideOnTypeFormattingEdits(i.URI.revive($),H,q,J,de),void 0,de)}registerWorkspaceSymbolProvider(I,$){const H=this.t(new z($,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof $.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,$,H){return this.s(I,z,q=>q.provideWorkspaceSymbols($,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,$,H){return this.s(I,z,q=>q.resolveWorkspaceSymbol($,H),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,z,H=>H.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,H){const q=this.t(new V(this.h,H,this.l),I);return this.e.$registerRenameSupport(q,this.o($),V.supportsResolving(H)),this.p(q)}$provideRenameEdits(I,$,H,q,J){return this.s(I,V,de=>de.provideRenameEdits(i.URI.revive($),H,q,J),void 0,J)}$resolveRenameLocation(I,$,H,q){return this.s(I,V,J=>J.resolveRenameLocation(i.URI.revive($),H,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,H,q){const J=this.t(new ie(this.h,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o($),q,de);let Se=this.p(J);if(de){const ae=H.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(de));Se=L.Disposable.from(Se,ae)}return Se}$provideDocumentSemanticTokens(I,$,H,q){return this.s(I,ie,J=>J.provideDocumentSemanticTokens(i.URI.revive($),H,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,ie,H=>H.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,H,q){const J=this.t(new ge(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o($),q),this.p(J)}$provideDocumentRangeSemanticTokens(I,$,H,q){return this.s(I,ge,J=>J.provideDocumentRangeSemanticTokens(i.URI.revive($),H,q),null,q)}registerCompletionItemProvider(I,$,H,q){const J=this.t(new ue(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(J,this.o($),q,ue.supportsResolving(H),`${I.identifier.value}(${q.join("")})`),this.p(J)}$provideCompletionItems(I,$,H,q,J){return this.s(I,ue,de=>de.provideCompletionItems(i.URI.revive($),H,q,J),void 0,J)}$resolveCompletionItem(I,$,H){return this.s(I,ue,q=>q.resolveCompletionItem($,H),void 0,H)}$releaseCompletionItems(I,$){this.s(I,ue,H=>H.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,H){const q=new se(I,this.h,H,this.j.converter),J=this.t(q,I);return this.e.$registerInlineCompletionsSupport(J,this.o($),q.supportsHandleDidShowCompletionItem),this.p(J)}$provideInlineCompletions(I,$,H,q,J){return this.s(I,re,de=>de.provideInlineCompletions(i.URI.revive($),H,q,J),void 0,J)}$handleInlineCompletionDidShow(I,$,H){this.s(I,re,async q=>{q.handleDidShowCompletionItem($,H)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,re,async H=>{H.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,H,q){const J=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,de=this.t(new _(this.h,H),I);return this.e.$registerSignatureHelpProvider(de,this.o($),J),this.p(de)}$provideSignatureHelp(I,$,H,q,J){return this.s(I,_,de=>de.provideSignatureHelp(i.URI.revive($),H,q,J),void 0,J)}$releaseSignatureHelp(I,$){this.s(I,_,H=>H.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,H){const q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new me(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(J,this.o($),typeof H.resolveInlayHint=="function",q,ce.u(I));let de=this.p(J);if(q!==void 0){const Se=H.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(q));de=L.Disposable.from(de,Se)}return de}$provideInlayHints(I,$,H,q){return this.s(I,me,J=>J.provideInlayHints(i.URI.revive($),H,q),void 0,q)}$resolveInlayHint(I,$,H){return this.s(I,me,q=>q.resolveInlayHint($,H),void 0,H)}$releaseInlayHints(I,$){this.s(I,me,H=>H.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,H){const q=this.t(new we(this.h,H),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof H.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,H){return this.s(I,we,q=>q.provideLinks(i.URI.revive($),H),void 0,H,$.scheme==="output")}$resolveDocumentLink(I,$,H){return this.s(I,we,q=>q.resolveLink($,H),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,we,H=>H.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,H){const q=this.t(new Me(this.h,H),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,H){return this.s(I,Me,q=>q.provideColors(i.URI.revive($),H),[],H)}$provideColorPresentations(I,$,H,q){return this.s(I,Me,J=>J.provideColorPresentations(i.URI.revive($),H,q),void 0,q)}registerFoldingRangeProvider(I,$,H){const q=this.q(),J=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new oe(new We(this.h,H),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,J);let de=this.p(q);if(J!==void 0){const Se=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));de=L.Disposable.from(de,Se)}return de}$provideFoldingRanges(I,$,H,q){return this.s(I,We,J=>J.provideFoldingRanges(i.URI.revive($),H,q),void 0,q)}registerSelectionRangeProvider(I,$,H){const q=this.t(new Qe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,H,q){return this.s(I,Qe,J=>J.provideSelectionRanges(i.URI.revive($),H,q),[],q)}registerCallHierarchyProvider(I,$,H){const q=this.t(new Te(this.h,H),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,H,q){return this.s(I,Te,J=>Promise.resolve(J.prepareSession(i.URI.revive($),H,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,H,q){return this.s(I,Te,J=>J.provideCallsTo($,H,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,H,q){return this.s(I,Te,J=>J.provideCallsFrom($,H,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Te,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,H){const q=this.t(new De(this.h,H),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,H,q){return this.s(I,De,J=>Promise.resolve(J.prepareSession(i.URI.revive($),H,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,H,q){return this.s(I,De,J=>J.provideSupertypes($,H,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,H,q){return this.s(I,De,J=>J.provideSubtypes($,H,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,De,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,H){const q=this.q();return this.f.set(q,new oe(new ke(this.e,this.h,H,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,H,q,J,de){return this.s(I,ke,Se=>Promise.resolve(Se.provideDocumentOnDropEdits($,i.URI.revive(H),q,J,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,H,q){const J=this.q();return this.f.set(J,new oe(new R(this.e,this.h,H,J),I)),this.e.$registerPasteEditProvider(J,this.o($),!!H.prepareDocumentPaste,q.pasteMimeTypes),this.p(J)}$prepareDocumentPaste(I,$,H,q,J){return this.s(I,R,de=>de.prepareDocumentPaste(i.URI.revive($),H,q,J),void 0,J)}$providePasteEdits(I,$,H,q,J,de){return this.s(I,R,Se=>Se.providePasteEdits($,i.URI.revive(H),q,J,de),void 0,de)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,H){const{wordPattern:q}=H;if(q&&(0,S.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const J=this.q(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ce.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ce.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ce.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(J,$,de),this.p(J)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[211],Ce([1,0,4,8,6,29,14,7]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(M,D,m,v){this.c=D,this.d=m,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=M.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this.b=M}async getLanguages(){return this.b.slice(0)}async changeLanguage(M,D){await this.a.$changeLanguage(M,D);const m=this.c.getDocumentData(M);if(!m)throw new Error(`document '${M.toString()}' NOT found`);return m.document}async tokenAtPosition(M,D){const m=M.version,v=T.Position.from(D),f=await this.a.$tokensAtPosition(M.uri,v),t={type:y.StandardTokenType.Other,range:M.getWordRangeAtPosition(D)??new y.Range(D.line,D.character,D.line,D.character)};if(!f)return t;const c={range:T.Range.to(f.range),type:T.TokenType.to(f.type)};return!c.range.contains(D)||m!==M.version?t:c}createLanguageStatusItem(M,D,m){const v=this.f++,f=this.a,t=this.g,c=`${M.identifier.value}/${D}`;if(t.has(c))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);t.add(c);const l={selector:m,id:D,name:M.displayName??M.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const E=new O.DisposableStore,b=()=>{p?.dispose(),p=(0,C.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(v,{id:c,name:l.name??M.displayName??M.name,source:M.displayName??M.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?L.default.Error:l.severity===y.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){E.dispose(),p?.dispose(),f.$removeLanguageStatus(v),t.delete(c)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,b()},get selector(){return l.selector},set selector(r){l.selector=r,b()},get text(){return l.text},set text(r){l.text=r,b()},get detail(){return l.detail},set detail(r){l.detail=r,b()},get severity(){return l.severity},set severity(r){l.severity=r,b()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,b()},get command(){return l.command},set command(r){l.command=r,b()},get busy(){return l.busy},set busy(r){l.busy=r,b()}};return b(),w}}e.ExtHostLanguages=S}),define(Ie[74],Ce([1,0,21,10,2,3,12,4,27,15]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let M=class{constructor(m,v,f){this.f=f,this.d=new Map,this.a=v.getProxy(O.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,v){const{message:f,args:t,comment:c}=v;if(this.c)return(0,T.format2)(f,t??{});let l=f;c&&c.length>0&&(l+=`/${Array.isArray(c)?c.join():c}`);const p=this.d.get(m)?.contents[l];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(p??f,t??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const t=await this.a.$fetchBundleContents(f),c=JSON.parse(t);v=m.isBuiltin?c.contents?.bundle:c}catch(t){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${t.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:f})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return y.URI.revive(v)}return m.l10n?y.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};M=qe([Ve(0,S.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,C.ILogService)],M),e.ExtHostLocalizationService=M,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ie[212],Ce([1,0,12,4,27,15,2,5,9]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(m,v){super(v.logLevel,O.Event.None),this.g=m.getProxy(T.MainContext.MainThreadLogger)}$setLevel(m,v){v?this.setLevel(C.URI.revive(v),m):(0,S.isUndefined)(m)||this.setLevel(m)}f(m,v,f){return new M(this.g,m,v,f)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class M extends i.AbstractMessageLogger{constructor(m,v,f,t){super(t?.always),this.m=m,this.n=v,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(v,t).then(()=>{this.r(this.l),this.k=!0})}g(m,v){const f=[[m,v]];this.k?this.r(f):this.l.push(...f)}r(m){this.m.$log(this.n,m)}}}),define(Ie[213],Ce([1,0,4,12,25]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(O){return O&&O.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,k,M,D,m){const v={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof D=="string"||L(D)?f=[D,...m]:(v.modal=D?.modal,v.useCustom=D?.useCustom,v.detail=D?.detail,f=m),v.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const t=[];for(let c=0;c<f.length;c++){const l=f[c];if(typeof l=="string")t.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:p,isCloseAffordance:E}=l;t.push({title:p,isCloseAffordance:!!E,handle:c})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,M,v,t).then(c=>{if(typeof c=="number")return f[c]})}};C=qe([Ve(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[214],Ce([1,0,24,5,7,28,10,9,2,52,4,38,8,6,43,187,97]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,b,w,r){this.q=w,this.r=r,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(M.MainContext.MainThreadNotebook),this.c=E.getProxy(M.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(M.MainContext.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const a=s.notebookEditor?.notebookUri,d=s.cell.handle,u=this.g.get(a)?.getCell(d);if(u)return u.apiCell}if(s&&s.$mid===14){const a=s.uri,d=this.g.get(a);if(d)return d.apiNotebook}return s}}),l.x(b)}getEditorById(E){const b=this.h.get(E);if(!b)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(E){for(const[b,w]of this.h)if(w.apiEditor===E)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,b){const w=this.g.get(E);if(!w&&!b)throw new Error(`NO notebook document for '${E}'`);return w}static s(E,b){if(!b)return;const w=b.filenamePattern.map(r=>m.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(b.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:b.displayName,filenamePattern:w,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,b,w){const r=l.a++,s=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(r,w),this.b.$registerNotebookCellStatusBarItemProvider(r,s,b);let a;return s!==void 0&&(a=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(s))),new v.Disposable(()=>{this.f.delete(r),this.b.$unregisterNotebookCellStatusBarItemProvider(r,s),a?.dispose()})}async createNotebookDocument(E){const b=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return S.URI.revive(b)}async openNotebookDocument(E){const b=this.g.get(E);if(b)return b.apiNotebook;const w=await this.c.$tryOpenNotebook(E),r=this.g.get(S.URI.revive(w));return(0,O.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(E,b){S.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let w;typeof b=="object"?w={position:m.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(m.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:w={preserveFocus:!1};const r=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,w),s=r&&this.h.get(r)?.apiEditor;if(s)return s;throw r?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,b,w,r){const s=this.f.get(E),a=S.URI.revive(b),d=this.g.get(a);if(!d||!s)return;const o=d.getCellFromIndex(w);if(!o)return;const u=await s.provideCellStatusBarItems(o.apiCell,r);if(!u)return;const n=new y.DisposableStore,h=this.p.add([n]),P=(Array.isArray(u)?u:[u]).map(N=>m.NotebookStatusBarItem.from(N,this.i,n));return{cacheId:h,items:P}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,b,w,r,s){if((0,C.isFalsyOrWhitespace)(b))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:E.identifier,location:E.extensionLocation},b,m.NotebookDocumentContentOptions.from(r),l.s(E,s)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(E,b,w){const r=this.u.get(E);if(!r)throw new Error("NO serializer found");const s=await r.deserializeNotebook(b.buffer,w);return new f.SerializableObjectWithBuffers(m.NotebookData.from(s))}async $notebookToData(E,b,w){const r=this.u.get(E);if(!r)throw new Error("NO serializer found");const s=await r.serializeNotebook(m.NotebookData.to(b.value),w);return i.VSBuffer.wrap(s)}w(E,b,w){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const r=new c.ExtHostNotebookEditor(b,this.d,E,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this.h.set(b,r)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const w of E.value.removedDocuments){const r=S.URI.revive(w),s=this.g.get(r);s&&(s.dispose(),this.g.delete(r),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(s.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===r.toString()&&this.h.delete(a.id)}if(E.value.addedDocuments){const w=[];for(const r of E.value.addedDocuments){const s=S.URI.revive(r.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new t.ExtHostNotebookDocument(this.c,this.q,this.r,s,r);w.push(...r.cells.map(d=>t.ExtHostCell.asModelAddData(a.apiNotebook,d))),this.g.get(s)?.dispose(),this.g.set(s,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(E.value.addedEditors)for(const w of E.value.addedEditors){if(this.h.has(w.id))return;const r=S.URI.revive(w.documentUri),s=this.g.get(r);s&&this.w(s,w.id,w)}const b=[];if(E.value.removedEditors)for(const w of E.value.removedEditors){const r=this.h.get(w);r&&(this.h.delete(w),this.k?.id===r.id&&(this.k=void 0),b.push(r))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(r=>this.h.get(r)).filter(r=>!!r);const w=new Set;this.l.forEach(r=>w.add(r.id));for(const r of this.h.values()){const s=w.has(r.id);r._acceptVisibility(s)}this.l=[...this.h.values()].map(r=>r).filter(r=>r.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const b=D.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new D.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>i.VSBuffer.wrap(s))],new D.ApiCommandResult("Notebook Data",s=>m.NotebookData.to(s.value))),r=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new f.SerializableObjectWithBuffers(m.NotebookData.from(s)))],new D.ApiCommandResult("Bytes",s=>s.buffer));E.registerApiCommand(w),E.registerApiCommand(r)}}e.ExtHostNotebookController=l,l.a=0}),define(Ie[215],Ce([1,0,16,14,20,5,7,28,2,26,12,52,4,38,8,6,69,175,25,43]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let b=class{constructor(o,u,n,h,g){this.k=u,this.l=n,this.m=h,this.n=g,this.b=new O.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(m.MainContext.MainThreadNotebookKernels);const P=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const j=this.l.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:j}}else if(N&&"notebookEditor"in N){const j=this.l.getIdByEditor(N.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return N})],v.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(o,u,n,h,g,P){for(const re of this.h.values())if(re.controller.id===u&&k.ExtensionIdentifier.equals(o.identifier,re.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const N=this.i++,j=this;this.n.trace(`NotebookController[${N}], CREATED by ${o.identifier.value}, ${u}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${o.identifier}'`);let G=!1;const R=new C.DisposableStore,A=new L.Emitter,F=new L.Emitter,B={id:a(o.identifier,u),notebookType:n,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:h||o.identifier.value,preloads:P?P.map(f.NotebookRendererScript.from):[]};let z=g??Z,V;this.a.$addKernel(N,B).catch(re=>{console.log(re),G=!0});let K=0;const ie=()=>{if(G)return;const re=++K;Promise.resolve().then(()=>{re===K&&this.a.$updateKernel(N,B)})},ge=new O.ResourceMap,ue={get id(){return u},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return B.label},set label(re){B.label=re??o.displayName??o.name,ie()},get detail(){return B.detail??""},set detail(re){B.detail=re,ie()},get description(){return B.description??""},set description(re){B.description=re,ie()},get kind(){return(0,p.checkProposedApiEnabled)(o,"notebookControllerKind"),B.kind??""},set kind(re){(0,p.checkProposedApiEnabled)(o,"notebookControllerKind"),B.kind=re,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(re){B.supportedLanguages=re,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(re){B.supportsExecutionOrder=re,ie()},get rendererScripts(){return B.preloads?B.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(re){z=re??Z},get interruptHandler(){return V},set interruptHandler(re){V=re,B.supportsInterrupt=Boolean(re),ie()},createNotebookCellExecution(re){if(G)throw new Error("notebook controller is DISPOSED");if(!ge.has(re.notebook.uri))throw j.n.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return j._createNotebookCellExecution(re,a(o.identifier,this.id))},dispose:()=>{G||(this.n.trace(`NotebookController[${N}], DISPOSED`),G=!0,this.h.delete(N),R.dispose(),A.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(re,se){se===t.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(N,re.uri,se)},onDidReceiveMessage:F.event,postMessage(re,se){return(0,p.checkProposedApiEnabled)(o,"notebookMessaging"),j.a.$postMessage(N,se&&j.l.getIdByEditor(se),re)},asWebviewUri(re){return(0,p.checkProposedApiEnabled)(o,"notebookMessaging"),(0,c.asWebviewUri)(re,j.k.remote)}};return this.h.set(N,{extensionId:o.identifier,controller:ue,onDidReceiveMessage:F,onDidChangeSelection:A,associatedNotebooks:ge}),ue}getIdByController(o){for(const[u,n]of this.h)if(n.controller===o)return a(n.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,u){const n=this.d++,h=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(n,u);const g={dispose:()=>{this.c.delete(n),h.a.$removeKernelDetectionTask(n)}};return this.c.set(n,g),g}registerKernelSourceActionProvider(o,u,n){const h=this.f++,g=this;return this.e.set(h,n),this.n.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(h,u),{dispose:()=>{this.e.delete(h),g.a.$removeKernelSourceActionProvider(h)}}}async $provideKernelSourceActions(o,u){const n=this.e.get(o);if(n){const h=new C.DisposableStore;return this.g.add([h]),(await n.provideNotebookKernelSourceActions(u)??[]).map(P=>f.NotebookKernelSourceAction.from(P,this.m.converter,h))}return[]}$acceptNotebookAssociation(o,u,n){const h=this.h.get(o);if(h){const g=this.l.getNotebookDocument(S.URI.revive(u));n?h.associatedNotebooks.set(g.uri,!0):h.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,g.uri.toString(),n),h.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(o,u,n){const h=this.h.get(o);if(!h)return;const g=this.l.getNotebookDocument(S.URI.revive(u)),P=[];for(const N of n){const j=g.getCell(N);j&&P.push(j.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,g.uri.toString(),P.length),await h.controller.executeHandler.call(h.controller,P,g.apiNotebook,h.controller)}catch(N){this.n.error(`NotebookController[${o}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(o,u,n){const h=this.h.get(o);if(!h)return;const g=this.l.getNotebookDocument(S.URI.revive(u));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,g.apiNotebook);else for(const P of n){const N=g.getCell(P);N&&this.b.get(N.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,u,n){const h=this.h.get(o);if(!h)return;const g=this.l.getEditorById(u);h.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(o,u,n){const g=this.l.getNotebookDocument(S.URI.revive(o)).getCell(u);if(g){const P=n?f.NotebookCellExecutionState.to(n):t.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:g.apiCell,state:P})}}_createNotebookCellExecution(o,u){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const g=new r(u,h,this.a);this.b.set(h.uri,g);const P=g.onDidChangeState(()=>{g.state===w.Resolved&&(g.dispose(),P.dispose(),this.b.delete(h.uri))});return g.asApiObject()}};b=qe([Ve(4,M.ILogService)],b),e.ExtHostNotebookKernels=b;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class r extends C.Disposable{get state(){return this.f}constructor(o,u,n){super(),this.j=u,this.k=n,this.b=r.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new s(10,h=>this.m(h)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const u=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(o){let u=this.j;if(o&&(u=this.j.notebook.getCellFromApiCell(o)),!u)throw new Error("INVALID cell");return u.handle}s(o){return o.map(u=>{const n=t.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return n===u.items?f.NotebookCellOutput.from(u):f.NotebookCellOutput.from({items:n,id:u.id,metadata:u.metadata})})}async t(o,u,n){const h=this.r(u),g=this.s((0,i.asArray)(o));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:h,append:n,outputs:g})}async w(o,u,n){return o=t.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(o),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:o.map(f.NotebookCellOutputItem.from),outputId:u.id,append:n})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(n){o.i=n,o.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(n){if(o.f===w.Resolved||o.f===w.Started)throw new Error("Cannot call start again");o.f=w.Started,o.c.fire(),o.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,h){if(o.f===w.Resolved)throw new Error("Cannot call resolve twice");o.f=w.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new E.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:n}))},clearOutput(n){return o.n(),o.t([],n,!1)},appendOutput(n,h){return o.n(),o.t(n,h,!0)},replaceOutput(n,h){return o.n(),o.t(n,h,!1)},appendOutputItems(n,h){return o.n(),o.w(n,h,!0)},replaceOutputItems(n,h){return o.n(),o.w(n,h,!1)}})}}r.a=0;class s{constructor(o,u){this.d=o,this.e=u,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>o.complete())}}function a(d,o){return`${d.value}/${o}`}e.createKernelId=a}),define(Ie[216],Ce([1,0,5,4,97]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(O,S){this.c=S,this.a=new Map,this.b=O.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(O,S,k){const M=this.c.getEditorById(O);this.a.get(S)?.fire({editor:M.apiEditor,message:k})}createRendererMessaging(O,S){if(!O.contributes?.notebookRenderer?.some(M=>M.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(M,D,m)=>this.d(S).event(M,D,m),postMessage:(M,D)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(M)&&([M,D]=[D,M]);const m=D&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(m?.id,S,M)}}}d(O){let S=this.a.get(O);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(O)}}),this.a.set(O,S),S)}}e.ExtHostNotebookRenderers=L}),define(Ie[217],Ce([1,0,7,2,25,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,k,M){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,M),this.a.$registerProfileContentHandler(k,M.name,S.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(S,k,M,D){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.saveProfile(k,M,D)}async $readProfile(S,k,M){const D=this.b.get(S);if(!D)throw new Error(`Unknown handler with id: ${S}`);return D.readProfile(T.URI.revive(k),M)}}e.ExtHostProfileContentHandlers=C}),define(Ie[218],Ce([1,0,20,5,7,4,2,6,11,16,29,65]),function(ee,e,i,T,y,L,C,O,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(v,f,t){const c=v.getProxy(L.MainContext.MainThreadQuickOpen);class l{constructor(o,u){this.e=new Map,this.f=0,this.a=o,this.b=u}showQuickPick(o,u,n=i.CancellationToken.None){this.c=void 0;const h=Promise.resolve(o),g=++this.f,P=c.$show(g,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),N={},j=P.then(()=>N);return Promise.race([j,h]).then(Z=>{if(Z!==N)return h.then(G=>{const R=[];for(let A=0;A<G.length;A++){const F=G[A];typeof F=="string"?R.push({label:F,handle:A}):F.kind===O.QuickPickItemKind.Separator?R.push({type:"separator",label:F.label}):R.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:A})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=A=>{u.onDidSelectItem(G[A])}),c.$setItems(g,R),P.then(A=>{if(typeof A=="number")return G[A];if(Array.isArray(A))return A.map(F=>G[F])})})}).then(void 0,Z=>{if(!(0,S.isCancellationError)(Z))return c.$setError(g,Z),Promise.reject(Z)})}$onItemSelected(o){this.c?.(o)}showInput(o,u=i.CancellationToken.None){return this.d=o?.validateInput,c.$input(o,typeof this.d=="function",u).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(o){if(!this.d)return;const u=await this.d(o);if(!u||typeof u=="string")return u;let n;switch(u.severity){case O.InputBoxValidationSeverity.Info:n=M.default.Info;break;case O.InputBoxValidationSeverity.Warning:n=M.default.Warning;break;case O.InputBoxValidationSeverity.Error:n=M.default.Error;break;default:n=u.message?M.default.Error:M.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(o,u=i.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!n)return;const h=await this.a.getWorkspaceFolders2();if(!!h)return h.find(g=>g.uri.toString()===n.uri.toString())}createQuickPick(o){const u=new s(o,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(o){const u=new a(o,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(o,u){this.e.get(o)?._fireDidChangeValue(u)}$onDidAccept(o){this.e.get(o)?._fireDidAccept()}$onDidChangeActive(o,u){const n=this.e.get(o);n instanceof s&&n._fireDidChangeActive(u)}$onDidChangeSelection(o,u){const n=this.e.get(o);n instanceof s&&n._fireDidChangeSelection(u)}$onDidTriggerButton(o,u){this.e.get(o)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(o,u,n){const h=this.e.get(o);h instanceof s&&h._fireDidTriggerItemButton(u,n)}$onDidHide(o){this.e.get(o)?._fireDidHide()}}class p{constructor(o,u){this.x=o,this.y=u,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(o){this.b=o,this.z({title:o})}get step(){return this.c}set step(o){this.c=o,this.z({step:o})}get totalSteps(){return this.d}set totalSteps(o){this.d=o,this.z({totalSteps:o})}get enabled(){return this.g}set enabled(o){this.g=o,this.z({enabled:o})}get busy(){return this.j}set busy(o){this.j=o,this.z({busy:o})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(o){this.k=o,this.z({ignoreFocusOut:o})}get value(){return this.l}set value(o){this.l=o,this.z({value:o})}get placeholder(){return this.m}set placeholder(o){this.m=o,this.z({placeholder:o})}get buttons(){return this.n}set buttons(o){this.n=o.slice(),this.o.clear(),o.forEach((u,n)=>{const h=u===O.QuickInputButtons.Back?-1:n;this.o.set(h,u)}),this.z({buttons:o.map((u,n)=>({...r(u),tooltip:u.tooltip,handle:u===O.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(o){this.l=o,this.q.fire(o)}_fireDidTriggerButton(o){const u=this.o.get(o);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(o){if(!this.v){for(const u of Object.keys(o)){const n=o[u];this.u[u]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function E(d){if(d instanceof O.ThemeIcon)return{id:d.id};const o=w(d),u=b(d);return{dark:typeof o=="string"?C.URI.file(o):o,light:typeof u=="string"?C.URI.file(u):u}}function b(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const o=E(d.iconPath);let u,n;return"id"in o?n=D.ThemeIcon.asClassName(o):u=o,{iconPath:u,iconClass:n}}class s extends p{constructor(o,u){super(o.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(o){this.B=o.slice(),this.C.clear(),this.D.clear(),o.forEach((n,h)=>{this.C.set(h,n),this.D.set(n,h)});const u=[];for(let n=0;n<o.length;n++){const h=o[n];h.kind===O.QuickPickItemKind.Separator?u.push({type:"separator",label:h.label}):u.push({handle:n,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((g,P)=>({...r(g),tooltip:g.tooltip,handle:P}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(o){this.E=o,this.z({canSelectMany:o})}get matchOnDescription(){return this.F}set matchOnDescription(o){this.F=o,this.z({matchOnDescription:o})}get matchOnDetail(){return this.G}set matchOnDetail(o){this.G=o,this.z({matchOnDetail:o})}get sortByLabel(){return this.H}set sortByLabel(o){this.H=o,this.z({sortByLabel:o})}get keepScrollPosition(){return this.I}set keepScrollPosition(o){this.I=o,this.z({keepScrollPosition:o})}get activeItems(){return this.J}set activeItems(o){this.J=o.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(o){this.L=o.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(o){const u=(0,k.coalesce)(o.map(n=>this.C.get(n)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(o){const u=(0,k.coalesce)(o.map(n=>this.C.get(n)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(o,u){const n=this.C.get(o);if(!n||!n.buttons||!n.buttons.length)return;const h=n.buttons[u];h&&this.N.fire({button:h,item:n})}}class a extends p{constructor(o,u){super(o.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(o){this.B=o,this.z({password:o})}get prompt(){return this.C}set prompt(o){this.C=o,this.z({prompt:o})}get valueSelection(){return this.D}set valueSelection(o){this.D=o,this.z({valueSelection:o})}get validationMessage(){return this.E}set validationMessage(o){this.E=o,o?typeof o=="string"?this.z({validationMessage:o,severity:M.default.Error}):this.z({validationMessage:o.message,severity:o.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new l(f,t)}e.createExtHostQuickOpen=m});var Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ie[219],Ce([1,0,2,5,61,7,14,4,16,122,12,26,65,8,25]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f){"use strict";var t,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||m.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function p(h,g){if(!h.iconPath&&!g.iconPath)return 0;if(h.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,N=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(P,N)}function E(h,g){let P=0;if(h.strikeThrough!==g.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==g.faded)return h.faded?1:-1;if(h.tooltip!==g.tooltip)return(h.tooltip||"").localeCompare(g.tooltip||"");if(P=p(h,g),P!==0)return P;if(h.light&&g.light)P=p(h.light,g.light);else{if(h.light)return 1;if(g.light)return-1}if(P!==0)return P;if(h.dark&&g.dark)P=p(h.dark,g.dark);else{if(h.dark)return 1;if(g.dark)return-1}return P}function b(h,g){if(h.command!==g.command)return h.command<g.command?-1:1;if(h.title!==g.title)return h.title<g.title?-1:1;if(h.tooltip!==g.tooltip){if(h.tooltip!==void 0&&g.tooltip!==void 0)return h.tooltip<g.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(h.arguments===g.arguments)return 0;if(h.arguments)if(g.arguments){if(h.arguments.length!==g.arguments.length)return h.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const N=h.arguments[P],j=g.arguments[P];if(N!==j)return N<j?-1:1}return 0}function w(h,g){let P=(0,k.comparePaths)(h.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&g.command)P=b(h.command,g.command);else{if(h.command)return 1;if(g.command)return-1}if(P!==0)return P;if(h.decorations&&g.decorations)P=E(h.decorations,g.decorations);else{if(h.decorations)return 1;if(g.decorations)return-1}return P}function r(h,g){for(let P=0;P<h.length;P++)if(h[P]!==g[P])return!1;return!0}function s(h,g){return h.command===g.command&&h.title===g.title&&h.tooltip===g.tooltip&&(h.arguments&&g.arguments?r(h.arguments,g.arguments):h.arguments===g.arguments)}function a(h,g){return(0,S.equals)(h,g,s)}class d{get value(){return this.d}set value(g){g=g??"",Re(this,t,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Re(this,t,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Re(this,t,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Re(this,t,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Re(this,t,"f").$setInputBoxVisibility(this.l,g))}constructor(g,P,N){this.k=g,this.l=N,t.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,t,P,"f")}showValidationMessage(g,P){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Re(this,t,"f").$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=d,t=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,N,j,Z){this.q=g,this.s=P,this.t=N,this.u=j,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const N=this.h.get(g);return N?(0,C.asPromise)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(w),N=(0,S.sortedDiff)(this.o,g,w).map(G=>{const R=G.toInsert.map(A=>{const F=this.e++;this.g.set(F,A);const B=A.resourceUri;let z;if(A.command)if(A.command.command==="vscode.open"||A.command.command==="vscode.diff"){const me=new L.DisposableStore;z=this.s.converter.toInternal(A.command,me),this.j.set(F,me)}else this.h.set(F,A.command);const V=l(A.decorations),K=A.decorations&&l(A.decorations.light)||V,ie=A.decorations&&l(A.decorations.dark)||V,ge=[K,ie],ue=A.decorations&&A.decorations.tooltip||"",re=A.decorations&&!!A.decorations.strikeThrough,se=A.decorations&&!!A.decorations.faded,le=A.contextValue||"";return{rawResource:[F,B,ge,ue,re,se,le,z],handle:F}});return{start:G.start,deleteCount:G.deleteCount,toInsert:R}}),j=N.map(({start:G,deleteCount:R,toInsert:A})=>[G,R,A.map(F=>F.rawResource)]),Z=N.reverse();for(const{start:G,deleteCount:R,toInsert:A}of Z){const F=A.map(z=>z.handle),B=this.n.splice(G,R,...F);for(const z of B)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=g,j}dispose(){this.l=!0,this.m.fire()}}o.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Re(this,c,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Re(this,c,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Re(this,c,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new L.DisposableStore,this.l=g;const P=this.v.converter.toInternal(g,this.k.value);Re(this,c,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=g;const P=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(N=>N.map(j=>this.v.converter.toInternal(j,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Re(this,c,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&a(this.p,g))return;this.o.value=new L.DisposableStore,this.p=g;const P=(g||[]).map(N=>this.v.converter.toInternal(N,this.o.value));Re(this,c,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(g,P,N,j,Z,G){this.u=g,this.v=N,this.w=j,this.x=Z,this.y=G,c.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Ye(this,c,P,"f"),this.f=new d(g,Re(this,c,"f"),this.t),Re(this,c,"f").$registerSourceControl(this.t,j,Z,G)}createResourceGroup(g,P){const N=new o(Re(this,c,"f"),this.v,this.t,g,P),j=T.Event.once(N.onDidDispose)(()=>this.z.delete(N));return this.z.set(N,j),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const g=[],P=[];for(const[N,j]of this.z){j.dispose();const Z=N.onDidUpdateResourceStates(()=>{this.A.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.A.delete(N),Z.dispose(),this.e.delete(N.handle),Re(this,c,"f").$unregisterGroup(this.t,N.handle)}),g.push([N.handle,N.id,N.label,N.features]);const G=N._takeResourceStateSnapshot();G.length>0&&P.push([N.handle,G]),this.e.set(N.handle,N)}Re(this,c,"f").$registerGroups(this.t,g,P),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&g.push([P.handle,N])}),g.length>0&&Re(this,c,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Re(this,c,"f").$unregisterSourceControl(this.t)}}c=new WeakMap,u.d=0,qe([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class nn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,N){this.l=P,this.m=N,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=g.getProxy(O.MainContext.MainThreadSCM),this.f=g.getProxy(O.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const Z=this.g.get(j.sourceControlHandle);if(!Z)return j;const G=Z.getResourceGroup(j.groupHandle);return G?G.getResourceState(j.handle):j}else if(j&&j.$mid===4){const Z=this.g.get(j.sourceControlHandle);return Z?Z.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const Z=this.g.get(j.handle);return Z||j}return j}})}createSourceControl(g,P,N,j){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,N,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const Z=nn.d++,G=new u(g,this.e,this.l,P,N,j);this.g.set(Z,G);const R=this.h.get(D.ExtensionIdentifier.toKey(g.identifier))||[];return R.push(G),this.h.set(D.ExtensionIdentifier.toKey(g.identifier),R),G}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(D.ExtensionIdentifier.toKey(g.identifier)),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(g,P,N){const j=i.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",g,j.toString());const Z=this.g.get(g);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(j,N)).then(G=>G||null)}$onInputBoxValueChange(g,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const N=this.g.get(g);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,N,j){this.m.trace("ExtHostSCM#$executeResourceCommand",g,P,N);const Z=this.g.get(g);if(!Z)return Promise.resolve(void 0);const G=Z.getResourceGroup(P);return G?G.$executeResourceCommand(N,j):Promise.resolve(void 0)}$validateInput(g,P,N){this.m.trace("ExtHostSCM#$validateInput",g);const j=this.g.get(g);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>j.inputBox.validateInput(P,N)).then(Z=>{if(!Z)return Promise.resolve(void 0);const G=v.MarkdownString.fromStrict(Z.message);return G?Promise.resolve([G,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};n.d=0,n=qe([Ve(2,M.ILogService)],n),e.ExtHostSCM=n}),define(Ie[75],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(O){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,S){return this.a.$getPassword(O,S)}store(O,S,k){return this.a.$setPassword(O,S,k)}delete(O,S){return this.a.$deletePassword(O,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[220],Ce([1,0,6,4,137,7,8,9]),function(ee,e,i,T,y,L,C,O){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(f,t,c,l,p=i.StatusBarAlignment.Left,E){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new L.DisposableStore,Ye(this,S,f,"f"),Ye(this,k,t,"f"),this.c=M.a++,this.e=c,this.f=l,this.g=p,this.h=this.t(E)}t(f){if(!!(0,O.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(f){this.k=f,this.u()}set name(f){this.m=f,this.u()}set tooltip(f){this.l=f,this.u()}set color(f){this.n=f,this.u()}set backgroundColor(f){f&&!M.b.has(f.id)&&(f=void 0),this.o=f,this.u()}set command(f){this.q?.fromApi!==f&&(this.p.clear(),typeof f=="string"?this.q={fromApi:f,internal:Re(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.q={fromApi:f,internal:Re(this,k,"f").toInternal(f,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(f){this.s=f,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Re(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let t;this.m?t=this.m:t=(0,y.localize)(0,null,this.e.displayName||this.e.name);let c=this.n;this.o&&(c=M.b.get(this.o.id));const l=C.MarkdownString.fromStrict(this.l);Re(this,S,"f").$setEntry(this.c,f,t,this.k,l,this.q?.internal,c,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=M,S=new WeakMap,k=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const t={message:f};return this.b.unshift(t),this.c(),new i.Disposable(()=>{const c=this.b.indexOf(t);c>=0&&(this.b.splice(c,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,t){this.a=f.getProxy(T.MainContext.MainThreadStatusBar),this.b=t,this.c=new D(this)}createStatusBarEntry(f,t,c,l){return new M(this.a,this.b,f,t,c,l)}setStatusBarMessage(f,t){const c=this.c.setMessage(f);let l;return typeof t=="number"?l=setTimeout(()=>c.dispose(),t):typeof t<"u"&&t.then(()=>c.dispose(),()=>c.dispose()),new i.Disposable(()=>{c.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=m}),define(Ie[76],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(O,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,S){this.a.$registerExtensionStorageKeysToSync(O,S)}async initializeExtensionStorage(O,S,k){const M=await this.a.$initializeExtensionStorage(O,S);let D;return M&&(D=this.d(O,S,M)),D||k}setValue(O,S,k){return this.a.$setValue(O,S,k)}$acceptValue(O,S,k){const M=this.d(O,S,k);M&&this.b.fire({shared:O,key:S,value:M})}d(O,S,k){try{return JSON.parse(k)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${O}): ${M}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ie[77],Ce([1,0,3,27,12,58,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let O=class{constructor(k,M,D){this.d=M,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,M=await this.g(k);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(C.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=qe([Ve(0,T.IExtHostInitDataService),Ve(1,y.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(Ie[59],Ce([1,0,5,4,3,2,15,7,6,138,11,176,20,34,162,65,9,14,8]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class E{constructor(n,h,g,P){this.k=n,this._id=h,this.l=g,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.j},sendText(j,Z=!0){N.o(),N.k.$sendText(N._id,j,Z)},show(j){N.o(),N.k.$show(N._id,j)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(n,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,c.withNullAsUndefined)(n.shellPath),shellArgs:(0,c.withNullAsUndefined)(n.shellArgs),cwd:(0,c.withNullAsUndefined)(n.cwd),env:(0,c.withNullAsUndefined)(n.env),icon:(0,c.withNullAsUndefined)(d(n.iconPath)),color:t.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,c.withNullAsUndefined)(n.message),strictEnv:(0,c.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this.n(n.location,h?.resolvedExtHostIdentifier),isTransient:(0,c.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,h,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:t.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(n,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,h){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in n?{viewColumn:p.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,h){this.h=Object.freeze({code:n,reason:h})}setDimensions(n,h){return n===this.d&&h===this.g||n===0||h===0?!1:(this.d=n,this.g=h,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(h=>{h!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=E;class b{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,h){this.g.setDimensions?.({columns:n,rows:h})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,r=class extends O.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,h){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=h.getProxy(T.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[g,P]of this.g)P.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,h){const g=new E(this.a,(0,v.generateUuid)(),n,n.name),P=new b(n.pty);return g.createExtensionTerminal(n.location,this.L(n,h).resolvedExtHostIdentifier,d(n.iconPath),o(n.color)).then(N=>{const j=this.M(N,P);this.h[N]=j}),this.f.push(g),g.value}L(n,h){if(h=h||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const P=this.f.find(N=>N.value===g);P&&(h.resolvedExtHostIdentifier=P._id)}}else n.location&&typeof n.location!="object"?h.location=n.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(n,h){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const P=new b(h),N=this.M(n,P);this.h[n]=N}async $acceptActiveTerminalChanged(n){const h=this.b;if(n===null){this.b=void 0,h!==this.b&&this.F.fire(this.b);return}const g=this.O(n);g&&(this.b=g,h!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,h){const g=this.O(n);g&&this.I.fire({terminal:g.value,data:h})}async $acceptTerminalDimensions(n,h,g){const P=this.O(n);P&&P.setDimensions(h,g)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(n,h,g){this.g.get(n)?.resize(h,g)}async $acceptTerminalTitleChange(n,h){const g=this.O(n);g&&(g.name=h)}async $acceptTerminalClosed(n,h,g){const P=this.Q(this.f,n);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(h,g),this.C.fire(N.value)}}$acceptTerminalOpened(n,h,g,P){if(h){const Z=this.Q(this.f,h);if(Z!==null){this.f[Z]._id=n,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new E(this.a,n,N,g);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(n,h){this.O(n)?._setProcessId(h)}async $startExtensionTerminal(n,h){const g=this.O(n);if(!g)return{message:(0,k.localize)(0,null,n)};g.isOpen||await new Promise(N=>{const j=this.onDidOpenTerminal(async Z=>{Z===g.value&&(j.dispose(),N())})});const P=this.g.get(n);P?P.startSendingEvents(h):this.j[n]={initialDimensions:h}}M(n,h){const g=new O.DisposableStore;g.add(h.onProcessReady(N=>this.a.$sendProcessReady(n,N.pid,N.cwd))),g.add(h.onDidChangeProperty(N=>this.a.$sendProcessProperty(n,N))),this.s.startBuffering(n,h.onProcessData),g.add(h.onProcessExit(N=>this.N(n,N))),this.g.set(n,h);const P=this.j[n];return P&&h instanceof b&&(h.startSendingEvents(P.initialDimensions),delete this.j[n]),g}$acceptProcessAckDataEvent(n,h){this.g.get(n)?.acknowledgeDataEvent(h)}$acceptProcessInput(n,h){this.g.get(n)?.input(h)}$acceptTerminalInteraction(n){const h=this.O(n);h?.setInteractedWith()&&this.H.fire(h.value)}$acceptProcessResize(n,h,g){try{this.g.get(n)?.resize(h,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(n,h){this.g.get(n)?.shutdown(h)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(h=>this.a.$sendProcessProperty(n,{type:"cwd",value:h}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,h,g){if(this.v.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.v.set(h,g),this.a.$registerProfileProvider(h,n.identifier.value),new S.Disposable(()=>{this.v.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(n,h,g){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,g),this.a.$registerQuickFixProvider(n,h),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,h){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const P=this.w.get(n);if(!P)return;const N=await P.provideTerminalQuickFixes(h,g);if(N!==null)return N}async $createContributedProfileTerminal(n,h){const g=new m.CancellationTokenSource().token;let P=await this.v.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(n,h){const g=this.O(n);if(!g)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const N=new m.CancellationTokenSource;this.z.set(n,N);const j=[],Z={terminal:g.value,line:h},G=[];for(const F of this.u)G.push(l.Promises.withAsyncBody(async B=>{N.token.onCancellationRequested(()=>B({provider:F,links:[]}));const z=await F.provideTerminalLinks(Z,N.token)||[];N.token.isCancellationRequested||B({provider:F,links:z})}));const R=await Promise.all(G);if(N.token.isCancellationRequested)return[];const A=new Map;for(const F of R)F&&F.links.length>0&&j.push(...F.links.map(B=>{const z={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return A.set(z.id,{provider:F.provider,link:B}),z}));return this.y.set(n,A),j}$activateLink(n,h){const g=this.y.get(n)?.get(h);!g||g.provider.handleTerminalLink(g.link)}N(n,h){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const g=this.h[n];g&&(g.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,h)}O(n){return this.P(this.f,n)}P(n,h){const g=this.Q(n,h);return g!==null?n[g]:null}Q(n,h){let g=null;return n.some((P,N)=>P._id===h?(g=N,!0):!1),g}getEnvironmentVariableCollection(n){let h=this.l.get(n.identifier.value);return h||(h=new s,this.S(n.identifier.value,h)),h}R(n,h){const g=(0,D.serializeEnvironmentVariableCollection)(h.map);this.a.$setEnvironmentVariableCollection(n,h.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(h=>{const g=h[0],P=new s(h[1]);this.S(g,P)})}$acceptDefaultProfile(n,h){const g=this.m;this.m=n,this.n=h,g?.path!==n.path&&this.J.fire(n.path)}S(n,h){this.l.set(n,h),h.onDidChangeCollection(()=>{this.R(n,h)})}};r=qe([Ve(1,C.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class s{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Replace})}append(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,h){const g=this.map.get(n);(!g||g.value!==h.value||g.type!==h.type)&&(this.map.set(n,h),this.b.fire())}get(n){return this.map.get(n)}forEach(n,h){this.map.forEach((g,P)=>n.call(h,P,g,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends r{constructor(n){super(!1,n)}createTerminal(n,h,g){throw new M.NotSupportedError}createTerminalFromOptions(n,h){throw new M.NotSupportedError}};a=qe([Ve(0,C.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function o(u){return t.ThemeColor.isThemeColor(u)?u:void 0}});var Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ie[221],Ce([1,0,16,14,24,20,5,185,222,7,23,9,34,4,15,98,8,6,42,68,54]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b){"use strict";var w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(A,F,B){this.j=B,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=A.getProxy(v.MainContext.MainThreadTesting),this.h=new j(this.f),this.g=new u(this.f),F.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const V=z,K=V.tests[V.tests.length-1].item.extId;return this.d.get(p.TestId.root(K))?.collection.tree.get(K)?.actual??(0,t.toItemFromContext)(z)}})}createTestController(A,F,B){if(this.d.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const z=new k.DisposableStore,V=z.add(new t.ExtHostTestItemCollection(A,F,this.j));V.root.label=F;const K=new Map,ie=this.f,ge={items:V.root.children,get label(){return F},set label(re){F=re,V.root.label=re,ie.$updateController(A,{label:F})},get refreshHandler(){return B},set refreshHandler(re){B=re,ie.$updateController(A,{canRefresh:!!re})},get id(){return A},createRunProfile:(re,se,le,_,me)=>{let we=(0,S.hash)(re);for(;K.has(we);)we++;return new Z(this.f,K,A,we,re,se,le,_,me)},createTestItem(re,se,le){return new t.TestItemImpl(A,re,se,le)},createTestRun:(re,se,le=!0)=>this.g.createTestRun(A,V,re,se,le),set resolveHandler(re){V.resolveHandler=re},get resolveHandler(){return V.resolveHandler},dispose:()=>{z.dispose()}};ie.$registerTestController(A,F,!!B),z.add((0,k.toDisposable)(()=>ie.$unregisterTestController(A)));const ue={controller:ge,collection:V,profiles:K};return this.d.set(A,ue),z.add((0,k.toDisposable)(()=>this.d.delete(A))),z.add(V.onDidGenerateDiff(re=>ie.$publishDiff(A,re.map(b.TestsDiffOp.serialize)))),ge}createTestObserver(){return this.h.checkout()}async runTests(A,F=L.CancellationToken.None){const B=n(A);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get(B.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:A.include?.map(V=>p.TestId.fromExtHostTestItem(V,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:G[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:A.exclude?.map(V=>V.id)},F)}$syncTests(){for(const{collection:A}of this.d.values())A.flushDiff();return Promise.resolve()}$provideFileCoverage(A,F,B){return(0,i.mapFind)(this.g.trackers,V=>V.id===A?V.getCoverage(F):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(A,F,B,z){return(0,i.mapFind)(this.g.trackers,K=>K.id===A?K.getCoverage(F):void 0)?.resolveFileCoverage(B,z)??Promise.resolve([])}$configureRunProfile(A,F){this.d.get(A)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(A,F){await this.d.get(A)?.controller.refreshHandler?.(F)}$publishTestResults(A){this.results=Object.freeze(A.map(F=>(0,M.deepFreeze)(c.TestResults.to(F))).concat(this.results).sort((F,B)=>B.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(A,F){const B=this.d.get(p.TestId.fromString(A).controllerId)?.collection;B&&(await B.expand(A,F<0?1/0:F),B.flushDiff())}$acceptDiff(A){this.h.applyDiff(A.map(b.TestsDiffOp.deserialize))}async $runControllerTests(A,F){return Promise.all(A.map(B=>this.runControllerTestRequest(B,F)))}async runControllerTestRequest(A,F){const B=this.d.get(A.controllerId);if(!B)return{};const{collection:z,profiles:V}=B,K=V.get(A.profileId);if(!K)return{};const ie=A.testIds.map(se=>z.tree.get(se)).filter(D.isDefined),ge=A.excludeExtIds.map(se=>B.collection.tree.get(se)).filter(D.isDefined).filter(se=>ie.some(le=>le.fullId.compare(se.fullId)===2));if(!ie.length)return{};const ue=new l.TestRunRequest(ie.some(se=>se.actual instanceof t.TestItemRootImpl)?void 0:ie.map(se=>se.actual),ge.map(se=>se.actual),K),re=this.g.prepareForMainThreadTestRun(ue,h.fromInternal(A,B.collection),F);try{return await K.runHandler(ue,F),{}}catch(se){return{error:String(se)}}finally{re.hasRunningTasks&&!F.isCancellationRequested&&await C.Event.toPromise(re.onEnd),re.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.g.cancelAllRuns():this.g.cancelRunById(A)}};s=qe([Ve(0,f.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var d;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(d||(d={}));class o extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(A,F,B){super(),this.k=A,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(B));const z=this.B(new T.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(A){return this.f.get(A)?.coverage}createRun(A){const F=this.k.id,B=this.k.controllerId,z=(0,m.generateUuid)(),V=new g(this.l,F,z),K=re=>(se,...le)=>{if(ge){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(se)||(this.s(se),re(se,...le))},ie=(re,se)=>{const le=se instanceof Array?se.map(c.TestMessage.from):[c.TestMessage.from(se)];if(re.uri&&re.range){const _={range:c.Range.from(re.range),uri:re.uri};for(const me of le)me.location=me.location||_}this.l.$appendTestMessagesInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),le)};let ge=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:A,get coverageProvider(){return V.coverageProvider},set coverageProvider(re){V.coverageProvider=re},enqueued:K(re=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),1)}),skipped:K(re=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),5)}),started:K(re=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),2)}),errored:K((re,se,le)=>{ie(re,se),this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),6,le)}),failed:K((re,se,le)=>{ie(re,se),this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),4,le)}),passed:K((re,se)=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,se)}),appendOutput:(re,se,le)=>{ge||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(F,z,y.VSBuffer.fromString(re),se&&c.location.from(se),le&&p.TestId.fromExtHostTestItem(le,B).toString()))},end:()=>{ge||(ge=!0,this.l.$finishedTestRunTask(F,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ue,coverage:V}),this.l.$startedTestRunTask(F,{id:z,name:A,running:!0}),ue}m(){for(const{run:A}of this.f.values())A.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(A){if(!(A instanceof t.TestItemImpl))throw new E.InvalidTestItemError(A.id);if(this.g.has(p.TestId.fromExtHostTestItem(A,this.k.controllerId).toString()))return;const F=[],B=this.k.colllection.root;for(;;){const z=c.TestItem.from(A);if(F.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),A===B))break;A=A.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class u{get trackers(){return this.c.values()}constructor(A){this.d=A,this.c=new Map}prepareForMainThreadTestRun(A,F,B){return this.f(A,F,B)}cancelRunById(A){for(const F of this.c.values())if(F.id===A){F.cancel();return}}cancelAllRuns(){for(const A of this.c.values())A.cancel()}createTestRun(A,F,B,z,V){const K=this.c.get(B);if(K)return K.createRun(z);const ie=h.fromPublic(A,F,B,V),ge=n(B);this.d.$startedExtensionTestRun({controllerId:A,profile:ge&&{group:G[ge.kind],id:ge.profileId},exclude:B.exclude?.map(re=>p.TestId.fromExtHostTestItem(re,F.root.id).toString())??[],id:ie.id,include:B.include?.map(re=>p.TestId.fromExtHostTestItem(re,F.root.id).toString())??[F.root.id],persist:V});const ue=this.f(B,ie);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),ue.dispose()}),ue.createRun(z)}f(A,F,B){const z=new o(F,this.d,B);return this.c.set(A,z),z.onEnd(()=>this.c.delete(A)),z}}e.TestRunCoordinator=u;const n=R=>{if(!!R.profile){if(!(R.profile instanceof Z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class h{static fromPublic(A,F,B,z){return new h(A,(0,m.generateUuid)(),B.include?.map(V=>p.TestId.fromExtHostTestItem(V,A).toString())??[A],B.exclude?.map(V=>p.TestId.fromExtHostTestItem(V,A).toString())??[],z,F)}static fromInternal(A,F){return new h(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,F)}constructor(A,F,B,z,V,K){this.controllerId=A,this.id=F,this.isPersisted=V,this.colllection=K,this.c=B.map(ie=>ie+"\0"),this.d=z.map(ie=>ie+"\0")}isIncluded(A){const F=p.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const B of this.d)if(F===B||F.startsWith(B))return!1;for(const B of this.c)if(F===B||F.startsWith(B))return!0;return!1}}e.TestRunDto=h;class g{set coverageProvider(A){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this.c=A,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(A,F,B){this.f=A,this.g=F,this.h=B}async provideFileCoverage(A){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(A))());try{return(await this.d)?.map(c.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(A,F){const B=await this.d;let z=B?.[A];return!this.c||!B||!z?[]:(z.detailedCoverage||(z=B[A]=await this.c.resolveFileCoverage?.(z,F)??z),z.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class P{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(A){this.h=A,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(A){this.c.add(A)}update(A){Object.assign(A.revived,c.TestItem.toPlain(A.item)),this.c.has(A)||this.d.add(A)}remove(A){if(this.c.has(A)){this.c.delete(A);return}this.d.delete(A);const F=p.TestId.parentId(A.item.extId);if(F&&this.g.has(F.toString())){this.g.add(A.item.extId);return}this.f.add(A)}getChangeEvent(){const{c:A,d:F,f:B}=this;return{get added(){return[...A].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...B].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class N extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(A){return this.d.get(A)}getMirroredTestDataByReference(A){return this.d.get(A.id)}p(A,F){return{...A,revived:c.TestItem.toPlain(A.item),depth:F?F.depth+1:0,children:new Set}}o(){return new P(this.q)}}e.MirroredTestCollection=N;class j{constructor(A){this.d=A}checkout(){this.c||(this.c=this.f());const A=this.c;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(F=>F.revived)},dispose:(0,O.once)(()=>{--A.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(A){return this.c?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.c?.tests.apply(A)}f(){const A=new N;return this.d.$subscribeToDiffs(),{observers:0,tests:A}}}class Z{get label(){return this.d}set label(A){A!==this.d&&(this.d=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this.f}set isDefault(A){A!==this.f&&(this.f=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?c.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this.c}set configureHandler(A){A!==this.c&&(this.c=A,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}constructor(A,F,B,z,V,K,ie,ge=!1,ue=void 0){this.controllerId=B,this.profileId=z,this.d=V,this.kind=K,this.runHandler=ie,this.f=ge,this._tag=ue,w.set(this,void 0),r.set(this,void 0),Ye(this,w,A,"f"),Ye(this,r,F,"f"),F.set(z,this);const re=G[K];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Re(this,w,"f").$publishTestRunProfile({profileId:z,controllerId:B,tag:ue?c.TestTag.namespace(this.controllerId,ue.id):null,label:V,group:re,isDefault:ge,hasConfigurationHandler:!1})}dispose(){Re(this,r,"f")?.delete(this.profileId)&&(Ye(this,r,void 0,"f"),Re(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Z,w=new WeakMap,r=new WeakMap;const G={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ie[223],Ce([1,0,16,5,4,99,8,6]),function(ee,e,i,T,y,L,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(M,D){this.i=D,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const D=this.i.allEditors();return M?D:D.map(m=>m.value)}async showTextDocument(M,D,m){let v;typeof D=="number"?v={position:C.ViewColumn.from(D),preserveFocus:m}:typeof D=="object"?v={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(M.uri,v),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,D){return new L.TextEditorDecorationType(this.h,M,D).value}$acceptEditorPropertiesChanged(M,D){const m=this.i.getEditor(M);if(!m)throw new Error("unknown text editor");if(D.options&&m._acceptOptions(D.options),D.selections){const v=D.selections.selections.map(C.Selection.to);m._acceptSelections(v)}if(D.visibleRanges){const v=i.coalesce(D.visibleRanges.map(C.Range.to));m._acceptVisibleRanges(v)}if(D.options&&this.b.fire({textEditor:m.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const v=O.TextEditorSelectionChangeKind.fromValue(D.selections.source),f=D.selections.selections.map(C.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:v})}if(D.visibleRanges){const v=i.coalesce(D.visibleRanges.map(C.Range.to));this.c.fire({textEditor:m.value,visibleRanges:v})}}$acceptEditorPositionData(M){for(const D in M){const m=this.i.getEditor(D);if(!m)throw new Error("Unknown text editor");const v=C.ViewColumn.to(M[D]);m.value.viewColumn!==v&&(m._acceptViewColumn(v),this.d.fire({textEditor:m.value,viewColumn:v}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.ExtHostEditors=S}),define(Ie[224],Ce([1,0,2,3,4,7,6,8,9]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class k{constructor(m,v){this.b=new Map,this.c=new Map,this.a=m.getProxy(y.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===12){const t=f.uri===void 0?void 0:i.URI.revive(f.uri);return this.c.get(f.source)?.get(M(t))?.get(f.handle)}return f}})}async $getTimeline(m,v,f,t){return this.b.get(m)?.provideTimeline(i.URI.revive(v),f,t)}registerTimelineProvider(m,v,f,t){const c=new L.DisposableStore,l=this.d(v.id,t,c).bind(this);let p;v.onDidChange&&(p=v.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:v.id}),this));const E=this.c;return this.f({...v,scheme:m,onDidChange:void 0,async provideTimeline(b,w,r){w?.resetCache&&(c.clear(),E.get(v.id)?.clear());const s=await v.provideTimeline(b,w,r);if(s==null)return;const a=l(b,w);return{...s,source:v.id,items:s.items.map(a)}},dispose(){for(const b of E.values())b.get(v.id)?.clear();p?.dispose(),c.dispose()}})}d(m,v,f){return(t,c)=>{let l;if(c?.cacheResults){let p=this.c.get(m);p===void 0&&(p=new Map,this.c.set(m,p));const E=M(t);l=p.get(E),l===void 0&&(l=new Map,p.set(E,l))}return p=>{const{iconPath:E,...b}=p,w=`${m}|${p.id??p.timestamp}`;l?.set(w,p);let r,s,a;p.iconPath&&(E instanceof C.ThemeIcon?a={id:E.id,color:E.color}:i.URI.isUri(E)?(r=E,s=E):{light:r,dark:s}=E);let d;return C.MarkdownString.isMarkdownString(b.tooltip)?d=O.MarkdownString.from(b.tooltip):(0,S.isString)(b.tooltip)?d=b.tooltip:C.MarkdownString.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=O.MarkdownString.from(b.detail)):(0,S.isString)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=b.detail),{...b,id:b.id??void 0,handle:w,source:m,command:p.command?v.toInternal(p.command,f):void 0,icon:r,iconDark:s,themeIcon:a,tooltip:d,accessibilityInformation:p.accessibilityInformation}}}}f(m){if(this.b.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this.a.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this.b.set(m.id,m),(0,L.toDisposable)(()=>{for(const f of this.c.values())f.get(m.id)?.clear();this.b.delete(m.id),this.a.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function M(D){return D?.toString()}}),define(Ie[225],Ce([1,0,7,13,2,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,M,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=D.schemes.find(v=>!C.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,M),this.b.$registerUriOpener(k,D.schemes,S,D.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,M){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const m=y.URI.revive(k);return D.canOpenExternalUri(m,M)}async $openUri(S,k,M){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},M)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(Ie[226],Ce([1,0,4,2,7,11,26]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,M){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=O.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(D,M),this.b.$registerUriHandler(D,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(k,M){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(M))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=O,O.a=0});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[60],Ce([1,0,5,13,23,2,150,170,69,4]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";var M,D,m,v,f,t,c,l,p,E,b,w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(N,j,Z,G,R,A,F){M.set(this,void 0),D.set(this,void 0),m.set(this,void 0),v.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,""),l.set(this,void 0),p.set(this,!1),E.set(this,!1),b.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new i.Emitter),this._onDidDispose=Re(this,r,"f").event,Ye(this,M,N,"f"),Ye(this,D,j,"f"),Ye(this,l,Z,"f"),Ye(this,v,G,"f"),Ye(this,f,R,"f"),Ye(this,t,A,"f"),Ye(this,b,a(A),"f"),Ye(this,w,d(A),"f"),Ye(this,m,F,"f")}dispose(){Ye(this,p,!0,"f"),Re(this,r,"f").fire(),Re(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(N){return Ye(this,E,!0,"f"),(0,S.asWebviewUri)(N,Re(this,v,"f"))}get cspSource(){const N=Re(this,t,"f").extensionLocation;if(N.scheme===T.Schemas.https||N.scheme===T.Schemas.http){let j=N.toString();return j.endsWith("/")||(j+="/"),j+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Re(this,c,"f")}set html(N){this.a(),Re(this,c,"f")!==N&&(Ye(this,c,N,"f"),Re(this,w,"f")&&!Re(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(N)&&(Ye(this,E,!0,"f"),Re(this,m,"f").report("Webview vscode-resource: uris",Re(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,D,"f").$setHtml(Re(this,M,"f"),this.b(N)))}get options(){return this.a(),Re(this,l,"f")}set options(N){this.a(),y.equals(Re(this,l,"f"),N)||Re(this,D,"f").$setOptions(Re(this,M,"f"),n(Re(this,t,"f"),Re(this,f,"f"),N)),Ye(this,l,N,"f")}async postMessage(N){if(Re(this,p,"f"))return!1;const j=(0,O.serializeWebviewMessage)(N,{serializeBuffersForPostMessage:Re(this,b,"f")});return Re(this,D,"f").$postMessage(Re(this,M,"f"),j.message,...j.buffers)}a(){if(Re(this,p,"f"))throw new Error("Webview is disposed")}b(N){if(!Re(this,w,"f"))return N;const j=Re(this,t,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,Z=Re(this,t,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Re(this,t,"f").extensionLocation.authority:void 0;return N.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,R,A,F,B,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(V,{isRemote:j,authority:Z}).toString();return`${R}${K}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,R,A,F,B,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(V,{isRemote:j,authority:Z}).toString();return`${R}${K}${z}`})}}e.ExtHostWebview=s,M=new WeakMap,D=new WeakMap,m=new WeakMap,v=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,l=new WeakMap,p=new WeakMap,E=new WeakMap,b=new WeakMap,w=new WeakMap,r=new WeakMap;function a(P){try{const N=(0,C.normalizeVersion)((0,C.parseVersion)(P.engines.vscode));return!!N&&N.majorBase>=1&&N.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function d(P){try{const N=(0,C.normalizeVersion)((0,C.parseVersion)(P.engines.vscode));return N?N.majorBase<1||N.majorBase===1&&N.minorBase<60:!1}catch{return!1}}class o{constructor(N,j,Z,G,R){this.c=j,this.d=Z,this.e=G,this.f=R,this.b=new Map,this.a=N.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(N,j,Z){const G=this.g(N);if(G){const{message:R}=(0,O.deserializeWebviewMessage)(j,Z.value);G._onMessageEmitter.fire(R)}}$onMissingCsp(N,j){this.e.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(N,j,Z){const G=new s(N,this.a,h(j),this.c,this.d,Z,this.f);return this.b.set(N,G),G._onDidDispose(()=>{this.b.delete(N)}),G}deleteWebview(N){this.b.delete(N)}g(N){return this.b.get(N)}}e.ExtHostWebviews=o;function u(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=u;function n(P,N,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||g(P,N)}}e.serializeWebviewOptions=n;function h(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(N=>L.URI.from(N))}}function g(P,N){return[...(N?.getWorkspaceFolders()||[]).map(j=>j.uri),P.extensionLocation]}}),define(Ie[227],Ce([1,0,20,222,7,13,22,2,8,60,52,4,6]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new M.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,d){const o=this.b(s,a.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const u=new v(a,d);return this.a.set(o,u),u}delete(s,a){const d=this.b(s,a.uri);this.a.delete(d)}b(s,a){return`${s}@@@${a}`}}var t;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(t||(t={}));class c{constructor(){this.a=new Map}addTextProvider(s,a,d){return this.b(0,s,a,d)}addCustomProvider(s,a,d){return this.b(1,s,a,d)}get(s){return this.a.get(s)}b(s,a,d,o){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:d,provider:o}),new m.Disposable(()=>this.a.delete(a))}}class l{constructor(s,a,d,o,u){this.d=a,this.f=d,this.g=o,this.h=u,this.b=new c,this.c=new f,this.a=s.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,d,o){const u=new y.DisposableStore;return E(d)?(u.add(this.b.addTextProvider(a,s,d)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(s),a,o.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(s))):(u.add(this.b.addCustomProvider(a,s,d)),p(d)&&u.add(d.onDidChangeCustomDocument(n=>{const h=this.i(a,n.document.uri);if(b(n)){const g=h.addEdit(n);this.a.$onDidEdit(n.document.uri,a,g,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(s),a,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(s))),m.Disposable.from(u,new m.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,d,o,u){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const h=O.URI.revive(s),g=await n.provider.openCustomDocument(h,{backupId:d,untitledDocumentData:o?.buffer},u);let P;return p(n.provider)&&this.f&&(P=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,g,P),{editable:p(n.provider)}}async $disposeCustomDocument(s,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const o=O.URI.revive(s),{document:u}=this.i(a,o);this.c.delete(a,u),u.dispose()}async $resolveCustomEditor(s,a,d,o,u,n){console.log("xxxx");const h=this.b.get(d);if(!h)throw new Error(`No provider found for '${d}'`);const g=S.ViewColumn.to(u),P=this.g.createNewWebview(a,o.contentOptions,h.extension),N=this.h.createNewWebviewPanel(a,d,o.title,g,o.options,P,!0),j=O.URI.revive(s);switch(h.type){case 1:{const{document:Z}=this.i(d,j);return h.provider.resolveCustomEditor(Z,N,n)}case 0:{const Z=this.d.getDocument(j);return h.provider.resolveCustomTextEditor(Z,N,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,d){this.i(a,s).disposeEdits(d)}async $onMoveCustomEditor(s,a,d){const o=this.b.get(d);if(!o)throw new Error(`No provider found for '${d}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(s);if(!u)throw new Error("No webview found");const n=O.URI.revive(a),h=this.d.getDocument(n);await o.provider.moveCustomTextEditor(h,u,i.CancellationToken.None)}async $undo(s,a,d,o){return this.i(a,s).undo(d,o)}async $redo(s,a,d,o){return this.i(a,s).redo(d,o)}async $revert(s,a,d){const o=this.i(a,s);await this.j(a).revertCustomDocument(o.document,d),o.disposeBackup()}async $onSave(s,a,d){const o=this.i(a,s);await this.j(a).saveCustomDocument(o.document,d),o.disposeBackup()}async $onSaveAs(s,a,d,o){const u=this.i(a,s);return this.j(a).saveCustomDocumentAs(u.document,O.URI.revive(d),o)}async $backup(s,a,d){const o=this.i(a,s),n=await this.j(a).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},d);return o.updateBackup(n),n.id}i(s,a){const d=this.c.get(s,O.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!p(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function p(r){return!!r.onDidChangeCustomDocument}function E(r){return typeof r.resolveCustomTextEditor=="function"}function b(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function w(r){const s=r.scheme===L.Schemas.file||r.scheme===L.Schemas.untitled?r.fsPath:r.toString();return(0,T.hash)(s)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[228],Ce([1,0,5,7,2,34,8,60,4,6]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";var M,D,m,v,f,t,c,l,p,E,b,w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends T.Disposable{constructor(u,n,h,g){super(),M.set(this,void 0),D.set(this,void 0),m.set(this,void 0),v.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,void 0),l.set(this,void 0),p.set(this,!0),E.set(this,void 0),b.set(this,!1),w.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,w,"f").event,r.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Re(this,r,"f").event,Ye(this,M,u,"f"),Ye(this,D,n,"f"),Ye(this,v,h,"f"),Ye(this,m,g.viewType,"f"),Ye(this,f,g.panelOptions,"f"),Ye(this,l,g.viewColumn,"f"),Ye(this,t,g.title,"f"),Ye(this,E,g.active,"f")}dispose(){Re(this,b,"f")||(Ye(this,b,!0,"f"),Re(this,w,"f").fire(),Re(this,D,"f").$disposeWebview(Re(this,M,"f")),Re(this,v,"f").dispose(),super.dispose())}get webview(){return this.c(),Re(this,v,"f")}get viewType(){return this.c(),Re(this,m,"f")}get title(){return this.c(),Re(this,t,"f")}set title(u){this.c(),Re(this,t,"f")!==u&&(Ye(this,t,u,"f"),Re(this,D,"f").$setTitle(Re(this,M,"f"),u))}get iconPath(){return this.c(),Re(this,c,"f")}set iconPath(u){this.c(),Re(this,c,"f")!==u&&(Ye(this,c,u,"f"),Re(this,D,"f").$setIconPath(Re(this,M,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Re(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Re(this,l,"f")=="number"&&Re(this,l,"f")<0))return Re(this,l,"f")}get active(){return this.c(),Re(this,E,"f")}get visible(){return this.c(),Re(this,p,"f")}_updateViewState(u){Re(this,b,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Ye(this,E,u.active,"f"),Ye(this,p,u.visible,"f"),Ye(this,l,u.viewColumn,"f"),Re(this,r,"f").fire({webviewPanel:this}))}reveal(u,n){this.c(),Re(this,D,"f").$reveal(Re(this,M,"f"),{viewColumn:typeof u>"u"?void 0:C.ViewColumn.from(u),preserveFocus:!!n})}c(){if(Re(this,b,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,D=new WeakMap,m=new WeakMap,v=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,l=new WeakMap,p=new WeakMap,E=new WeakMap,b=new WeakMap,w=new WeakMap,r=new WeakMap;class a{static c(){return(0,L.generateUuid)()}constructor(u,n,h){this.g=n,this.h=h,this.e=new Map,this.f=new Map,this.d=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,h,g,P={}){const N=typeof g=="object"?g.viewColumn:g,j={viewColumn:C.ViewColumn.from(N),preserveFocus:typeof g=="object"&&!!g.preserveFocus},Z=(0,O.shouldSerializeBuffersForPostMessage)(u),G=a.c();this.d.$createWebviewPanel((0,O.toExtensionData)(u),G,n,{title:h,panelOptions:d(P),webviewOptions:(0,O.serializeWebviewOptions)(u,this.h,P),serializeBuffersForPostMessage:Z},j);const R=this.g.createNewWebview(G,P,u);return this.createNewWebviewPanel(G,n,h,N,P,R,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((h,g)=>{const P=u[h],N=u[g];return P.active?1:N.active?-1:+P.visible-+N.visible});for(const h of n){const g=this.getWebviewPanel(h);if(!g)continue;const P=u[h];g._updateViewState({active:P.active,visible:P.visible,viewColumn:C.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,n,h){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:h,extension:u}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,h,g){const P=this.f.get(n);if(!P)throw new Error(`No serializer found for '${n}'`);const{serializer:N,extension:j}=P,Z=this.g.createNewWebview(u,h.webviewOptions,j),G=this.createNewWebviewPanel(u,n,h.title,g,h.panelOptions,Z,h.active);await N.deserializeWebviewPanel(G,h.state)}createNewWebviewPanel(u,n,h,g,P,N,j){const Z=new s(u,this.d,N,{viewType:n,title:h,viewColumn:g,panelOptions:P,active:j});return this.e.set(u,Z),Z}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=a;function d(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[229],Ce([1,0,5,7,60,8,4,6]),function(ee,e,i,T,y,L,C,O){"use strict";var S,k,M,D,m,v,f,t,c,l,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends T.Disposable{constructor(r,s,a,d,o,u){super(),S.set(this,void 0),k.set(this,void 0),M.set(this,void 0),D.set(this,void 0),m.set(this,!1),v.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,void 0),l.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Re(this,l,"f").event,p.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,p,"f").event,Ye(this,M,a,"f"),Ye(this,f,d,"f"),Ye(this,S,r,"f"),Ye(this,k,s,"f"),Ye(this,D,o,"f"),Ye(this,v,u,"f")}dispose(){Re(this,m,"f")||(Ye(this,m,!0,"f"),Re(this,p,"f").fire(),Re(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Re(this,f,"f")}set title(r){this.a(),Re(this,f,"f")!==r&&(Ye(this,f,r,"f"),Re(this,k,"f").$setWebviewViewTitle(Re(this,S,"f"),r))}get description(){return this.a(),Re(this,t,"f")}set description(r){this.a(),Re(this,t,"f")!==r&&(Ye(this,t,r,"f"),Re(this,k,"f").$setWebviewViewDescription(Re(this,S,"f"),r))}get visible(){return Re(this,v,"f")}get webview(){return Re(this,D,"f")}get viewType(){return Re(this,M,"f")}_setVisible(r){r===Re(this,v,"f")||Re(this,m,"f")||(Ye(this,v,r,"f"),Re(this,l,"f").fire())}get badge(){return this.a(),Re(this,c,"f")}set badge(r){this.a(),!(r?.value===Re(this,c,"f")?.value&&r?.tooltip===Re(this,c,"f")?.tooltip)&&(Ye(this,c,L.ViewBadge.from(r),"f"),Re(this,k,"f").$setWebviewViewBadge(Re(this,S,"f"),r))}show(r){this.a(),Re(this,k,"f").$show(Re(this,S,"f"),!!r)}a(){if(Re(this,m,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,M=new WeakMap,D=new WeakMap,m=new WeakMap,v=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,l=new WeakMap,p=new WeakMap;class b{constructor(r,s){this.d=s,this.b=new Map,this.c=new Map,this.a=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,a,d){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:a,extension:r}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(r),s,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(r)}),new O.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,a,d,o){const u=this.b.get(s);if(!u)throw new Error(`No view provider found for '${s}'`);const{provider:n,extension:h}=u,g=this.d.createNewWebview(r,{},h),P=new E(r,this.a,s,a,g,!0);this.c.set(r,P),await n.resolveWebviewView(P,{state:d},o)}async $onDidChangeWebviewViewVisibility(r,s){this.e(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.e(r);this.c.delete(r),s.dispose(),this.d.deleteWebview(r)}e(r){const s=this.c.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=b}),define(Ie[102],Ce([1,0,5,4,2,13,10,3,15]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class rn{get state(){return this.d}constructor(D){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=rn.a,this.b=D.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,m){let v;if(typeof D=="string"){v=D;try{D=y.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,v,m)}async asExternalUri(D,m){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(D,m);return y.URI.from(v)}};k.a={focused:!0},k=qe([Ve(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(Ie[230],Ce([1,0,200,27,15]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(O,S){super(O,S)}f(O,S,k){S.apply(console,k)}};L=qe([Ve(0,y.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ie[231],Ce([1,0,14,24,20,11,5,7,123,194,43]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(P,N){try{return JSON.stringify(P,N)}catch{return"null"}}const v="$$ref$$",f={[v]:-1};class t{constructor(N,j){this.jsonString=N,this.referencedBuffers=j}}function c(P,N=null,j=!1){const Z=[];return{jsonString:(j?m:JSON.stringify)(P,(R,A)=>{if(typeof A>"u")return f;if(typeof A=="object"){if(A instanceof T.VSBuffer){const F=Z.push(A)-1;return{[v]:F}}if(N)return N(R,A)}return A}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=c;function l(P,N,j){return JSON.parse(P,(Z,G)=>{if(G){const R=G[v];if(typeof R=="number")return N[R];if(j&&G.$mid===1)return j.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=l;function p(P,N){return JSON.stringify(P,N)}function E(P){return P?(N,j)=>j&&j.$mid===1?P.transformOutgoing(j):j:null}var b;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends O.Disposable{constructor(N,j=null,Z=null){super(),this[D]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=j,this.g=Z,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,R=M.ProxyIdentifier.count;G<R;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(G=>this.G(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(N=>{this.s[N].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(N){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(N){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(N){this.t!==N&&(this.t=N,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(N){return this.g?(0,S.transformIncomingURIs)(N,this.g):N}getProxy(N){const{nid:j,sid:Z}=N;return this.l[j]||(this.l[j]=this.F(j,Z)),this.l[j]}F(N,j){const Z={get:(G,R)=>(typeof R=="string"&&!G[R]&&R.charCodeAt(0)===36&&(G[R]=(...A)=>this.O(N,R,A)),R===a?j:G[R])};return new Proxy(Object.create(null),Z)}set(N,j){return this.k[N.nid]=j,j}assertRegistered(N){for(let j=0,Z=N.length;j<Z;j++){const G=N[j];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}G(N){if(this.j)return;const j=N.byteLength,Z=o.read(N,0),G=Z.readUInt8(),R=Z.readUInt32();switch(G){case 1:case 2:{let{rpcId:A,method:F,args:B}=n.deserializeRequestJSONArgs(Z);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(j,R,A,F,B,G===2);break}case 3:case 4:{let{rpcId:A,method:F,args:B}=n.deserializeRequestMixedArgs(Z);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(j,R,A,F,B,G===4);break}case 5:{this.f?.logIncoming(j,R,0,"ack"),this.z(R);break}case 6:{this.I(j,R);break}case 7:{this.J(j,R,void 0);break}case 9:{let A=n.deserializeReplyOKJSON(Z);this.g&&(A=(0,S.transformIncomingURIs)(A,this.g)),this.J(j,R,A);break}case 10:{const A=n.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(j,R,A);break}case 8:{const A=n.deserializeReplyOKVSBuffer(Z);this.J(j,R,A);break}case 11:{let A=n.deserializeReplyErrError(Z);this.g&&(A=(0,S.transformIncomingURIs)(A,this.g)),this.L(j,R,A);break}case 12:{this.L(j,R,void 0);break}default:console.error("received unexpected message"),console.error(N)}}H(N,j,Z,G,R,A){this.f?.logIncoming(N,j,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(Z)}.${G}(`,R);const F=String(j);let B,z;if(A){const K=new y.CancellationTokenSource;R.push(K.token),B=this.M(Z,G,R),z=()=>K.cancel()}else B=this.M(Z,G,R),z=r;this.p[F]=z;const V=n.serializeAcknowledged(j);this.f?.logOutgoing(V.byteLength,j,1,"ack"),this.c.send(V),B.then(K=>{delete this.p[F];const ie=n.serializeReplyOK(j,K,this.h);this.f?.logOutgoing(ie.byteLength,j,1,"reply:",K),this.c.send(ie)},K=>{delete this.p[F];const ie=n.serializeReplyErr(j,K);this.f?.logOutgoing(ie.byteLength,j,1,"replyErr:",K),this.c.send(ie)})}I(N,j){this.f?.logIncoming(N,j,1,"receiveCancel");const Z=String(j);this.p[Z]?.()}J(N,j,Z){this.f?.logIncoming(N,j,0,"receiveReply:",Z);const G=String(j);if(!this.s.hasOwnProperty(G))return;const R=this.s[G];delete this.s[G],R.resolveOk(Z)}L(N,j,Z){this.f?.logIncoming(N,j,0,"receiveReplyErr:",Z);const G=String(j);if(!this.s.hasOwnProperty(G))return;const R=this.s[G];delete this.s[G];let A;Z&&(Z.$isError?(A=new Error,A.name=Z.name,A.message=Z.message,A.stack=Z.stack):A=Z),R.resolveErr(A)}M(N,j,Z){try{return Promise.resolve(this.N(N,j,Z))}catch(G){return Promise.reject(G)}}N(N,j,Z){const G=this.k[N];if(!G)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(N));const R=G[j];if(typeof R!="function")throw new Error("Unknown method "+j+" on actor "+(0,M.getStringIdentifierForProxy)(N));return R.apply(G,Z)}O(N,j,Z){if(this.j)return new k.CanceledLazyPromise;let G=null;if(Z.length>0&&y.CancellationToken.isCancellationToken(Z[Z.length-1])&&(G=Z.pop()),G&&G.isCancellationRequested)return Promise.reject(L.canceled());const R=n.serializeRequestArguments(Z,this.h),A=++this.m,F=String(A),B=new k.LazyPromise;G&&G.onCancellationRequested(()=>{const V=n.serializeCancel(A);this.f?.logOutgoing(V.byteLength,A,0,"cancel"),this.c.send(n.serializeCancel(A))}),this.s[F]=B,this.y(A);const z=n.serializeRequest(A,N,j,R,!!G);return this.f?.logOutgoing(z.byteLength,A,0,`request: ${(0,M.getStringIdentifierForProxy)(N)}.${j}(`,Z),this.c.send(z),B}}e.RPCProtocol=d,D=s,d.a=3*1e3;class o{static alloc(N,j,Z){const G=new o(T.VSBuffer.alloc(Z+1+4),0);return G.writeUInt8(N),G.writeUInt32(j),G}static read(N,j){return new o(N,j)}get buffer(){return this.a}constructor(N,j){this.a=N,this.b=j}static sizeUInt8(){return 1}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+N).toString();return this.b+=N,Z}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+N).toString();return this.b+=N,Z}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+N);return this.b+=N,j}static sizeMixedArray(N){let j=0;j+=1;for(let Z=0,G=N.length;Z<G;Z++){const R=N[Z];switch(j+=1,R.type){case 1:j+=this.sizeLongString(R.value);break;case 2:j+=this.sizeVSBuffer(R.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(R.value);for(let A=0;A<R.buffers.length;++A)j+=this.sizeVSBuffer(R.buffers[A]);break;case 4:break}}return j}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let j=0,Z=N.length;j<Z;j++){const G=N[j];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let R=0;R<G.buffers.length;++R)this.writeBuffer(G.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const j=new Array(N);for(let Z=0;Z<N;Z++)switch(this.readUInt8()){case 1:j[Z]=this.readLongString();break;case 2:j[Z]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),A=this.readLongString(),F=[];for(let B=0;B<R;++B)F.push(this.readVSBuffer());j[Z]=new M.SerializableObjectWithBuffers(l(A,F,null));break}case 4:j[Z]=void 0;break}return j}}o.sizeUInt32=4;var u;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(u||(u={}));class n{static a(N){for(let j=0,Z=N.length;j<Z;j++)if(N[j]instanceof T.VSBuffer||N[j]instanceof M.SerializableObjectWithBuffers||typeof N[j]>"u")return!0;return!1}static serializeRequestArguments(N,j){if(this.a(N)){const Z=[];for(let G=0,R=N.length;G<R;G++){const A=N[G];if(A instanceof T.VSBuffer)Z[G]={type:2,value:A};else if(typeof A>"u")Z[G]={type:4};else if(A instanceof M.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:B}=c(A.value,j);Z[G]={type:3,value:T.VSBuffer.fromString(F),buffers:B}}else Z[G]={type:1,value:T.VSBuffer.fromString(p(A,j))}}return{type:1,args:Z}}return{type:0,args:p(N,j)}}static serializeRequest(N,j,Z,G,R){switch(G.type){case 0:return this.b(N,j,Z,G.args,R);case 1:return this.c(N,j,Z,G.args,R)}}static b(N,j,Z,G,R){const A=T.VSBuffer.fromString(Z),F=T.VSBuffer.fromString(G);let B=0;B+=o.sizeUInt8(),B+=o.sizeShortString(A),B+=o.sizeLongString(F);const z=o.alloc(R?2:1,N,B);return z.writeUInt8(j),z.writeShortString(A),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(N){const j=N.readUInt8(),Z=N.readShortString(),G=N.readLongString();return{rpcId:j,method:Z,args:JSON.parse(G)}}static c(N,j,Z,G,R){const A=T.VSBuffer.fromString(Z);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(A),F+=o.sizeMixedArray(G);const B=o.alloc(R?4:3,N,F);return B.writeUInt8(j),B.writeShortString(A),B.writeMixedArray(G),B.buffer}static deserializeRequestMixedArgs(N){const j=N.readUInt8(),Z=N.readShortString(),G=N.readMixedArray(),R=new Array(G.length);for(let A=0,F=G.length;A<F;A++){const B=G[A];typeof B=="string"?R[A]=JSON.parse(B):R[A]=B}return{rpcId:j,method:Z,args:R}}static serializeAcknowledged(N){return o.alloc(5,N,0).buffer}static serializeCancel(N){return o.alloc(6,N,0).buffer}static serializeReplyOK(N,j,Z){if(typeof j>"u")return this.d(N);if(j instanceof T.VSBuffer)return this.e(N,j);if(j instanceof M.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:R}=c(j.value,Z,!0);return this.g(N,G,R)}else return this.f(N,m(j,Z))}static d(N){return o.alloc(7,N,0).buffer}static e(N,j){let Z=0;Z+=o.sizeVSBuffer(j);const G=o.alloc(8,N,Z);return G.writeVSBuffer(j),G.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,j){const Z=T.VSBuffer.fromString(j);let G=0;G+=o.sizeLongString(Z);const R=o.alloc(9,N,G);return R.writeLongString(Z),R.buffer}static g(N,j,Z){const G=T.VSBuffer.fromString(j);let R=0;R+=o.sizeUInt32,R+=o.sizeLongString(G);for(const F of Z)R+=o.sizeVSBuffer(F);const A=o.alloc(10,N,R);A.writeUInt32(Z.length),A.writeLongString(G);for(const F of Z)A.writeBuffer(F);return A.buffer}static deserializeReplyOKJSON(N){const j=N.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(N,j){const Z=N.readUInt32(),G=N.readLongString(),R=[];for(let A=0;A<Z;++A)R.push(N.readVSBuffer());return new M.SerializableObjectWithBuffers(l(G,R,j))}static serializeReplyErr(N,j){const Z=j?m(L.transformErrorForSerialization(j),null):void 0;if(typeof Z!="string")return this.h(N);const G=T.VSBuffer.fromString(Z);let R=0;R+=o.sizeLongString(G);const A=o.alloc(11,N,R);return A.writeLongString(G),A.buffer}static deserializeReplyErrError(N){const j=N.readLongString();return JSON.parse(j)}static h(N){return o.alloc(12,N,0).buffer}}var h;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var g;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[232],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const C=O=>{self.removeEventListener("message",C);const S=O.data;Object.defineProperties(self,{postMessage:{value(k,M){S.postMessage(k,M)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(L,C,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${C}'))`,k=new Blob([S],{type:"application/javascript"}),M=URL.createObjectURL(k),D=new MessageChannel,m=M,v={type:"_newWorker",id:m,port:D.port2,url:M,options:O};L(v,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(M),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(f){D.port1.onmessage=f}},onmessageerror:{get(){return D.port1.onmessageerror},set(f){D.port1.onmessageerror=f}}}),D.port1.addEventListener("messageerror",f=>{const t=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(t)}),D.port1.addEventListener("message",f=>{const t=new MessageEvent("message",{data:f.data});this.dispatchEvent(t)}),D.port1.start()}}e.NestedWorker=T}),define(Ie[233],Ce([1,0,5,30,41,3,36,11,14]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(t=>f.push(t)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}T.Registry.add(e.Extensions.OutputChannels,new M);function D(v,f,t,c,l){return(0,S.createCancelablePromise)(async p=>{await(0,C.whenProviderRegistered)(t,c);const E=T.Registry.as(e.Extensions.OutputChannels);try{await m(t,1,c,l,p),E.registerChannel({id:v,label:f,file:t,log:!0})}catch(b){(0,O.isCancellationError)(b)||l.error("Error while registering log channel",t.toString(),(0,O.getErrorMessage)(b))}})}e.registerLogChannel=D;async function m(v,f,t,c,l){if(!await t.exists(v)){if(l.isCancellationRequested)throw new O.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");c.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",v.toString()),await(0,S.timeout)(1e3,l),await m(v,f+1,t,c,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ie[103],Ce([1,0,4,3,15,26,12,233,58,27,37,117,24,9,36,5,7]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,r,s,a,d){super(),this.id=w,this.name=r,this.m=s,this.n=a,this.extension=d,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Clear,w)}replace(w){const r=this.k;this.info(w),this.n.$update(this.id,O.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(w,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:r))}hide(){this.n.$close(this.id)}g(w,r){this.k+=m.VSBuffer.fromString(r).byteLength,(0,C.log)(this.m,w,r),this.visible&&(this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends l{appendLine(w){this.append(w)}}let E=class{constructor(w,r,s,a,d,o){this.i=r,this.j=s,this.k=a,this.l=d,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(w,r,s){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof r=="object"&&r.log,d=(0,v.isString)(r)?r:void 0;if((0,v.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const u=this.i.environment.extensionLogLevel?.find(([h])=>L.ExtensionIdentifier.equals(s.identifier,h))?.[1];u&&(o=(0,C.parseLogLevel)(u));const n=a?this.o(w,o,s):this.n(w,d,s);return n.then(h=>{this.g.set(h.id,h),h.visible=h.id===this.h}),a?this.r(w,o??this.m.getLevel(),n):this.q(w,n)}async n(w,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,r,s.identifier.value);return new l(u,w,o,this.a,s)}async o(w,r,s){const a=await this.p(s),d=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(d,{name:w},r),u=await this.a.$register(w,d,!0,void 0,s.identifier.value);return new p(u,w,o,this.a,s)}p(w){let r=this.d.get(w.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return r}q(w,r){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return w},append(d){a(),r.then(o=>o.append(d))},appendLine(d){a(),r.then(o=>o.appendLine(d))},clear(){a(),r.then(d=>d.clear())},replace(d){a(),r.then(o=>o.replace(d))},show(d,o){a(),r.then(u=>u.show(d,o))},hide(){a(),r.then(d=>d.hide())},dispose(){s=!0,r.then(d=>d.dispose())}}}r(w,r,s){const a=new c.DisposableStore,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},o=a.add(new t.Emitter);return s.then(u=>{a.add(u),a.add(u.onDidChangeLogLevel(n=>{r=n,o.fire(n)}))}),{...this.q(w,s),get logLevel(){return r},onDidChangeLogLevel:o.event,trace(u,...n){d(),s.then(h=>h.trace(u,...n))},debug(u,...n){d(),s.then(h=>h.debug(u,...n))},info(u,...n){d(),s.then(h=>h.info(u,...n))},warn(u,...n){d(),s.then(h=>h.warn(u,...n))},error(u,...n){d(),s.then(h=>h.error(u,...n))},dispose(){a.dispose()}}}};E=qe([Ve(0,y.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,M.IExtHostFileSystemInfo),Ve(4,C.ILoggerService),Ve(5,C.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ie[234],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ie[235],Ce([1,0,39,13,19,21,22,2,3,166,51,181,234]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let v=class sn{constructor(t,c,l,p){this.d=t,this.e=c,this.f=l,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(p=>this.h(t,p,c)):this.h(t,c,l)}h(t,c,l){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,C.basename)(t),c===1):!0}get defaultUriScheme(){return sn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,c){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(c.getWorkspace());if(l)return l;const p=c.getWorkspace().folders[0];if(p)return p.uri.scheme;const E=c.getWorkspace().configuration;return E?E.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?y.win32:y.posix)}async fileURI(t){let c="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const p=t.indexOf("/",2);p===-1?(c=t.substring(2),t="/"):(c=t.substring(2,p),t=t.substring(p)||"/")}return O.URI.from({scheme:T.Schemas.file,authority:c,path:t,query:"",fragment:""})}};v=qe([Ve(1,m.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,M.IWorkspaceContextService)],v),e.AbstractPathService=v}),define(Ie[104],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(C,O){this.line=C,this.character=O}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,O){return new i(0,0)}with(C){return new i(0,0)}}e.Position=i;class T{constructor(C,O,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(C,O),this.end=new i(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[44],Ce([1,0,16,35,23,39,10,3,19,11,104,14]),function(ee,e,i,T,y,L,C,O,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",f=(m.length+v.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var t;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function p(ue){return!!ue.resource}e.isFileMatch=p;function E(ue){return!!ue.message}e.isProgressMessage=E;var b;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(b=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=w;class r{constructor(re,se,le){this.ranges=se;const _=Array.isArray(se)?se:[se];if(le&&le.matchLines===1&&s(_)){re=(0,C.getNLines)(re,le.matchLines);let me="",we=0,Me=0;const We=Math.floor(le.charsPerLine/5),Qe=[];for(const Te of _){const De=Math.max(Te.startColumn-We,0),ke=Te.startColumn+le.charsPerLine;if(De>Me+We+f){const oe=m+(De-Me)+v;me+=oe+re.slice(De,ke),we+=De-(Me+oe.length)}else me+=re.slice(Me,ke);Qe.push(new d(0,Te.startColumn-we,Te.endColumn-we)),Me=ke}this.preview={text:me,matches:Array.isArray(this.ranges)?Qe:Qe[0]}}else{const me=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:re,matches:(0,i.mapArrayOrNot)(se,we=>new a(we.startLineNumber-me,we.startColumn,we.endLineNumber-me,we.endColumn))}}}}e.TextSearchMatch=r;function s(ue){const re=ue[0].startLineNumber;for(const se of ue)if(se.startLineNumber!==re||se.endLineNumber!==re)return!1;return!0}class a{constructor(re,se,le,_){this.startLineNumber=re,this.startColumn=se,this.endLineNumber=le,this.endColumn=_}}e.SearchRange=a;class d extends a{constructor(re,se,le){super(re,se,re,le)}}e.OneLineRange=d;var o;(function(ue){ue.List="list",ue.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var u;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(ue,re=!0){const se=ue&&ue.files&&ue.files.exclude,le=re&&ue&&ue.search&&ue.search.exclude;if(!se&&!le)return;if(!se||!le)return se||le;let _=Object.create(null);return _=y.mixin(_,y.deepClone(se)),_=y.mixin(_,y.deepClone(le),!0),_}e.getExcludes=n;function h(ue,re){return ue.excludePattern&&T.match(ue.excludePattern,re)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.match(ue.includePattern,re)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(se=>{const le=se.folder.fsPath;if(L.isEqualOrParent(re,le)){const _=S.relative(le,re);return!se.includePattern||!!T.match(se.includePattern,_)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(re,se){super(re),this.code=se}}e.SearchError=P;function N(ue){const re=ue.message;if((0,k.isCancellationError)(ue))return new P(re,g.canceled);try{const se=JSON.parse(re);return new P(se.message,se.code)}catch{return new P(re,g.other)}}e.deserializeSearchError=N;function j(ue){const re={message:ue.message,code:ue.code};return new Error(JSON.stringify(re))}e.serializeSearchError=j;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function G(ue){return ue.type==="success"}e.isSerializedSearchSuccess=G;function R(ue){return!!ue.path}e.isSerializedFileMatch=R;function A(ue,re){const se=ue.searchPath?ue.searchPath:ue.relativePath;return(0,C.fuzzyContains)(se,re)}e.isFilePatternMatch=A;class F{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function B(ue,re){const se={...ue||{},...re||{}};return Object.keys(se).filter(le=>{const _=se[le];return typeof _=="boolean"&&_})}e.resolvePatternsForProvider=B;class z{constructor(re,se){this.c=null,this.a={...re.excludePattern||{},...se.excludePattern||{}},this.b=T.parse(this.a);let le=re.includePattern;se.includePattern&&(le?le={...le,...se.includePattern}:le=se.includePattern),le&&(this.c=T.parse(le))}matchesExcludesSync(re,se,le){return!!(this.b&&this.b(re,se,le))}includedInQuerySync(re,se,le){return!(this.b&&this.b(re,se,le)||this.c&&!this.c(re,se,le))}includedInQuery(re,se,le){const _=this.b(re,se,le),me=()=>this.c?!!this.c(re,se,le):!0;return(0,D.isThenable)(_)?_.then(we=>we?!1:me()):me()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(ue){for(const re in ue)if(typeof ue[re]!="boolean")return!0;return!1}function K(ue){if(!ue)return;let re;return se=>(re||(re=(ue()||Promise.resolve([])).then(le=>le?ge(le):{})),re.then(le=>!!le[se]))}e.hasSiblingPromiseFn=K;function ie(ue){if(!ue)return;let re;return se=>{if(!re){const le=ue();re=le?ge(le):{}}return!!re[se]}}e.hasSiblingFn=ie;function ge(ue){const re={};for(const se of ue)re[se]=!0;return re}}),define(Ie[31],Ce([1,0,16,14,20,5,7,46,13,111,22,10,9,2,140,3,12,155,51,37,27,15,8,6,53,44,4]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w,r,s,a,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(G,R,A){return new M.ExtUri(F=>P(F,A)).isEqual(G,R)}function n(G,R,A){return u(G.uri,R.uri,A)?0:(0,D.compare)(G.uri.toString(),R.uri.toString())}function h(G,R,A){return G.index!==R.index?G.index<R.index?-1:1:u(G.uri,R.uri,A)?(0,D.compare)(G.name,R.name):(0,D.compare)(G.uri.toString(),R.uri.toString())}function g(G,R,A,F){const B=G.slice(0).sort((V,K)=>A(V,K,F)),z=R.slice(0).sort((V,K)=>A(V,K,F));return(0,i.delta)(B,z,(V,K)=>A(V,K,F))}function P(G,R){const A=R.getCapabilities(G.scheme);return!(A&&A&1024)}class N extends p.Workspace{static toExtHostWorkspace(R,A,F,B){if(!R)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:K,configuration:ie,transient:ge,isUntitled:ue}=R,re=[],se=A;A?K.forEach((we,Me)=>{const We=v.URI.revive(we.uri),Qe=N.e(F||A,We,B);Qe?(Qe.name=we.name,Qe.index=we.index,re.push(Qe)):re.push({uri:We,name:we.name,index:Me})}):re.push(...K.map(({uri:we,name:Me,index:We})=>({uri:v.URI.revive(we),name:Me,index:We}))),re.sort((we,Me)=>we.index<Me.index?-1:1);const le=new N(z,V,re,!!ge,ie?v.URI.revive(ie):null,!!ue,we=>P(we,B)),{added:_,removed:me}=g(se?se.workspaceFolders:[],le.workspaceFolders,n,B);return{workspace:le,added:_,removed:me}}static e(R,A,F){for(let B=0;B<R.folders.length;B++){const z=R.workspaceFolders[B];if(u(z.uri,A,F))return z}}constructor(R,A,F,B,z,V,K){super(R,F.map(ie=>new p.WorkspaceFolder(ie)),B,z,K),this.s=A,this.t=V,this.o=[],this.q=O.TernarySearchTree.forUris(K),F.forEach(ie=>{this.o.push(ie),this.q.set(ie.uri,ie)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(R,A){return A&&this.q.get(R)&&(R=(0,M.dirname)(R)),this.q.findSubstr(R)}resolveWorkspaceFolder(R){return this.q.get(R)}}let j=class{constructor(R,A,F,B,z){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=F,this.s=z,this.h=new k.Counter,this.j=new T.Barrier,this.n=R.getProxy(o.MainContext.MainThreadWorkspace),this.o=R.getProxy(o.MainContext.MainThreadMessageService);const V=A.workspace;this.k=V?new N(V.id,V.name,[],!!V.transient,V.configuration?v.URI.revive(V.configuration):null,!!V.isUntitled,K=>P(K,F)):void 0}$initializeWorkspace(R,A){this.u=A,this.$acceptWorkspaceData(R),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?v.URI.from({scheme:S.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(R,A,F,...B){const z=[];if(Array.isArray(B)&&B.forEach(ue=>{v.URI.isUri(ue.uri)&&!z.some(re=>u(re.uri,ue.uri,this.q))&&z.push({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri)})}),this.l||[A,F].some(ue=>typeof ue!="number"||ue<0)||F===0&&z.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(A+F>V.length)return!1;const K=V.slice(0);K.splice(A,F,...z.map(ue=>({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<K.length;ue++){const re=K[ue];if(K.some((se,le)=>le!==ue&&u(re.uri,se.uri,this.q)))return!1}K.forEach((ue,re)=>ue.index=re);const{added:ie,removed:ge}=g(V,K,h,this.q);if(ie.length===0&&ge.length===0)return!1;if(this.n){const ue=R.displayName||R.name;this.n.$updateWorkspaceFolders(ue,A,F,z).then(void 0,re=>{this.l=void 0;const se={source:{identifier:R.identifier,label:R.displayName||R.name}};this.o.$showMessage(l.Severity.Error,(0,f.localize)(0,null,ue,re.toString()),se,[])})}return this.x(K),!0}getWorkspaceFolder(R,A){if(!!this.w)return this.w.getWorkspaceFolder(R,A)}async getWorkspaceFolder2(R,A){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(R,A)}async resolveWorkspaceFolder(R){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(R)}getPath(){if(!this.w)return;const{folders:R}=this.w;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,A){let F,B="";if(typeof R=="string"?(F=v.URI.file(R),B=R):typeof R<"u"&&(F=R,B=R.fsPath),!F)return B;const z=this.getWorkspaceFolder(F,!0);if(!z)return B;typeof A>"u"&&this.w&&(A=this.w.folders.length>1);let V=(0,M.relativePath)(z.uri,F);return A&&z.name&&(V=`${z.name}/${V}`),V}x(R){this.w&&(this.l=N.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:R,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:A,added:F,removed:B}=N.toExtHostWorkspace(R,this.k,this.l,this.q);this.k=A||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(R,A,F,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let V;if(A===null?V=!1:A&&(typeof A=="string"?V=A:V=A.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:ie}=Z(r.GlobPattern.from(R));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(K),(0,m.withUndefinedAsNull)(ie),(0,m.withUndefinedAsNull)(V),(0,m.withUndefinedAsNull)(F),z).then(ge=>Array.isArray(ge)?ge.map(ue=>v.URI.revive(ue)):[])}async findTextInFiles(R,A,F,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),K=typeof A.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:ie,folder:ge}=Z(r.GlobPattern.from(A.include)),ue=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,re={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:K,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:ie,excludePattern:ue},se=!1;if(this.t[V]=le=>{if(se)return;const _=v.URI.revive(le.resource);le.results.forEach(me=>{(0,d.resultIsMatch)(me)?F({uri:_,preview:{text:me.preview.text,matches:(0,i.mapArrayOrNot)(me.preview.matches,we=>new s.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,i.mapArrayOrNot)(me.ranges,we=>new s.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:_,text:me.text,lineNumber:me.lineNumber})})},z.isCancellationRequested)return{};try{const le=await this.n.$startTextSearch(R,(0,m.withUndefinedAsNull)(ge),re,V,z);return delete this.t[V],le||{}}catch(le){throw delete this.t[V],le}}$handleTextSearchResult(R,A){this.t[A]?.(R)}saveAll(R){return this.n.$saveAll(R)}resolveProxy(R){return this.n.$resolveProxy(R)}get trusted(){return this.u}requestWorkspaceTrust(R){return this.n.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(R,A){if(this.v.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.v.set(R,A);const F=this.s.transformOutgoingScheme(R),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,F),(0,C.toDisposable)(()=>{this.v.delete(R),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(R,A){this.g.info("Getting edit session identifier for workspaceFolder",R);const F=await this.resolveWorkspaceFolder(v.URI.revive(R));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const z=await B.provideEditSessionIdentity(F,A);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(R,A,F,B){this.g.info("Getting edit session identifier for workspaceFolder",R);const z=await this.resolveWorkspaceFolder(v.URI.revive(R));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const K=await V.provideEditSessionIdentityMatch?.(A,F,B);if(this.g.info("Provider returned edit session identifier match result: ",K),!!K)return K}};j=qe([Ve(0,w.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,c.ILogService),Ve(4,a.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function Z(G){let R,A;return G&&(typeof G=="string"?R=G:(R=G.pattern,A=v.URI.revive(G.baseUri))),{includePattern:R,folder:A}}}),define(Ie[32],Ce([1,0,23,5,31,4,6,158,90,9,14,3,15,12,2]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(s,a){if(a){const d=a.split(".");let o=s;for(let u=0;o&&u<d.length;u++)o=o[d[u]];return o}}function c(s){return s instanceof f.URI}function l(s){return s&&s.uri instanceof f.URI&&s.languageId&&typeof s.languageId=="string"}function p(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function E(s){return s&&s.uri instanceof f.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function b(s){if(c(s))return{resource:s};if(l(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(p(s))return{overrideIdentifier:s.languageId};if(E(s))return{resource:s.uri};if(s===null)return{resource:null}}let w=class{constructor(a,d,o){this.a=a.getProxy(L.MainContext.MainThreadConfiguration),this.c=d,this.b=o,this.d=new M.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new r(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(a,d))}};w=qe([Ve(0,m.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,v.ILogService)],w),e.ExtHostConfiguration=w;class r{constructor(a,d,o,u){this.a=new T.Emitter,this.b=a,this.f=u,this.c=d,this.e=O.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=O.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,o))}getConfiguration(a,d,o){const u=b(d)||{},n=this.g(a?t(this.e.getValue(void 0,u,this.c.workspace),a):this.e.getValue(void 0,u,this.c.workspace));a&&this.h(a,u,o?.identifier);function h(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(P){return typeof t(n,P)<"u"},get:(P,N)=>{this.h(a?`${a}.${P}`:P,u,o?.identifier);let j=t(n,P);if(typeof j>"u")j=N;else{let Z;const G=(R,A)=>{let F;const B=()=>{Z=Z||(0,i.deepClone)(n),F=F||t(Z,A)};return(0,k.isObject)(R)?new Proxy(R,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return B(),()=>F;if(Z)return F=F||t(Z,A),F[V];const K=z[V];return typeof V=="string"?G(K,`${A}.${V}`):K},set:(z,V,K)=>(B(),F&&(F[V]=K),!0),deleteProperty:(z,V)=>(B(),F&&delete F[V],!0),defineProperty:(z,V,K)=>(B(),F&&Object.defineProperty(F,V,K),!0)}):R};j=G(j,P)}return j},update:(P,N,j,Z)=>{P=a?`${a}.${P}`:P;const G=h(j);return N!==void 0?this.b.$updateConfigurationOption(G,P,N,u,Z):this.b.$removeConfigurationOption(G,P,u,Z)},inspect:P=>{P=a?`${a}.${P}`:P;const N=this.e.inspect(P,u,this.c.workspace);if(N)return{key:P,defaultValue:(0,i.deepClone)(N.policy?.value??N.default?.value),globalValue:(0,i.deepClone)(N.user?.value??N.application?.value),workspaceValue:(0,i.deepClone)(N.workspace?.value),workspaceFolderValue:(0,i.deepClone)(N.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(N.default?.override),globalLanguageValue:(0,i.deepClone)(N.user?.override??N.application?.override),workspaceLanguageValue:(0,i.deepClone)(N.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(N.workspaceFolder?.override),languageIds:(0,i.deepClone)(N.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(g,n,!1),Object.freeze(g)}g(a){const d=o=>(0,k.isObject)(o)?new Proxy(o,{get:(u,n)=>d(u[n]),set:(u,n,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return d(a)}h(a,d,o){const u=S.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=o?`[${o.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const o=new O.ConfigurationChangeEvent(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,n)=>o.affectsConfiguration(u,b(n))})}k(a){return a.reduce((d,o)=>(d.set(o[0],o[1]),d),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[105],Ce([1,0,2,14,5,4,6,31,56,32,20,59,15,27,3,13,21,12,73,193,11]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(R){function A(B){if(B!=null)return B}R.from=A;function F(B){if(B!=null)return B}R.to=F})(r||(r={}));var s;(function(R){function A(B){if(B!=null)return B}R.from=A;function F(B){if(B!=null)return B}R.to=F})(s||(s={}));var a;(function(R){function A(B){if(B!=null)return B}R.from=A;function F(B){if(B!=null)return B}R.to=F})(a||(a={}));var d;(function(R){function A(z){if(z){const V=z;return V&&!!V.process}else return!1}R.is=A;function F(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=a.from(z.options)),V}R.from=F;function B(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}R.to=B})(d||(d={}));var o;(function(R){function A(B){if(B!=null)return B}R.from=A;function F(B){if(B!=null)return B}R.to=F})(o||(o={}));var u;(function(R){function A(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}R.is=A;function F(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=o.from(z.options)),V}R.from=F;function B(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}R.to=B})(u||(u={}));var n;(function(R){function A(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}R.is=A;function F(z){return{customExecution:"customExecution"}}R.from=F;function B(z,V){return V.get(z)}R.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(R){function A(F,B){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&B&&B.workspaceFile?z=B.workspaceFile:z=E.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}R.from=A})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(R){function A(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}R.from=A})(g||(g={}));var P;(function(R){function A(z,V){if(z==null)return[];const K=[];for(const ie of z){const ge=F(ie,V);ge&&K.push(ge)}return K}R.fromMany=A;function F(z,V){if(z==null)return;let K;z.execution instanceof C.ProcessExecution?K=d.from(z.execution):z.execution instanceof C.ShellExecution?K=u.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(K=n.from(z.execution));const ie=r.from(z.definition);let ge;return z.scope?typeof z.scope=="number"?ge=z.scope:ge=z.scope.uri:ge=C.TaskScope.Workspace,!ie||!ge?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:ge},execution:K,isBackground:z.isBackground,group:g.from(z.group),presentationOptions:s.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}R.from=F;async function B(z,V,K){if(z==null)return;let ie;d.is(z.execution)?ie=d.to(z.execution):u.is(z.execution)?ie=u.to(z.execution):n.is(z.execution)&&(ie=n.to(z._id,K));const ge=r.to(z.definition);let ue;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ue=z.source.scope:ue=await V.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):ue=C.TaskScope.Workspace),!ge||!ue)return;const re=new C.Task(ge,ue,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(re.isBackground=z.isBackground),z.group!==void 0&&(re.group=C.TaskGroup.from(z.group._id),re.group&&z.group.isDefault&&(re.group=new C.TaskGroup(re.group.id,re.group.label),z.group.isDefault===!0&&(re.group.isDefault=z.group.isDefault))),z.presentationOptions&&(re.presentationOptions=s.to(z.presentationOptions)),z._id&&(re._id=z._id),z.detail&&(re.detail=z.detail),re}R.to=B})(P=e.TaskDTO||(e.TaskDTO={}));var N;(function(R){function A(B){return B}R.from=A;function F(B){if(!!B)return Object.assign(Object.create(null),B)}R.to=F})(N||(N={}));class j{constructor(A,F,B){this._id=F,this.a=B,w.set(this,void 0),Ye(this,w,A,"f")}get task(){return this.a}terminate(){Re(this,w,"f").terminateTask(this)}fireDidStartProcess(A){}fireDidEndProcess(A){}}w=new WeakMap;let Z=class{constructor(A,F,B,z,V,K,ie,ge){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=A.getProxy(L.MainContext.MainThreadTask),this.b=B,this.c=z,this.d=V,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=ge,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(A,F,B){if(!B)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:B,extension:A}),this.a.$registerTaskProvider(z,F),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(A,F){this.a.$registerTaskSystem(A,F)}fetchTasks(A){return this.a.$fetchTasks(N.from(A)).then(async F=>{const B=[];for(const z of F){const V=await P.to(z,this.b,this.m);V&&B.push(V)}return B})}get taskExecutions(){const A=[];return this.k.forEach(F=>A.push(F)),A}terminateTask(A){if(!(A instanceof j))throw new Error("No valid task execution provided");return this.a.$terminateTask(A._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(A,F,B){const z=this.m.get(A.id);z&&(this.o.set(A.id,z),this.e.attachPtyToTerminal(F,await z.callback(B))),this.p=A.id,this.q.fire({execution:await this.y(A)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(A){const F=await this.y(A);this.l.delete(A.id),this.k.delete(A.id),this.A(A),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(A){const F=await this.y(A.id);this.s.fire({execution:F,processId:A.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(A){const F=await this.y(A.id);this.t.fire({execution:F,exitCode:A.exitCode})}$provideTasks(A,F){const B=this.j.get(A);if(!B)return Promise.reject(new Error("no handler found"));const z=[],V=(0,T.asPromise)(()=>B.provider.provideTasks(M.CancellationToken.None)).then(K=>this.u(F,z,B,K));return new Promise(K=>{V.then(ie=>{Promise.all(z).then(()=>{K(ie)})})})}async $resolveTask(A,F){const B=this.j.get(A);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const z=await P.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await B.provider.resolveTask(z,M.CancellationToken.None);if(!V)return;this.z(V,B);const K=P.from(V,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(K.execution)&&await this.x(K,V,!0),await this.v(K)}w(){return this.h++}async x(A,F,B){const z=await this.a.$createTaskId(A);!B&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(A,F){if(typeof A=="string"){const V=this.l.get(A);if(!V)throw new b.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const B=this.l.get(A.id);if(B)return B;const z=new Promise((V,K)=>{function ie(ge,ue,re){re?V(new j(ge,ue.id,re)):K("Unexpected: Task does not exist.")}F?ie(this,A,F):P.to(A.task,this.b,this.m).then(ge=>ie(this,A,ge))});return this.l.set(A.id,z),z.then(V=>(this.k.set(A.id,V),V),V=>Promise.reject(V))}z(A,F){A._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(A){this.o.get(A.id)&&this.o.delete(A.id),this.n.has(A.id)&&this.p!==A.id&&(this.m.delete(A.id),this.n.delete(A.id));const B=this.n.values();let z=B.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=B.next()}};Z=qe([Ve(0,m.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,p.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let G=class extends Z{constructor(A,F,B,z,V,K,ie,ge){super(A,F,B,z,V,K,ie,ge),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(A,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=P.from(F,A);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,F,!1);else throw new b.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(B),F);return this.a.$executeTask(B).catch(V=>{throw new Error(V)}),z}u(A,F,B,z){const V=[];if(z)for(const K of z){this.z(K,B),(!K.definition||!A[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=P.from(K,B.extension);ie&&n.is(ie.execution)?(V.push(ie),F.push(this.x(ie,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:B.extension}}async v(A){if(n.is(A.execution))return A;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(A,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(A,F,B){}};G=qe([Ve(0,m.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,p.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[236],Ce([1,0,19,20,45,35,22,100,44]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,v,f){this.k=m,this.l=v,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((f,t)=>{const c=l=>{this.f++,m(l)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const p=l.toString(),E=i.basename(p);this.j&&this.j(p,E)||this.v(c,{base:l,basename:E})}),Promise.all(v.map(l=>this.p(l,c))).then(l=>{f({limitHit:this.e,stats:l[0]||void 0})},l=>{t(new Error((0,y.toErrorMessage)(l)))})})}async p(m,v){const f=new T.CancellationTokenSource,t=this.q(m),c=this.r(),l=new S.QueryGlobTester(this.k,m),p=!l.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=O.StopWatch.create();const b=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},t,f.token),w=E.elapsed(),r=O.StopWatch.create();return this.g&&!this.e||(b&&b.forEach(s=>{const a=i.posix.relative(m.folder.path,s.path);if(p){const d=i.basename(s.path);this.v(v,{base:m.folder,relativePath:a,basename:d});return}this.s(c,m.folder,a,v)}),this.g&&!this.e)?null:(this.u(c,l,v),{providerTime:w,postProcessTime:r.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const v=(0,S.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,f,t){if(f===this.a){const l=i.basename(this.a);this.v(t,{base:v,relativePath:this.a,basename:l})}function c(l){const p=i.basename(l),E=i.dirname(l);let b=m[E];b||(b=m[E]=[],c(E)),b.push({base:v,relativePath:l,basename:p})}c(f)}u({rootEntries:m,pathToEntries:v},f,t){const c=this,l=this.a;function p(E){const b=(0,S.hasSiblingFn)(()=>E.map(w=>w.basename));for(let w=0,r=E.length;w<r;w++){const s=E[w],{relativePath:a,basename:d}=s;if(f.matchesExcludesSync(a,d,l!==d?b:void 0))continue;const o=v[a];if(o)p(o);else{if(a===l)continue;c.v(t,s)}if(c.e)break}}p(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class M{constructor(){this.b=new Map}fileSearch(m,v,f,t){const c=this.c(m.cacheKey),l=new k(m,v,c&&c.token);let p=0;const E=b=>{p+=b.length,f(b.map(w=>this.d(w)))};return this.e(l,M.a,E,t).then(b=>({limitHit:b.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:b.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new T.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:C.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,v,f,t){t.onCancellationRequested(()=>{m.cancel()});const c=p=>{p&&(l.push(p),v>0&&l.length>=v&&(f(l),l=[]))};let l=[];return m.search(c).then(p=>(l.length&&f(l),p),p=>(l.length&&f(l),Promise.reject(p)))}}e.FileSearchManager=M,M.a=512}),define(Ie[237],Ce([1,0,16,79,35,83,28,13,19,22,10,9,2,253,148,40,12,51,94,235,44]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,P,N,j,Z){this.a=g,this.b=P,this.c=N,this.d=j,this.e=Z}text(g,P,N={}){g=this.f(g,N);const j=this.a.getValue(),Z=P&&P.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(P?.map(l.toWorkspaceFolder),N),type:2,contentPattern:g,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:j.search.usePCRE2||Z||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(g,P){const N=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const j={...g,wordSeparators:N.editor.wordSeparators};return this.j(g,P)&&(j.isCaseSensitive=!0),this.k(g)&&(j.isMultiline=!0),j}file(g,P={}){return{...this.h(g,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}g(g,P){return g?(g=Array.isArray(g)?g.map(o):o(g),P?this.parseSearchPaths(g):{pattern:s(...Array.isArray(g)?g:[g])}):{}}h(g=[],P={}){const N=this.g(P.includePattern,P.expandPatterns),j=this.g(P.excludePattern,P.expandPatterns),Z=g.length>1,G=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(F=>this.q(F,P,j)):g.map(F=>this.r(F,P,j,Z))).filter(F=>!!F),R={_reason:P._reason,folderQueries:G,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:j.pattern,includePattern:N.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const F=i.coalesce(i.flatten(this.c.groups.map(V=>V.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(V=>(0,b.pathIncludedInQuery)(R,V.fsPath)),z=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...R,...z}}const A=P.extraFileResources&&P.extraFileResources.filter(F=>(0,b.pathIncludedInQuery)(R,F.fsPath));return R.extraFileResources=A&&A.length?A:void 0,R}i(g){const P=[],N=new C.ResourceMap,j={};let Z=!1;return g.forEach(G=>{if(G.scheme===O.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(G)){const A=this.b.getWorkspaceFolder(G)?.uri??G.with({path:S.dirname(G.fsPath)});let F=N.get(A);F||(Z=!0,F={folder:A,includePattern:{}},P.push(F),N.set(A,F));const B=S.relative(A.fsPath,G.fsPath);(0,D.assertIsDefined)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else G.fsPath&&(Z=!0,j[G.fsPath]=!0)}),{folderQueries:P,includePattern:j,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(g,P){if(P.isSmartCase){if(g.isRegExp){if(M.containsUppercaseCharacter(g.pattern,!0))return!0}else if(M.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,v.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const P=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),j=(Array.isArray(g)?g:a(g)).map(z=>{const V=this.e.resolvedUserHome;return V?(0,L.untildify)(z,V.scheme===O.Schemas.file?V.fsPath:V.path):z}),Z=T.groupBy(j,z=>P(z)?"searchPaths":"exprSegments"),G=(Z.exprSegments||[]).map(z=>M.rtrim(z,"/")).map(z=>M.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),R={},A=this.m(Z.searchPaths||[]);A&&A.length&&(R.searchPaths=A);const F=i.flatten(G),B=s(...F);return B&&(R.pattern=B),R}l(g,P){return P.disregardExcludeSettings?void 0:(0,b.getExcludes)(g,!P.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const P=i.flatten(g.map(j=>{let{pathPortion:Z,globPortion:G}=r(j);G&&(G=u(G));const R=this.n(Z);return i.flatten(R.map(A=>this.o(A,G)))})),N=new Map;return P.forEach(j=>{const Z=j.searchPath.toString(),G=N.get(Z);G?j.pattern&&(G.pattern=G.pattern||{},G.pattern[j.pattern]=!0):N.set(Z,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(N.values())}n(g){if(S.isAbsolute(g)){const P=this.b.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==O.Schemas.file?[{searchPath:P[0].uri.with({path:g})}]:[{searchPath:m.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const P=this.b.getWorkspace().folders[0].uri;if(g=o(g),g.startsWith("../")||g===".."){const j=S.posix.resolve(P.path,g);return[{searchPath:P.with({path:j})}]}const N=u(g);return[{searchPath:P,pattern:N}]}else{if(g==="./"||g===".\\")return[];{const P=g.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(Z=>{const G=P.match(new RegExp(`^${M.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return G?{match:G,folder:Z}:null}).filter(D.isDefined);if(j.length)return j.map(Z=>{const G=Z.match[1];return{searchPath:Z.folder.uri,pattern:G&&u(G)}});{const Z=g.match(/\.[\/\\](.+)[\/\\]?/),G=Z?Z[1]:g,R=f.localize(0,null,G);throw new Error(R)}}}}o(g,P){const N=g.pattern&&P?`${g.pattern}/${P}`:g.pattern||P,j=[{searchPath:g.searchPath,pattern:N}];return N&&!N.endsWith("**")&&j.push({searchPath:g.searchPath,pattern:N+"/**"}),j}q(g,P,N){const j=this.r((0,l.toWorkspaceFolder)(g.searchPath),P,N,!1);return j?{...j,includePattern:g.pattern}:null}r(g,P,N,j){let Z;const G=m.URI.isUri(g)?g:g.uri;if(N.searchPaths){const z=N.searchPaths.filter(V=>(0,k.isEqual)(V.searchPath,G))[0];if(z&&!z.pattern)return null;z&&(Z=z.pattern)}const R=this.a.getValue({resource:G}),F={...this.l(R,P)||{},...Z||{}},B=m.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:G,folderName:j?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!R.search.followSymlinks}}};w=qe([Ve(0,t.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,p.IEditorGroupsService),Ve(3,c.ILogService),Ve(4,E.IPathService)],w),e.QueryBuilder=w;function r(h){const g=h.match(/[\*\{\}\(\)\[\]\?]/);if(g){const P=g.index,N=h.substr(0,P).match(/[/|\\][^/\\]*$/);if(N){let j=h.substr(0,N.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((N.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((g,P)=>(g[P]=!0,g),Object.create(null)):void 0}function a(h){return y.splitGlobAware(h,",").map(g=>g.trim()).filter(g=>!!g.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function o(h){return h.replace(/\\/g,"/")}function u(h){return o(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(h,g){h=i.distinct(h,j=>j.toString());const P=[],N=g.getWorkspace();return h&&h.forEach(j=>{let Z;if(g.getWorkbenchState()===2)Z=(0,k.relativePath)(N.folders[0].uri,j),Z&&Z!=="."&&(Z="./"+Z);else{const G=g.getWorkspaceFolder(j);if(G){const R=G.name;if(N.folders.filter(F=>F.name===R).length===1){const F=(0,k.relativePath)(G.uri,j);F===""?Z=`./${G.name}`:Z=`./${G.name}/${F}`}else Z=j.fsPath}}Z&&P.push(Z)}),P}e.resolveResourcesForSearchIncludes=n}),define(Ie[238],Ce([1,0,22,2,20,11,3,237,44,51]),function(ee,e,i,T,y,L,C,O,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function D(t,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const p=[],E=[];for(const d of l)if(/^workspaceContains:/.test(d)){const o=d.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||t.forceUsingSearch?E.push(o):p.push(o)}if(p.length===0&&E.length===0)return Promise.resolve(void 0);let b;const w=new Promise((d,o)=>{b=d}),r=d=>b({activationEvent:d}),s=Promise.all(p.map(d=>m(t,d,r))).then(()=>{}),a=v(t,c.identifier,E,r);return Promise.all([s,a]).then(()=>{b(void 0)}),w}e.checkActivateWorkspaceContainsExtension=D;async function m(t,c,l){for(const p of t.folders)if(await t.exists(i.joinPath(T.URI.revive(p),c))){l(`workspaceContains:${c}`);return}}async function v(t,c,l,p){if(l.length===0)return Promise.resolve(void 0);const E=new y.CancellationTokenSource,b=t.checkExists(t.folders,l,E.token),w=setTimeout(async()=>{E.cancel(),t.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},M);let r=!1;try{r=await b}catch(s){L.isCancellationError(s)||L.onUnexpectedError(s)}E.dispose(),clearTimeout(w),r&&p(`workspaceContains:${l.join(",")}`)}function f(t,c,l,p){const E=t.get(C.IInstantiationService),b=t.get(S.ISearchService),r=E.createInstance(O.QueryBuilder).file(c.map(s=>(0,k.toWorkspaceFolder)(T.URI.revive(s))),{_reason:"checkExists",includePattern:l,exists:!0});return b.fileSearch(r,p).then(s=>!!s.limitHit,s=>L.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[33],Ce([1,0,135,19,78,22,14,7,46,2,12,4,32,182,76,31,25,95,11,26,24,167,6,91,3,27,77,15,64,66,59,5,238,75,169,13,74]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w,r,s,a,d,o,u,n,h,g,P,N,j,Z,G,R){"use strict";var A,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Ni extends O.Disposable{constructor(se,le,_,me,we,Me,We,Qe,Te,De,ke){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=le,this.g=_,this.f=We,this.j=me,this.k=we,this.l=Me,this.m=Te,this.p=De,this.s=ke,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const oe=(0,c.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(ie(this.F,oe)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new j.ExtHostSecretState(this.g),this.I=Qe,this.h=se.createChild(new n.ServiceCollection([f.IExtHostStorage,this.G],[j.IExtHostSecretState,this.H])),this.J=this.B(new v.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,Y,I)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(Y),I)},actualActivateExtension:async(ce,Y)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,Y),new v.HostExtension;const I=this.D.getExtensionDescription(ce);return this.Y(I,Y)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(se){p.onUnexpectedError(se)}}async Q(){this.I.onWillDeactivateAll();let se=[];try{se=this.D.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.X(we))}catch{}await Promise.all(se)}terminate(se,le=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${se}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const _=this.Q();Promise.race([(0,C.timeout)(5e3),_]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.l.info(`Extension host exiting with code ${le}`),this.l.flush(),this.l.dispose(),this.c.exit(le)})}isActivated(se){return this.z.isOpen()?this.J.isActivated(se):!1}async getExtension(se){const le=await this.v.$getExtension(se);let _;if(le?.browserNlsBundleUris){_={};for(const me of Object.keys(le.browserNlsBundleUris))_[me]=k.URI.revive(le.browserNlsBundleUris[me])}return le&&{...le,identifier:new E.ExtensionIdentifier(le.identifier.value),extensionLocation:k.URI.revive(le.extensionLocation),browserNlsBundleUris:_}}R(se,le){return this.J.activateByEvent(se,le)}S(se,le){return this.J.activateById(se,le)}activateByIdWithErrors(se,le){return this.S(se,le).then(()=>{const _=this.J.getActivatedExtension(se);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(se=>this.D)}getExtensionExports(se){return this.z.isOpen()?this.J.getActivatedExtension(se).exports:null}async U(se){if(se.scheme!==G.Schemas.file)return se;const le=await this.c.realpath(se.fsPath);return k.URI.file(le)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(se=>new ue(se))),this.L}async W(se){const le=S.TernarySearchTree.forUris(_=>L.extUriBiasedIgnorePathCase.ignorePathCasing(_));return await Promise.all(se.map(async _=>{if(this.ob(_)){const me=await this.U(_.extensionLocation);le.set(me,_)}})),le}X(se){let le=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(se))return le;const _=this.J.getActivatedExtension(se);if(!_)return le;try{typeof _.module.deactivate=="function"&&(le=Promise.resolve(_.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${se.value}':`),this.l.error(me)}try{(0,O.dispose)(_.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this.l.error(me)}return le}async Y(se,le){return this.f.remote.isRemote?this.v.$onWillActivateExtension(se.identifier):await this.v.$onWillActivateExtension(se.identifier),this.ab(se,le).then(_=>{const me=_.activationTimes;return this.v.$onDidActivateExtension(se.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,le),this.Z(se,le,"success",me),_},_=>{throw this.Z(se,le,"failure"),_})}Z(se,le,_,me){const we=V(se,le);this.u.$publicLog2("extensionActivationTimes",{...we,...me||{},outcome:_})}ab(se,le){const _=V(se,le);this.u.$publicLog2("activatePlugin",_);const me=this.ob(se);if(!me)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${se.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.l.flush();const we=new v.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this.pb(se,(0,L.joinPath)(se.extensionLocation,me),we),this.bb(se)]).then(Me=>(y.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Ni.cb(this.l,se.identifier,Me[0],Me[1],we))).then(Me=>(y.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),Me))}bb(se){const le=new w.ExtensionGlobalMemento(se,this.G),_=new w.ExtensionMemento(se.identifier.value,!1,this.G),me=new Z.ExtensionSecrets(se,this.H),we=se.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Me=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([le.whenReady,_.whenReady,this.I.whenReady]).then(()=>{const We=this;let Qe,Te;const De=(0,c.isProposedApiEnabled)(se,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:_,secrets:me,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(ke){return T.join(se.extensionLocation.fsPath,ke)},get storagePath(){return We.I.workspaceValue(se)?.fsPath},get globalStoragePath(){return We.I.globalValue(se).fsPath},get logPath(){return T.join(We.f.logsLocation.fsPath,se.identifier.value)},get logUri(){return k.URI.joinPath(We.f.logsLocation,se.identifier.value)},get storageUri(){return We.I.workspaceValue(se)},get globalStorageUri(){return We.I.globalValue(se)},get extensionMode(){return we},get extension(){return Qe===void 0&&(Qe=new K(We,se.identifier,se,Me,!1)),Qe},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(se,"extensionRuntime"),We.extensionRuntime},get environmentVariableCollection(){return We.p.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Te){if(!De)return;const ke=P.Event.buffer(P.Event.fromDOMEventEmitter(De,"message",oe=>oe.data));De.start(),Te={onDidReceiveMessage:ke,postMessage:De.postMessage.bind(De)}}return Te}})})}static cb(se,le,_,me,we){return _=_||{activate:void 0,deactivate:void 0},this.db(se,le,_,me,we).then(Me=>new v.ActivatedExtension(!1,null,we.build(),_,Me,me.subscriptions))}static db(se,le,_,me,we){if(typeof _.activate=="function")try{we.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Me=typeof global=="object"?global:self,We=_.activate.apply(Me,[me]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(We).then(Qe=>(we.activateResolveStop(),Qe))}catch(Me){return Promise.reject(Me)}else return Promise.resolve(_)}eb(se,le){this.S(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:le}).then(void 0,_=>{this.l.error(_)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const se of this.D.getAllExtensionDescriptions())if(se.activationEvents)for(const le of se.activationEvents)le==="onStartupFinished"&&this.eb(se,le)}gb(){const se=this.R("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.hb(we.added)));const le=this.j.workspace?this.j.workspace.folders:[],_=this.hb(le),me=Promise.all([se,_]).then(()=>{});return Promise.race([me,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),me}hb(se){return se.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(le=>this.ib(se,le))).then(()=>{})}async ib(se,le){if(this.isActivated(le.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:se.map(Me=>Me.uri),forceUsingSearch:_,exists:Me=>this.c.exists(Me.fsPath),checkExists:(Me,We,Qe)=>this.t.$checkExists(Me,We,Qe)},we=await(0,N.checkActivateWorkspaceContainsExtension)(me,le);if(!!we)return this.S(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:we.activationEvent}).then(void 0,Me=>this.l.error(Me))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(se){throw console.error(se),se}}async jb(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:le}=this.f.environment;if(!se||!le)throw new Error(i.localize(0,null));const _=await this.pb(null,le,new v.ExtensionActivationTimesBuilder(!1));if(!_||typeof _.run!="function")throw new Error(i.localize(1,null,le.toString()));return new Promise((me,we)=>{const Me=(Te,De)=>{Te?we(Te):me(typeof De=="number"&&De>0?1:0)},We=(0,L.originalFSPath)(le),Qe=_.run(We,Me);Qe&&Qe.then&&Qe.then(()=>{me(0)}).catch(Te=>{we(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,le){return this.M[se]=le,(0,O.toDisposable)(()=>{delete this.M[se]})}async lb(se){const le=se.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const _=se.substr(0,le);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.M[_]}}async $resolveAuthority(se,le){this.l.info(`$resolveAuthority invoked for authority (${ge(se)})`);const{authorityPrefix:_,resolver:me}=await this.lb(se);if(!me)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${_}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(me)),y.mark(`code/extHost/willResolveAuthority/${_}`);const we=await me.resolve(se,{resolveAttempt:le});y.mark(`code/extHost/didResolveAuthorityOK/${_}`);const Me={authority:se,host:we.host,port:we.port,connectionToken:we.connectionToken},We={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Me,options:We,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(y.mark(`code/extHost/didResolveAuthorityError/${_}`),we instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(se,le){this.l.info(`$getCanonicalURI invoked for authority (${ge(se)})`);const{resolver:_}=await this.lb(se);if(!_)return null;const me=k.URI.revive(le);if(typeof _.getCanonicalURI>"u")return me;const we=await(0,C.asPromise)(()=>_.getCanonicalURI(me));return we||me}static mb(se,le,_){const me=new l.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());me.deltaExtensions(_.toAdd,_.toRemove);const we=(0,c.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(We=>We.identifier));for(const We of _.myToRemove)we.delete(E.ExtensionIdentifier.toKey(We));for(const We of _.myToAdd)we.add(E.ExtensionIdentifier.toKey(We));const Me=ie(me,we);return{globalRegistry:me,myExtensions:Me}}$startExtensionHost(se){se.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:le,myExtensions:_}=Ni.mb(this.F,this.D,se);return this.F.set(le.getAllExtensionDescriptions()),this.D.set(_),this.kb()}$activateByEvent(se,le){return le===1?this.R(se,!1):this.z.wait().then(_=>this.R(se,!1))}async $activate(se,le){return await this.z.wait(),this.D.getExtensionDescription(se)?(await this.S(se,le),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(Me=>Me.extensionLocation=k.URI.revive(Me.extensionLocation));const{globalRegistry:le,myExtensions:_}=Ni.mb(this.F,this.D,se),me=await this.W(_);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(le.getAllExtensionDescriptions()),this.D.set(_),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const le=b.VSBuffer.alloc(se),_=Math.random()%256;for(let me=0;me<se;me++)le.writeUInt8(_,me);return le}async $updateRemoteConnectionData(se){this.P=se,this.a.fire()}};z=qe([Ve(0,a.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,u.IExtHostRpcService),Ve(3,t.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,M.ILogService),Ve(6,d.IExtHostInitDataService),Ve(7,o.IExtensionStoragePaths),Ve(8,h.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,R.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function V(re,se){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class K{constructor(se,le,_,me,we){A.set(this,void 0),F.set(this,void 0),B.set(this,void 0),Ye(this,A,se,"f"),Ye(this,F,le,"f"),Ye(this,B,_.identifier,"f"),this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=me,this.isFromDifferentExtensionHost=we}get isActive(){return Re(this,A,"f").isActivated(Re(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,A,"f").getExtensionExports(Re(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,A,"f").activateByIdWithErrors(Re(this,B,"f"),{startup:!1,extensionId:Re(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=K,A=new WeakMap,F=new WeakMap,B=new WeakMap;function ie(re,se){return re.getAllExtensionDescriptions().filter(le=>se.has(E.ExtensionIdentifier.toKey(le.identifier)))}function ge(re){const se=re.indexOf("+");return se===-1?re:re.substring(0,se)}class ue{constructor(se){this.a=se}setSearchTree(se){this.a=se}findSubstr(se){return this.a.findSubstr(se)}forEach(se){return this.a.forEach(se)}}e.ExtensionPaths=ue}),define(Ie[239],Ce([1,0,78,2,4,32,25,26,15,27,3,33,49,12,10]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(w,r,s,a,d,o,u){this.c=w,this.d=r,this.e=s,this.f=a,this.g=d,this.h=o,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new l(this.c,r,this.d,w,this.i)),this.register(this.e.createInstance(p,r)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,r,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const r of w.nodeModuleName)this.a.set(r,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(r=>w.alternativeModuleName(r))}};t=qe([Ve(2,M.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,v.ILogService)],t),e.RequireInterceptor=t;let c=class en{constructor(w){if(w.environment.appRoot&&en.a.size){const r=(0,f.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),s="[a-z0-9_.-]",a=`@${s}+\\/${s}+|${s}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${d}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const r=this.b.exec(this.c(w));if(!r)return;const[,s,a,d]=r,o=en.a.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),s+o+d}c(w){return w.replace(/\\/g,"/")}};c.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),c=qe([Ve(0,k.IExtHostInitDataService)],c);class l{constructor(w,r,s,a,d){this.c=w,this.d=r,this.e=s,this.f=a,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,r){const s=this.d.findSubstr(r);if(s){let a=this.a.get(O.ExtensionIdentifier.toKey(s.identifier));return a||(a=this.c(s,this.e,this.f),this.a.set(O.ExtensionIdentifier.toKey(s.identifier),a)),a}if(!this.b){let a="";this.d.forEach((d,o)=>a+=`	${o} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${a}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(w,r,s){this.d=w,this.nodeModuleName="keytar",this.a=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:a}=s,d=r.getProxy(y.MainContext.MainThreadKeytar);if(a.appRoot){let o=a.appRoot.fsPath;m.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,u)=>d.$getPassword(o,u),setPassword:(o,u,n)=>d.$setPassword(o,u,n),deletePassword:(o,u)=>d.$deletePassword(o,u),findPassword:o=>d.$findPassword(o),findCredentials(o){return d.$findCredentials(o)}}}load(w,r){const s=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const r=w.length;if(r<=7||!this.b)return;const s=r-7;if((w.charAt(s)==="/"||w.charAt(s)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};p=qe([Ve(1,S.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],p);let E=class{constructor(w,r,s){this.e=w,this.f=r,this.nodeModuleName=["open","opn"],this.d=s.getProxy(y.MainContext.MainThreadTelemetry);const a=s.getProxy(y.MainContext.MainThreadWindow);this.c=(d,o)=>{const u=T.URI.parse(d);return o?this.g(d,o):u.scheme==="http"||u.scheme==="https"?a.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?a.$openUri(u,d,{}):this.g(d,o)}}load(w,r,s){const a=this.e.findSubstr(r);return a&&(this.a=a.identifier.value,this.h()),this.b=s(w),this.c}g(w,r){return this.i(),this.b(w,r)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,S.IExtHostRpcService)],E)}),define(Ie[106],Ce([1,0,205,7,19,49,3,56,57,33,6,31,179,32]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(l,p,E,b,w,r,s){function a(){if(E){const d=E.activeEditor();if(d)return d.document.uri;const o=b.tabGroups.all.find(u=>u.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof M.TextDiffTabInput||o.input instanceof M.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof M.TextTabInput||o.input instanceof M.NotebookEditorTabInput||o.input instanceof M.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:d=>{const o=r.folders.filter(u=>u.name===d);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(d,o)=>w.getConfiguration(void 0,d).get(o),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const d=a();if(d){const o=p.getWorkspaceFolder(d);if(o)return y.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(E){const d=E.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(E){const d=E.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let t=class extends T.Disposable{constructor(l,p,E,b,w){super(),this.b=l,this.c=p,this.g=E,this.h=b,this.i=w,this.a=new i.Lazy(async()=>{const r=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,r,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};t=qe([Ve(0,k.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,O.IExtHostDocumentsAndEditors),Ve(3,v.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(Ie[107],Ce([1,0,14,5,9,2,3,4,57,33,15,6,31,171,173,32,106]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,d,o,u,n,h){this.D=d,this.E=o,this.F=u,this.G=n,this.H=h,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=a.getProxy(O.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(P=>{this.I(g)}),this.I(g)})}asDebugSourceUri(a,d){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let u=`debug:${encodeURIComponent(o.path||"")}`,n="?";return d&&(u+=`${n}session=${encodeURIComponent(d.id)}`,n="&"),u+=`${n}ref=${o.sourceReference}`,L.URI.parse(u)}else{if(o.path)return L.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const d=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,f.isDebuggerMainContribution)(n)&&d.push(n.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(d=>a.push(d)),a}addBreakpoints(a){this.T();const d=a.filter(n=>{const h=n.id;return this.w.has(h)?!1:(this.w.set(h,n),!0)});this.U(d,[],[]);const o=[],u=new Map;for(const n of d)if(n instanceof D.SourceBreakpoint){let h=u.get(n.location.uri.toString());h||(h={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),h),o.push(h)),h.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof D.FunctionBreakpoint&&o.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(a){this.T();const d=a.filter(h=>this.w.delete(h.id));this.U([],d,[]);const o=d.filter(h=>h instanceof D.SourceBreakpoint).map(h=>h.id),u=d.filter(h=>h instanceof D.FunctionBreakpoint).map(h=>h.id),n=d.filter(h=>h instanceof D.DataBreakpoint).map(h=>h.id);return this.k.$unregisterBreakpoints(o,u,n)}startDebugging(a,d,o){return this.k.$startDebugging(a?a.uri:void 0,d,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,d,o){if(!d)return new D.Disposable(()=>{});const u=this.d++;return this.f.push({type:a,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(a,o,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new D.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(a,d,o){if(!o)return new D.Disposable(()=>{});if(!this.P(a,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.M(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new D.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(a,d){if(!d)return new D.Disposable(()=>{});const o=this.i++;return this.j.push({type:a,handle:o,factory:d}),new D.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(a,d){return Promise.resolve(void 0)}async $substituteVariables(a,d){let o;const u=await this.W(a);return u&&(o={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,d)}J(a,d){if(a.type==="implementation")return new w(a.implementation)}K(){}async $startDASession(a,d){const o=this,u=await this.V(d);return this.R(this.M(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const h=this.L(n),g=this.J(h,u);if(!g)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const P=g;return this.A.set(a,P),this.Q(u).then(N=>(N&&this.B.set(a,N),P.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const Z=j,G={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const R=await this.C.sign(Z.arguments.value);G.body={signature:R},P.sendResponse(G)}else throw new Error("no signer")}catch(R){G.success=!1,G.message=R.message,P.sendResponse(G)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(j),j=(0,f.convertToVSCPaths)(j,!0),o.k.$acceptDAMessage(a,j)}),P.onError(j=>{N&&N.onError&&N.onError(j),this.k.$acceptDAError(a,j.name,j.message,j.stack)}),P.onExit(j=>{N&&N.onExit&&N.onExit((0,y.withNullAsUndefined)(j),void 0),this.k.$acceptDAExit(a,(0,y.withNullAsUndefined)(j),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),P.startSession()))})}$sendDAMessage(a,d){d=(0,f.convertToDAPaths)(d,!1);const o=this.B.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(d),this.A.get(a)?.sendMessage(d)}$stopDASession(a){const d=this.B.get(a);this.B.delete(a),d&&d.onWillStopSession&&d.onWillStopSession();const o=this.A.get(a);return this.A.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const d=[],o=[],u=[];if(a.added)for(const n of a.added){const h=n.id;if(h&&!this.w.has(h)){let g;if(n.type==="function")g=new D.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")g=new D.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const P=L.URI.revive(n.uri);g=new D.SourceBreakpoint(new D.Location(P,new D.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}g._id=h,this.w.set(h,g),d.push(g)}}if(a.removed)for(const n of a.removed){const h=this.w.get(n);h&&(this.w.delete(n),o.push(h))}if(a.changed){for(const n of a.changed)if(n.id){const h=this.w.get(n.id);if(h){if(h instanceof D.FunctionBreakpoint&&n.type==="function"){const g=h;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.functionName=n.functionName}else if(h instanceof D.SourceBreakpoint&&n.type==="source"){const g=h;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.location=new D.Location(L.URI.revive(n.uri),new D.Position(n.line,n.character))}u.push(h)}}}this.U(d,o,u)}$provideDebugConfigurations(a,d,o){return(0,i.asPromise)(async()=>{const u=this.O(a);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(d);return u.provideDebugConfigurations(n,o)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(a,d,o,u){return(0,i.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.W(d);return n.resolveDebugConfiguration(h,o,u)})}$resolveDebugConfigurationWithSubstitutedVariables(a,d,o,u){return(0,i.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.W(d);return n.resolveDebugConfigurationWithSubstitutedVariables(h,o,u)})}async $provideDebugAdapter(a,d){const o=this.N(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.R(o,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const d=await this.V(a);this.m.fire(d)}async $acceptDebugSessionTerminated(a){const d=await this.V(a);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,d){(await this.V(a))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(a,d){const u={session:await this.V(a),event:d.event,body:d.body};this.u.fire(u)}L(a){if(a instanceof D.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof D.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const d=this.h.filter(o=>o.type===a);if(d.length>0)return d[0].factory}N(a){const d=this.h.filter(o=>o.handle===a);if(d.length>0)return d[0].factory}O(a){const d=this.f.filter(o=>o.handle===a);if(d.length>0)return d[0].provider}P(a,d){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const u of o)if(u.label&&u.type&&u.type===d)return!0}}return!1}Q(a){const o=a.configuration.type,u=this.j.filter(n=>n.type===o||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(h=>h,h=>null));return Promise.race([Promise.all(u).then(n=>{const h=n.filter(g=>!!g);if(h.length>0)return new b(h)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,d){const o=d.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new D.DebugAdapterServer(o));if(a){const n=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>a.createDebugAdapterDescriptor(d,this.S(d,n))).then(h=>{if(h)return h})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(d,u))}S(a,d){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,d,o){(a.length>0||d.length>0||o.length>0)&&this.z.fire(Object.freeze({added:a,removed:d,changed:o}))}async V(a){if(a)if(typeof a=="string"){const d=this.l.get(a);if(d)return d}else{let d=this.l.get(a.id);if(!d){const o=await this.W(a.folderUri),u=a.parent?this.l.get(a.parent):void 0;d=new p(this.k,a.id,a.type,a.name,o,a.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(a){if(a){const d=L.URI.revive(a);return this.D.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=qe([Ve(0,M.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class p{constructor(a,d,o,u,n,h,g){this.d=a,this.f=d,this.g=o,this.h=u,this.i=n,this.j=h,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,d){return this.d.$customDebugAdapterRequest(this.f,a,d)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=p;class E{constructor(a){this.value=Object.freeze({append(d){a.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=E;class b{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(d=>d.onError?d.onError(a):void 0)}onExit(a,d){this.d.forEach(o=>o.onExit?o.onExit(a,d):void 0)}}class w extends v.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends l{constructor(a,d,o,u,n,h){super(a,d,o,u,n,h)}};r=qe([Ve(0,M.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(Ie[240],Ce([1,0,11,78,2,4,231,12,63,64,27,153,15,53,33,71]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{static async installEarlyHandler(E){const b=E.get(O.ILogService),r=E.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(s=>{b.error(s);const a=i.transformErrorForSerialization(s);r.$onUnexpectedError(a)})}static async installFullHandler(E){const b=E.get(O.ILogService),w=E.get(m.IExtHostRpcService),r=E.get(f.IExtHostExtensionService),s=E.get(t.IExtHostTelemetry),a=w.getProxy(L.MainContext.MainThreadExtensionService),d=w.getProxy(L.MainContext.MainThreadErrors),o=await r.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,h)=>{let g="",P,N;for(const j of h)g+=`
	at ${j.toString()}`,N=j.getFileName(),!P&&N&&(P=o.findSubstr(y.URI.file(N)));return u.set(n,P?.identifier),`${n.name||"Error"}: ${n.message||""}${g}`},i.setUnexpectedErrorHandler(n=>{b.error(n);const h=i.transformErrorForSerialization(n),g=u.get(n);if(!g){d.$onUnexpectedError(h);return}a.$onExtensionRuntimeError(g,h);const P=s.onExtensionError(g,n);b.trace("forwarded error to extension?",P,g)})}}Error.stackTraceLimit=100;class l{constructor(E,b,w,r,s){this.a=w,this.b=new C.RPCProtocol(E,null,r),b=l.e(b,this.b);const a=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());a.set(M.IExtHostInitDataService,{_serviceBrand:void 0,...b,messagePorts:s}),a.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),a.set(v.IURITransformerService,new v.URITransformerService(r)),a.set(f.IHostUtils,w);const d=new D.InstantiationService(a,!0);d.invokeFunction(c.installEarlyHandler),this.d=d.invokeFunction(o=>o.get(O.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",b),this.c=d.invokeFunction(o=>o.get(f.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(c.installFullHandler)}async asBrowserUri(E){const b=this.b.getProxy(L.MainContext.MainThreadExtensionService);return y.URI.revive(await b.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,b){E.allExtensions.forEach(r=>{r.extensionLocation=y.URI.revive(b.transformIncomingURIs(r.extensionLocation));const s={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(a=>s[a]=y.URI.revive(b.transformIncomingURIs(r.browserNlsBundleUris[a]))),r.browserNlsBundleUris=s)}),E.environment.appRoot=y.URI.revive(b.transformIncomingURIs(E.environment.appRoot));const w=E.environment.extensionDevelopmentLocationURI;return w&&(E.environment.extensionDevelopmentLocationURI=w.map(r=>y.URI.revive(b.transformIncomingURIs(r)))),E.environment.extensionTestsLocationURI=y.URI.revive(b.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=y.URI.revive(b.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=y.URI.revive(b.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=y.URI.revive(b.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=y.URI.revive(b.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=y.URI.revive(b.transformIncomingURIs(E.logsLocation)),E.logFile=y.URI.revive(b.transformIncomingURIs(E.logFile)),E.workspace=b.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(Ie[241],Ce([1,0,16,14,20,45,13,19,22,2,44]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(p,E,b,w){this.d=p,this.e=E,this.f=b,this.g=w,this.a=null,this.b=!1,this.c=0}search(p,E){const b=this.d.folderQueries||[],w=new y.CancellationTokenSource;return E.onCancellationRequested(()=>w.cancel()),new Promise((r,s)=>{this.a=new v(p);let a=!1;const d=(o,u)=>{if(!a&&!this.b){const n=this.h(o);t(o)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),o=this.j(o,this.d.maxResults-this.c));const h=this.h(o);this.c+=h,(h>0||!t(o))&&this.a.add(o,u)}};Promise.all(b.map((o,u)=>this.k(o,n=>d(n,u),w.token))).then(o=>{w.dispose(),this.a.flush();const u=o.some(n=>!!n&&!!n.limitHit);r({limitHit:this.b||u,messages:(0,i.flatten)(o.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},o=>{w.dispose();const u=(0,L.toErrorMessage)(o);s(new Error(u))})})}h(p){return t(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,E){const b=Array.isArray(p.ranges)?p.ranges:[p.ranges],w=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:b.slice(0,E),preview:{matches:w.slice(0,E),text:p.preview.text},uri:p.uri}}async k(p,E,b){const w=new M.QueryGlobTester(this.d,p),r=[],s={report:o=>{if(!this.l(o))return;const u=p.folder.scheme===C.Schemas.file?(0,M.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(o.uri))):void 0,n=S.relativePath(p.folder,o.uri);if(n){const h=w.includedInQuery(n,O.basename(n),u);(0,T.isThenable)(h)?r.push(h.then(g=>{g&&E(o)})):h&&E(o)}}},a=this.n(p),d=await this.e.provideTextSearchResults(m(this.d.contentPattern),a,s,b);return r.length&&await Promise.all(r),d}l(p){if(t(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const E=(0,M.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),b=(0,M.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),w={folder:k.URI.from(p.folder),excludes:b,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=D;function m(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class v{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new c(512,E=>this.g(E))}add(p,E){this.d&&(this.b!==E||!S.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:p.uri,results:[]}),this.d.results.push(f(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=v;function f(l){return t(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function t(l){return!!l.preview}e.extensionResultIsMatch=t;class c{constructor(p,E){this.g=p,this.h=E,this.c=0,this.d=[],this.e=0}addItem(p,E){!p||this.j(p,E)}addItems(p,E){!p||this.k(p,E)}j(p,E){this.d.push(p),this.e+=E,this.l()}k(p,E){this.d=this.d.concat(p),this.e+=E,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=c,c.a=4e3,c.b=50}),define(Ie[108],Ce([1,0,7,4,3,236,15,53,12,2,241]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let D=class{constructor(t,c,l){this.k=t,this.l=c,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(t){return this.l.transformOutgoingScheme(t)}registerTextSearchProvider(t,c){if(this.g.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this.g.add(t);const l=this.d++;return this.e.set(l,c),this.c.$registerTextSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.g.delete(t),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(t,c){if(this.i.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this.i.add(t);const l=this.d++;return this.h.set(l,c),this.c.$registerFileSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.i.delete(t),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(t,c,l,p){const E=m(l),b=this.h.get(t);if(b)return this.j.fileSearch(E,b,w=>{this.c.$handleFileMatch(t,c,w.map(r=>r.resource))},p);throw new Error("unknown provider: "+t)}$clearCache(t){return this.j.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,c,l,p){const E=this.e.get(t);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const b=m(l);return this.q(b,E).search(r=>this.c.$handleTextMatch(t,c,r),p)}$enableExtensionHostSearch(){}q(t,c){return new M.TextSearchManager(t,c,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};D=qe([Ve(0,C.IExtHostRpcService),Ve(1,O.IURITransformerService),Ve(2,S.ILogService)],D),e.ExtHostSearch=D;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(v),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=m;function v(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ie[242],Ce([1,0,63,103,31,101,32,38,56,59,105,107,108,76,66,73,102,58,37,75,71,57,212,12,183,106,74]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w,r,s,a,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,i.registerSingleton)(s.ILoggerService,r.ExtHostLoggerService,1),(0,i.registerSingleton)(s.ILogService,a.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands,0),(0,i.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage,0),(0,i.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(b.IExtHostTelemetry,b.ExtHostTelemetry,0),(0,i.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,i.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(Ie[243],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const L=this.a.get(y);return this.a.delete(y),L}}addDragOperationTransfer(y,L){this.a.set(y,L)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,L){this.b.set(y,L)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=i}),define(Ie[244],Ce([1,0,139,6,22,2,5,7,14,6,9,16,8,20,243,25]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(E,b){if((0,M.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let w;return Array.isArray(E.highlights)&&(w=E.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),w=w.length?w:void 0),{label:E.label,highlights:w}}}class l{constructor(b,w,r){this.d=b,this.e=w,this.f=r,this.a=new Map,this.b=new f.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(d=>s(d)?this.i(d):d):a})}registerTreeDataProvider(b,w,r){const s=this.createTreeView(b,{treeDataProvider:w},r);return{dispose:()=>s.dispose()}}createTreeView(b,w,r){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,o=!!w.dragAndDropController?.handleDrop,u=this.h(b,w,r),n=this.d.$registerTreeViewDataProvider(b,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:d,hasHandleDrop:o});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(r,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(h){u.message=h},get title(){return u.title},set title(h){u.title=h},get description(){return u.description},set description(h){u.description=h},get badge(){return u.badge},set badge(h){h!==void 0&&k.ViewBadge.isViewBadge(h)?u.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(u.badge=void 0)},reveal:(h,g)=>u.reveal(h,g),dispose:async()=>{await n,this.a.delete(b),u.dispose()}}}$getChildren(b,w){const r=this.a.get(b);return r?r.getChildren(w):Promise.reject(new Error((0,i.localize)(0,null,b)))}async $handleDrop(b,w,r,s,a,d,o,u){const n=this.a.get(b);if(!n)return Promise.reject(new Error((0,i.localize)(1,null,b)));const h=m.DataTransfer.toDataTransfer(r,async g=>(await this.d.$resolveDropFileData(b,w,g)).buffer);return o===b&&u&&await this.g(h,n,u,a,d),n.onDrop(h,s,a)}async g(b,w,r,s,a){const d=this.b.removeDragOperationTransfer(a);if(d)(await d)?.forEach((o,u)=>{o&&b.set(u,o)});else if(a&&w.handleDrag){const o=w.handleDrag(r,b,s);this.b.addDragOperationTransfer(a,o),await o}return b}async $handleDrag(b,w,r,s){const a=this.a.get(b);if(!a)return Promise.reject(new Error((0,i.localize)(2,null,b)));const d=await this.g(new T.DataTransfer,a,w,s,r);if(!!d)return m.DataTransfer.toDataTransferDTO(d)}async $hasResolve(b){const w=this.a.get(b);if(!w)throw new Error((0,i.localize)(3,null,b));return w.hasResolve}$resolve(b,w,r){const s=this.a.get(b);if(!s)throw new Error((0,i.localize)(4,null,b));return s.resolveTreeItem(w,r)}$setExpanded(b,w,r){const s=this.a.get(b);if(!s)throw new Error((0,i.localize)(5,null,b));s.setExpanded(w,r)}$setSelection(b,w){const r=this.a.get(b);if(!r)throw new Error((0,i.localize)(6,null,b));r.setSelection(w)}$setFocus(b,w){const r=this.a.get(b);if(!r)throw new Error((0,i.localize)(7,null,b));r.setFocus(w)}$setVisible(b,w){const r=this.a.get(b);if(!r)throw new Error((0,i.localize)(8,null,b));r.setVisible(w)}$changeCheckboxState(b,w){const r=this.a.get(b);if(!r)throw new Error((0,i.localize)(9,null,b));r.setCheckboxState(w)}h(b,w,r){const s=new p(b,w,this.d,this.e.converter,this.f,r);return this.a.set(b,s),s}i(b){const w=this.a.get(b.$treeViewId);return w&&"$treeItemHandle"in b?w.getExtensionElement(b.$treeItemHandle):w&&"$focusedTreeItem"in b&&b.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class p extends O.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(b=>this.getExtensionElement(b)).filter(b=>!(0,M.isUndefinedOrNull)(b))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(b,w,r,s,a,d){if(super(),this.C=b,this.D=r,this.F=s,this.G=a,this.H=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new v.CancellationTokenSource,d.contributes&&d.contributes.views)for(const n in d.contributes.views)for(const h of d.contributes.views[n])h.id===b&&(this.J=h.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let o,u;this.B(C.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(o||(o=new Promise(g=>u=g),this.y=this.y.then(()=>o)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const g=u;return o=null,this.U(h).then(()=>g())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(b){const w=b?this.getExtensionElement(b):void 0;if(b&&!w)return this.G.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let r=this.Q(b);return r||(r=await this.R(w)),r?r.map(s=>s.item):void 0}getExtensionElement(b){return this.i.get(b)}reveal(b,w){w=w||{select:!0,focus:!1};const r=(0,M.isUndefinedOrNull)(w.select)?!0:w.select,s=(0,M.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,M.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.y.then(()=>this.N(b)).then(d=>this.P(b,d[d.length-1]).then(o=>this.D.$reveal(this.C,{item:o.item,parentChain:d.map(u=>u.item)},{select:r,focus:s,expand:a})),d=>this.G.error(d)):this.D.$reveal(this.C,void 0,{select:r,focus:s,expand:a})}get message(){return this.I}set message(b){this.I=b,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(b){this.J=b,this.D.$setTitle(this.C,b,this.L)}get description(){return this.L}set description(b){this.L=b,this.D.$setTitle(this.C,this.J,b)}get badge(){return this.M}set badge(b){this.M?.value===b?.value&&this.M?.tooltip===b?.tooltip||(this.M=m.ViewBadge.from(b),this.D.$setBadge(this.C,b))}setExpanded(b,w){const r=this.getExtensionElement(b);r&&(w?this.r.fire(Object.freeze({element:r})):this.s.fire(Object.freeze({element:r})))}setSelection(b){(0,D.equals)(this.l,b)||(this.l=b,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(b){this.m=b}setVisible(b){b!==this.k&&(this.k=b,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(b){const w=(await Promise.all(b.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);w.forEach(r=>{r.treeItem.checkboxState=r.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(r=>[r.extensionItem,r.newState])})}async handleDrag(b,w,r){const s=[];for(const a of b){const d=this.getExtensionElement(a);d&&s.push(d)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,w,r),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(b,w,r){const s=w?this.getExtensionElement(w):void 0;if(!(!s&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,b,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(b,w){if(!this.f.resolveTreeItem)return;const r=this.i.get(b);if(r){const s=this.j.get(r);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,r,w)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(b){return this.O(b).then(w=>w?this.N(w).then(r=>this.P(w,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}O(b){const w=this.j.get(b);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(b))}P(b,w){const r=this.j.get(b);return r?Promise.resolve(r):(0,S.asPromise)(()=>this.f.getTreeItem(b)).then(s=>this.gb(b,s,w,!0)).then(s=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const d=this.j.get(a);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(b){if(b){let w;if(typeof b=="string"){const r=this.getExtensionElement(b);w=r?this.j.get(r):void 0}else w=b;return w&&w.children||void 0}return this.h}async R(b){this.nb(b);const w=new v.CancellationTokenSource(this.S.token);try{const r=b?this.j.get(b):void 0,s=await this.f.getChildren(b);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,D.coalesce)(s||[]).map(async d=>{const o=await this.f.getTreeItem(d);return o&&!w.token.isCancellationRequested?this.Z(d,o,r):null}));return w.token.isCancellationRequested?void 0:(0,D.coalesce)(a)}finally{w.dispose()}}U(b){if(b.some(r=>!r))return this.S.dispose(!0),this.S=new v.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const r=this.W(b);if(r.length)return this.X(r)}return Promise.resolve(void 0)}W(b){const w=new Set,r=b.map(a=>this.j.get(a));for(const a of r)if(a&&!w.has(a.item.handle)){let d=a;for(;d&&d.parent&&r.findIndex(o=>d&&d.parent&&o&&o.item.handle===d.parent.item.handle)===-1;){const o=this.i.get(d.parent.item.handle);d=o?this.j.get(o):void 0}d&&!d.parent&&w.add(a.item.handle)}const s=[];return w.forEach(a=>{const d=this.i.get(a);if(d){const o=this.j.get(d);o&&(!o.parent||!w.has(o.parent.item.handle))&&s.push(a)}}),s}X(b){const w={};return Promise.all(b.map(r=>this.Y(r).then(s=>{s&&(w[r]=s.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(b){const w=this.getExtensionElement(b);if(w){const r=this.j.get(w);if(r)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(s=>{if(s){const a=this.eb(w,s,r.parent);return this.lb(w,a,r,r.parent),r.dispose(),a}return null})}return Promise.resolve(null)}Z(b,w,r){const s=this.eb(b,w,r);if(w.id&&this.i.has(s.item.handle))throw new Error((0,i.localize)(10,null,w.id));return this.kb(b,s),this.mb(s,r),s}ab(b){return k.MarkdownString.isMarkdownString(b)?m.MarkdownString.from(b):b}bb(b,w){return w?{...this.F.toInternal(w,b),originalId:w.command}:void 0}cb(b){if(!b.checkboxState)return;let w,r;return typeof b.checkboxState=="number"?w=b.checkboxState:(w=b.checkboxState.state,r=b.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:r}}db(b){if(!k.TreeItem.isTreeItem(b,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(b,w,r){this.db(w);const s=new O.DisposableStore,a=this.gb(b,w,r),d=this.hb(w);return{item:{handle:a,parentHandle:r?r.item.handle:void 0,label:c(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(s,w.command),contextValue:w.contextValue,icon:d,iconDark:this.ib(w)||d,themeIcon:this.fb(w),collapsibleState:(0,M.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(b){return b.iconPath instanceof k.ThemeIcon?b.iconPath:void 0}gb(b,{id:w,label:r,resourceUri:s},a,d){if(w)return`${p.b}/${w}`;const o=c(r,this.H),u=a?a.item.handle:p.a;let n=o?o.label:s?(0,y.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(b)?this.j.get(b).item.handle:void 0,g=this.Q(a)||[];let P,N=0;do{if(P=`${u}/${N}:${n}`,d||!this.i.has(P)||h===P)break;N++}while(N<=g.length);return P}hb(b){if(b.iconPath&&!(b.iconPath instanceof k.ThemeIcon))return typeof b.iconPath=="string"||L.URI.isUri(b.iconPath)?this.jb(b.iconPath):this.jb(b.iconPath.light)}ib(b){if(b.iconPath&&!(b.iconPath instanceof k.ThemeIcon)&&b.iconPath.dark)return this.jb(b.iconPath.dark)}jb(b){return L.URI.isUri(b)?b:L.URI.file(b)}kb(b,w){this.i.set(w.item.handle,b),this.j.set(b,w)}lb(b,w,r,s){this.i.delete(w.item.handle),this.j.delete(b),w.item.handle!==r.item.handle&&this.i.delete(r.item.handle),this.kb(b,w);const a=this.Q(s)||[],d=a.filter(o=>o.item.handle===r.item.handle)[0];d&&a.splice(a.indexOf(d),1,w)}mb(b,w){w?(w.children||(w.children=[]),w.children.push(b)):(this.h||(this.h=[]),this.h.push(b))}nb(b){if(b){const w=this.j.get(b);if(w){if(w.children)for(const r of w.children){const s=this.i.get(r.item.handle);s&&this.ob(s)}w.children=void 0}}else this.pb()}ob(b){const w=this.j.get(b);if(w){if(w.children)for(const r of w.children){const s=this.i.get(r.item.handle);s&&this.ob(s)}this.j.delete(b),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(b=>b.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}p.a="0",p.b="1"}),define(Ie[245],Ce([1,0,20,11,5,29,2,126,254,115,124,36,4,70,198,197,38,199,32,201,202,203,186,204,56,33,206,207,210,211,213,103,189,218,219,220,76,59,223,244,8,6,50,226,60,102,31,177,209,48,101,105,107,108,12,53,15,27,214,184,66,73,195,224,77,58,229,227,228,196,37,221,225,75,57,71,215,104,216,13,88,188,168,208,7,25,172,74,165,217]),function(ee,e,i,T,y,L,C,O,S,k,M,D,m,v,f,t,c,l,p,E,b,w,r,s,a,d,o,u,n,h,g,P,N,j,Z,G,R,A,F,B,z,V,K,ie,ge,ue,re,se,le,_,me,we,Me,We,Qe,Te,De,ke,oe,ce,Y,I,$,H,q,J,de,Se,ae,ve,be,ze,He,tt,xe,et,it,dt,Oe,st,X,Q,pe,Ne,$e,je,Je,nt,wt,yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ct(lt){const at=lt.get(ke.IExtHostInitDataService),Ut=lt.get(be.IExtHostFileSystemInfo),Ft=lt.get(J.IExtHostConsumerFileSystem),Mt=lt.get(d.IExtHostExtensionService),ht=lt.get(re.IExtHostWorkspace),It=lt.get(et.IExtHostTelemetry),Bt=lt.get(p.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(De.IExtHostRpcService),Pt=lt.get(R.IExtHostStorage),Lt=lt.get(q.IExtensionStoragePaths),Ht=lt.get(Qe.ILoggerService),ft=lt.get(Qe.ILogService),Tt=lt.get(Y.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),fe=lt.get(tt.IExtHostSecretState),x=lt.get(xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Ut),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Ge.set(m.ExtHostContext.ExtHostWorkspace,ht),Ge.set(m.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(m.ExtHostContext.ExtHostExtensionService,Mt),Ge.set(m.ExtHostContext.ExtHostStorage,Pt),Ge.set(m.ExtHostContext.ExtHostTunnelService,Tt),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,fe),Ge.set(m.ExtHostContext.ExtHostTelemetry,It),Ge.set(m.ExtHostContext.ExtHostEditorTabs,x);const Ae=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(me.IExtHostDecorations)),Le=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(a.IExtHostDocumentsAndEditors)),Xe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(c.IExtHostCommands)),Be=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get(A.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Me.IExtHostDebugService)),bt=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(We.IExtHostSearch)),Et=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(we.IExtHostTask)),kt=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(P.IExtHostOutputService)),pt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),vt=Ge.set(m.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ge)),mt=Ge.set(m.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Ge,Le)),Vt=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ge,Le,ft)),si=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(ft,mt,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),St=Ge.set(m.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ge,Xe,Le,mt)),ti=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(St)),oi=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(ft,St)),Yt=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,St,Xe,ft)),bi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Oe.ExtHostNotebookRenderers(Ge,St)),At=Ge.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ge,Le)),ai=Ge.set(m.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Xe,ft)),jt=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),At,at.remote)),Jt=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,ft,Ut,Le)),ci=Ge.set(m.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ge,mt,Xe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,Nt,mt,Xe,Jt,ft,ye,It)),Zt=Ge.set(m.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Ge,ct)),qt=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ge,ft,Le)),Xt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ht,Xe)),ui=Ge.set(m.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(Ge,Xe,ft)),Ei=Ge.set(m.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Xe,mt)),li=Ge.set(m.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),wi=Ge.set(m.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ge)),di=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ei=Ge.set(m.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),Li=Ge.set(m.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,Xe)),ii=Ge.set(m.ExtHostContext.ExtHostWebviews,new ge.ExtHostWebviews(Ge,at.remote,ht,ft,ye)),ni=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ii,ht)),Si=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new Se.ExtHostCustomEditors(Ge,mt,Lt,ii,ni)),yi=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ge,ii)),ri=Ge.set(m.ExtHostContext.ExtHostTesting,new ze.ExtHostTesting(Ge,Xe,Le)),Di=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ii=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new yt.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Ge,St,Le,Xe,ft));const Ui=Object.values(m.ExtHostContext);Ge.assertRegistered(Ui);const Bi=new ve.ExtHostBulkEdits(Ge,Le),$i=new t.ExtHostClipboard(Ge),Ci=new g.ExtHostMessageService(Ge,ft),Ai=new b.ExtHostDialogs(Ge),Ri=new G.ExtHostStatusBar(Ge,Xe.converter);return f.ExtHostApiCommands.register(Xe),function(Ue,zt,Oi){const gt=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")he();else{const Dt=rt;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),zi={getSession(ne,he,Fe){return ei.getSession(Ue,ne,he,Fe)},async hasSession(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ei.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(ne,he,Fe,rt){return ei.registerAuthenticationProvider(ne,he,Fe,rt)}},hi={registerCommand(ne,he,Fe){return Xe.registerCommand(!0,ne,he,Fe,void 0,Ue)},registerTextEditorCommand(ne,he,Fe){return Xe.registerCommand(!0,ne,(...rt)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Rt=>{he.apply(Fe,[Dt,Rt,...rt])}).then(Rt=>{Rt||ft.warn("Edits from command "+ne+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+ne,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Fe)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Xe.registerCommand(!0,ne,async(...rt)=>{const Dt=Le.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);he.apply(Fe,[Rt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...he){return Xe.executeCommand(ne,...he)},getCommands(ne=!1){return Xe.getCommands(ne)}},Fi={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return $i.value},get shell(){return Be.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),Be.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),It.instantiateLogger(Ue,ne)},openExternal(ne,he){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return vt.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(he){if((0,X.matchesScheme)(ne,st.Schemas.http)||(0,X.matchesScheme)(ne,st.Schemas.https))return ne;throw he}},get remoteName(){return(0,_.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Fi);const Wi={createTestController(ne,he,Fe){return ri.createTestController(ne,he,Fe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},fi=at.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Hi={getExtension(ne,he){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Fe=zt.mine.getExtensionDescription(ne);if(Fe)return new d.Extension(Mt,Ue.identifier,Fe,fi,!1);if(he){const rt=zt.all.getExtensionDescription(ne);if(rt)return new d.Extension(Mt,Ue.identifier,rt,fi,!0)}},get all(){const ne=[];for(const he of zt.mine.getAllExtensionDescriptions())ne.push(new d.Extension(Mt,Ue.identifier,he,fi,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(zt.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),he=[];for(const Fe of zt.all.getAllExtensionDescriptions()){const rt=!ne.has(Fe.identifier);he.push(new d.Extension(Mt,Ue.identifier,Fe,fi,rt))}return he},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(zt.mine.onDidChange,zt.all.onDidChange):zt.mine.onDidChange}},ki={createDiagnosticCollection(ne){return Jt.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:ne=>Jt.getDiagnostics(ne),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ne,he){return ci.changeLanguage(ne.uri,he)},match(ne,he){const Fe=mt.getDocumentData(he.uri)?.notebook;return(0,M.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ne,he,Fe){return ct.registerCodeActionProvider(Ue,gt(ne),he,Fe)},registerDocumentPasteEditProvider(ne,he,Fe){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,gt(ne),he,Fe)},registerCodeLensProvider(ne,he){return ct.registerCodeLensProvider(Ue,gt(ne),he)},registerDefinitionProvider(ne,he){return ct.registerDefinitionProvider(Ue,gt(ne),he)},registerDeclarationProvider(ne,he){return ct.registerDeclarationProvider(Ue,gt(ne),he)},registerImplementationProvider(ne,he){return ct.registerImplementationProvider(Ue,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return ct.registerTypeDefinitionProvider(Ue,gt(ne),he)},registerHoverProvider(ne,he){return ct.registerHoverProvider(Ue,gt(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return ct.registerEvaluatableExpressionProvider(Ue,gt(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return ct.registerInlineValuesProvider(Ue,gt(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return ct.registerDocumentHighlightProvider(Ue,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ct.registerLinkedEditingRangeProvider(Ue,gt(ne),he)},registerReferenceProvider(ne,he){return ct.registerReferenceProvider(Ue,gt(ne),he)},registerRenameProvider(ne,he){return ct.registerRenameProvider(Ue,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Fe){return ct.registerDocumentSymbolProvider(Ue,gt(ne),he,Fe)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return ct.registerDocumentFormattingEditProvider(Ue,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,gt(ne),he,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(ne,he,Fe){return ct.registerDocumentSemanticTokensProvider(Ue,gt(ne),he,Fe)},registerDocumentRangeSemanticTokensProvider(ne,he,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),he,Fe)},registerSignatureHelpProvider(ne,he,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Ue,gt(ne),he,Fe):ct.registerSignatureHelpProvider(Ue,gt(ne),he,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(ne,he,...Fe){return ct.registerCompletionItemProvider(Ue,gt(ne),he,Fe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,gt(ne),he)},registerDocumentLinkProvider(ne,he){return ct.registerDocumentLinkProvider(Ue,gt(ne),he)},registerColorProvider(ne,he){return ct.registerColorProvider(Ue,gt(ne),he)},registerFoldingRangeProvider(ne,he){return ct.registerFoldingRangeProvider(Ue,gt(ne),he)},registerSelectionRangeProvider(ne,he){return ct.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return ct.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return ct.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>ct.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),ci.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ct.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return ci.createLanguageStatusItem(Ue,ne,he)},registerDocumentDropEditProvider(ne,he){return ct.registerDocumentOnDropEditProvider(Ue,ne,he)}},Vi={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Be.activeTerminal},get terminals(){return Be.terminals},async showTextDocument(ne,he,Fe){const rt=await(C.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(rt,he,Fe)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Fe){return At.onDidChangeActiveTextEditor(ne,he,Fe)},onDidChangeVisibleTextEditors(ne,he,Fe){return At.onDidChangeVisibleTextEditors(ne,he,Fe)},onDidChangeTextEditorSelection(ne,he,Fe){return At.onDidChangeTextEditorSelection(ne,he,Fe)},onDidChangeTextEditorOptions(ne,he,Fe){return At.onDidChangeTextEditorOptions(ne,he,Fe)},onDidChangeTextEditorVisibleRanges(ne,he,Fe){return At.onDidChangeTextEditorVisibleRanges(ne,he,Fe)},onDidChangeTextEditorViewColumn(ne,he,Fe){return At.onDidChangeTextEditorViewColumn(ne,he,Fe)},onDidCloseTerminal(ne,he,Fe){return Be.onDidCloseTerminal(ne,he,Fe)},onDidOpenTerminal(ne,he,Fe){return Be.onDidOpenTerminal(ne,he,Fe)},onDidChangeActiveTerminal(ne,he,Fe){return Be.onDidChangeActiveTerminal(ne,he,Fe)},onDidChangeTerminalDimensions(ne,he,Fe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),Be.onDidChangeTerminalDimensions(ne,he,Fe)},onDidChangeTerminalState(ne,he,Fe){return Be.onDidChangeTerminalState(ne,he,Fe)},onDidWriteTerminalData(ne,he,Fe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Be.onDidWriteTerminalData(ne,he,Fe)},get state(){return Pe.state},onDidChangeWindowState(ne,he,Fe){return Pe.onDidChangeWindowState(ne,he,Fe)},showInformationMessage(ne,...he){return Ci.showMessage(Ue,L.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Ci.showMessage(Ue,L.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Ci.showMessage(Ue,L.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Fe){return Xt.showQuickPick(ne,he,Fe)},showWorkspaceFolderPick(ne){return Xt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Xt.showInput(ne,he)},showOpenDialog(ne){return Ai.showOpenDialog(ne)},showSaveDialog(ne){return Ai.showSaveDialog(ne)},createStatusBarItem(ne,he,Fe){let rt,Dt,Rt;return typeof ne=="string"?(rt=ne,Dt=he,Rt=Fe):(Dt=ne,Rt=he),Ri.createStatusBarEntry(Ue,rt,Dt,Rt)},setStatusBarMessage(ne,he){return Ri.setStatusBarMessage(ne,he)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),li.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(he,Fe)=>ne({report(rt){}}))},withProgress(ne,he){return li.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return kt.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Fe,rt){return ni.createWebviewPanel(Ue,ne,he,Fe,rt)},createWebviewTextEditorInset(ne,he,Fe,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),jt.createWebviewEditorInset(ne,he,Fe,rt,Ue)},createTerminal(ne,he,Fe){return typeof ne=="object"?"pty"in ne?Be.createExtensionTerminal(ne):Be.createTerminalFromOptions(ne):Be.createTerminal(ne,he,Fe)},registerTerminalLinkProvider(ne){return Be.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return Be.registerProfileProvider(Ue,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),Be.registerTerminalQuickFixProvider(ne,Ue.identifier.value,he)},registerTreeDataProvider(ne,he){return ai.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return ai.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ni.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Fe={})=>Si.registerCustomEditorProvider(Ue,ne,he,Fe),registerFileDecorationProvider(ne){return Ae.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return vt.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Xt.createQuickPick(Ue)},createInputBox(){return Xt.createInputBox(Ue)},get activeColorTheme(){return di.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Fe){return di.onDidChangeActiveColorTheme(ne,he,Fe)},registerWebviewViewProvider(ne,he,Fe){return yi.registerWebviewViewProvider(Ue,ne,he,Fe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Fe){return St.onDidChangeActiveNotebookEditor(ne,he,Fe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Fe){return oi.onDidChangeNotebookEditorSelection(ne,he,Fe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Fe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Fe)},showNotebookDocument(ne,he){return St.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Fe){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Di.registerExternalUriOpener(Ue.identifier,ne,he,Fe)},registerProfileContentHandler(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ii.registrProfileContentHandler(Ue,ne,he)},get tabGroups(){return x.tabGroups}},Kt={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw T.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,he,...Fe)=>ht.updateWorkspaceFolders(Ue,ne,he||0,...Fe),onDidChangeWorkspaceFolders:function(ne,he,Fe){return ht.onDidChangeWorkspace(ne,he,Fe)},asRelativePath:(ne,he)=>ht.getRelativePath(ne,he),findFiles:(ne,he,Fe,rt)=>ht.findFiles(ne,he,Fe,Ue.identifier,rt),findTextInFiles:(ne,he,Fe,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Rt;return typeof he=="object"?(Dt=he,Rt=Fe):(Dt={},Rt=he,rt=Fe),ht.findTextInFiles(ne,Dt||{},Rt,Ue.identifier,rt)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,he){return Bi.applyWorkspaceEdit(ne,Ue,he)},createFileSystemWatcher:(ne,he,Fe,rt)=>qt.createFileSystemWatcher(ht,Ue,ne,he,Fe,rt),get textDocuments(){return mt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let he;const Fe=ne;if(typeof ne=="string")he=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))he=Promise.resolve(ne);else if(!Fe||typeof Fe=="object")he=mt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>mt.ensureDocumentData(rt).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,he,Fe)=>mt.onDidAddDocument(ne,he,Fe),onDidCloseTextDocument:(ne,he,Fe)=>mt.onDidRemoveDocument(ne,he,Fe),onDidChangeTextDocument:(ne,he,Fe)=>mt.onDidChangeDocument(ne,he,Fe),onDidSaveTextDocument:(ne,he,Fe)=>mt.onDidSaveDocument(ne,he,Fe),onWillSaveTextDocument:(ne,he,Fe)=>si.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Fe),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Fe;if(C.URI.isUri(ne))Fe=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Fe=C.URI.revive(await St.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ne,he,Fe){return ti.onDidSaveNotebookDocument(ne,he,Fe)},onDidChangeNotebookDocument(ne,he,Fe){return ti.onDidChangeNotebookDocument(ne,he,Fe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Fe,rt){return St.registerNotebookSerializer(Ue,ne,he,Fe,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,he,Fe)=>Oi.onDidChangeConfiguration(ne,he,Fe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Oi.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return Vt.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Fe){return(0,$e.combinedDisposable)(Zt.registerFileSystemProvider(Ue,ne,he,Fe),Ft.addFileSystemProvider(ne,he))},get fs(){return Ft.value},registerFileSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Mt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Fe)=>qt.onDidCreateFile(ne,he,Fe),onDidDeleteFiles:(ne,he,Fe)=>qt.onDidDeleteFile(ne,he,Fe),onDidRenameFiles:(ne,he,Fe)=>qt.onDidRenameFile(ne,he,Fe),onWillCreateFiles:(ne,he,Fe)=>qt.getOnWillCreateFileEvent(Ue)(ne,he,Fe),onWillDeleteFiles:(ne,he,Fe)=>qt.getOnWillDeleteFileEvent(Ue)(ne,he,Fe),onWillRenameFiles:(ne,he,Fe)=>qt.getOnWillRenameFileEvent(Ue)(ne,he,Fe),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),Tt.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(ne,he,Fe)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),Tt.onDidChangeTunnels(ne,he,Fe)),registerPortAttributesProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),Tt.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),Li.registerTimelineProvider(ne,he,Ue.identifier,Xe.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Fe)=>ht.onDidGrantWorkspaceTrust(ne,he,Fe),registerEditSessionIdentityProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,he))},mi={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ui.getLastInputBox(Ue)},createSourceControl(ne,he,Fe){return ui.createSourceControl(Ue,ne,he,Fe)}},ji={createCommentController(ne,he){return Ei.createCommentController(Ue,ne,he)}},$t={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,he,Fe){return Ze.onDidStartDebugSession(ne,he,Fe)},onDidTerminateDebugSession(ne,he,Fe){return Ze.onDidTerminateDebugSession(ne,he,Fe)},onDidChangeActiveDebugSession(ne,he,Fe){return Ze.onDidChangeActiveDebugSession(ne,he,Fe)},onDidReceiveDebugSessionCustomEvent(ne,he,Fe){return Ze.onDidReceiveDebugSessionCustomEvent(ne,he,Fe)},onDidChangeBreakpoints(ne,he,Fe){return Ze.onDidChangeBreakpoints(ne,he,Fe)},registerDebugConfigurationProvider(ne,he,Fe){return Ze.registerDebugConfigurationProvider(ne,he,Fe||Je.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Ze.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Ze.startDebugging(ne,he,{parentSession:Fe}):Ze.startDebugging(ne,he,Fe||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Ze.asDebugSourceUri(ne,he)}},gi={registerTaskProvider:(ne,he)=>Et.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>Et.fetchTasks(ne),executeTask:ne=>Et.executeTask(Ue,ne),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ne,he,Fe)=>Et.onDidStartTask(ne,he,Fe),onDidEndTask:(ne,he,Fe)=>Et.onDidEndTask(ne,he,Fe),onDidStartTaskProcess:(ne,he,Fe)=>Et.onDidStartTaskProcess(ne,he,Fe),onDidEndTaskProcess:(ne,he,Fe)=>Et.onDidEndTaskProcess(ne,he,Fe)},qi={createNotebookController(ne,he,Fe,rt,Dt){return Yt.createNotebookController(Ue,ne,he,Fe,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>St.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createRendererMessaging(ne){return bi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Yt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Yt.registerKernelSourceActionProvider(Ue,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Fe){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(ne,he,Fe)}},Ki={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Fe=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Ue.identifier.value,{message:he,args:Fe})}return pt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:zi,commands:hi,comments:ji,debug:$t,env:Fi,extensions:Hi,l10n:Ki,languages:ki,notebooks:qi,scm:mi,tasks:gi,tests:Wi,window:Vi,workspace:Kt,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Je.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:k.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:v.UIKind,Uri:C.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:K.TrustedTelemetryValue,LogLevel:Qe.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ct}),define(Ie[246],Ce([1,0,245,33,2,239,6,14,230]),function(ee,e,i,T,y,L,C,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(v,f){for(const t of this.b){const c=t(v);if(c){v=c;break}}if(this.a.has(v))return this.a.get(v).load(v,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const v=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,v,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(v){return v.browser}async pb(v,f,t){f=f.with({path:D(f.path,".js")});const c=v?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const l=y.URI.revive(await this.v.$asBrowserUri(f)),p=await fetch(l.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),p.status!==200)throw new Error(p.statusText);const E=await p.text(),b=`${f.toString(!0)}#vscode-extension`,w=`${E}
//# sourceURL=${b}`;let r;try{r=new Function("module","exports","require",w)}catch(o){throw console.error(c?`Loading code for extension ${c} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${f.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}v&&await this.s.initializeLocalizedMessages(v);const s={},a={exports:s},d=o=>{const u=this.r.getModule(o,f);if(u===void 0)throw new Error(`Cannot load module '${o}'`);return u};try{return t.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),r(a,s,d),a.exports!==s?a.exports:s}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),t.codeLoadingStop()}}async $setRemoteEnvironment(v){}async tb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+v;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.timeout)(10)}}e.ExtHostExtensionService=M;function D(m,v){return m.endsWith(v)?m:m+v}}),define(Ie[247],Ce([1,0,63,33,77,246]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(T.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ie[255],Ce([1,0,24,5,70,240,232,19,78,13,2,242,247]),function(ee,e,i,T,y,L,C,O,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function t(r){self.fetch=async function(s,a){return s instanceof Request||v(String(s))&&(s=(await r(M.URI.parse(String(s)))).toString(!0)),f(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,d,o,u){(async()=>(v(a.toString())&&(a=(await r(M.URI.parse(a.toString()))).toString(!0)),super.open(s,a,d??!0,o,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=k.FileAccess.uriToBrowserUri(M.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(g){function P(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const N=fetch.bind(self);self.fetch=function(Z,G){return Z instanceof Request?N(Z,G):N(P(Z),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,G,R,A,F){return super.open(Z,P(G),R??!0,A,F)}};const j=importScripts.bind(self);self.importScripts=(...Z)=>{j(...Z.map(P))},j(g)}.toString()}('${s}'))`;a=a||{},a.name=a.name||O.basename(s.toString());const u=new Blob([o],{type:"application/javascript"}),n=URL.createObjectURL(u);return new r(n,a)}}else self.Worker=class extends C.NestedWorker{constructor(r,s){super(m,r,{name:O.basename(r.toString()),...s})}};const c=new class{constructor(){this.pid=void 0}exit(r){D()}async exists(r){return!0}async realpath(r){return r}};class l{constructor(){const s=new MessageChannel,a=new T.Emitter;let d=!1;m(s.port2,[s.port2]),s.port1.onmessage=o=>{const{data:u}=o;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const n=i.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(n,2)){d=!0,E("received terminate message from renderer");return}a.fire(n)},this.protocol={onMessage:a.event,send:o=>{if(!d){const u=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);s.port1.postMessage(u,[u])}}}}}function p(r){return new Promise(s=>{const a=r.onMessage(d=>{a.dispose();const o=JSON.parse(d.toString());r.send((0,y.createMessageOfType)(0)),s({protocol:r,initData:o})});r.send((0,y.createMessageOfType)(1))})}let E=r=>D();function b(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const r=new l;return{onmessage(s){!b(s)||p(r.protocol).then(a=>{S.mark("code/extHost/didWaitForInitData");const d=new L.ExtensionHostMain(a.protocol,a.initData,c,null,s.data);t(o=>d.asBrowserUri(o)),E=o=>d.terminate(o)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/64a739f7aa1092187348afa9378931d47683be12/core/vs/workbench/api/worker/extensionHostWorker.js.map
